import java.io.*;
import java.util.*;

public class spacepin_pk_assert20_3 {
	public static void main(String[] args) {
		new spacepin_pk_assert20_3().run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public void solve() throws IOException {
		long r = nextInt();
		long n = nextInt();
		assert ((1 <= r) && (r <= 700));
		assert ((1 <= n) && (n <= 200000));
		long ballR = nextInt();
		assert ((1 <= ballR) && (ballR <= 1e9));
		long ballX = nextInt();
		long ballY = nextInt();
		assert ((-1e6 <= ballX) && (ballX <= 1e6));
		assert ((-1e6 <= ballY) && (1000 * ballY < -(r + ballR)));
		long vX = nextInt();
		long vY = nextInt();
		assert ((-1e6 <= vX) && (vX <= 1e6));
		assert ((0 < vY) && (vY <= 1e6));
		
		assert((n <= 1000) && (vX != 0));
		
		double rOnX = (ballR + r) / (double) vY * Math.sqrt(vX * vX + vY * vY) / 1000;
		double a = -vY;
		double b = vX;
		double c = -a * ballX - b * ballY;
		long ans = 0;
		for (int i = 0; i < n; i++) {
			double x = (-b * i - c) / a;
			double lX = x - rOnX - 1e-7;
			double rX = x + rOnX + 1e-7;
			
			int leftKilled = (int) Math.floor(lX);
			int rightKilled = (int) Math.floor(rX);
			if (Math.abs(leftKilled) % 2 != i % 2)
				leftKilled++;
			if (Math.abs(rightKilled) % 2 != i % 2)
				rightKilled++;
			
			while (leftKilled >= lX + 1e-7)
				leftKilled -= 2;
			while (leftKilled <= lX - 1e-7)
				leftKilled += 2;
			while (rightKilled <= rX - 1e-6)
				rightKilled += 2;
			while (rightKilled >= rX + 1e-6)
				rightKilled -= 2;
			
			if (leftKilled < -i)
				leftKilled = -i;
			if (leftKilled > i)
				continue;
			if (rightKilled > i)
				rightKilled = i;
			if (rightKilled < -i)
				continue;
			
			ans += (rightKilled - leftKilled) / 2 + 1;
		}
		
		out.println(ans);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("spacepin.in"));
			out = new PrintWriter("spacepin.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}