#include <iostream>
#include <fstream>
#include <string>
#include <tr1/unordered_map>

using namespace std;

const long long X = 997;
const int MAXLEN = 50;

long long **hashes;
string *s;
tr1::unordered_map<long long, int> *cnt;
long long *XPOW;

void build_hashes(const string& s, long long *hash)
{
	int n = s.size();
	hash[0] = 0;
	for (int i = 0; i < n; i++)
		hash[i + 1] = hash[i] * X + s[i];
}

long long get_hash(long long *hashes, int left, int right)
{
 	return hashes[right] - hashes[left] * XPOW[right - left];
}                                                        

int main()
{
	ifstream in("sufpref.in");
	ofstream out("sufpref.out");
	int n;
	in >> n;
	hashes = new long long*[n];
	s = new string[n];
	cnt = new tr1::unordered_map<long long, int>[MAXLEN + 1];
	XPOW = new long long[MAXLEN + 1];
	XPOW[0] = 1;
	for (int i = 1; i < MAXLEN + 1; i++)
		XPOW[i] = XPOW[i - 1] * X;
	for (int i = 0; i < n; i++)
	{
		in >> s[i];
		hashes[i] = new long long[s[i].size() + 1];
		build_hashes(s[i], hashes[i]);
		for (size_t len = 1; len <= s[i].size(); len++)
		{
			long long pref = get_hash(hashes[i], 0, len);
			long long suf= get_hash(hashes[i], s[i].size() - len, s[i].size());
			if (pref == suf)
				cnt[len][pref]++;
		}
	}
	
	int m;
	in >> m;
	for (int i = 0; i < m; i++)
	{
		string q;
		in >> q;
		long long hash = 0;
		for (size_t i = 0; i < q.size(); i++)
			hash = hash * X + q[i];
		out << cnt[q.size()][hash] << "\n";
	}
}
