import java.io.*;
import java.util.*;

public class sufpref_ats implements Runnable {
    public static void main(String[] args) {
        new Thread(new sufpref_ats()).start();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    final int MAXLEN = 50;
    final int MAXM = (int) 1e5;
    final int MAXN = (int) 1e5;
    final int MAXSUM = (int) 1e6;

    final int prime = 37;
    final int base = (int) 1e7 + 7;

    public int getNum(char c) {
        if (c == '$') {
            return 0;
        } else {
            return (int) (c - 'a' + 1);
        }
    }

    public char getChar(int num) {
        if (num == 0) {
            return '$';
        } else {
            return (char) (num - 1 + 'a');
        }
    }

    public String makeMagic(String t) {
        String ans = "";
        for (int i = 0; i < t.length(); i++) {
            ans += t.charAt(i);
            ans += t.charAt(t.length() - 1 - i);
        }
        return ans;
    }

    char[][] s;
    // int[][] hash;
    int[] sorted;

    public void sort() {
        int[] sizes = new int[27];
        int[] pos = new int[27];
        int[] newOrder = new int[sorted.length];
        for (int i = MAXLEN * 2 - 1; i >= 0; i--) {
            Arrays.fill(sizes, 0);
            Arrays.fill(pos, 0);
            for (int j = 0; j < s.length; j++) {
                sizes[getNum(s[sorted[j]][i])]++;
            }
            pos[0] = 0;
            for (int j = 1; j < sizes.length; j++) {
                pos[j] = pos[j - 1] + sizes[j - 1];
            }
            for (int j = 0; j < s.length; j++) {
                newOrder[pos[getNum(s[sorted[j]][i])]] = sorted[j];
                pos[getNum(s[sorted[j]][i])]++;
            }
            for (int j = 0; j < s.length; j++) {
                sorted[j] = newOrder[j];
            }
        }
    }

    char[] q;

    public int calc(int done, int pos) {
        int ans = Math.max(0, done);
        for (int i = done; i < q.length; i++) {
            if (q[i] != s[sorted[pos]][i]) {
                return ans;
            }
            ans++;
        }
        return ans;
    }

    public int getRight() {
        int l = 0;
        int r = sorted.length;
        int eqLeft = calc(0, 0);
        int eqRight = 0;
        while (l < r - 1) {
            if (l == r - 2) {
                if (calc(Math.min(eqLeft, eqRight), r - 1) == q.length) {
                    return r - 1;
                } else if (calc(Math.min(eqLeft, eqRight), l) == q.length) {
                    return l;
                } else {
                    return -1;
                }
            }
            int m = (l + r) / 2;
            int len = calc(Math.min(eqLeft, eqRight), m);
            if (len == q.length) {
                l = m;
                eqLeft = len;
            } else if (len < q.length
                    && getNum(s[sorted[m]][len]) > getNum(q[len])) {
                r = m;
                eqRight = len;
            } else {
                l = m;
                eqLeft = len;
            }
        }
        if (eqLeft == q.length) {
            return l;
        } else {
            return -1;
        }
    }

    public int getLeft() {
        int l = 0;
        int r = sorted.length;
        int eqLeft = calc(0, 0);
        int eqRight = 0;
        while (l < r - 1) {
            if (l == r - 2) {
                if (calc(Math.min(eqLeft, eqRight), l) == q.length) {
                    return l;
                } else if (calc(Math.min(eqLeft, eqRight), r - 1) == q.length) {
                    return r - 1;
                } else {
                    return sorted.length;
                }
            }
            int m = (l + r) / 2;
            int len = calc(Math.min(eqLeft, eqRight), m);
            if (len == q.length) {
                r = m + 1;
                eqRight = len;
            } else if (len < q.length
                    && getNum(s[sorted[m]][len]) > getNum(q[len])) {
                r = m;
                eqRight = len;
            } else {
                l = m;
                eqLeft = len;
            }
        }
        if (eqLeft == q.length) {
            return l;
        } else {
            return sorted.length;
        }
    }

    public int calc(String query) {
        q = new char[query.length() * 2];
        int pos = 0;
        for (int i = 0; i < query.length(); i++) {
            q[pos++] = query.charAt(i);
            q[pos++] = query.charAt(query.length() - 1 - i);
        }
        return Math.max(0, getRight() - getLeft() + 1);
    }

    int left;
    int right;

    public void solve() throws IOException {
        int n = Integer.parseInt(br.readLine());
        assert (1 <= n && n <= MAXN);
        int sum = 0;
        s = new char[n][MAXLEN * 2];
        sorted = new int[n];
        for (int i = 0; i < n; i++) {
            String tmp = br.readLine();
            assert (0 < tmp.length() && tmp.length() <= MAXLEN);
            sum += tmp.length();
            int pos = 0;
            for (int j = 0; j < tmp.length(); j++) {
                s[i][pos++] = tmp.charAt(j);
                s[i][pos++] = tmp.charAt(tmp.length() - 1 - j);
            }
            while (pos < MAXLEN * 2) {
                s[i][pos++] = '$';
            }
            sorted[i] = i;
        }
        // System.err.println(sum + " " + MAXSUM);
        assert (sum <= MAXSUM);

        sort();
        // for (int i = 0; i < sorted.length; i++) {
        // System.err.println(Arrays.toString(s[sorted[i]]));
        // }
        // for (int i = 0; i < sorted.length; i++) {
        // hash[i][0] = s[i][0];
        // for (int j = 1; j < MAXLEN * 2; j++) {
        // hash[i][j] = (hash[i][j - 1] * prime + getNum(s[sorted[i]][j]))
        // % base;
        // }
        // }
        int m = Integer.parseInt(br.readLine());
        sum = 0;
        assert (1 <= m && m <= MAXM);
        for (int i = 0; i < m; i++) {
            String query = br.readLine();
            assert (query.length() <= MAXLEN);
            sum += query.length();
            out.println(calc(query));
        }
        assert (sum <= MAXSUM);
    }

    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new BufferedReader(new FileReader("sufpref.in"));
            out = new PrintWriter("sufpref.out");

            solve();

            out.close();
            br.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
