import java.io.*;
import java.util.*;

public class sufpref_ats_slow_ML implements Runnable {
    public static void main(String[] args) {
        new Thread(new sufpref_ats_slow_ML()).start();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    final int ALPHSIZE = 26;
    final int MAXSIZE = 52;

    public class Node {
        int cnt;
        int ownCnt;
        Node[] next;

        public Node() {
            next = new Node[ALPHSIZE];
            cnt = -1;
            ownCnt = 0;
        }

        public void add(String s) {
            if (s.equals("")) {
                ownCnt++;
                return;
            }
            if (next[getNum(s.charAt(0))] == null) {
                Node newNode = new Node();
                next[getNum(s.charAt(0))] = newNode;
            }
            next[getNum(s.charAt(0))].add(s.substring(1));
        }

        public int calc() {
            if (cnt != -1) {
                return cnt;
            }
            cnt = ownCnt;
            for (int i = 0; i < ALPHSIZE; i++) {
                if (next[i] != null) {
                    cnt += next[i].calc();
                }
            }
            return cnt;
        }

        public int get(String s) {
            if (s.equals("")) {
                return cnt;
            }
            if (next[getNum(s.charAt(0))] == null) {
                return 0;
            } else {
                return next[getNum(s.charAt(0))].get(s.substring(1));
            }
        }
    }

    public int getNum(char c) {
        return (int) (c - 'a');
    }

    public char getChar(int num) {
        return (char) (num + 'a');
    }

    public String makeMagic(String t) {
        String ans = "";
        for (int i = 0; i < t.length(); i++) {
            ans += t.charAt(i);
            ans += t.charAt(t.length() - 1 - i);
        }
        return ans;
    }

    String[] s;

    int left;
    int right;

    public void solve() throws IOException {
        int n = nextInt();
        Node trieRoot = new Node();
        s = new String[n];
        for (int i = 0; i < n; i++) {
            s[i] = nextToken();
            trieRoot.add(makeMagic(s[i]));
        }
        trieRoot.calc();
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            String query = nextToken();
            out.println(trieRoot.get(makeMagic(query)));
        }
    }

    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new BufferedReader(new FileReader("sufpref.in"));
            out = new PrintWriter("sufpref.out");

            solve();

            out.close();
            br.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
