#include <cstdlib>
#include <cstdio>
#include <memory>
#include <iostream>
#include <cstring>

using namespace std;

const int MAXN = (int)1e5;
const int MAXLEN = 50;

char s[MAXN][MAXLEN * 2];
char q[MAXLEN * 2], tmp[MAXLEN * 2];
int sorted[MAXN];

int n;

int getNum(char c){ 
    if (c == '$')
        return 0;
    else
        return static_cast<int>(c - 'a' + 1);
}

void bsort(){
    int sizes[27];
    int pos[27];
    int newOrder[MAXN];
    for (int i = MAXLEN * 2 - 1; i >= 0; i--) {
            memset(sizes, 0, sizeof(sizes));
            memset(pos, 0, sizeof(pos));
            for (int j = 0; j < n; j++) {
                sizes[getNum(s[sorted[j]][i])]++;
            }
            pos[0] = 0;
            for (int j = 1; j < 27; j++) {
                pos[j] = pos[j - 1] + sizes[j - 1];
            }
            for (int j = 0; j < n; j++) {
                newOrder[pos[getNum(s[sorted[j]][i])]] = sorted[j];
                pos[getNum(s[sorted[j]][i])]++;
            }
            for (int j = 0; j < n; j++) {
                sorted[j] = newOrder[j];
            }
        }   
}

void magic(int num){
    int len = MAXLEN;
    for(int i = 0; i < MAXLEN; i++){
        if (tmp[i] == 0){
            len = i;
            break;
        }        
    }
    if (num == -1){
        int pos = 0;
        for(int i = 0; i < len; i++){
            q[pos++] = tmp[i];
            q[pos++] = tmp[len - 1 - i];        
        }
        while(pos < MAXLEN * 2){
            q[pos++] = '$';
        }
    } else {
        int pos = 0;
        for(int i = 0; i < len; i++){
            //cerr << i << " " << tmp[i] << " " << pos << endl;
            s[num][pos++] = tmp[i];
            s[num][pos++] = tmp[len - 1 - i];        
        }
        while(pos < MAXLEN * 2){
            s[num][pos++] = '$';
        }
    }
}

int calc(int done, int num){
    int ans = done;
    for(int i = done; q[i] != '$' && i < MAXLEN * 2; i ++){
        if (q[i] != s[sorted[num]][i]){
            return ans;
        }
        ans++;
    }
    return ans;
}               

int getRight(){
    //cerr << "right" << endl;
    int toFind = MAXLEN * 2;
    for(int i = 0; i < MAXLEN * 2; i++){
        if (q[i] == '$'){
            toFind = i;
            break;
        }
    }
    //cerr << "toFind = " << toFind << endl;
    int leftEq = calc(0, 0);
    int rightEq = calc(0, n - 1);
    int l = 0;
    int r = n - 1;
    while(l < r){
        //cerr << l << " " << r << endl;
        if (l == r - 1){
            //cerr << "! " << calc(min(leftEq, rightEq), l) << " " << calc(min(leftEq, rightEq), r) << endl;
            if (calc(min(leftEq, rightEq), r) == toFind)
                return r;
            else if (calc(min(leftEq, rightEq), l) == toFind)
                return l;
            else
                return -1;
        }
        int m = (l + r + 1) / 2;
        int len = calc(min(leftEq, rightEq), m);
        //cerr << m << " " << len << " " << s[sorted[m]][len] << " " << q[len] << endl;
        if (len == toFind){
            l = m;
            leftEq = len;    
        } else if (getNum(s[sorted[m]][len]) < getNum(q[len])){
            l = m;
            leftEq = len;
        } else {
            r = m;
            rightEq = len;
        }
    }
    //cerr << l << endl;
    if (leftEq == toFind)
        return l;
    else
        return -1;
}

int getLeft(){
    //cerr << "left" << endl;
    int toFind = MAXLEN * 2;
    for(int i = 0; i < MAXLEN * 2; i++){
        if (q[i] == '$'){
            toFind = i;
            break;
        }
    }
    int leftEq = calc(0, 0);
    int rightEq = calc(0, n - 1);
    int l = 0;
    int r = n - 1;
    while(l < r){
        //cerr << l << " " << r << endl;
        if (l == r - 1){
            //cerr << "! " << calc(min(leftEq, rightEq), l) << " " << calc(min(leftEq, rightEq), r) << endl;
            if (calc(min(leftEq, rightEq), l) == toFind)
                return l;
            else if (calc(min(leftEq, rightEq), r) == toFind)
                return r;
            else
                return n + 1;
        }
        int m = (l + r + 1) / 2;
        int len = calc(min(leftEq, rightEq), m);
        //cerr << m << " " << len << " " << s[sorted[m]][len + 1] << " " << q[len + 1] << endl;
        if (len == toFind){
            r = m;
            rightEq = m;    
        } else if (getNum(s[sorted[m]][len]) < getNum(q[len])){
            l = m;
            leftEq = len;
        } else {
            r = m;
            rightEq = len;
        }
    }
    //cerr << l << endl;
    if (leftEq == toFind)
        return l;
    else
        return n + 1;
}


int answer(){
    int r = getRight();
    int l = getLeft();
    //cerr << r << " " << l << endl;
    return max(0, r - l + 1);
}

int main(){
    freopen("sufpref.in", "r", stdin);
    freopen("sufpref.out", "w", stdout);
    //freopen("log", "w", stderr);
    scanf("%d\n", &n);
    for(int i = 0; i < n; i ++){
        scanf("%s\n", tmp);
        //cerr << tmp << endl;
        magic(i);
        //cerr << s[i] << endl;
        sorted[i] = i;
    }
    bsort();
    for(int i = 0; i < n; i ++){
        //cerr << sorted[i] << endl;
    }
    int m;
    scanf("%d\n", &m);
    for(int i = 0; i < m; i++){
        scanf("%s\n", tmp);
        magic(-1);
        //cerr << q << endl;
        int val = answer();
        //if (val == 11)
        //    cerr << q << endl;
        printf("%d\n", val);
    } 
    fclose(stdin);
    fclose(stdout);
    return 0;
}
