import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Queue;
import java.util.StringTokenizer;

public class army_sm_hashtable {
    int n;


    final int FREE = 0;
    final int USED = 1;
    final int IN_A = 2;
    int[] hashTableKey;
    long[] hashTableValue;
    int HASH_TABLE_SIZE;
    Queue<Integer> queue;

    int[] a;

    int hash(int s) {
        return s % HASH_TABLE_SIZE;
    }

    long get(int s) {
        int j = hash(s);
        while (hashTableKey[j] != -1 && hashTableKey[j] != s) {
            j = j + 1;
            if (j == HASH_TABLE_SIZE) {
                j = 0;
            }
        }
        if (hashTableKey[j] == -1) {
            return -1;
        }
        return hashTableValue[j];
    }

    void inc(int s, long x) {
        int j = hash(s);
        while (hashTableKey[j] != -1 && hashTableKey[j] != s) {
            j = j + 1;
            if (j == HASH_TABLE_SIZE) {
                j = 0;
            }
        }
        if (hashTableKey[j] == -1) {
            hashTableKey[j] = s;
        }
        hashTableValue[j] += x;
    }


    void solve() throws IOException {
        n = nextInt();
        HASH_TABLE_SIZE = (int) (4 * Math.pow(3, n));
        int k = nextInt();
        a = new int[k];
        for (int i = 0; i < k; i++) {
            a[i] = nextInt() - 1;
        }
        queue = new ArrayDeque<Integer>();
        hashTableKey = new int[HASH_TABLE_SIZE];
        hashTableValue = new long[HASH_TABLE_SIZE];
        Arrays.fill(hashTableKey, -1);
        int start = 0;
        inc(start, 1);
        queue.add(start);
        int[] sMask = new int[n];
        while (!queue.isEmpty()) {
            int s = queue.poll();
            int sCompleted = getCompleted(s);
            getMask(sMask, s);
            long add = get(s);
//            System.err.println(" s = " + s +" mask = " + Arrays.toString(sMask) + " sCompleted = " + sCompleted + " ans = " + add);

            int[] armyt = new int[n + 1];
            int armytLen = 0;
            for (int i = 0; i < n; i++) {
                if (sMask[i] == IN_A) {
                    armyt[armytLen++] = i;
                }
            }
            armyt[armytLen++] = n + 1;
            armyt = Arrays.copyOf(armyt, armytLen);
//            System.err.println(" armyt = " + Arrays.toString(armyt));
            for (int i = 0; i < n; i++) {
                if (sMask[i] != FREE) {
                    continue;
                }
                for (int j = 0; j < armytLen; j++) {
                    if ((j == 0 || armyt[j - 1] < i) && i < armyt[j]) {
                        int[] newMask = sMask;
                        if (armyt[j] != n + 1) {
                            assert newMask[armyt[j]] == IN_A;
                            newMask[armyt[j]] = USED;
                        }
                        assert newMask[i] == FREE;
                        newMask[i] = IN_A;
                        int newCompleted = sCompleted + ((sCompleted < a.length && i == a[sCompleted]) ? 1 : 0);
                        int newState = assembly(newMask, newCompleted);
                        if (get(newState) == -1) {
                            queue.add(newState);
                        }
                        inc(newState, add);
                        newMask[i] = FREE;
                        if (armyt[j] != n + 1) {
                            newMask[armyt[j]] = IN_A;
                        }
                    }
                }

            }
        }
        long ans = 0;
        int[] mask = new int[n];
        int pCount = 0;
        for (int jj = 0; jj < hashTableKey.length; jj++) {
            if (hashTableKey[jj] == -1) {
                continue;
            }
            int j = hashTableKey[jj];
            pCount++;
            int sCompleted = getCompleted(j);
            if (sCompleted != a.length) {
                continue;
            }
            boolean completed = true;
            int inLasCnt = 0;
            getMask(mask, j);
            for (int i : mask) {
                completed &= i != FREE;
                if (i == IN_A) {
                    inLasCnt++;
                }
            }
            if (completed && sCompleted == a.length && inLasCnt == a.length) {
                ans += hashTableValue[jj];
            }
        }
        System.err.println("pCount = " + pCount + ", 3^n = " + Math.pow(3, n));
        System.out.println(ans);
        out.println(ans);
    }

    private int getCompleted(int s) {
        return s % (a.length + 1);
    }

    private void getMask(int[] sMask, int s) {
        s /= a.length + 1;
        for (int i = sMask.length - 1; i >= 0; i--) {
            sMask[i] = s % 3;
            s /= 3;
        }
    }

    private int assembly(int[] mask, int completed) {
        int res = 0;
        for (int i : mask) {
            res = res * 3 + i;
        }
        res = res * (a.length + 1) + completed;
        return res;
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("army.in"));
        out = new PrintWriter("army.out");
        solve();
        out.close();
    }

    int nextInt() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }

    public static void main(String[] args) throws IOException {
        long start = System.currentTimeMillis();
        new army_sm_hashtable().run();
        System.err.println("time = " + (System.currentTimeMillis() - start));
    }

}
