#pragma comment(linker, "/STACK:64000000")
#include <iostream>
#include <cstdio>
#include <ctime>
using namespace std;

int n;
int a[100500], b[100500];
int k;
const int N=1<<17;

int ramn[2*N+1], rbmn[2*N+1], ramx[2*N+1], rbmx[2*N+1];

inline int getmn(int a, int b, int *val, bool m){
	if (a==0 || b==0) return a+b;
	if ((val[a]<val[b])^m) return a;
	else return b;
}

void build(int *a, int *val, bool m){
	for (int i=N-1; i; --i){
		a[i]=getmn(a[i*2], a[i*2+1], val, m);
	}
}

int getv(int *a, int l, int r, int *val, bool m){
	l+=N;
	r+=N;
	int ans=0;
	while (l<=r){
		if (l%2) ans=getmn(a[l++], ans, val, m);
		if (!(r%2)) ans=getmn(a[r--], ans, val, m);
		if (r<l) break;
		l/=2;
		r/=2;
	}
	return ans;
}

bool good(int v1, int v2){
	return (a[v1]==a[v2] || b[v1]==b[v2]);
}

int main(){
	double t0=clock();
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i=1; i<=n; ++i){
		scanf("%d%d", &a[i], &b[i]);
	}
	scanf("%d", &k);

	for (int i=1; i<=n; ++i)
		ramn[i+N]=ramx[i+N]=rbmx[i+N]=rbmn[i+N]=i;
	build(ramn, a, false);
	build(ramx, a, true);
	build(rbmn, b, false);
	build(rbmx, b, true);

	int t[4];
	for (int i=0; i<k; ++i){
		int a1, a2;
		scanf("%d%d", &a1, &a2);
		int mna=getv(ramn, a1, a2, a, false);
		int mxa=getv(ramx, a1, a2, a, true);
		int mnb=getv(rbmn, a1, a2, b, false);
		int mxb=getv(rbmx, a1, a2, b, true);
		t[0]=mna, t[1]=mxa, t[2]=mnb, t[3]=mxb;
		for (int j=0; j<4; ++j)
			for (int l=j+1; l<4; ++l){
				if (!good(t[j], t[l])){
					printf("%d %d\n", t[j], t[l]);
					goto here;
				}
			}
		printf("0 0\n");
		here:;
	}
	//cerr<<(clock()-t0)/CLOCKS_PER_SEC<<endl;
}