#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "password"

const int maxs = 100001;
char s[maxs], q[maxs];
int sumpref[maxs];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	while (scanf("%s%s", s, q) >= 1) {
		int n = strlen(s);
		int m = strlen(q);
		assert(n >= m);
		assert(n <= (int)1e5);

		int pospref;
		for (pospref = 0; pospref < m && s[pospref] == q[pospref]; pospref++);
		
		int possuf;
		for (possuf = m - 1; possuf >= 0 && s[possuf + n - m] == q[possuf]; possuf--);
		
		//eprintf("%d %d\n", pospref, possuf);	
		sumpref[0] = 0;
		for (int i = 0; i < n; i++)
			sumpref[i + 1] = sumpref[i] + s[i] - '0'; 
			
		bool found = 0;
		for (int start = 0; !found && start < m; start++) {
			int now = 0;
			for (int len = 0; len < 6 && start + len < m; len++) {
				now *= 10;
				now += q[start + len] - '0';	
				//eprintf("%d %d -> %d\n", start, len, now);
				//eprintf("sumn = %d\n", sumpref[n - m + start + len + 1] - sumpref[start]);
				if ((start + len >= possuf) && (pospref >= start) && (now == sumpref[n - m + start + len + 1] - sumpref[start])) {
					int p1 = start, p2 = n - m + start + len;
					printf("%d %d\n", p1 + 1, p2 + 1);
					for (int i = 0; i < p1; i++)
						while (s[i] != q[i])
							eprintf("mmmmmm....");
					for (int i = p2 + 1; i < n; i++)
						while (s[i] != q[i + m - n])
							eprintf("mmmmmm....");
					found = 1;
					break;
				}
			}
		}
		assert(found);
		break;
	}

	return 0;
}
