#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "virus"

struct Graph {
	const static int sqn = 1400;
	int remsqn;
	vi plesqn;
	vi color;
	vi now, nowsqn;
	vi start, end;

	vvi es;
	int n;
	vi pr;
	
	int boss;
	vi g;

	Graph(int _n = 0) : n(_n) {
		es = vvi(n);
		pr = vi(n, -1);
		g = vi(n, 0);
	}

	void adde(int s, int t) {
		es[s].pb(t);
	}	

	int tme;
	void dfs(int v) {
		start[v] = ++tme;
		for (int it = 0; it < (int)es[v].size(); it++) {
			int u = es[v][it];
			g[u] = g[v] + 1;
			dfs(u);
		}	
		end[v] = ++tme;
	}

	void prec() {
	  g[boss] = 0;
		start = end = vi(n, 0);
		tme = 0;
		dfs(boss);
		
		vi cnt(sqn, 0);
		color = vi(n, -1);
		for (int i = 0; i < n; i++) {
			color[i] = g[i] % sqn;
			cnt[color[i]]++;
		}
		remsqn = min_element(cnt.begin(), cnt.end()) - cnt.begin();
		plesqn = vi(cnt[remsqn], -1);
		
		int rn = 0;
		for (int i = 0; i < n; i++)
			if (color[i] == remsqn)
				plesqn[rn++] = i;
		assert(rn == (int)plesqn.size());
		now = nowsqn = vi(n, 0);
	}

	inline void addv(int v, int x) {
		now[v] += x;
		for (int i = 0; i < (int)plesqn.size(); i++) {
			int u = plesqn[i];
			if (start[v] <= start[u] && end[u] <= end[v])
				nowsqn[u] += x;
		}	
	}
	inline int countv(int v) {
		int res = 0;
		while (v >= 0 && color[v] != remsqn)
			res += now[v], v = pr[v];
		if (v >= 0) {
			assert(color[v] == remsqn);
			res += nowsqn[v];
		}
		return res;	
	}
};

Graph g[2];

ll ans;
void dfs(int v) {
	ans += g[1].countv(v);
	g[1].addv(v, 1);
	for (int it = 0; it < (int)g[0].es[v].size(); it++) {
		int u = g[0].es[v][it];
		dfs(u);
	}
	g[1].addv(v, -1);
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n;
	while (scanf("%d", &n) >= 1) {
		for (int it = 0; it < 2; it++) {
		  g[it] = Graph(n);
			for (int i = 0; i < n; i++) {
				scanf("%d", &g[it].pr[i]);
				g[it].pr[i]--;
				if (g[it].pr[i] == -1)
					g[it].boss = i;
				else
					g[it].adde(g[it].pr[i], i);	
			}
		}

		g[1].prec();
		ans = 0;
		dfs(g[0].boss);
		printf("%I64d\n", ans);
		//break;
	}

	return 0;
}
