#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "apricot"

const int maxn = (int)1e6;
int d[maxn + 1];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n0, r, u;
	while (scanf("%d%d%d", &n0, &r, &u) >= 1) {
		d[0] = 0;
		d[1] = 0;
		for (int n = 2; n <= n0; n++) {
			int &cur = d[n];
			cur = INF;

			int left = 0, right = (n + 1) / 2;
			while (left + 1 < right) {
				int mid = (left + right) >> 1;
				if (d[mid] + u > d[n - 2 * mid] + r)
					right = mid;
				else
					left = mid;
			}
			for (int x = max(1, left - 1); x <= min(n, right + 1); x++)
				cur = min(cur, max(d[x] + u, (2 * x == n) ? -1 : (d[n - 2 * x] + r)));
			
			for (int x = n - 1; x >= 0 && d[x] > cur; x--)
				d[x] = cur;
		}

		printf("%d\n", d[n0]);	
		//break;
	}

	return 0;
}
