#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "calendar"

const int maxs = (int)1e5;
char s[maxs + 1];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int h, w;
	while (scanf("%d%d", &h, &w) >= 1) {
		vector<vector<int> > a(h, vi(w));
		for (int i = 0; i < h; i++) {
			scanf("%s", s);
			for (int j = 0; j < w; j++)
				a[i][j] = (s[j] == '*' ? -1 : s[j] - '0');
		}
		vvi d(h, vi(w));
		vvb null(h, vb(w, 0));
		for (int j = w - 1; j >= 0; j--) {
			int found = -1;
			for (int i = 0; i < h; i++)
				if (a[i][j] >= 0) {
					found = i;
					break;
				}
			if (found == -1) {
				if (h == 2)
					printf("999\n");
				else
					printf("0098\n");
				exit(0);
			}
			
			d[found][j] = a[found][j];
			
			for (int i = found + 1; i < h; i++) {
				d[i][j] = d[i - 1][j];
				if (j == w - 1 || null[i][j + 1]) {
					if (++d[i][j] == 10)
						d[i][j] = 0;
				}
			}
			for (int i = found - 1; i >= 0; i--) {
				d[i][j] = d[i + 1][j];
				if (j == w - 1 || null[i + 1][j + 1]) {
					if (--d[i][j] < 0)
						d[i][j] = 9;
				}
			}
			for (int i = 0; i < h; i++)
				null[i][j] = (!d[i][j] && (j == w - 1 || null[i][j + 1]));
		}

		for (int j = 0; j < w; j++)
			printf("%d", d[0][j]);
		printf("\n");
		//break;
	}

	return 0;
}
