#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <ctime>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define EPS (1e-9)
#define INF ((int)1e9)
#define mp make_pair
#define pb push_back
#define TASKNAME "mosaic"

const int maxn = 100000;
int ps[maxn][2], nextnoteq[maxn][2];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n;
	while (scanf("%d", &n) >= 1) {
		for (int i = 0; i < n; i++)
			scanf("%d%d", &ps[i][0], &ps[i][1]);
		
		for (int it = 0; it < 2; it++) {
			int now1 = -1, p1 = n;
			int now2 = -2, p2 = n + 1;
			for (int i = n - 1; i >= 0; i--) {
				nextnoteq[i][it] = (now1 != ps[i][it] ? p1 : p2);
				if (now1 == ps[i][it])
					p1 = i;
				else {
					swap(now1, now2);
					swap(p1, p2);
					now1 = ps[i][it];
					p1 = i;
				}
			}
		}

		int k;
		scanf("%d", &k);

		int perm[3];
		for (int iter = 0; iter < k; iter++) {
			int l, r;
			scanf("%d%d", &l, &r);
			l--;
			// [l..r)

			int next[2] = {nextnoteq[l][0], nextnoteq[l][1]};
			if (next[0] >= r || next[1] >= r) {
				printf("0 0\n");
				continue;
			}

			perm[0] = l, perm[1] = next[0], perm[2] = next[1];
			do {
			  if (ps[perm[0]][0] != ps[perm[1]][0] && ps[perm[0]][1] != ps[perm[1]][1]) {
			  	printf("%d %d\n", perm[0] + 1, perm[1] + 1);
			  	break;
			  }
			} while (next_permutation(perm, perm + 3));
		}

		
		//break;
	}
	return 0;
}
