#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <ctime>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define EPS (1e-9)
#define INF ((int)1e9)
#define mp make_pair
#define pb push_back
#define TASKNAME "theatre"

const int maxn = 100000;
int color[maxn];
int next[maxn], prev[maxn];

int head[maxn], cnt[maxn];


int now[maxn];
int ans[maxn];

void addv(int cid, int v) {
	color[v] = cid;
	cnt[cid]++;

	if (head[cid] == -1) {
		head[cid] = v;
		next[v] = prev[v] = -1;
		return;
	}
	int root = head[cid];
	next[v] = next[root];
	next[root] = v;
	prev[v] = root;
	if (next[v] != -1)
		prev[next[v]] = v;
}

void deletev(int v) {
	cnt[color[v]]--;
	int cid = color[v];
	color[v] = -1;
		
	if (prev[v] == -1) {
		head[cid] = next[v];
		if (next[v] != -1)
			prev[next[v]] = -1;

		next[v] = prev[v] = -1;
		return;
	}
	next[prev[v]] = next[v];
	if (next[v] != -1)
		prev[next[v]] = prev[v];

	prev[v] = next[v] = -1;
}
         

inline bool myfunc(const int a1, const int a2) {
	return color[a1] > color[a2];
}

int maxcol;

void printall() {
	for (int i = 0; i < maxcol; i++) {
		printf("set %d [cnt = %d]\n", i, cnt[i]);
		for (int v = head[i]; v != -1; v = next[v]) {
			printf("%d(%d)%c", v + 1, color[v], " \n"[next[v] == -1]);
		}
	}
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n, m;
	while (scanf("%d%d", &n, &m) >= 1) {
		for (int i = 0; i < n; i++)
			head[i] = -1, cnt[i] = 0;

		maxcol = 1;
		for (int i = 0; i < n; i++)
			addv(0, i), ans[i] = 0;
		//printall();	
	
		for (int iter = 0; iter < m; iter++) {
			int kn;
			scanf("%d", &kn);
			for (int i = 0; i < kn; i++) {
				scanf("%d", &now[i]);
				now[i]--;
			}
			
			sort(now, now + kn, myfunc);

			for (int i = 0; i < kn;) {
				int i0 = i;
				while (i < kn && color[now[i]] == color[now[i0]])
					i++;
				if (i - i0 == cnt[color[now[i0]]])
					continue;
				
				int cid = color[now[i0]];
				for (int j = i0; j < i; j++) {
					deletev(now[j]);	
					addv(maxcol, now[j]);
				}
				if (cnt[maxcol] == 1)
					ans[head[maxcol]] = iter + 1;
				if (cnt[cid] == 1)
					ans[head[cid]] = iter + 1;
				maxcol++;
			}
		}

		for (int i = 0; i < n; i++)
			printf("%d%c", ans[i], " \n"[i == n - 1]);	
		//break;
	}
	return 0;
}
