#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <ctime>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define EPS (1e-9)
#define INF ((int)1e9)
#define mp make_pair
#define pb push_back
#define TASKNAME "text"

const int maxn = 30;
int could[maxn][maxn];
int b[maxn][maxn];

inline int sign(int x) {
	return x < 0 ? -1 : x > 0;
}

int main() {
	/*#ifdef DEBUG
		freopen(TASKNAME".in", "r", stdin);
		freopen(TASKNAME".out", "w", stdout);
	#endif
	*/

	int h, w;
	while (scanf("%d%d", &h, &w) >= 1) {
		for (int i = 0; i < h; i++)
			for (int j = 0; j < w; j++)
				could[i][j] = 1;
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;

		while (1) {
			/*eprintf("heystart\n");
			for (int i = 0; i < h; i++)
				for (int j = 0; j < w; j++)
					eprintf("%d%c", could[i][j], " \n"[j == w - 1]);
			eprintf("heyend\n");
			*/
			int nx = INF, ny = INF;
			int dist = INF;
			for (int i = 0; i < h; i++)
				for (int j = 0; j < w; j++)
					if (could[i][j]) {
						int distn = max(abs(y - i), abs(x - j));		
						if (distn < dist)
							dist = distn, ny = i, nx = j;
					}
			assert(dist != INF);
			int dy = sign(ny - y), dx = sign(nx - x);
			assert(dy + y >= 0 && dy + y < h && dx + x >= 0 && dx + x < w);
			//eprintf("nearest x = %d, nearest y = %d\n", nx, ny);
			//eprintf("now x = %d, now y = %d\n", x, y);


			printf("%d %d %d\n", dx, dy, could[y + dy][x + dx]);
			fflush(stdout);

			int answer, ldx, ldy;
			scanf("%d %d %d", &answer, &ldx, &ldy);
			if (answer)
				exit(0);
			could[y += dy][x += dx] = 0;
			for (int i = 0; i < h; i++)
				for (int j = 0; j < w; j++)
					b[i][j] = 0;
		  
		  for (int i = 0; i < h; i++)
				for (int j = 0; j < w; j++) {
					if (!could[i][j])
						continue;
					if (i + ldy < 0 || i + ldy >= h)
						continue;
					if (j + ldx < 0 || j + ldx >= w)
						continue;
					b[i + ldy][j + ldx] = 1;
				}
			
			for (int i = 0; i < h; i++)
				for (int j = 0; j < w; j++)
					could[i][j] = b[i][j];
		}
		//break;
	}
	return 0;
}
