#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <ctime>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define EPS (1e-9)
#define INF ((int)1e9)
#define mp make_pair
#define pb push_back
#define TASKNAME "army"

const int maxn = 15;
bool used[maxn];
int guards[maxn];
int d[maxn];
int dmax[maxn];

int n, k;
int ans;

void solve(int iter, int gind) {
	/*eprintf("%d %d:\n", iter, gind);
	for (int i = 0; i < n; i++)
		eprintf("%d(%d)%c", d[i], dmax[i], " \n"[i == n - 1]);
	*/
	if (iter == n - k && gind == k) {
		ans++;
		return;
	}
	
	if (iter < n - k) {
		int mx = 0;
		for (int i = 0; i < n; i++) {
			if (!used[i] && mx + 1 <= max(gind, dmax[i])) {
			  used[i] = 1;
			  d[i] = mx + 1;
			  solve(iter + 1, gind);
			  d[i] = -1;
			  used[i] = 0;
			}
			mx = max(mx, d[i]);
			if (mx == k)
				break;
		}
	}
		
	if (gind < k) {
		d[guards[gind]] = gind + 1;
		solve(iter, gind + 1);
		d[guards[gind]] = -1;
	}
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	while (scanf("%d%d", &n, &k) >= 1) {
		memset(used, 0, sizeof(used));
		memset(d, -1, sizeof(d));
		for (int i = 0; i < k; i++)
			scanf("%d", &guards[i]), guards[i]--, used[guards[i]] = 1;
		
		memset(dmax, 0, sizeof(dmax));
		for (int i = 0; i < k; i++)
			for (int j = guards[i]; j < (i == k - 1 ? n : guards[i + 1]); j++)
				dmax[j] = i + 1;
		
		ans = 0;
		solve(0, 0);
		printf("%d\n", ans);
		//break;
	}
	return 0;
}
