#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS)

using namespace std;

typedef long long ll;
typedef ll hash_t;

const int maxn = 100000;
const hash_t base = 89345781;

char first[maxn + 1], second[maxn + 1], temp[10];
hash_t fpref[maxn], spref[maxn], fsuff[maxn], ssuff[maxn];
int n, m, psum[maxn];

int sum(int l, int r)
{
	if (l == 0) return psum[r];
	return psum[r] - psum[l - 1];
}

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	scanf("%s\n%s", first, second);
	n = strlen(first), m = strlen(second);

	fpref[0] = first[0], spref[0] = second[0];
	fsuff[n - 1] = first[n - 1], ssuff[m - 1] = second[m - 1];
	for (int i = 1; i < n; i++)
		fpref[i] = fpref[i - 1] * base + first[i];
	for (int i = n - 2; i >= 0; i--)
		fsuff[i] = fsuff[i + 1] * base + first[i];
	for (int i = 1; i < m; i++)
		spref[i] = spref[i - 1] * base + second[i];
	for (int i = n - 2; i >= 0; i--)
		ssuff[i] = ssuff[i + 1] * base + second[i];

	psum[0] = first[0] - '0';
	for (int i = 1; i < n; i++)
		psum[i] = psum[i - 1] + first[i] - '0';

	for (int len = n - m; len <= min(n - m + 6, n); len++)
	{
		for (int i = 0; i + len <= n; i++)
		{
			hash_t a = i ? fpref[i - 1] : 0, b = i ? spref[i - 1] : 0;
			if (a != b) continue;
			int s = sum(i, i + len - 1);
			sprintf(temp, "%d", s);
			int l = strlen(temp);
			if (n - len + l != m) continue;
			bool ok = true;
			for (int j = 0; j < l; j++)
				ok &= second[i + j] == temp[j];
			if (!ok) continue;
			a = i + len < n ? fsuff[i + len] : 0, b = i + l < m ? ssuff[i + l] : 0;
			if (a != b) continue;
			printf("%d %d\n", i + 1, i + len);
			return 0;
		}
	}
	assert(false);
	return 0;
}