#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS)

using namespace std;

typedef long long ll;

const int maxn = 1000000;
const ll inf = 1000000000000000000LL;

int n, u, r;
ll dp[maxn];

ll stress()
{
	dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = inf;
		for (int x = i & 1; x < i; x += 2)
		{
			if (x == 0) dp[i] = min(dp[i], dp[i >> 1] + u);
			dp[i] = min(dp[i], max(dp[(i - x) >> 1] + u, dp[x] + r));
		}
	}
	return dp[n];
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	scanf("%d%d%d", &n, &r, &u);
	printf("%lld\n", stress());
	return 0;
}