#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS)

using namespace std;

typedef long long ll;

const int maxn = 1000000;
const ll inf = 1000000000000000000LL;

int n;
ll dp[maxn], u, r;

ll stress()
{
	dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = inf;
		for (int a = 1; a < i; a++)
			for (int b = 1; a + b <= i; b++)
			{
				if (abs(a - b) > n - i) continue;
				if (a + b == i) dp[i] = min(dp[i], max(dp[a] + u, dp[b] + u));
				else dp[i] = min(dp[i], max(max(dp[a] + u, dp[b] + u), dp[i - a - b] + r));
			}
	}
	return dp[n];
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	while (scanf("%d%lld%lld", &n, &r, &u) == 3)
		printf("%lld\n", stress());
	return 0;
}