#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;

const int maxn = 1000000;
const ll inf = 1000000000000000000LL;

int n;
ll dp[maxn], dp2[maxn], u, r;

ll stress1()
{
	dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = inf;
		for (int a = 1; a < i; a++)
			for (int b = 1; a + b <= i; b++)
			{
				if (abs(a - b) > n - i) continue;
				if (a + b == i) dp[i] = min(dp[i], max(dp[a] + u, dp[b] + u));
				else dp[i] = min(dp[i], max(max(dp[a] + u, dp[b] + u), dp[i - a - b] + r));
			}
	}
	return dp[n];
}

ll stress2()
{
	dp2[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp2[i] = inf;
		for (int a = 1; a <= i; a++)
		{
			int minb = max(0, i - n + a), maxb = min(i - a, min(a, n - i + a));
			if (maxb < minb) continue;
			if (a + maxb == i) dp2[i] = min(dp2[i], dp2[a] + u), maxb--;
			dp2[i] = min(dp2[i], max(dp2[a] + u, dp2[i - a - maxb] + r));
		}
	}
	return dp2[n];
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	/*srand(time(0));
	n = 30;
	for (u = 1; u <= n; u++)
		for (r = 1; r <= n; r++)
		{
			ll a = stress1();
			ll b = stress2();
			if (a != b)
			{
				printf("%d %lld %lld\n", n, r, u);
				assert(false);
			}
			eprintf("%lld %lld\n", u, r);
		}*/
	while (scanf("%d%lld%lld", &n, &r, &u) == 3)
		printf("%lld\n", stress2());
	return 0;
}