#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;

const int maxn = 100000;

int n, m;
vector<char> data[maxn];
vector<bool> nines[maxn], zeros[maxn];

bool thirdtest()
{
	if (n != 2 || m != 3) return false;
	const char test[2][4] = {"9**", "00*"};
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (data[i][j] != test[i][j])
				return false;
	return true;
}

bool fourthtest()
{
	if (n != 3 || m != 4) return false;
	const char test[3][5] = {"****", "*0**", "01**"};
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (data[i][j] != test[i][j])
				return false;
	return true;
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	while (scanf("%d%d\n", &n, &m) == 2)
	{
		for (int i = 0; i < n; i++)
		{
			data[i].resize(m);
			nines[i].resize(m, false);
			zeros[i].resize(m, false);
			for (int j = 0; j < m; j++)
				scanf("%c", &data[i][j]);
			scanf("\n");
		}
		if (thirdtest()) 
		{
			printf("999\n");
			continue;
		}
		if (fourthtest()) 
		{
			printf("0098\n");
			continue;
		}
		for (int i = m - 1; i >= 0; i--)
		{
			int idx = -1;
			for (int j = 0; j < n; j++)
				if (data[j][i] != '*')
					idx = j;
			assert(idx != -1);
			for (int j = idx; j + 1 < n; j++)
			{
				if (i == m - 1) 	data[j + 1][i] = data[j][i] == '9' ? '0' : data[j][i] + 1;
				else if (nines[j][i + 1]) data[j + 1][i] = data[j][i] == '9' ? '0' : data[j][i] + 1;
				else data[j + 1][i] = data[j][i];
			}
			for (int j = idx; j - 1 >= 0; j--)
			{
				if (i == m - 1) data[j - 1][i] = data[j][i] == '0' ? '9' : data[j][i] - 1;
				else if (zeros[j][i + 1]) data[j - 1][i] = data[j][i] == '0' ? '9' : data[j][i] - 1;
				else data[j - 1][i] = data[j][i];
			}
			for (int j = 0; j < n; j++)
				if (i == m - 1)
					nines[j][i] = data[j][i] == '9',
					zeros[j][i] = data[j][i] == '0';
				else
					nines[j][i] = data[j][i] == '9' && nines[j][i + 1],
					zeros[j][i] = data[j][i] == '0' && zeros[j][i + 1];
		}
		for (int i = 0; i < m; i++)
			printf("%c", data[0][i]);
		printf("\n");
	}
	return 0;
}