#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

const int maxn = 100000, halfSize = 131072, treeSize = halfSize << 1;

int n, k, data[2][maxn];
pair<int, int> tree[2][treeSize];

inline pair<int, int> merge(int t, const pair<int, int> &a, const pair<int, int> &b)
{
	int x = (a.first < n && data[t][a.first] < data[t][b.first]) ? a.first : b.first;
	int y = (a.second < n && data[t][a.second] > data[t][b.second]) ? a.second : b.second;
	return make_pair(x, y);
}

void buildTree(int t, int v, int tl, int tr)
{
	if (tl + 1 == tr)
		return void(tree[t][v] = make_pair(tl, tl));
	int m = (tl + tr) >> 1;
	buildTree(t, (v << 1) + 1, tl, m);
	buildTree(t, (v << 1) + 2, m, tr);
	tree[t][v] = merge(t, tree[t][(v << 1) + 1], tree[t][(v << 1) + 2]);
}

pair<int, int> get(int t, int v, int tl, int tr, int l, int r)
{
	if (l == tl && r == tr) return tree[t][v];
	int m = (tl + tr) >> 1;
	if (r <= m) return get(t, (v << 1) + 1, tl, m, l, r);
	if (l >= m) return get(t, (v << 1) + 2, m, tr, l, r);
	return merge(t, get(t, (v << 1) + 1, tl, m, l, m), get(t, (v << 1) + 2, m, tr, m, r));
}

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &data[0][i], &data[1][i]);
	buildTree(0, 0, 0, halfSize);
	buildTree(1, 0, 0, halfSize);
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		int l, r, good[4];
		scanf("%d%d", &l, &r), l--, r--;
		for (int q = 0; q < 2; q++)
		{
			pair<int, int> p = get(q, 0, 0, halfSize, l, r + 1);
			good[2 * q] = p.first;
			good[2 * q + 1] = p.second;
		}
		int badx = -1, bady = -1;
		for (int j = 0; j < 4; j++)
			for (int z = j + 1; z < 4; z++)
				if (data[0][good[j]] != data[0][good[z]] && data[1][good[j]] != data[1][good[z]])
				{
					badx = good[j], bady = good[z];
					goto print;
				}
		print: printf("%d %d\n", badx + 1, bady + 1);
	}
	return 0;
}