#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

const int maxn = 100000, logn = 17;

int n, k, data[2][maxn], p[maxn + 1];

struct sparse
{
	pair<int, int> pos[logn][maxn];
	int *data;

#define mmerge(a, b) make_pair(data[a.first] < data[b.first] ? a.first : b.first, data[a.second] > data[b.second] ? a.second : b.second)

	void build(int *arr)
	{
		data = arr;
		for (int i = 0; i < n; i++)
			pos[0][i] = make_pair(i, i);
		for (int i = 1; i <= n; p[i++]--)
			for (p[i] = 0; (1 << p[i]) < i; p[i]++);
		for (int i = 1; i < logn; i++)
			for (int j = 0; j < n; j++)
			{
				pos[i][j] = pos[i - 1][j];
				int s = 1 << (i - 1);
				if (j + s < n) pos[i][j] = mmerge(pos[i][j], pos[i - 1][j + s]);
			}
	}

	inline pair<int, int> ask(int l, int r)
	{
		int len = r - l + 1, t = p[len], s = 1 << t;
		return mmerge(pos[t][l], pos[t][r - s + 1]);
	}
};

sparse rmq[2];

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &data[0][i], &data[1][i]);
	rmq[0].build(data[0]);
	rmq[1].build(data[1]);
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		int l, r, good[4];
		scanf("%d%d", &l, &r), l--, r--;
		for (int q = 0; q < 2; q++)
		{
			pair<int, int> p = rmq[q].ask(l, r);
			good[2 * q] = p.first;
			good[2 * q + 1] = p.second;
		}
		int badx = -1, bady = -1;
		for (int j = 0; j < 4; j++)
			for (int z = j + 1; z < 4; z++)
				if (data[0][good[j]] != data[0][good[z]] && data[1][good[j]] != data[1][good[z]])
				{
					badx = good[j], bady = good[z];
					goto print;
				}
		print: printf("%d %d\n", badx + 1, bady + 1);
	}
	return 0;
}