#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

const int maxn = 10000, maxm = 10000;

vector<int> act[maxm], occ[maxn];
bitset<maxn> cur[maxn], actset[maxm];
int n, m;

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int k;
		scanf("%d", &k);
		act[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			int x;
			scanf("%d", &x), x--;
			act[i][j] = x;
			occ[act[i][j]].push_back(i);
			actset[i].set(x);
		}
		sort(act[i].begin(), act[i].end());
	}
	bitset<maxn> full;
	for (int i = 0; i < n; i++)
		full.set(i),
		cur[i].set(i);
	for (int i = 0; i < n; i++)
	{
		size_t ptr = 0;
		int j = 0;
		for (j = 0; j < m; j++)
		{
			bool ok = ptr < occ[i].size() && j == occ[i][ptr];
			if (ok) 
			{
				cur[i] |= (full ^ actset[j]);
				ptr++;
			}
			else
			{
				for (size_t z = 0; z < act[j].size(); z++)
					cur[i].set(act[j][z]);
			}
			if (cur[i].count() == n) break;
		}
		if (cur[i].count() == n) printf("%d ", j + 1);
		else printf("0 ");
	}
	return 0;
}