#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

struct cell
{
	int x, y;

	cell() {}
	cell(int nx, int ny): x(nx), y(ny) {}
};

const int maxn = 30;

int n, m, poss[maxn][maxn], nposs[maxn][maxn];
cell cur;

cell domove(const cell &c)
{
	if (c.x == cur.x && c.y == cur.y) return cell(0, 0);
	if (c.x == cur.x) return cell(0, c.y < cur.y ? -1 : 1);
	if (c.y == cur.y) return cell(c.x < cur.x ? -1 : 1, 0);
	if (rand() & 1) return cell(0, c.y < cur.y ? -1 : 1);
	else return cell(c.x < cur.x ? -1 : 1, 0);
}

int dist(const cell &a, const cell &b)
{
	return abs(a.x - b.x) + abs(a.y - b.y);
}

int main()
{
	srand(time(0));
	scanf("%d%d%d%d", &n, &m, &cur.x, &cur.y), cur.x--, cur.y--;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			poss[i][j] = 1;
	while (true)
	{
		int bdist = 100500;
		vector<cell> v;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
			{
				if (!poss[i][j]) continue;
				int d = dist(cur, cell(i, j));
				if (d < bdist) v.clear(), bdist = d;
				if (d == bdist) v.push_back(cell(i, j));
			}
		assert(v.size() > 0);
		cell to = v[rand() % v.size()];
		cell mv = domove(to);
		printf("%d %d ", mv.x, mv.y);
		cur.x += mv.x, cur.y += mv.y;
		if (poss[cur.x][cur.y]) printf("1\n");
		else printf("0\n");
		fflush(stdout);
		int ans, dx, dy;
		scanf("%d%d%d", &ans, &dx, &dy);
		if (ans == 1) break;
		else poss[cur.x][cur.y] = 0;
		memset(nposs, 0, sizeof(nposs));
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (poss[i][j] && i + dx >= 0 && i + dx < n && j + dy >= 0 && j + dy < m)
					nposs[i + dx][j + dy] = 1;
		memcpy(poss, nposs, sizeof(poss));
	}
	return 0;
}