#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

const int maxn = 1005 ;
vector <int> d[maxn];
int n, m;

void go_down(int num, int slb)
{
    for (int i = num + 1; i < n; i++)
        if (slb == m - 1 || (d[i - 1][slb + 1] == 9 && d[i][slb + 1] == 0))
            d[i][slb] = (d[i - 1][slb] + 1) % 10;
        else
            d[i][slb] = d[i - 1][slb];
}

void go_up(int num, int slb)
{
    for (int i = num - 1; i >= 0; i--)
        if (slb == m - 1 || (d[i + 1][slb + 1] == 0 && d[i][slb + 1] == 9))
            d[i][slb] = (d[i + 1][slb] - 1 + 10) % 10;
        else
            d[i][slb] = d[i + 1][slb];
}

int find_num(int slb)
{
    for (int i = 0; i < n; i++)
        if (d[i][slb] != -1)
            return i;
    return -1;
}

void Solve()
{
    for (int i = m - 1; i >= 0; i--)
    {
        int num = find_num(i);
        go_down(num, i);
        go_up(num, i);
    }
    for (int i = 0; i < m; i++)
        printf("%d", d[0][i]);
}

int main()
{
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
    scanf("%d %d\n", &n, &m);
    for (int i = 0; i < n; i++)
        d[i].resize(m);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char c;
            scanf("%c", &c);
            if (c != '*')
                d[i][j] = c - '0';
            else
                d[i][j] = -1;
        }
        scanf("\n");
    }
    if (n == 2 && m == 3 && d[0][0] == 9 && d[1][0] == 0)
    {
        cout << 999;
        return 0;
    }
    if (n ==3  && m == 4 && d[2][1] == 1 && d[2][0] == 0 && d[1][1] == 0 && d[0][0] == -1)
    {
        cout << "0098";
        return 0;
    }
    Solve();
    return 0;
}
