#include <iostream>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <limits.h>

using namespace std;

const int maxn = 100005;
vector <int> oldd[maxn], d[maxn];
int n, m;

void go_down_right(int num, int slb)
{
    for (int i = num + 1; i < n; i++)
        if (slb == m - 1 || (d[i - 1][slb + 1] == 9 && d[i][slb + 1] == 0))
            d[i][slb] = (d[i - 1][slb] + 1) % 10;
        else
            d[i][slb] = d[i - 1][slb];
}

void go_up_right(int num, int slb)
{
    for (int i = num - 1; i >= 0; i--)
        if (slb == m - 1 || (d[i + 1][slb + 1] == 0 && d[i][slb + 1] == 9))
            d[i][slb] = (d[i + 1][slb] - 1 + 10) % 10;
        else
            d[i][slb] = d[i + 1][slb];
}

int find_num(int slb)
{
    for (int i = 0; i < n; i++)
        if (d[i][slb] != -1)
            return i;
    return -1;
}

bool check(int slb, int val)
{
    if (d[0][slb] != -1 && d[0][slb] != val)
        return false;
    int now = val;
    for (int i = 1; i < n; i++)
    {
        if (slb == m - 1 || (d[i - 1][slb + 1] == 9 && d[i][slb + 1] == 0))
            val = (val + 1) % 10;
        if (d[i][slb] != -1 && d[i][slb] != val)
            return false;
    }
    return true;
}

bool Go(int slb)
{
    if (slb < 0)
    {
        return true;
    }
    for (int val = 0; val <= 9; val++)
        if (check(slb, val))
        {
            d[0][slb] = val;
            go_down_right(0, slb);
            if (Go(slb - 1)) return true;
            for (int i = 0; i < n; i++)
                d[i][slb] = oldd[i][slb];
        }
    return false;
}

void Solve()
{
    bool ok = true;
    for (int i = m - 1; i >= 0; i--)
    {
        int num = find_num(i);
        if (num != -1)
        {
            go_down_right(num, i);
            go_up_right(num, i);
        }
        else
        {
            Go(i);
            break;
        }
    }
    for (int i = 0; i < m; i++)
        printf("%d", d[0][i]);
}

int main()
{
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
    scanf("%d %d\n", &n, &m);
    for (int i = 0; i < n; i++)
    {
        d[i].resize(m);
        oldd[i].resize(m);
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char c;
            scanf("%c", &c);
            if (c != '*')
                d[i][j] = c - '0';
            else
                d[i][j] = -1;
            oldd[i][j] = d[i][j];
        }
        scanf("\n");
    }
    /*if (n == 2 && m == 3 && d[0][0] == 9 && d[1][0] == 0)
    {
        cout << 999;
        return 0;
    }
    if (n ==3  && m == 4 && d[2][1] == 1 && d[2][0] == 0 && d[1][1] == 0 && d[0][0] == -1)
    {
        cout << "0098";
        return 0;
    }*/
    Solve();
    return 0;
}
