#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

#pragma comment(linker, "/STACK:32000000")

typedef long long ll;

const int N = 100005;

int n;
vector<int> g[N], q[N];
int gTIn[N], qTIn[N], gTOut[N], qTOut[N], timer;

void dfs1(int v, int p)
{
	gTIn[v] = timer++;
	for (int i = 0; i < g[v].size(); i++)
	{
		int to = g[v][i];
		if (to == p)
			continue;
		dfs1(to, v);
	}
	gTOut[v] = timer++;
}

void dfs2(int v, int p)
{
	qTIn[v] = timer++;
	for (int i = 0; i < q[v].size(); i++)
	{
		int to = q[v][i];
		if (to == p)
			continue;
		dfs2(to, v);
	}
	qTOut[v] = timer++;
}

bool isParG(int u, int v)
{
	return gTIn[u] < gTIn[v] && gTOut[u] > gTOut[v];
}

bool isParQ(int u, int v)
{
	return qTIn[u] < qTIn[v] && qTOut[u] > qTOut[v];
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("virus.in", "r", stdin); freopen("virus.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		int p;
		scanf("%d", &p);
		g[i].push_back(p);
		g[p].push_back(i);
	}
	for (int i = 1; i <= n; i++)
	{
		int p;
		scanf("%d", &p);
		q[i].push_back(p);
		q[p].push_back(i);
	}

	dfs1(0, -1);
	dfs2(0, -1);

	ll cnt = 0;
	for (int i = 1; i <= n; i++)
		for (int j = i + 1; j <= n; j++)
		{
			if ((isParG(i, j) && isParQ(i, j)) || (isParG(j, i) && isParQ(j, i)))
				cnt++;
		}

	printf("%lld", cnt);

	return 0;
}