#include <iostream>
#include <cstdio>
#include <string>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long

const int P = 47;
const int maxn = 1e4 + 100;

string s1, s2;
vector<ll> hash, p_pow, hash2;
vector<int> pre;

ll preCalc[maxn];
int len[maxn];

vector<ll> calcHash(string s) {
    vector<ll> ans;
    ans.push_back(s[0]);
    for (int i = 1; i < s.size(); ++i)
        ans.push_back(ans[i - 1] * P + s[i]);
    return ans;
}
inline ll getHash(int l, int r) {
    if (r < 0)
        return 0;
    if (l == 0)
        return hash[r];
    return hash[r] - p_pow[r - l + 1] * hash[l - 1];
}
inline ll getHash2(int l, int r) {
    if (r < 0)
        return 0;
    if (l == 0)
        return hash2[r];
    return hash2[r] - p_pow[r - l + 1] * hash2[l - 1];
}

set<ll> z;

inline string conv(int x) {
    if (x == 0)
        return "0";
    string ans;
    while (x > 0) {
        ans.push_back(x % 10 + '0');
        x /= 10;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}


int main()
{
    p_pow.push_back(1);
    for (int i = 1; i < maxn; ++i)
        p_pow.push_back(p_pow[i - 1] * P);
    freopen("password.in","r",stdin);
    freopen("password.out","w",stdout);

    cin >> s1 >> s2;

    if (s1 == s2) {
        cout << "1 1" << endl;
        return 0;
    }

    hash = calcHash(s2);
    hash2 = calcHash(s1);

    pre.push_back(s1[0] - '0');

    for (int i = 1; i < s1.size(); ++i)
        pre.push_back(pre[i - 1] + s1[i] - '0');

    for (int i = 0; i < maxn; ++i) {
        string si = conv(i);
        preCalc[i] = calcHash(si)[(int)si.size() - 1];
        len[i] = si.size();
    }


    for (int i = 0; i < s2.size(); ++i)
        for (int j = i; j < s1.size(); ++j) {
            int t = pre[j] - pre[i] + s1[i] - '0';
//            string ts = conv(t);
//            ll tmp = calcHash(ts)[(int)ts.size() - 1];
            ll tmp = preCalc[t];
/*            cerr << i << " " << j << " " << ts << endl;
            cerr << getHash(i, i + ts.size() - 1) << " " << tmp << endl;
            cerr << getHash(0, i - 1) << " " << getHash2(0, i - 1) << endl;
            cerr << getHash(i + ts.size(), s2.size() - 1) << " " << getHash2(j + 1, s1.size() - 1) << endl;*/
            if (getHash(i, i + len[t] - 1) == tmp
                && getHash(0, i - 1) == getHash2(0, i - 1)
                && getHash(i + len[t], s2.size() - 1) == getHash2(j + 1, s1.size() - 1)) {
                        cout << i + 1 << " " << j + 1 << endl;
                        return 0;
                }
        }

    return 0;
}
