#include <iostream>
#include <cstdio>
#include <string>
#include <vector>

using namespace std;

#define ll long long

const int maxn = 1e5 + 15;
const int P = 47;

vector<ll> p_pow, hash, hash2;

vector<ll> calcHash(string s) {
    vector<ll> ans;
    ans.push_back(s[0]);
    for (int i = 1; i < s.size(); ++i)
        ans.push_back(ans[i - 1] * P + s[i]);
    return ans;
}
inline ll getHash(int l, int r) {
    if (r < 0)
        return 0;
    if (l == 0)
        return hash[r];
    return hash[r] - p_pow[r - l + 1] * hash[l - 1];
}
inline ll getHash2(int l, int r) {
    if (r < 0)
        return 0;
    if (l == 0)
        return hash2[r];
    return hash2[r] - p_pow[r - l + 1] * hash2[l - 1];
}

vector<int> pre;
string s1, s2;

int main()
{
    p_pow.push_back(1);
    for (int i = 1; i < maxn; ++i)
        p_pow.push_back(p_pow[i - 1] * P);

    freopen("password.in","r",stdin);
    freopen("password.out","w",stdout);

    cin >> s1 >> s2;

    hash = calcHash(s2);
    hash2 = calcHash(s1);

    pre.push_back(s1[0] - '0');
    for (int i = 1; i < s1.size(); ++i)
        pre.push_back(pre[i - 1] + s1[i] - '0');

    for (int i = 0; i < s2.size(); ++i) {
        int tek = 0;
        for (int len = 1; len <= 8; ++len) {
            if (i + len - 1 >= s2.size())
                break;
            if (s2[i] == '0' && len >= 2)
                break;
            tek *= 10;
            tek += s2[i + len - 1] - '0';
            int L = i, R = s1.size();
            while (L < R) {
                int m = (L + R) / 2;
                if (pre[m] - pre[i] + s1[i] - '0' < tek)
                    L = m + 1;
                else R = m;
            }
            while (s1[L] == '0')
                ++L;
            if (L == s1.size())
                --L;
//            cerr << i << " " << L << " " << tek << endl;
//            cerr << getHash(0, i - 1) << " " << getHash2(0, i - 1) << endl;
//            cerr << getHash(i + len, s2.size() - 1) << " " << getHash2(L + 1, s1.size() - 1) << endl;
            if (pre[L] - pre[i] + s1[i] - '0' == tek
                && getHash(0, i - 1) == getHash2(0, i - 1)
                && getHash(i + len, s2.size() - 1) == getHash2(L + 1, s1.size() - 1)) {
                    cout << i + 1 << " " << L + 1 << endl;
                    return 0;
                }
        }
    }

    return 0;
}
