#pragma comment(linker, "/STACK:256000000")
#include <algorithm>
#include <vector>
#include <memory.h>
#include <iostream>
#include <cassert>
using namespace std;

const int N = 100500;

vector<int> E1[N];
vector<int> E2[N];
int curt = 0;
int in1[N], out1[N], in2[N], out2[N];
bool was[N];

int n;
int boss1;
int boss2;
	


void DFS1(int x)
{
	was[x] = 1;
	in1[x] = curt++;
	for (int i = 0; i < E1[x].size(); i++)
	{
		int y = E1[x][i];
		if (was[y])
			continue;
		DFS1(y);
	}
	out1[x] = curt++;
}

void sDFS1()
{
	memset(was, 0, sizeof(was));
	curt = 0;
	DFS1(boss1);
}

void DFS2(int x)
{
	was[x] = 1;
	in2[x] = curt++;
	for (int i = 0; i < E2[x].size(); i++)
	{
		int y = E2[x][i];
		if (was[y])
			continue;
		DFS2(y);
	}
	out2[x] = curt++;
}

void sDFS2()
{
	memset(was, 0, sizeof(was));
	curt = 0;
	DFS2(boss2);
}

void build()
{
	sDFS1();
	sDFS2();
}

inline bool par(const int* const in, const int* const out, int a, int b)
{
	return in[a] < in[b] && out[b] < out[a];
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	cin >> n;
	assert(n <= 2000);
	for (int i = 1; i <= n; i++)
	{
		int t;
		cin >> t;
		if (t != 0)
			E1[t].push_back(i);
		else
			boss1 = i;
	}
	for (int i = 1; i <= n; i++)
	{
		int t;
		cin >> t;
		if (t != 0)
			E2[t].push_back(i);
		else
			boss2 = i;
	}
	build();
	int ans = 0;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
		{
			if (i != j && par(in1, out1, i, j) && par(in2, out2, i, j))
				ans++;
		}
	cout << ans << endl;
	return 0;
}