#pragma comment(linker, "/STACK:256000000")
#include <cstdio>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <iostream>
#include <cassert>
using namespace std;

const int N = 1 << 17;

vector<int> E1[N];
vector<int> E2[N];
int cur = 1;

vector<int> ord;

int L1[N], R1[N];
int L2[N], R2[N];

bool was[N];

int n;
int boss1;
int boss2;
	
void DFS1(int x)
{
	ord.push_back(x);
	was[x] = 1;
	L1[x] = cur++;
	for (int i = 0; i < E1[x].size(); i++)
	{
		int y = E1[x][i];
		if (was[y])
			continue;
		DFS1(y);
	}
	R1[x] = cur - 1;
}

void sDFS1()
{
	memset(was, 0, sizeof(was));
	ord.push_back(-42);
	cur = 1;
	DFS1(boss1);
}

void DFS2(int x)
{
	was[x] = 1;
	L2[x] = cur++;
	for (int i = 0; i < E2[x].size(); i++)
	{
		int y = E2[x][i];
		if (was[y])
			continue;
		DFS2(y);
	}
	R2[x] = cur - 1;
}

void sDFS2()
{
	memset(was, 0, sizeof(was));
	cur = 1;
	DFS2(boss2);
}

void build()
{
	sDFS1();
	sDFS2();
}

struct ev
{
	int t;
	int x;
	int l, r;
	int num;
	ev(){}
	friend bool operator <(ev a, ev b)
	{
		if (a.x != b.x)
			return a.x < b.x;
		else
			return a.t < b.t;
	}
	ev(int _t, int _x, int _l, int _r, int _num) : t(_t), x(_x), l(_l), r(_r), num(_num) {}
} E[4 * N];

int ans[N];

int T[2 * N];

/*int get(int l, int r, int L, int R, int v)
{
	int ans = 0;
	for (int i = l; i <= r; i++)
		ans += T[i];
	return ans;
}

void set(int x, int v)
{
	T[x] = v;
}*/

int get(int l, int r, int L, int R, int v)
{
	if (l > R || r < L)
		return 0;
	else if (l <= L && R <= r)
		return T[v];
	else
		return get(l, r, L, (L + R) / 2, 2 * v) + get(l, r, (L + R) / 2 + 1, R, 2 * v + 1);
}

void set(int x, int v)
{
	x += N - 1;
	T[x] = v;
	while (x /= 2)
		T[x] = T[2 * x] + T[2 * x + 1];
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	cin >> n;
	assert(n < N);
	for (int i = 1; i <= n; i++)
	{
		int t;
		cin >> t;
		if (t != 0)
			E1[t].push_back(i);
		else
			boss1 = i;
	}
	for (int i = 1; i <= n; i++)
	{
		int t;
		cin >> t;
		if (t != 0)
			E2[t].push_back(i);
		else
			boss2 = i;
	}
	build();
	
	int pt = 0;

	for (int i = 1; i <= n; i++)
	{
		int v = ord[i];
		assert(L1[v] == i);
		E[pt++] = ev(0, i, -42, -42, v);
		E[pt++] = ev(1, L1[v], L2[v] + 1, R2[v], v);
		E[pt++] = ev(2, R1[v], L2[v] + 1, R2[v], v);
	}
	sort(E, E + pt);
	for (int i = 0; i < pt; i++)
	{
		//cerr << E[i].t << ' ' << E[i].x << ' ' << E[i].l << ' ' << E[i].r << ' ' << E[i].num << endl;
		int v = E[i].num;
		if (E[i].t == 0)
			set(L2[v], 1);
		else if (E[i].t == 1)
			ans[v] -= get(E[i].l, E[i].r, 1, N, 1);
		else
			ans[v] += get(E[i].l, E[i].r, 1, N, 1);
	}
	for (int i = 1; i <= n; i++)
		cerr << ans[i] << ' ';
	cerr << endl;
	long long gans = 0;
	for (int i = 1; i <= n; i++)
		gans += ans[i];
	cout << gans << endl;
	return 0;
}