#pragma comment(linker, "/STACK:256000000")
#include <cstdio>
#include <iostream>
#include <cassert>
using namespace std;

typedef long long llong;

const int N = 1000500;
llong D[N];

const llong INF = 1e18;

int n;
llong R, U;
	
inline llong getU(int x, int k)
{
	assert(x >= 0 && x < k);
	return U + D[x];
}

inline llong getR(int x, int k)
{
	assert(k - 2 * x >= 0 && k - 2 * x < k);
	return R + D[k - 2 * x];
}

inline llong get(int x, int k)
{
	if (x < 1 || 2 * x > k)
		return INF;
	else
		return max(getU(x, k), getR(x, k));
}

int main()
{
	freopen("apricot.in", "r", stdin);
	//freopen("apricot.out", "w", stdout);
	cin >> n >> R >> U;
	assert(n <= 1000000);
	D[1] = 0;
	D[0] = -INF;
	int mn = 1;
	for (int k = 2; k <= n; k++)
	{
		int u = k / 2 + 1;
		D[k] = INF;
		if (2 * u <= n && u <= k)
			D[k] = U + D[u];
		//
		//for (int a = 1; 2 * a <= k; a++)
		//	D[k] = min(D[k], max(R + D[k - 2 * a], U + D[a]));
		while (2 * mn <= k && getR(mn, k) > getU(mn, k))
			mn++;
		llong r = get(mn, k);
		llong l = get(mn - 1, k);
		D[k] = min(D[k], min(l, r));
	}
	for (int i = 1; i <= n; i++)
		assert(D[i - 1] <= D[i]);
	cout << D[n] << endl;
}