#pragma comment(linker, "/STACK:256000000")
#include <cstdio>
#include <cassert>
#include <iostream>
#include <string>
using namespace std;

const int N = 1050;

string A[N];

string umsk[N], dmsk[N];
string BAD = "#";

inline string merge(const string& a, const string& b)
{
	if (a == BAD || b == BAD)
		return BAD;
	assert(a.size() == b.size());
	string ret(a.size(), '*');
	for (int i = 0; i < ret.size(); i++)
	{
		if (a[i] != '*' && b[i] != '*' && a[i] != b[i])
			return BAD;
		if (a[i] != '*')
			ret[i] = a[i];
		if (b[i] != '*')
			ret[i] = b[i];
	}
	return ret;
}

string tail[N];

void any(string& s)
{
	assert(s != BAD);
	for (int i = 0; i < s.size(); i++)
		if (s[i] == '*')
			s[i] = '0';
}
	
string gethead(const string& a, const string& b)
{
	int ns = -1;
	assert(a != BAD && b != BAD);
	assert(a.size() == b.size());
	int n = a.size();
	for (int i = 0; i < a.size(); i++)
		if (a[n - i - 1] != b[n - i - 1] && a[n - i - 1] != '*' && b[n - i - 1] != '*')
			ns = i;
	if (ns == -1)
	{
		string u = merge(a, b);
		any(u);
		if (b.back() != '*')
			u = (b.back() - '0' + 9) % 10 + '0';
		return u;
	}
	else
	{
		int u = a[n - ns - 1];
		int v = b[n - ns - 1];
		u -= '0';
		v -= '0';
		if ((u + 1) % 10 != v)
			return BAD;
		string ut(ns, '9');
		string vt(ns, '0');
		if (merge(ut, a.substr(n - ns, ns)) == BAD || merge(vt, b.substr(n - ns, ns)) == BAD)
			return BAD;
		string h = merge(a.substr(0, n - ns - 1), b.substr(0, n - ns - 1));
		assert(h != BAD);
		return h + string(1, u + '0') + ut;
	}
}

int n, m;

inline void set(char& c, char v)
{
	if (c != '*')
		assert(c == v);
	else
		c = v;
}
	
void stup()
{
	cerr << "megagood!" << endl;
	bool br[N];
	for (int i = 0; i < n; i++)
		br[i] = 1;
	for (int j = m - 2; j >= 0; j--)
	{
		int pos = -1;
		for (int i = 0; i < n; i++)
			if (A[i][j] != '*')
				pos = i;
		assert(pos != -1);
		for (int i = pos - 1; i >= 0; i--)
			set(A[i][j], (A[i + 1][j] - '0' + 10 - br[i]) % 10 + '0');
		for (int i = pos + 1; i < n; i++)
			set(A[i][j], (A[i - 1][j] - '0' + 10 + br[i - 1]) % 10 + '0');
		for (int i = 0; i < n - 1; i++)
			br[i] = (A[i][j] == '9' && A[i + 1][j] == '0');
	}
	cout << A[0] << endl;
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	cin >> n >> m;
	assert(n <= 1000 && m <= 100);
	for (int i = 0; i < n; i++)
		cin >> A[i], assert(A[i].size() == m);
	bool megagood = true;
	for (int j = 0; j < m; j++)
	{
		bool good = false;
		for (int i = 0; i < n; i++)
			if (A[i][j] != '0')
				good = true;
		megagood &= good;
	}
	int r = min(m, 3);
	for (int i = 0; i < n; i++)
		tail[i] = A[i].substr(m - r, r);
	int s = m - r;
	cerr << "from top" << endl;
	umsk[0] = string(s, '*');
	for (int i = 0; i < n; i++)
	{
		umsk[i + 1] = merge(umsk[i], A[i].substr(0, s));
		//cerr << umsk[i + 1] << endl;
	}
	cerr << "from bottom" << endl;
	dmsk[0] = string(s, '*');
	for (int i = 0; i < n; i++)
	{
		dmsk[i + 1] = merge(dmsk[i], A[n - i - 1].substr(0, s));
		//cerr << dmsk[i + 1] << endl;
	}
	int st = 1;
	for (int i = 0; i < r; i++)
		st *= 10;
	cerr << "st = " << st << endl;
	for (int y = 0; y < st; y++)
	{
		int br = n;
		bool bad = false;
		for (int i = 0; i < n; i++)
		{
			char buf[10];
			int u = y + i;
			if (u == st)
			{
				assert(br == n);
				br = i;
			}
			for (int k = 0; k < r; k++)
			{
				buf[r - k - 1] = u % 10 + '0';
				u /= 10;
			}
			buf[r] = 0;
			string s(buf);
			if (merge(s, tail[i]) == BAD)
			{
				bad = true;
				break;
			}
		}
		if (bad)
			continue;
		if (umsk[br] == BAD || dmsk[n - br] == BAD)
			continue;
		string head = gethead(umsk[br], dmsk[n - br]);
		if (head == BAD)
			continue;
		any(head);
		char resbuf[10];
		int u = y;
		for (int k = 0; k < r; k++)
		{
			resbuf[r - k - 1] = u % 10 + '0';
			u /= 10;
		}
		resbuf[r] = 0;
		string ttail(resbuf);
		cout << head + ttail << endl;
		return 0;
	}
	assert(false);
}