#include <iostream>
#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int N = 100;

int x, y;
int n, m;
	
int sign(int x)
{
	return (x < 0) ? -1 : x > 0;
}

int mnx = 0, mny = 0, mxx = 0, mxy = 0;
int lx = 0, ly = 0;

int bmnx = 0, bmny = 0, bmxx, bmxy;


bool _was[N][N];
bool __was[N][N];

void shift(int y, int x)
{
	for (int i = max(0, -y); i < n; i++)
		for (int j = max(0, -x); j < m; j++)
			__was[i][j] = _was[i + y][j + x];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			_was[i][j] = __was[i][j];
}


void recount()
{
	if (lx > mxx)
		mxx = lx, bmxx--, shift(0, -1);
	if (lx < mnx)
		mnx = lx, bmnx++, shift(0, 1);
	if (ly > mxy)
		mxy = ly, bmxy--, shift(-1, 0);
	if (ly < mny)
		mny = ly, bmny++, shift(1, 0);
	assert(bmny >= 0);
	assert(bmnx >= 0);
	assert(bmxy < n);
	assert(bmxx < m);
}

bool& was(int i, int j)
{
	//assert(i - mny + bmny >= mny && j >= mnx && i <= mxy && j <= mxx);
	assert(0 <= i && i <= bmxy - bmny && 0 <= j && j <= bmxx - bmnx);
	return _was[i][j];
	//return _was[i + N / 2][j + N / 2];
}

bool we_won = false;

void call()
{
	eprintf("wanna call.\n(ly, lx) = (%d, %d),\n"
			"(y, x) = (%d, %d)\n"
			"(mny, mnx, mxy, mxx) = (%d, %d, %d, %d),\n"
			"(bmny, bmnx, bmxy, bmxx) = (%d, %d, %d, %d)\n",
			ly, lx, y, x, mny, mnx, mxy, mxx, bmny, bmnx, bmxy, bmxx);
	for (int i = 0; i <= bmxy - bmny; i++)
	{
		for (int j = 0; j <= bmxx - bmnx; j++)
			eprintf("%d", was(i, j));
		eprintf("\n");
	}
	bool good = (x >= bmnx && x <= bmxx && y >= bmny && y <= bmxy);
	bool calling = false;;
	if (good)
	{
		eprintf("we are in bounding box\n");
		int wx = x - bmnx, wy = y - bmny;
		eprintf("wy = %d, wx = %d\n", wy, wx);
		if (!was(wy, wx))
			calling = 1, was(wy, wx) = 1, eprintf("gonna call\n");
		else
			eprintf("called before\n");
	}
	else
		eprintf("outside bounding box");
	pair<int, pair<int, int> > near(1e9, make_pair(-42, -42));
 	for (int i = bmny; i <= bmxy; i++)
		for (int j = bmnx; j <= bmxx; j++)
		{
			if (!was(i - bmny, j - bmnx))
				near = min(near, make_pair(abs(i - y) + abs(j - x), make_pair(i, j)));
		}
	int dy, dx;
	if (near.first == 1e9)
		we_won = true, eprintf("we won, i think\n"), dy = dx = 0;
	else
		dy = sign(near.second.first - y), dx = sign(near.second.second - x);
	x += dx, y += dy;
	eprintf("going to (%d, %d)\n", near.second.first, near.second.second);
	printf("%d %d %d\n", calling, dx, dy);
	fflush(stdout);
}

void get()
{
	int r, dy, dx;
	scanf("%d %d %d", &r, &dx, &dy);
	if (we_won)
		assert(r == 1);
	if (r == 1)
		exit(0);
	lx += dx, ly += dy;
	bmnx += dx, bmny += dy, bmxx += dx, bmxy += dy;
	recount();
}

int main()
{
	scanf("%d %d", &n, &m);
	scanf("%d %d", &x, &y);
	--x, --y;
	bmxx = m - 1;
	bmxy = n - 1;
	int iter = 0;
	while (true)
	{
		call();
		get();
		assert(iter <= 10000);
	}
	return 0;
}