program Project2;

{$APPTYPE CONSOLE}  {$R+ Q-}

uses
  SysUtils;

const inf = 1 / 0;
      nmax = 100 * 1000;
     // hmax = 1 shl 62;
      ymax = 1000 * 1000 * 1000;
      stmax = 1000 * 1000;
      
type tnode = record
         left, right, x, y : longint;
     end;
     queue = record
         t : longint;
         a : array[1 .. stmax] of longint;
     end;
     tnodeh = record
         left, right, y : longint;
         x : int64;
         count, b, p : longint;
     end;
var n, m, root : longint;
    ans : array[1 .. nmax] of longint;
    node : array[1 .. nmax] of tnode;
    q : queue;
    h : array[1 .. nmax] of longint;
    nodeh : array[1 .. stmax] of tnodeh;
    stack : array[0 .. stmax] of longint;

procedure pout;
var i : longint;
begin
    for i := 1 to n do begin
        write(ans[i], ' ');
    end;
    halt(0);
end;

procedure pinit;
begin
    assign(input, 'theatre.in');
    reset(input);
    assign(output, 'theatre.out');
    rewrite(output);
    read(n, m);
end;

procedure split(t, x : longint; var l, r : longint);
begin
    if t = 0 then begin
        l := 0;
        r := 0;
        exit;
    end;
    if x < node[t].x then begin
        split(node[t].left, x, l, r);
        node[t].left := r;
        r := t;
    end
    else begin
        split(node[t].right, x, l, r);
        node[t].right := l;
        l := t;
    end;
end;

function merge(l, r : longint) : longint;
begin
    if (l = 0) or (r = 0) then begin
        result := l + r;
        exit;
    end;
    if node[l].y > node[r].y then begin
        node[l].right := merge(node[l].right, r);
        result := l;
    end
    else begin
        node[r].left := merge(l, node[r].left);
        result := r;
    end;
end;

procedure splith(t, x : longint; var l, r : longint);
begin
    if t = 0 then begin
        l := 0;
        r := 0;
        exit;
    end;
    if x < nodeh[t].x then begin
        splith(nodeh[t].left, x, l, r);
        nodeh[t].left := r;
        r := t;
    end
    else begin
        splith(nodeh[t].right, x, l, r);
        nodeh[t].right := l;
        l := t;
    end;
end;

function mergeh(l, r : longint) : longint;
begin
    if (l = 0) or (r = 0) then begin
        result := l + r;
        exit;
    end;
    if nodeh[l].y > nodeh[r].y then begin
        nodeh[l].right := mergeh(nodeh[l].right, r);
        result := l;
    end
    else begin
        nodeh[r].left := mergeh(l, nodeh[r].left);
        result := r;
    end;
end;


function addh(t, v : longint) : longint;
var l, r : longint;
begin
    if t = 0 then begin
        result := v;
        exit;
    end;
    if node[t].y < node[v].y then begin
        result := v;
        split(t, node[v].x, l, r);
        node[v].left := l;
        node[v].right := r;
      //  update(v);
    end
    else begin
        result := t;
        if node[v].x < node[t].x then begin
            node[t].left := addh(node[t].left, v);
        end
        else begin
            node[t].right := addh(node[t].right, v);
        end;
    end;
end;

function del(t, v : longint) : longint;
begin
    if node[t].x = node[v].x then begin
        result := merge(node[v].left, node[v].right);
        node[v].left := 0;
        node[v].right := 0;
    //    node[v]count := 1;
        exit;
    end;
    if node[v].x < node[t].x then begin
        result := t;
        node[t].left := del(node[t].left, v);
    end
    else begin
        result := t;
        node[t].right := del(node[t].right, v);
    end;
end;

function delh(t, v : longint) : longint;
begin
    if nodeh[t].x = nodeh[v].x then begin
        result := mergeh(nodeh[v].left, nodeh[v].right);
        nodeh[v].left := 0;
        nodeh[v].right := 0;
        inc(stack[0]);
        stack[stack[0]] := v;
    //    node[v]count := 1;
        exit;
    end;
    if nodeh[v].x < nodeh[t].x then begin
        result := t;
        nodeh[t].left := delh(nodeh[t].left, v);
    end
    else begin
        result := t;
        nodeh[t].right := del(nodeh[t].right, v);
    end;
end;


function addhash(t, v : longint) : longint;
var l, r : longint;
begin
    if t = 0 then begin
        result := v;
        exit;
    end;
    if nodeh[t].y < nodeh[v].y then begin
        result := v;
        splith(t, nodeh[v].x, l, r);
        nodeh[v].left := l;
        nodeh[v].right := r;
      //  update(v);
    end
    else begin
        result := t;
        if nodeh[v].x < nodeh[t].x then begin
            nodeh[t].left := addhash(nodeh[t].left, v);
        end
        else begin
            nodeh[t].right := addhash(nodeh[t].right, v);
        end;
    end;
end;

procedure addq(x : longint);
begin
    inc(q.t);
    q.a[q.t] := x;
end;

function hash(h, x : int64) : int64;
begin
    result := h + x * x * x;
end;

function newnode(x : int64) : longint;
var c : longint;
begin
    c := stack[stack[0]];
    dec(stack[0]);
    nodeh[c].x := x;
    nodeh[c].y := random(ymax);
    nodeh[c].left := 0;
    nodeh[c].right := 0;
    nodeh[c].count := 0;
    nodeh[c].b := 0;
    nodeh[c].p := 0;
    result := c;
end;

function search(t : longint; x : int64) : longint;
begin
    if t = 0 then begin
        result := 0;
        exit;
    end;
    if nodeh[t].x = x then begin
        result := t;
        exit;
    end;
    if x < nodeh[t].x then begin
        result := search(nodeh[t].left, x);
    end
    else begin
        result := search(nodeh[t].right, x);
    end;
end;

procedure add(x : longint; ind : int64);
var nh : int64;
    new, c : longint;
begin
    nh := hash(nodeh[h[x]].x, ind);
    if nodeh[h[x]].b <> ind then begin
        addq(h[x]);
    end;
    nodeh[h[x]].b := ind;
    dec(nodeh[h[x]].count);
    nodeh[h[x]].p := del(nodeh[h[x]].p, x);
    c := search(root, nh);
    if c = 0 then begin
        new := newnode(nh);
        root := addhash(root, new);
        c := new; 
    end;
    h[x] := c;
    if nodeh[h[x]].b <> ind then begin
        addq(h[x]);
    end;
    nodeh[h[x]].b := ind;
    inc(nodeh[h[x]].count);
    nodeh[h[x]].p := addh(nodeh[h[x]].p, x);
end;

procedure solve;
var i, j, k, x, t0 : longint;
begin
    for i := stmax downto 1 do begin
        stack[stmax - i + 1] := i;
    end;
    stack[0] := stmax;
    root := 0;
    t0 := newnode(0);
    root := addhash(root, t0);
    for i := 1 to n do begin
        node[i].x := i;
        node[i].y := random(ymax);
        node[i].left := 0;
        node[i].right := 0;
        nodeh[t0].p := merge(nodeh[t0].p, i);
        h[i] := t0;
        inc(nodeh[t0].count);
       // node[i].count := 1;
    end;
    fillchar(ans, sizeof(ans), 0);
    for i := 1 to m do begin
        q.t := 0;
        read(k);
        for j := 1 to k do begin
            read(x);
            if ans[x] = 0 then begin
                add(x, i);
            end;
        end;
        for j := 1 to q.t do begin
            if nodeh[q.a[j]].count = 1 then begin
                ans[node[nodeh[q.a[j]].p].x] := i;
            end;
            if nodeh[q.a[j]].count = 0 then begin
                root := delh(root, q.a[j]);
            end;
        end;
    end;
end;

begin
    randomize;
    pinit;
    //test;
    solve;
    pout;
end.
 