
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>
    
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>
    
#pragma comment(linker, "/STACK:10536000")
    
using namespace std;
    
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
    
const bool debug = !true;
const int step = 112;
const int tstep = 895;
    
int n, ra, rta[100100], rtb[100100], ppos[100100], ttm, lasta[100100], lastb[100100], tag[100100], tg = 0;
vector<int> pa[100100];
bool gda[tstep + 2][100100], gdb[tstep + 2][100100];
int d[tstep + 2][tstep + 2];
    
void dfs(const int &x)
{
    rta[ttm++] = x;
    for (int i = 0; i < pa[x].size(); i++)
        dfs(pa[x][i]);
    lasta[x] = ttm;
}
    
ll solve(int p1, int p2)
{
   int l1 = (p1 / step) * step, l2 = (p2 / step) * step;
   int r1 = min(n, l1 + step), r2 = min(n, l2 + step);
   int t1 = p1 / step, t2 = p2 / step;
   tg++; ll ans = 0;
   if (r1 - p1 < p1 - l1)
       if (r2 - p2 < p2 - l2)
       {
            ans = d[t1 + 1][t2 + 1];
           for (int i = p1; i < r1; i++)
           {
               if (gdb[t2 + 1][rta[i]]) ans--;
                tag[rta[i]] = tg;
           }
           for (int i = p2; i < r2; i++)
           {
               if (gda[t1 + 1][rtb[i]]) ans--;
               if (tag[rtb[i]] == tg) ans++;
           }
       }
       else
       {
            ans = d[t1 + 1][t2];
           for (int i = p1; i < r1; i++)
           {
               if (gdb[t2][rta[i]]) ans--;
               tag[rta[i]] = tg;
           }
           for (int i = l2; i < p2; i++)
           {
               if (gda[t1 + 1][rtb[i]]) ans++;
               if (tag[rtb[i]] == tg) ans--;
           }
       }
   else
        if (r2 - p2 < p2 - l2)
        {
             ans = d[t1][t2 + 1];
            for (int i = p2; i < r2; i++)
            {
                if (gda[t1][rtb[i]]) ans--;
                tag[rtb[i]] = tg;
            }
            for (int i = l1; i < p1; i++)
            {
                if (gdb[t2 + 1][rta[i]]) ans++;
                if (tag[rta[i]] == tg) ans--;
            }
        }
        else
        {
             ans = d[t1][t2];
            for (int i = l1; i < p1; i++)
            {
                if (gdb[t2][rta[i]]) ans++;
                tag[rta[i]] = tg;
            }
            for (int i = l2; i < p2; i++)
            {
                if (gda[t1][rtb[i]] || tag[rtb[i]] == tg) ans++;
            }
        }
    return ans;
}
    
int main()
{
    if (debug)
        freopen("input.txt", "r", stdin),
        freopen("output.txt", "w", stdout);
    else
        freopen("virus.in", "r", stdin),
        freopen("virus.out", "w", stdout);
    
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        int v; scanf("%d", &v); v--;
        if (v == -1) ra = i;
        else pa[v].push_back(i);
    }
    ttm = 0; dfs(ra);
    for (int i = 0; i < n; i++)
        pa[i].clear();
    for (int i = 0; i < n; i++)
    {
        rtb[i] = rta[i], lastb[i] = lasta[i];
        ppos[rtb[i]] = i;
    }
    for (int i = 0; i < n; i++)
    {
        int v; scanf("%d", &v); v--;
        if (v == -1) ra = i;
        else pa[v].push_back(i);
    }
    ttm = 0; dfs(ra);
    for (int i = 0; i <= (n - 1) / step; i++)
    {
        for (int j = 0; j < min(n, step * (i + 1)); j++)
            gda[i + 1][rta[j]] = true, gdb[i + 1][rtb[j]] = true;
        int ans = 0;
        for (int k = 0; k <= (n - 1) / step; k++)
        {
            for (int j = step * k; j < min(n, step * (k + 1)); j++)
                if (gda[i + 1][rtb[j]]) ans++;
            d[i + 1][k + 1] = ans;
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        int al = i, ar = lasta[rta[i]], bl = ppos[rta[i]], br = lastb[rta[i]];
        ans += solve(ar, br) - solve(ar, bl) - solve(al, br) + solve(al, bl);
    }
    printf("%lld\n", ans - (ll)n);
    return 0;
}