#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;
const int inf = 200000;
const int k2 = (1 << 17) - 1;

int n, a[100100], b[100100], bad[100100];
int tr[2 * k2 + 2], ptr[2 * k2 + 2];

int get(int x, int l, int r, int lt, int rt, int &pt)
{
	if (lt <= l && r <= rt)
	{
		pt = ptr[x];
		return tr[x];
	}
	if (rt <= l || r <= lt) return inf;
	int t1, pt1, t2, pt2;
	t1 = get(2 * x + 1, l, (l + r) >> 1, lt, rt, pt1);
	t2 = get(2 * x + 2, (l + r) >> 1, r, lt, rt, pt2);
	if (t1 < t2) { pt = pt1; return t1; }
	else { pt = pt2; return t2; }
}

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else
		freopen("mosaic.in", "r", stdin),
		freopen("mosaic.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &a[i], &b[i]);
	fill(tr, tr + 2 * k2 + 2, inf);
	for (int i = n - 1; i >= 0; i--)
	{
		bad[i] = i + 1;
		while (bad[i] < n && (a[bad[i]] == a[i] || b[bad[i]] == b[i])) bad[i]++;
		tr[k2 + i] = bad[i]; ptr[k2 + i] = i;
	}
	for (int i = k2 - 1; i >= 0; i--)
		if (tr[2 * i + 1] < tr[2 * i + 2])
			tr[i] = tr[2 * i + 1], ptr[i] = ptr[2 * i + 1];
		else
			tr[i] = tr[2 * i + 2], ptr[i] = ptr[2 * i + 2];
	int m; scanf("%d", &m);
	for (int i = 0; i < m; i++)
	{
		int pt, u, v; scanf("%d%d", &u, &v); u--;
		int t = get(0, k2, 2 * k2 + 1, k2 + u, k2 + v, pt);
		if (t >= v) printf("0 0\n");
		else printf("%d %d\n", pt + 1, t + 1);
	}
	return 0;
}