#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;

const int dx[9] = {-1, 1, -1, 0, 1, -1, 1, 0, 0};
const int dy[9] = {1, 0, -1, 1, -1, 0, 1, -1, 0};

int n, m, x, y, ms;
int a[40];

bool good(int vx, int vy) { return (0 <= vx && vx < n && 0 <= vy && vy < m); }

void mv_ver(int l, int r, int d)
{
	for (int i = l; i != r; i -= d)
		a[i + d] = a[i];
	a[r + d] = 0;
}

void mv_hor(int d)
{
	for (int i = 0; i < n; i++)
	{
		if (d == 1) a[i] <<= 1;
		else a[i] >>= 1;
		a[i] &= ms;
	}
}

void step(int k)
{
	printf("%d %d ", dx[k], dy[k]);
	x += dx[k], y += dy[k];
//	cerr << "    " << x << ' ' << y << endl;
	if ((a[x] >> y) & 1)
	{
		a[x] ^= (1 << y);
		printf("1\n");
	}
	else printf("0\n");
	fflush(stdout);
	int t, xx, yy;
	scanf("%d%d%d", &t, &xx, &yy);
	if (t == 1) exit(0);
	if (xx == 1) mv_ver(n - 2, -1, 1);
	else if (xx == -1) mv_ver(1, n, -1);
	else if (yy == 1) mv_hor(1);
	else if (yy == -1) mv_hor(-1);
	/*cerr << endl;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
			if ((a[i] >> j) & 1) cerr << 1;
			else cerr << 0;
		cerr << endl;
	}
	cerr << endl; */
}

void first_step()
{
	int nk = 0;
	for (int k = 0; k < 9; k++)
	{
		int vx = x + dx[k], vy = y + dy[k];
		if (!good(vx, vy)) continue;
		nk = k; break;
	}
	step(nk);
}

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else ;

	scanf("%d%d%d%d", &m, &n, &x, &y); x--; y--;
	ms = (1 << m) - 1;
	//cerr << "   " << n << ' ' << m << endl;
	for (int i = 0; i < n; i++) a[i] = ms;
	first_step();
	while (true)
	{
		int px = 0, py = 0, md = 100;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if ((a[i] >> j) & 1)
				{
					int t = max(abs(x - i), abs(y - j));
					if (t < md)
					{
						md = t;
						px = i; py = j;
					}
				}
		int nk = 8;
		for (int k = 0; k < 9; k++)
		{
			int vx = dx[k] + x, vy = dy[k] + y;
			if (!good(vx, vy)) continue;
			if (max(abs(vx - px), abs(vy - py)) < md)
			{
				nk = k; break;
			}
		}
		step(nk);
	}

	return 0;
}