#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cstring>
#include <memory.h>
using std::cin;
using std::cout;
using std::pair;
using std::swap;
using std::max;
using std::min;
using std::set;
using std::vector;

typedef unsigned long long ull;

#define fi first
#define se second

const int MAX_SIZE = 100000,
          INF = 18446744073709551615;

struct CVert1
{
  int nums, nume;
  vector <int> sons, edge;

  CVert1 ():
    nums (0), nume (0)
  {
  }

  void append_s (int x)
  {
    nums++;
    sons.push_back (x);
  }

  void append_e (int x)
  {
    nume++;
    edge.push_back (x);
  }
};

struct CVert2
{
  int nums, nume;
  set <int> sons;
  vector <int> edge;

  CVert2 ():
    nums (0), nume (0)
  {
  }

  void append_s (int x)
  {
    nums++;
    sons.insert (x);
  }

  void append_e (int x)
  {
    nume++;
    edge.push_back (x);
  }
};

CVert1 *v1;
CVert2 *v2;
bool was [100000];
int *vis, nv;

void dfs1 (CVert1 *v, int x)
{
  int pos = nv;
  vis [nv] = x;
  nv++;
  was [x] = 1;

  for (int i = 0; i < v [x].nume; i++)
  {
    if (!was [v [x].edge [i]])
    {
      dfs1 (v, v [x].edge [i]);
    }
  }

  for (int i = pos + 1; i < nv; i++)
  {
    v [x].append_s (vis [i]);
  }
}

void dfs2 (CVert2 *v, int x)
{
  int pos = nv;
  vis [nv] = x;
  nv++;
  was [x] = 1;

  for (int i = 0; i < v [x].nume; i++)
  {
    if (!was [v [x].edge [i]])
    {
      dfs2 (v, v [x].edge [i]);
    }
  }

  for (int i = pos + 1; i < nv; i++)
  {
    v [x].append_s (vis [i]);
  }
}

int main ()
{
  freopen ("virus.in", "r", stdin);
  freopen ("virus.out", "w", stdout);

  int n, a, j, jj, r1, r2;
  cin >> n;
  v1 = new CVert1 [n];
  v2 = new CVert2 [n];
  vis = new int [n];

  for (int i = 0; i < n; i++)
  {
    cin >> a;
    a--;
    if (a == -1)
    {
      r1 = i;
    }
    else
    {
      v1 [a].append_e (i);
    }
  }
  for (int i = 0; i < n; i++)
  {
    cin >> a;
    a--;
    if (a == -1)
    {
      r2 = i;
    }
    else
    {
      v2 [a].append_e (i);
    }
  }
  memset (was, 0, sizeof (was));
  nv = 0;
  dfs1 (v1, r1);

  memset (was, 0, sizeof (was));
  nv = 0;
  dfs2 (v2, r2);

  ull k = 0;
  set <int>::iterator found;

  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < v1 [i].nums; j++)
    {
      found = v2 [i].sons.find (v1 [i].sons [j]);

      if (found != v2 [i].sons.end ())
      {
        k++;
      }
    }
  }

  cout << k;
  fclose (stdout);
  return 0;
}
