#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <queue>

using namespace std;

#define x first
#define y second

typedef pair <int, int> CPos;

const int _DX [9] = {-1,  0,  1, -1, 0, 1, -1, 0, 1},
          _DY [9] = {-1, -1, -1,  0, 0, 0,  1, 1, 1};

int x, y, n, m, dx, dy, f, sz [2];
bool field [30][30], was [30][30];

void init ()
{
  sz [0] = n * m;
  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < m; j++)
    {
      field [i][j] = 1;
    }
  }
}

void update ()
{
  field [x][y] = 0;

  if (dx < 0)
  {
    for (int yy = 0; yy < n; yy++)
    {
      for (int xx = 0; xx < m; xx++)
      {
        field [xx][yy] = (xx != m - 1) && field [xx + 1][yy];
      }
    }
    return;
  }
  if (dx > 0)
  {
    for (int yy = 0; yy < n; yy++)
    {
      for (int xx = m - 1; xx > -1; xx--)
      {
        field [xx][yy] = (xx != 0) && field [xx - 1][yy];
      }
    }
    return;
  }
  if (dy < 0)
  {
    for (int yy = 0; yy < n; yy++)
    {
      for (int xx = 0; xx < m; xx++)
      {
        field [xx][yy] = (yy != n - 1) && field [xx + 1][yy];
      }
    }
    return;
  }
  if (dy > 0)
  {
    for (int yy = n - 1; yy << n> -1; yy--)
    {
      for (int xx = 0; xx < m; xx++)
      {
        field [xx][yy] = (yy != n - 1) && field [xx + 1][yy];
      }
    }
    return;
  }
}

bool ok (int x, int y)
{
  return (x > 0 && x < n) && (y > 0 && y < m);
}

CPos find_dst ()
{
  priority_queue <CPos> q;
  q.push (CPos (x, y));
  memset (was, 0, sizeof (was));
  was [x][y] = 1;
  CPos curr, next;

  while (q.size ())
  {
    curr = q.top ();
    q.pop ();

    if (field [curr.x][curr.y])
    {
      return curr;
    }

    for (int d = 0; d < 9; d++)
    {
      next = CPos (curr.x + _DX [d], curr.y + _DY [d]);
      if (ok (next.x, next.y) && !was [next.x][next.y])
      {
        q.push (next);
        was [next.x][next.y] = 1;
      }
    }
  }

  return CPos (0, 0);
}

int main ()
{
  cin >> n >> m >> x >> y;
  init ();

  cout << "0 0 1\n";
  cout.flush ();
  cin >> f >> dx >> dy;

  CPos dst;

  while (!f)
  {
    update ();

    dst = find_dst ();

    if (dst.x < x)
    {
      dx = -1;
    }
    else if (dst.x > x)
    {
      dx = 1;
    }
    if (dst.y < y)
    {
      dy = -1;
    }
    else if (dst.y > y)
    {
      dy = 1;
    }
    if (field [x + dx][y + dy])
    {
      f = 1;
    }

    x += dx;
    y += dy;
    cout << f << dx << dy;
    cout.flush ();
    cin >> f >> dx >> dy;
  }
  return 0;
}
