#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <queue>

using namespace std;

#define x first
#define y second

typedef pair <int, int> CPos;

const int _DX [8] = {1, 1, -1, -1, 0, 1, 0, -1},
          _DY [8] = {1, -1, 1, -1, 1, 0, -1, 0};

int x, y, n, m, dx, dy, f, sz [2];
bool field [30][30], was [30][30];

void init ()
{
  sz [0] = n * m;
  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < m; j++)
    {
      field [i][j] = 1;
    }
  }
  field [x][y] = 0;
}

void update ()
{
  field [x][y] = 0;

  if (dx < 0)
  {
    for (int yy = 0; yy < m; yy++)
    {
      for (int xx = 0; xx < n; xx++)
      {
        field [xx][yy] = (xx != n - 1) && field [xx + 1][yy];
      }
    }
    return;
  }
  if (dx > 0)
  {
    for (int yy = 0; yy < m; yy++)
    {
      for (int xx = n - 1; xx > -1; xx--)
      {
        field [xx][yy] = (xx != 0) && field [xx - 1][yy];
      }
    }
    return;
  }
  if (dy < 0)
  {
    for (int yy = 0; yy < m; yy++)
    {
      for (int xx = 0; xx < n; xx++)
      {
        field [xx][yy] = (yy != m - 1) && field [xx][yy + 1];
      }
    }
    return;
  }
  if (dy > 0)
  {
    for (int yy = m - 1; yy > - 1; yy--)
    {
      for (int xx = 0; xx < n; xx++)
      {
        field [xx][yy] = (yy != 0) && field [xx][yy - 1];
      }
    }
    return;
  }
}

bool ok (int x, int y)
{
  return (x >= 0 && x < n) && (y >= 0 && y < m);
}

struct CE
{
  CPos pos;
  int d;

  CE ():
    d (0)
  {
  }

  CE (int D, CPos p):
    d (D), pos (p)
  {
  }

  bool operator < (const CE & e) const
  {
    return d < e.d;
  }
};

CPos find_dst ()
{
  priority_queue <CE> q;
  q.push (CE (0, CPos (x, y)));
  memset (was, 0, sizeof (was));
  was [x][y] = 1;
  CE curr, next;

  while (q.size ())
  {
    curr = q.top ();
    q.pop ();

    if (field [curr.pos.x][curr.pos.y])
    {
      return curr.pos;
    }

    next.d = curr.d + 1;

    for (int d = 0; d < 8; d++)
    {
      next.pos = CPos (curr.pos.x + _DX [d], curr.pos.y + _DY [d]);
      if (ok (next.pos.x, next.pos.y) && !was [next.pos.x][next.pos.y])
      {
        q.push (next);
        was [next.pos.x][next.pos.y] = 1;
      }
    }
  }

  return CPos (0, 0);
}

int main ()
{
  cin >> n >> m >> y >> x;
  x--;
  y--;
  init ();

  cout << "0 0 1\n";
  cout.flush ();
  cin >> f >> dy >> dx;

  CPos dst;
  bool ndst;

  while (!f)
  {
    update ();

    if (!ok (dst.x, dst.y))
    {
      ndst = 1;
    }

    if (ndst)
    {
      dst = find_dst ();
      ndst = 0;
    }

    if (dst.x < x)
    {
      dx = -1;
    }
    else if (dst.x > x)
    {
      dx = 1;
    }
    else
    {
      dx = 0;
    }
    if (dst.y < y)
    {
      dy = -1;
    }
    else if (dst.y > y)
    {
      dy = 1;
    }
    else
    {
      dy = 0;
    }
    if (field [x + dx][y + dy])
    {
      f = ndst = 1;
    }

    x += dx;
    y += dy;
    cout << dy << ' ' << dx << ' ' << f << endl;
    cout.flush ();
    cin >> f >> dy >> dx;
    dst.x += dx;
    dst.y += dy;
  }
  return 0;
}
