#define ONLINE_JUDGE

#include <fstream>

#ifdef ONLINE_JUDGE
std::ifstream cin("password.in");
std::ofstream cout("password.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<int> z_fun(string &s)
{
	vector<int> z(s.length(), 0);
	z[0] = 0;
	int l = 0, r = 0;
	for (int i = 1; i < s.length(); i++)
	{
		if (r > i)
			z[i] = z[i - l];
		while (z[i] + i < s.length() &&  s[z[i]] == s[z[i] + i])
			z[i]++;
		if (i + z[i] > r)
		{
			r = i + z[i];
			l = i;
		}
	}
	return z;
}

int getLen(int x)
{
	if (x < 10)
		return 1;
	if (x < 100)
		return 2;
	if (x < 1000)
		return 3;
	if (x < 10000)
		return 4;
	if (x < 100000)
		return 5;
	if (x < 1000000)
		return 6;
	if (x < 10000000)
		return 7;
	if (x < 100000000)
		return 8;
	if (x < 1000000000)
		return 9;
}

int main()
{
	string stra, strb;
	cin >> stra >> strb;
	vector<int> a(stra.length()), b(strb.length());
	for (int i = 0; i < stra.length(); i++)
		a[i] = stra[i] - '0';
	for (int i = 0; i < strb.length(); i++)
		b[i] = strb[i] - '0';
	vector<int> sa = a;
	for (int i = 1; i < sa.size(); i++)
		sa[i] += sa[i - 1];
	int r = a.size() - b.size();
	if (r == 0 && a == b)
	{
		cout << "1 1\n";
		return 0;
	}
	int ns = -1;
	int ne = -1;
	for (int i = 0; i < b.size(); i++)
		if (a[i] != b[i] && ns == 0)
		{
			ns = i;
			break;
		}

	for (int i = 1; i <= b.size(); i++)
		if (a[a.size() - i] != b[b.size() - i])
		{
			ne = i;
			break;
		}

	for (int i = 0; i < sa.size(); i++)
	{
		for (int j = r; j + i < a.size() ; j++)
		{
			if (i > ns && ns != -1)
				continue;
			if (i + j < ne && ne != -1)
				continue;
			int sum = sa[i + j] - (i == 0 ? 0 :sa[i - 1]);
			int d = getLen(sum);
			if (j + 1 - d > r + 10)
				break;
			if (j + 1 - d != r)
				continue;
			if (sum == 0 && b[i] != 0)
				break;
			if (i + j + 1 < a.size() && a[i + j + 1] != b[i + d])
				continue;
			bool f = true;
			for (int q = i - 1 + d; q >= i; q--)
			{
				if (b[q] != sum % 10)
				{
					f = false;
					break;
				}
				sum /= 10;
				if (q == i && sum != 0)
					f = false;
			}
			if (f && sum == 0)
			{
				cout << i + 1 << " " << i + j + 1 << endl;
				return 0;
			}
		}
	}
    return 0;
}