#define ONLINE_JUDGE

#include <fstream>

#ifdef ONLINE_JUDGE
std::ifstream cin("virus.in");
std::ofstream cout("virus.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

struct vertex
{
	int in, out;
	vector<int> edge;
};

//vertex a[100], b[100];
vertex a[100500], b[100500];

int timer = 0;

void dfsA(int v)
{
	a[v].in = timer++;
	for (int i = 0; i < a[v].edge.size(); i++)
	{
		int u = a[v].edge[i];
		if (a[u].in == -1)
			dfsA(u);
	}
	a[v].out = timer++;
}

void dfsB(int v)
{
	b[v].in = timer++;
	for (int i = 0; i < b[v].edge.size(); i++)
	{
		int u = b[v].edge[i];
		if (b[u].in == -1)
			dfsB(u);
	}
	b[v].out = timer++;
}

bool isNorm(int i, int j)
{
	return a[i].in < a[j].in && a[j].out < a[i].out && b[i].in < b[j].in && b[j].out < b[i].out ;
}

int main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		a[i].in = b[i].in = a[i].out = b[i].out = -1;
	int sa = -1, sb = -1;
	for (int i = 0; i < n; i++)
	{
		int q;
		cin >> q;
		q--;
		if (q == -1)
			sa = i;
		else
			a[q].edge.pb(i);
	}
	for (int i = 0; i < n; i++)
	{
		int q;
		cin >> q;
		q--;
		if (q == -1)
			sb = i;
		else
			b[q].edge.pb(i);
	}
	dfsA(sa);
	dfsB(sb);
	int cnt = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (isNorm(i, j))
				cnt++;
	cout << cnt;
    return 0;
}