#define ONLINE_JUDGE

#include <fstream>
#ifdef ONLINE_JUDGE
std::ifstream cin("mosaic.in");
std::ofstream cout("mosaic.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

struct dnode
{
	dnode *l, *r;
	int x, y;
	int valx, valy, sumx, sumy, numx, numy, id;
	bool d;

	void push()
	{
	}

	void update()
	{
		x = 1;
		if (l != NULL)
			x += l -> x;
		if (r != NULL)
			x += r -> x;

		sumx = valx;
		sumy = valy;
		d = false;
		numx = numy = -2;
		if (l != NULL && !d)
		{
			if (l -> d)
			{
				d = true;
				numx = l -> numx;
				numy = l -> numy;
				sumx = -1;
				sumy = -1;
			}
			else
			{
				if (sumx != l -> valx)
					numx = l -> id;
				else
					numx = l -> numx;

				if (sumy != l -> valy)
					numy = l -> id;
				else
					numy = l -> numy;

				if (sumx != l -> sumx)
					sumx = -1;
				if (sumy != l -> sumy)
					sumy = -1;
				if (sumx == -1 && sumy == -1)
				{
					d = true;
					numx = id;
					if (valx != l -> valx && valy != l -> valy)
						numy = l -> id;
					else
					{
						if (valx == l -> valx && valy == l -> valy)
							numy = max(l -> numx, l -> numy);
						else if (valx == l -> valx)
							numy = l -> numx;
						else numy = l -> numy;
					}
				}
			}
		}
		if (r != NULL && !d)
		{
			if (r -> d)
			{
				d = true;
				numx = r -> numx;
				numy = r -> numy;
				sumx = -1;
				sumy = -1;
			}
			else
			{
				if (valx != r -> valx)
					numx = r -> id;
				else
					numx = max(numx, r -> numx);

				if (valy != r -> valy)
					numy = r -> id;
				else
					numy = max(numy, r -> numy);

				if (sumx != r -> sumx)
					sumx = -1;
				if (sumy != r -> sumy)
					sumy = -1;

				if (valx != r -> sumx && valy != r -> sumy)
				{
					d = true;
					numx = id;
					if (valx != r -> valx && valy != r -> valy)
						numy = l -> id;
					else
					{
						if (valx == r -> valx && valy == r -> valy)
							numy = max(r -> numx, r -> numy);
						else if (valx == r -> valx)
							numy = r -> numx;
						else numy = r -> numy;
					}	
				}
			}
		}
		if (!d && sumx == -1 && sumy == -1)
		{
			if (l -> valx != r -> valx && l -> valy != r -> valy)
			{
				d = true;
				numx = r -> id;
				numy = l -> id;
			}
			else if (l -> valx == r -> valx)
			{
				if (l -> numx != -2)
				{
					numx = l -> numx;
					numy = r -> id;
				}
				else
				{
					numx = r -> numx;
					numy = l -> id;
				}
			}
			else if (l -> valy == r -> valy)
			{
				if (l -> numy != -2)
				{
					numx = l -> numy;
					numy = r -> id;
				}
				else
				{
					numx = r -> numy;
					numy = l -> id;
				}
			}
		}
	}

	dnode()
	{
		l = r = NULL;
		x = 1;
		y = (rand() << 15) + rand();
	}

	dnode(int q, int w, int i)
	{
		l = r = NULL;
		x = 1;
		y = (rand() << 15) + rand();
		sumx = valx = q;
		sumy = valy = w;
		numx = numy = -1;
		id = i;
		d = false;
	}
};

dnode* merge(dnode *l, dnode *r)
{
	if (l == NULL)
		return r;
	if (r == NULL)
		return l;
	if (l -> y > r -> y)
	{
		l -> push();
		l -> r = merge(l -> r, r);
		l -> update();
		return l;
	}
	else
	{
		r -> push();
		r -> l = merge(l, r -> l);
		r -> update();
		return r;
	}
}

int dnode_getx(dnode *d)
{
	return (d == NULL ? 0 : d -> x);
}

void split(dnode *t, int k, dnode* &l, dnode* &r)
{
	if (t == NULL)
	{
		l = r = NULL;
		return;
	}
	t -> push();
	if (dnode_getx(t -> l) >= k)
	{
		split(t -> l, k, l, t -> l);
		t -> update();
		r = t;
		return;
	}
	else
	{
		split(t -> r, k - 1 - dnode_getx(t -> l), t -> r, r);
		t -> update();
		l = t;
		return ;
	}
}

pii Drsq(dnode *&t, int l, int r)
{
	dnode *lt, *rt;
	split(t, r, t, rt);
	split(t, l - 1, lt, t);
	pii res = mp(-1, -1);
	if (t != NULL && t -> d)
		res = mp(t -> numx, t -> numy);
	t = merge(merge(lt, t), rt);
	return res;
}

int main()
{
	//srand(7);
	int n;
	cin >> n;
	dnode *t = NULL;
	for (int i = 0; i < n; i++)
	{
		int q, w;
		cin >> q >> w;
		t = merge(t, new dnode(q, w, i));
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++)
	{
		int l, r;
		cin >> l >> r;
		pii e = Drsq(t, l, r);
		cout << e.first + 1 << " " << e.second + 1 << endl;
	}
    return 0;
}