#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <map>

using namespace std;

struct Two{
    int x, y;
    Two(){};
    Two(int _x, int _y): x(_x), y(_y){};
};

const int lt = 1 << 17;
int mtree[lt << 1], mnum[lt << 1];
int al[120000], ar[120000]; int n;
int pl[120000], pr[120000];

void norm(int * a, int n)
{
    map < int, int > Q;
    int i;
    for (i = 1; i <= n; i++)
        Q[a[i]] = 0;
    i = 0;
    for (map < int, int >::iterator it = Q.begin(); it != Q.end(); it++, i++)
        it->second = i;
    for (i = 1; i <= n; i++)
        a[i] = Q[a[i]];
    Q.clear();
}

bool operator<(Two A, Two B){
    return A.x < B.x;
}
Two askmin2(int root, int pl, int pr, int l, int r)
{
    if (r < pl || pr < l)
        return Two(1 << 30, 1 << 30);
    if (l <= pl && pr <= r)
        return Two(mtree[root], mnum[root]);
    return min(askmin2(root << 1, pl, (pl + pr) / 2, l, r), askmin2(root << 1 ^ 1, (pl + pr) / 2 + 1, pr, l, r));
}

Two askmin(int l, int r)
{
    Two ret(1 << 30, 1 << 30);
    while (l < r)
    {
        ret = min(ret, min(Two(mtree[l], mnum[l]), Two(mtree[r], mnum[r])));
        l = (l + 1) >> 1;
        r = (r - 1) >> 1;
    }
    if (l == r)
        ret = min(ret, Two(mtree[l], mnum[l]));
    return ret;
}

void bred(){
    FILE * out = fopen("mosaic.in", "wt");
    int n = 100000, k = 100000;
    fprintf(out, "%d\n", n);
    for (int i = 1; i <= n; i++)
        fprintf(out, "%d %d\n", i % 3, (i + 2) % 3);
    fprintf(out, "%d\n", k);
    for (int i = 1; i <= k; i++)
        fprintf(out, "%d %d\n", min(i, n - i + 1), max(i, n - i + 1));
    fclose(out);
};

int main()
{
    //bred();
    freopen("mosaic.in", "rt", stdin);
    freopen("mosaic.out", "wt", stdout);
    scanf("%d", &n);
    int i, j;
    for (i = 1; i <= n; i++)
        scanf("%d%d", &al[i], &ar[i]);
    norm(al, n);
    norm(ar, n);
    for (i = 0; i < (lt << 1); i++)
        mtree[i] = 1 << 30;
    for (i = lt; i < (lt << 1); i++)
        mnum[i] = i - lt;
    pl[n] = pr[n] = n + 1;
    for (i = n - 1; i > 0; i--){
        if (al[i] != al[i + 1])
            pl[i] = i + 1;
        else
            pl[i] = pl[i + 1];
        if (ar[i] != ar[i + 1])
            pr[i] = i + 1;
        else
            pr[i] = pr[i + 1];
    }
    for (i = n; i > 0; i--){
        j = i + 1;
        while (j <= n){
            if (al[i] == al[j] && ar[i] == ar[j])
            {
                mtree[lt + i] = mtree[lt + j];
                break;
            }
            if (al[i] != al[j] && ar[i] != ar[j]){
                mtree[lt + i] = j;
                break;
            }
            if (al[i] == al[j])
            {
                j = pl[j];
                continue;
            }
            if (ar[i] == ar[j])
            {
                j = pr[j];
                continue;
            }
        }
    }
    /*for (i = n; i > 0; i--)
    {
        if (pl[al[i]] != 0)
            mtree[lt + i] = pl[al[i]];
        else
            mtree[lt + i] = n + 1;
        if (pr[ar[i]] != 0)
            mtree[lt + i] = min(mtree[lt + i], pr[ar[i]]);
        else
            mtree[lt + i] = min(mtree[lt + i], n + 1);
        //pl[al[i]] = i;
        //pr[ar[i]] = i;
    }*/
    for (i = lt - 1; i > 0; i--)
        if (mtree[i << 1] < mtree[i << 1 ^ 1])
            mtree[i] = mtree[i << 1], mnum[i] = mnum[i << 1];
        else
            mtree[i] = mtree[i << 1 ^ 1], mnum[i] = mnum[i << 1 ^ 1];
    int k, l, r, _r, _l;
    scanf("%d", &k);
    int x, y;
    for (i = 1; i <= k; i++)
    {
        scanf("%d%d", &_l, &_r);
        l = _l, r = _r;
        //ret = askmin2(1, lt, lt * 2 - 1, l + lt, r + lt);
        l += lt, r += lt;
        x = 1 << 30;
        while (l < r)
        {
            if (x > mtree[l])
                x = mtree[l], y = mnum[l];
            if (x > mtree[r])
                x = mtree[r], y = mnum[r];
            l = (l + 1) >> 1;
            r = (r - 1) >> 1;
        }
        if (l == r && x > mtree[l])
            x = mtree[l], y = mnum[l];
        if (x > _r)
            printf("0 0\n");
        else
            printf("%d %d\n", y, x);
    }
    return 0;
}
