#include <cstdio>
#include <vector>
#include <iostream>
using namespace std;

#define MAXN 100000

vector<int> f[MAXN];
vector<int> g[MAXN];
int fin[MAXN];
int fout[MAXN];
int gin[MAXN];
int gout[MAXN];
int ft = 0, gt = 0;

void fdfs(int v) {
	fin[v] = ft;
	++ft;
	for (int i = 0; i < (int)f[v].size(); ++i)
		fdfs(f[v][i]);
	fout[v] = ft;
	++ft;
}

void gdfs(int v) {
	gin[v] = gt;
	++gt;
	for (int i = 0; i < (int)g[v].size(); ++i)
		gdfs(g[v][i]);
	gout[v] = gt;
	++gt;
}

int main() {
	int n, x;
	int a, b;
	int k = 0;

	ios_base::sync_with_stdio(false);

	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> x;
		if (x == 0)
			a = i;
		else
			f[x - 1].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> x;
		if (x == 0)
			b = i;
		else
			g[x - 1].push_back(i);
	}

	fdfs(a);
	gdfs(b);

	for (int a = 0; a < n; ++a)
		for (int b = 0; b < n; ++b)
			if (a != b && fin[a] < fin[b] && fout[a] > fout[b] && gin[a] < gin[b] && gout[a] > gout[b])
				++k;

	cout << k;

	return 0;
}
