#include<iostream>
using namespace std;

struct point
{
	int x, y, ind;
};

point min(point a, point b)
{
	if (a.x < b.x || a.x == b.x && a.y < b.y)
		return a;
	else
		return b;
}
point max(point a, point b)
{
	if (a.x > b.x || a.x == b.x && a.y > b.y)
		return a;
	else
		return b;
}

const int sz = 131072 - 1; 
//const int sz = 7;
const int inf = 1e9 + 2;

point Min[sz * 2 + 100], Max[sz * 2 * 100];
point p, q;
int x[sz], y[sz];

void Get(int l, int r)
{
	l += sz;
	r += sz;

	p.x = inf;
	q.x = -inf;

	while (l <= r)
	{
		if (l % 2 == 1)
		{
			p = min(p, Min[l]);
			q = max(q, Max[l]);
		}
		if (r % 2 == 0)
		{
			p = min(p, Min[r]);
			q = max(q, Max[r]);
		}

		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}
int n, m;

void solve()
{
	int l, r;
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &l, &r);
		int x1 = x[l], y1 = y[l];

		for (int j = l; j <= r; j++)
		{
			if (x[j] != x1)
				x1 = -j;
			if (y[j] != y1)
				y1 = -j;
		}

		if (x1 <= 0 && y1 <= 0)
		{
			x1 = abs(x1);
			y1 = abs(y1);
		}
		else
		{
			l = y1 = 0;
		}
		cout << l << " " << y1 << endl;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	freopen("mosaic.in", "r", stdin);freopen("mosaic.out", "w", stdout);

	
	cin >> n;
	int ind;
	for (int i = 0; i < n; i++)
	{
		ind = i + sz + 1;
		scanf("%d%d", &Min[ind].x, &Min[ind].y);
		x[i] = Min[ind].x;
		y[i] = Min[ind].y;

		Min[ind].ind = i + 1;
		Max[ind] = Min[ind];				
	}	

	

	for (int i = sz; i > 0; i--)
	{
		Min[i] = min(Min[i * 2], Min[i * 2 + 1]); 
		Max[i] = max(Max[i * 2], Max[i * 2 + 1]);
	}

	int l, r;
	cin >> m;
	
	if (n <= 5000 && m <= 5000)
	{
		solve();
		return 0;
	}

	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &l, &r);
		Get(l, r);
		if (p.x == q.x || p.y == q.y)
			p.ind = q.ind = 0;
		printf("%d %d\n", p.ind, q.ind);			
	}
}