#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const int maxN = 100100;
const int p = 997;

char s1[maxN], s2[maxN];
int sum1[maxN], sum2[maxN];
long long h1[maxN], h2[maxN], deg[maxN];
int n1, n2;
int first = 0, last = 0;
char s[maxN];

long long calch(int v)
{
	if (v == 0)
	{
		return '0';
	}
	int t = 0;
	while (v)
	{
		s[t++] = v % 10 + '0';
		v /= 10;
	}
	for (int i = 0, j = t - 1; i < j; i++, j--)
	{
		swap(s[i], s[j]);
	}
	long long res = s[0];
	for (int i = 1; i < t; i++)
	{
		res = res * p + s[i];
	}
	return res;
}

long long geth(long long *h, int l, int r)
{
	return l == 0 ? h[r] : h[r] - h[l - 1] * deg[r - l + 1];
}

int get_sum(int l, int r)
{
	return l == 0 ? sum1[r] : sum1[r] - sum1[l - 1];
}

int len(int v)
{
	if (v == 0)
	{
		return 1;
	}
	int res = 0;
	while (v > 0)
	{
		res++;
		v /= 10;
	}
	return res;
}

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	deg[0] = 1;
	for (int i = 1; i < maxN; i++)
	{
		deg[i] = deg[i - 1] * p;
	}
	scanf("%s%s", &s1, &s2);
	n1 = strlen(s1);
	n2 = strlen(s2);
	for (int i = 0; i < min(n1, n2); i++)
	{
		if (s1[i] != s2[i])
		{
			break;
		}
		first++;
	}
	sum1[0] = s1[0] - '0';
	sum2[0] = s2[0] - '0';
	h1[0] = s1[0];
	for (int i = 1; i < n1; i++)
	{
		h1[i] = h1[i - 1] * p + s1[i];
		sum1[i] = sum1[i - 1] + s1[i] - '0';
	}
	h2[0] = s2[0];
	for (int i = 1; i < n2; i++)
	{
		h2[i] = h2[i - 1] * p + s2[i];
		sum2[i] = sum2[i - 1] + s2[i] - '0';
	}
	int uk1 = n1 - 1, uk2 = n2 - 2;
	while (uk1 >= 0 && uk2 >= 0 && s1[uk1] == s2[uk2])
	{
		last++;
		uk1--, uk2--;
	}
	int d = n1 - n2;
	for (int i = d + 1; ; i++)
	{
		for (int pos = 0; pos <= first; pos++)
		{
			int k = get_sum(pos, pos + i - 1);
			long long allh = calch(k) * deg[n1 - (pos + i)] + geth(h1, pos + i, n1 - 1);
			long long hs2 = geth(h2, pos, n2 - 1);
			if (allh == hs2)
			{
				printf("%d %d\n", pos + 1, pos + i);
				return 0;
			}
		}
	}
	return 0;
}