#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const int maxN = 2010;

bool boss[maxN][maxN];
vector <int> edges[2][maxN];
bool was[2][maxN];
int n;
long long res = 0;

void dfs(int v)
{
	was[0][v] = true;
	for (int i = 0; i < edges[0][v].size(); i++)
	{
		int cur = edges[0][v][i];
		if (!was[0][cur])
		{
			dfs(cur);
		}
		boss[v][cur] = true;
		for (int j = 0; j < n; j++)
		{
			if (boss[cur][j])
			{
				boss[v][j] = true;
			}
		}
	}
}

void dfs2(int par, int v)
{
	res += (boss[par][v]);
	for (int i = 0; i < edges[1][v].size(); i++)
	{
		int cur = edges[1][v][i];
		dfs2(par, cur);
	}
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < n; j++)
		{
			int a;
			scanf("%d", &a);
			a--;
			if (a < 0)
			{
				continue;
			}	
			edges[i][a].push_back(j);
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (!was[0][i])
		{
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++)
	{
		dfs2(i, i);
	}
	cout << res << endl;
	return 0;
}