#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const int maxN = 100100;

struct Segment{
	int l, r, type;
	Segment(): l(0), r(0), type(0){}
	Segment(int _l, int _r, int _type): l(_l), r(_r), type(_type){}
};

int n, a, b, len1 = 0, len2 = 0;
Segment ar1[maxN], ar2[maxN];

int bin_s(Segment *ar, int v, int len)
{
	int l = 0, r = len, x;
	while (l + 1 < r)
	{
		x = (l + r) / 2;
		if (v >= ar[x].l)
		{
			l = x;
		}
		else
		{
			r = x;
		}
	}
	return l;
}

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d%d%d", &n, &a, &b);
	ar1[len1++] = Segment(1, 1, a);
	ar2[len2++] = Segment(1, 1, b);
	for (int i = 2; i <= n; i++)
	{
		scanf("%d%d", &a, &b);
		if (a == ar1[len1 - 1].type)
		{
			ar1[len1 - 1].r++;
		}
		else
		{
			ar1[len1++] = Segment(i, i, a);
		}
		if (b == ar2[len2 - 1].type)
		{
			ar2[len2 - 1].r++;
		}
		else
		{
			ar2[len2++] = Segment(i, i, b);
		}
	}
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &a, &b);
		int l1, r1, l2, r2;
		l1 = bin_s(ar1, a, len1);
		r1 = bin_s(ar1, b, len1);
		l2 = bin_s(ar2, a, len2);
		r2 = bin_s(ar2, b, len2);
		if (l1 == r1 || l2 == r2)
		{
			printf("0 0\n");
			continue;
		}
		int u11 = l1, u21 = l2;
		while (u11 < len1 && u21 < len2)
		{
			bool b = false;
			int u12 = r1, u22 = r2;
			while (u11 < u12 && u21 < u22)
			{
				if (ar1[u11].type != ar1[u12].type && ar2[u21].type != ar2[u22].type)
				{
					b = true;
					printf("%d %d\n", min(ar1[u11].r, ar2[u21].r), max(ar1[u12].l, ar2[u22].l));
					break;
				}
				if (ar1[u12].l < ar2[u22].l)
				{
					u22--;
				}
				else
				{
					if (ar1[u12].l == ar2[u22].l)
					{
						u12--;
						u22--;
					}
					else
					{
						u12--;
					}
				}
			}
			if (b)
			{
				break;
			}
			if (ar1[u11].r > ar2[u21].r)
			{
				u21++;
			}
			else
			{
				if (ar1[u11].r == ar2[u21].r)
				{
					u11++, u21++;
				}
				else
				{
					u11++;
				}
			}
		}
	}
	return 0;
}