#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const int maxN = 35;
const int dx[8] = {1, 1, -1, -1, 1, 0, -1, 0};
const int dy[8] = {1, -1, -1, 1, 0, -1, 0, 1};

struct Point{
	int x, y;
	Point(): x(0), y(0){}
	Point(int _x, int _y): x(_x), y(_y){}

	Point operator+(const Point & point)const
	{
		return Point(x + point.x, y + point.y);
	}

	Point operator-(const Point & point)const
	{
		return Point(x - point.x, y - point.y);
	}
};

int n, m, ans;
Point a;
Point lu, rd;
bool check[maxN][maxN];

void fixx()
{
	if (lu.x < 0)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < m; j++)
			{
				if (check[i][j])
				{
					if (i > 0)
					{
						check[i - 1][j] = true;
					}
					check[i][j] = false;
				}
			}
		}
		lu.x++;
	}
	if (lu.x == n)
	{
		lu.x--;
	}
	if (lu.y < 0)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < m; j++)
			{
				if (check[i][j])
				{
					if (j > 0)
					{
						check[i][j - 1] = true;
					}
					check[i][j] = false;
				}
			}
		}
		lu.y++;
	}
	if (lu.y == m)
	{
		lu.y--;
	}
	if (rd.x < 0)
	{
		rd.x++;
	}
	if (rd.x == n)
	{
		rd.x--;
	}
	if (rd.y < 0)
	{
		rd.y++;
	}
	if (rd.y == m)
	{
		rd.y--;
	}
}

bool good(int x, int y)
{
	return x >= 0 && y >= 0 && x < n && y < m;
}

bool in_zone(Point v)
{
	return v.x >= lu.x && v.x <= rd.x && v.y >= lu.y && v.y <= rd.y;
}

int x, y;

int main()
{
	scanf("%d%d%d%d", &m, &n, &a.x, &a.y);
	a.x--, a.y--;
	lu = Point(0, 0);
	rd = Point(n - 1, m - 1);
	while (true)
	{
		if (in_zone(a))
		{
			x = 0, y = 0;
			if (!check[a.x - lu.x][a.y - lu.y])
			{
				ans = 1;
			}
			else
			{
				int hor = -1, pl = -1;
				for (int i = 0; i < 8; i++)
				{
					Point now = a + Point(dx[i], dy[i]), bad = now - lu;
					if (in_zone(now))
					{
						if (!check[bad.x][bad.y])
						{
							hor = i;
						}
						else
						{
							pl = i;
						}
					}
				}
				if (hor >= 0)
				{
					x = dx[hor];
					y = dy[hor];
					a = a + Point(x, y);
					ans = 1;
				}
				else
				{
					x = dx[pl];
					y = dy[pl];
					ans = 0;
					a = a + Point(x, y);
				}
			}
		}
		else
		{
			int hor = -1, pl = -1;
			for (int i = 0; i < 8; i++)
			{
				Point now = a + Point(dx[i], dy[i]), bad = now - lu;
				if (in_zone(now))
				{
					if (!check[bad.x][bad.y])
					{
						hor = i;
					}
					else
					{
						pl = i;
					}
				}
			}
			if (hor >= 0)
			{
				x = dx[hor];
				y = dy[hor];
				a = a + Point(x, y);
				ans = 1;
			}
			else
			{
				x = dx[pl];
				y = dy[pl];
				ans = 0;
				a = a + Point(x, y);
			}
		}
		printf("%d %d %d\n", x, y, ans);
		check[a.x][a.y] = true;
		fflush(stdout);
		scanf("%d", &ans);
		if (ans == 1)
		{
			break;
		}
		scanf("%d %d", &x, &y);
		lu = lu + Point(x, y);
		rd = rd + Point(x, y);
		fixx();
	}
	return 0;
}