/*
 * b.cpp
 *
 *  Created on: 12.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

#define INF __INT_MAX__
#define BASE 262144

vector <int> a[100001], b[100001];
int order[1000001];
int ordc = BASE;
int first[100001], h[100001];
int n;
long long res = 0;

void dfs_precount(int u, int ch) {
	first[u] = ordc - BASE;
	h[u] = ch;
	order[ordc++] = u;
	for (size_t i = 0; i < a[u].size(); ++i) {
		int v = a[u][i];
		dfs_precount(v, ch + 1);
		order[ordc++] = u;
	}
}

inline int getmin(int u, int v) {
	return h[u] > h[v] ? v : u;
}

int get(int lq, int rq, int u = 1, int l = 0, int r = BASE - 1) {
	if (l >= lq && r <= rq)
		return order[u];
	if (l > rq || r < lq)
		return n;
	return getmin(get(lq, rq, u * 2, l, l + (r - l + 1) / 2 - 1),
			get(lq, rq, u * 2 + 1, l + (r - l + 1) / 2, r));
}

inline int lca(int u, int v) {
	if (first[u] > first[v])
		swap(u, v);
	return get(first[u], first[v]);
}

int lst[100001], lstc = 0;

void dfs(int u) {
	for (int i = 0; i < lstc; ++i)
		if (lca(u, lst[i]) == lst[i])
			++res;
	lst[lstc++] = u;
	for (size_t i = 0; i < b[u].size(); ++i)
		dfs(b[u][i]);
	lstc--;
}

int main() {
#ifndef LOCAL_BUILD
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	int q;
	cin >> n;
	int aroot, broot;
	for (int i = 0; i < n; ++i) {
		cin >> q;
		if (q)
			a[q - 1].push_back(i);
		else
			aroot = i;
	}
	for (int i = 0; i < n; ++i) {
		cin >> q;
		if (q)
			b[q - 1].push_back(i);
		else
			broot = i;
	}
	fill(order, order + BASE * 2, n);
	h[n] = INF;
	dfs_precount(aroot, 0);
	for (int i = BASE - 1; i > 0; --i)
		order[i] = getmin(order[i * 2], order[i * 2 + 1]);

	/*
	for (int i = 0; i < n; ++i)
		cout << first[i] << ' ';
	cout << endl;
	for (int i = 0; i < n; ++i)
		cout << h[i] << ' ';
	cout << endl;
	*/

	dfs(broot);
	cout << res;
}
