/*
 * b.cpp
 *
 *  Created on: 14.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <iostream>
#include <vector>
#include <memory.h>

#define INF __INT_MAX__
#define UNSET -1
#define UD -2

using namespace std;

vector <int> s[100001];
int ans[100001];

typedef struct node * lnk;

struct node {
	int zero, val;
	lnk to0, to1, par;
	node() {
		val = UNSET;
		zero = 1;
		to0 = to1 = par = 0;
	}
	node(int _val, int _zero, lnk _par, lnk _to0, lnk _to1) {
		val = _val;
		zero = _zero;
		to0 = _to0;
		to1 = _to1;
		par = _par;
	}
};

lnk root = new node(UNSET, 0, 0, 0, 0);

inline void addval(int val, lnk cur) {
	if (cur->val != UNSET && cur->val != val)
		cur->val = UD;
	else
		cur->val = val;
}

void dfs(lnk cur, int h) {
	//cout << "h: " << h << " val: " << cur->val << endl;
	if (cur->val != UD && cur->val != UNSET && ans[cur->val] > h)
		ans[cur->val] = h;
	if (cur->zero)
		h += cur->zero - 1;
	if (cur->to0)
		dfs(cur->to0, h + 1);
	if (cur->to1)
		dfs(cur->to1, h + 1);
}

int main() {
#ifndef LOCAL_BUILD
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	int n, m, q, w;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> q;
		for (int j = 0; j < q; ++j) {
			cin >> w;
			s[w - 1].push_back(i);
		}
	}
	for (int i = 0; i < n; ++i)
		s[i].push_back(m);
	for (int i = 0; i < n; ++i) {
		lnk cur = root;
		addval(i, cur);
		int pos = 0, prev = 0;
		for (size_t j = 0; j < s[i].size(); ++j) {
			int c = s[i][j];
			while (prev != c) {
				if (cur->zero - pos + prev >= c) {
					pos += c - prev;
					prev = c;
					if (cur->zero == pos) {
						//IN CUR
						addval(i, cur);
					} else {
						//MAKE NEW NODE
						lnk cur1 = new node(cur->val, pos, cur->par, cur, 0);
						addval(i, cur1);
						cur->zero -= pos;
						cur->par->to0 = cur1;
						cur->par = cur1;
						cur = cur1;
						pos = 0;
					}
				} else {
					prev += cur->zero - pos;
					pos = cur->zero;
					addval(i, cur);
					if (cur->to0) {
						//GO TO NEXT NODE
						cur = cur->to0;
						pos = 0;
					} else {
						//MAKE NEW NODE TO END
						lnk cur1 = new node(i, c - prev, cur, 0, 0);
						cur->to0 = cur1;
						cur = cur1;
						pos = cur->zero;
						prev = c;
					}
				}
			}
			if (cur->to1) {
				cur = cur->to1;
				pos = 0;
				addval(i, cur);
			} else {
				lnk cur1 = new node(i, 0, cur, 0, 0);
				cur->to1 = cur1;
				cur = cur1;
				pos = 0;
			}
			++prev;
		}
		//dfs(root, 0);
		//cout << endl;
	}
	fill(ans, ans + n, INF);
	dfs(root, 0);
	for (int i = 0; i < n; ++i)
		cout << (ans[i] == INF ? 0 : ans[i]) << ' ';
}
