#include<fstream>
#include<vector>

using namespace std;

ifstream cin("mosaic.in");
ofstream cout("mosaic.out");

int part_size;
int num_parts;

struct Pair
{
    int x, y;
};

bool AreGood(Pair A, Pair B)
{
    return (A.x == B.x || A.y == B.y);
}

istream & operator >> (istream & cin, Pair &P)
{
    cin >> P.x >> P.y;
}

ostream & operator << (ostream & cout, Pair &P)
{
    cout  << P.x << " " << P.y;
}

int main()
{
    int n;
    cin >> n;
    Pair A[n];
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
    }
    int A1[n];
    int A2[n];
    A1[0] = 1;
    A2[0] = 1;
    for (int i = 1; i < n; i++)
    {
        if (A[i].x != A[i - 1].x)
        {
            A1[i] = A1[i - 1] + 1;
        }
        else
        {
            A1[i] = A1[i - 1];
        }
        if (A[i].y != A[i - 1].y)
        {
            A2[i] = A2[i - 1] + 1;
        }
        else
        {
            A2[i] = A2[i - 1];
        }
    }
    vector <int> B1, B2;
//    B1.push_back(0);
//    B2.push_back(0);
    for (int i = 1; i < n; i++)
    {
        if (A1[i] != A1[i - 1])
        {
            B1.push_back(i - 1);
        }
        if (A2[i] != A2[i - 1])
        {
            B2.push_back(i - 1);
        }
    }
    B1.push_back(n - 1);
    B2.push_back(n - 1);

    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        if (A1[l] == A1[r] || A2[l] == A2[r])
        {
            cout << "0 0" << endl;
            continue;
        }
        int lp1 = 0;
        int lp2 = 0;
        int ll = 0, rr = B1.size();
        while (ll < rr - 1)
        {
            int mm = (ll + rr) / 2;
            if (B1[mm] < l)
            {
                ll = mm;
            }
            else
            {
                rr = mm;
            }
        }
        lp1 = ll;
        ll = 0;
        rr = B2.size();
        while (ll < rr - 1)
        {
            int mm = (ll + rr) / 2;
            if (B2[mm] < l)
            {
                ll = mm;
            }
            else
            {
                rr = mm;
            }
        }
        lp2 = ll;


        while (B1[lp1] < l)
        {
            lp1++;
        }
        while (B2[lp2] < l)
        {
            lp2++;
        }
        //cout << B1[lp1] << " " << B2[lp2] << endl;
        if (B2[lp2] > B1[lp1])
        {
            swap(lp2, lp1);
            swap(B2, B1);
        }
        if(!AreGood(A[l], A[B1[lp1] + 1]))
        {
            cout << l + 1 << " " << B1[lp1] + 2 << endl;
        }
        else
        {
            cout << B2[lp2] + 2 << " " << B1[lp1] + 2 << endl;
        }
    }

}
