#include<fstream>

using namespace std;

ifstream cin("mosaic.in");
ofstream cout("mosaic.out");

int part_size;
int num_parts;

struct Pair
{
    int x, y;
};

bool AreGood(Pair A, Pair B)
{
    return (A.x == B.x || A.y == B.y);
}

istream & operator >> (istream & cin, Pair &P)
{
    cin >> P.x >> P.y;
}

ostream & operator << (ostream & cout, Pair &P)
{
    cout  << P.x << " " << P.y;
}

bool operator == (Pair &A, Pair &B)
{
    return (A.x == B.x && A.y == B.y);
}

Pair ANS[1][5000][5000];

int main()
{
    int n;
    cin >> n;
    //part_size = sqrt(n);
    part_size = n;
    Pair A[n + part_size + 1];
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
    }
    for (int i = n; i <= n + part_size; i++)
    {
        A[i].x = -1;
        A[i].y = -1;
    }
    num_parts = (n + part_size - 1) / part_size;
    //cout << "*" << num_parts << endl;

    Pair Zero;
    Zero.x = 0;
    Zero.y = 0;



    for (int i = 0; i < num_parts; i++)
    {
        for (int j = 0; j < part_size; j++)
        {
            for (int k = 0; k < part_size - j; k++)
            {
                if (ANS[i][j][j + k] == Zero)
                {
                    if (!AreGood(A[j + part_size * i], A[j + k + part_size * i]))
                    {
                        int jj = j;
                        int kk = k;
                        //cout << "**" << j << " " << j + k << endl;
                        while (ANS[i][jj][jj + kk] == Zero && jj <= j)
                        {
                            for (int ii = 0; jj + ii + kk < part_size && jj + ii <= j; ii++)
                            {

                                //cout << "*" << jj + ii << " " << jj + kk + ii << endl;
                                ANS[i][jj + ii][jj + kk + ii].x = j + 1;
                                ANS[i][jj + ii][jj + kk + ii].y = j + k + 1;
                            }

                            jj = max(jj - 1, 0);
                            kk++;
                        }
                    }
                }
            }
        }
    }



    int m;
    cin >> m;
    int l, r;
    for (int i = 0; i < m; i++)
    {
        cin >> l >> r;
        cout << ANS[0][l - 1][r - 1] << endl;
    }

}
