#include <iostream>
#include <cstdio>

using namespace std;

#define SIZE 35
#define ABS(x) ( ( (x) > 0 ) ? (x) : ( - (x) ) )

int n, m, x, y;

bool ppos[SIZE][SIZE];
bool used[SIZE][SIZE];

void input() {
	cin >> n >> m >> x >> y;
	x--;y--;
	swap(n, m);
}

void com(int dx, int dy, int s) {
	cout << dx << " " << dy << " " << s << endl;
	cout.flush();
}

bool is_correct(int p, int q) {
	return p >= 0 && p < n && q >= 0 && q < m;
}

int get_dist(int i, int j) {
	return max(ABS(i-x), ABS(j-y));
}

void solve() {
	memset(ppos, 1, sizeof(ppos));
	com(0, 0, 1);
	int s = 0, dx, dy;
	cin >> s >> dx >> dy;
	while (!s) {
		ppos[x][y] = false;
		memset(used, 0, sizeof(used));
		int ex = -500, ey = -500;
		if (dx || dy)
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) 
				if (ppos[i][j]) {
					int p = i + dx;
					int q = j + dy;
					if (is_correct(p, q)) {
						used[p][q] = true;
						ppos[p][q] = true;
						ex = p; ey = q;
					}
					if (!used[i][j]) {
						ppos[i][j] = false;
					}
				}

		int dist = get_dist(ex, ey);

		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (ppos[i][j] && get_dist(i, j) < dist) {
					ex = i;
					ey = j;
					dist = get_dist(i, j);
				}

		/*cout << endl;
		for (int i = m-1; i >= 0 ; i--) {
			for (int j = 0; j < n; j++) {
				if (x == j && i == y)
					cout << "E";
				else
				if (ppos[j][i])
					cout << "T";
				else
					cout << "F";
			}
			cout << endl;
		}
		cout << ex << " " << ey << endl;*/

		int rx = 0, ry = 0;
		if (ex > x)
			rx = 1;
		else
		if (ex < x)
			rx = -1;

		if (ey > y)
			ry = 1;
		else if (ey < y)
			ry = -1;

		x+=rx; y+=ry;
		com(rx, ry, ppos[x][y] ? 1 : 0);
		cin >> s >> dx >> dy;
	}
}

int main() {
	input();
	solve();
	return 0;
}