#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

#define SIZE 17

int n, k;

int vip[SIZE];
bool isvip[SIZE];

void input() {
	cin >> n >> k;
	for (int i = 0; i < k; i++) {
		cin >> vip[i];
		vip[i]--;
		isvip[vip[i]] = true;
	}
}

int perm[SIZE];
bool used[SIZE];

int calc(int m) {
	int dp[SIZE][SIZE];
	memset(dp, 0, sizeof(dp));
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++) {
			int x = i+1;
			int y = j+1;
			if (perm[i] == j) {
				dp[x][y] = max(dp[x-1][y-1]+1, max(dp[x-1][y], dp[x][y-1]));
			} else
				dp[x][y] = max(dp[x-1][y], dp[x][y-1]);
		}
	if (dp[m][n] == k) return 1;
	return 0;
}

int rec(int cur, int v) {
	if (v == k) {
		if (!calc(cur))
			return 0;
	}
	if (cur == n) {
		return calc(n);
	}
	int res = 0;
	for (int i = 0; i < n; i++) {
		if (!isvip[i] && !used[i]) {
			used[i] = true;
			perm[cur] = i;
			res += rec(cur+1, v);
			used[i] = false;
		}
	}
	if (v < k) {
		int vp = vip[v];
		used[vp] = true;
		perm[cur] = vp;
		res += rec(cur+1, v+1);
		used[vp] = false;
	}
	return res;
}

void solve() {
	cout << rec(0, 0);
}


int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	input();
	solve();
	return 0;
}