#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <map>

#define mp make_pair

using namespace std;

#define vt pair<pair<int, int>, int>

const int INF = 2000000000;
const int maxn = 200000 << 2;
vt rmq0[maxn], rmq1[maxn], rmq2[maxn], rmq3[maxn];
int n;

void insert(vt rmq[], int i, vt w, bool minf) {
    int id = 1, l = 0, r = n, m;
    while (l < r) {
        m = (l + r) >> 1;
        id <<= 1;
        if (i <= m)
            r = m;
        else l = m + 1, ++id;
    }
    rmq[id] = w;
    id >>= 1;
    while (id >= 1) {
        if (minf) 
            rmq[id] = min(rmq[id << 1], rmq[(id << 1) | 1]);
        else rmq[id] = max(rmq[id << 1], rmq[(id << 1) | 1]);
        id >>= 1;
    }
}

vt getmin(vt rmq[], int i, int l, int r, int nl, int nr, bool minf) {
    if (nr < l || r < nl) return minf ? mp(mp(INF, INF), INF) : mp(mp(-INF, -INF), -INF);
    if (nl <= l && r <= nr) return rmq[i];
    int m = (l + r) >> 1;
    if (minf)
    return min(getmin(rmq, i << 1, l, m, nl, nr, minf), 
               getmin(rmq, (i << 1) | 1, m + 1, r, nl, nr, minf));
    return max(getmin(rmq, i << 1, l, m, nl, nr, minf), 
               getmin(rmq, (i << 1) | 1, m + 1, r, nl, nr, minf));
}

int main() {
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    cin >> n;
	int aa, bb;
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &aa, &bb);
        insert(rmq0, i, mp(mp(aa, bb), i), 1);
        insert(rmq1, i, mp(mp(aa, bb), i), 0);
        
        insert(rmq2, i, mp(mp(bb, aa), i), 1);
        insert(rmq3, i, mp(mp(bb, aa), i), 0);
    }
    int m, l, r;
    cin >> m;
    vt a[4];
    for (int i = 0; i < m; ++i) {
        scanf("%d%d", &l, &r);
        --l, --r;
        a[0] = getmin(rmq0, 1, 0, n, l, r, 1);
        a[1] = getmin(rmq1, 1, 0, n, l, r, 0);
        a[2] = getmin(rmq2, 1, 0, n, l, r, 1);
        a[3] = getmin(rmq3, 1, 0, n, l, r, 0);
		swap(a[2].first.first, a[2].first.second);
		swap(a[3].first.first, a[3].first.second);
        bool good = 0;
        for (int ah = 0; ah < 3 && (!good); ++ah)
            for (int bh = ah + 1; bh < 3; ++bh) 
                if (a[ah].first.first != a[bh].first.first &&
                    a[ah].first.second != a[bh].first.second) {
                    good = 1;
                    printf("%d %d\n", a[ah].second + 1, a[bh].second + 1);
                }
        if (!good) {
            printf("0 0\n");
        }
    }
}
