#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>
using namespace std;

struct vert{
	vert * lp, * rp;
	int sum;
	int val;
	int size;
	int h;
	vert(int _val) {
		sum = val = _val;
		size = 1;
		h = rand();
		lp = rp = 0;
	}
};

void norm(vert * x) {
	if (x == 0) return;
	x->sum = x->val;
	x->size = 1;
	if (x->lp != 0) {x->sum += x->lp->sum; x->size += x->lp->size;}
	if (x->rp != 0) {x->sum += x->rp->sum; x->size += x->rp->size;}
}

vert * merge(vert * a, vert * b) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (a->h > b->h) {
		a->rp = merge(a->rp, b);
		norm(a);
		return a;
	} else {
		b->lp = merge(a, b->lp);
		norm(b);
		return b;
	}
}

pair<vert *, vert * > split(vert * r, int k) {
	if (r == 0) return make_pair(r, r);
	int lsize = 1 + ((r->lp == 0)?0:r->lp->size);
	if (lsize <= k) {
		pair<vert*, vert*> buf = split(r->rp, k - lsize);
		r->rp = buf.first; norm(r);
		return make_pair(r, buf.second);
	} else {
		pair<vert*, vert*> buf = split(r->lp, k);
		r->lp = buf.second; norm(r);
		return make_pair(buf.first, r);
	}
}

#define MAXN 100000
vector<int> A[MAXN];
vector<int> B[MAXN];
int n;
int Ar, Br;
bool vis[MAXN];
int tin[MAXN], tout[MAXN];
int t = 0;
vert * rmq = 0;

void CrQu(int v) {
	if (vis[v]) return;
	vis[v] = true;
	tin[v] = t++;
	rmq = merge(rmq, new vert(1));
	for (int i = 0; i < A[v].size(); i++)
		CrQu(A[v][i]);
	rmq = merge(rmq, new vert(1));
	tout[v] = t++;
}
vector<int> ts;

void topsort(int v) {
	if (vis[v]) return;
	vis[v] = true;
	ts.push_back(v);
	for (int i = 0; i < B[v].size(); i++)
		topsort(B[v][i]);
}

int sum(int l, int r) {
	pair<vert*, vert*> buf = split(rmq, r + 1);
	vert * rp = buf.second;
	buf = split(buf.first, l);
	int res = buf.second->sum;
	rmq = merge(merge(buf.first, buf.second), rp);
	return res;
}

void vminus(int pos, int delta) {
	pair<vert*, vert*> buf = split(rmq, pos);
	vert* lp = buf.first;
	buf = split(buf.second, 1);
	buf.first->val -= delta;
	norm(buf.first);
	rmq = merge(lp, merge(buf.first, buf.second));
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		int ai; scanf("%d", &ai); ai--;
		if (ai == -1) Ar = i;
		else A[ai].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int bi; scanf("%d", &bi); bi--;
		if (bi == -1) Br = i;
		else B[bi].push_back(i);
	}
	memset(vis, 0, sizeof vis);
	CrQu(Ar);
	memset(vis, 0, sizeof vis);
	topsort(Br);
	int res = 0;
	for (int i = 0; i < n; i++) {
		res += sum(tin[ts[i]], tout[ts[i]])/2 - 1;
		vminus(tin[ts[i]], 2);
	}
	printf("%d", res);
	return 0;
}
