#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>
using namespace std;

struct vert{
	vert * lp, * rp;
	int key;
	int size;
	int h;
	vert(int _key) {
		key = _key;
		size = 1;
		h = rand();
		lp = rp = 0;
	}
};

void norm(vert * x) {
	if (x == 0) return;
	x->size = 1;
	if (x->lp != 0) {x->size += x->lp->size;}
	if (x->rp != 0) {x->size += x->rp->size;}
}

vert * merge(vert * a, vert * b) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (a->h > b->h) {
		a->rp = merge(a->rp, b);
		norm(a);
		return a;
	} else {
		b->lp = merge(a, b->lp);
		norm(b);
		return b;
	}
}

pair<vert *, vert * > split(vert * r, int k) {
	if (r == 0) return make_pair(r, r);
	if (r->key <= k) {
		pair<vert*, vert*> buf = split(r->rp, k);
		r->rp = buf.first; norm(r);
		return make_pair(r, buf.second);
	} else {
		pair<vert*, vert*> buf = split(r->lp, k);
		r->lp = buf.second; norm(r);
		return make_pair(buf.first, r);
	}
}

#define MAXN 100000
vector<int> A[MAXN];
vector<int> B[MAXN];
int n;
int Ar, Br;
bool vis[MAXN];
int tin[MAXN], tout[MAXN];
int t = 0;
int res = 0;

void dfsA(int v) {
	if (vis[v]) return;
	vis[v] = true;
	tin[v] = t++;
	for (int i = 0; i < A[v].size(); i++) {
		dfsA(A[v][i]);
	}
	tout[v] = t++;
}

int size(vert * rmq, int l, int r) {
	pair<vert*, vert*> buf = split(rmq, r + 1);
	vert * rp = buf.second;
	buf = split(buf.first, l);
	int res = (buf.second == 0)?0:buf.second->size;
	rmq = merge(merge(buf.first, buf.second), rp);
	return res;
}

vert* add(vert * x, vert * y) {
	pair<vert*, vert * > buf = split(x, y->key);
	return merge(merge(buf.first, y), buf.second);
}

vert* dfsB(int v) {
	if (vis[v]) return 0;
	vert * utree = 0;
	vis[v] = true;
	for (int i = 0; i < B[v].size(); i++)
		utree = merge(utree, dfsB(B[v][i]));
	res += size(utree, tin[v], tout[v]);
	return add(utree, new vert(tin[v]));
}


int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		int ai; scanf("%d", &ai); ai--;
		if (ai == -1) Ar = i;
		else A[ai].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int bi; scanf("%d", &bi); bi--;
		if (bi == -1) Br = i;
		else B[bi].push_back(i);
	}
	memset(vis, 0, sizeof vis);
	dfsA(Ar);
	memset(vis, 0, sizeof vis);
	dfsB(Br);
	printf("%d", res);
	return 0;
}
