#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>
using namespace std;

struct vert{
	vert * lp, * rp;
	int key;
	int size;
	int h;
	vert(int _key) {
		key = _key;
		size = 1;
		h = rand();
		lp = rp = 0;
	}
};

void norm(vert * x) {
	if (x == 0) return;
	x->size = 1;
	if (x->lp != 0) {x->size += x->lp->size;}
	if (x->rp != 0) {x->size += x->rp->size;}
}

vert * merge(vert * a, vert * b) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (a->h > b->h) {
		a->rp = merge(a->rp, b);
		norm(a);
		return a;
	} else {
		b->lp = merge(a, b->lp);
		norm(b);
		return b;
	}
}

pair<vert *, vert * > split(vert * r, int k) {
	if (r == 0) return make_pair(r, r);
	if (r->key <= k) {
		pair<vert*, vert*> buf = split(r->rp, k);
		r->rp = buf.first; norm(r);
		return make_pair(r, buf.second);
	} else {
		pair<vert*, vert*> buf = split(r->lp, k);
		r->lp = buf.second; norm(r);
		return make_pair(buf.first, r);
	}
}

#define MAXN 100000
vector<int> A[MAXN];
vector<int> B[MAXN];
int n;
int Ar, Br;
int tin[MAXN], tout[MAXN];
int tin2[MAXN], tout2[MAXN];
int t = 0;
long long res = 0;

void dfsA(int v) {
	tin[v] = t++;
	for (int i = 0; i < A[v].size(); i++)
		dfsA(A[v][i]);
	tout[v] = t++;
}

pair<int, vert*> size(vert * rmq, int l, int r) {
	pair<vert*, vert*> buf = split(rmq, r);
	vert * rp = buf.second;
	buf = split(buf.first, l - 1);
	int res = (buf.second == 0)?0:buf.second->size;
	rmq = merge(merge(buf.first, buf.second), rp);
	return make_pair(res, rmq);
}

vert* add(vert * x, vert * y) {
	pair<vert*, vert * > buf = split(x, y->key);
	return merge(merge(buf.first, y), buf.second);
}

vert* dfsB(int v) {
	vert * utree = 0;
	for (int i = 0; i < B[v].size(); i++)
		utree = merge(utree, dfsB(B[v][i]));
	pair<int, vert*> buf = size(utree, tin[v], tout[v]);
	res = res + buf.first;
	return add(buf.second, new vert(tin[v]));
}


void dfsB2(int v) {
	tin2[v] = t++;
	for (int i = 0; i < B[v].size(); i++)
		dfsB2(B[v][i]);
	tout2[v] = t++;
}

int a[MAXN];
int b[MAXN];

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	/*for (int ii = 0;;ii++){
		n = 6;
		t = 0;
		res = 0;
		for (int i = 0; i < n; i++) {A[i].clear(); B[i].clear();}*/
		for (int i = 0; i < n; i++) {
			int ai; scanf("%d", &ai); ai--;
			//int ai = (i==0)?-1:(rand()%i);
			//if (ai >= i) return 4;
			a[i] = ai;
			if (ai == -1) Ar = i;
			else A[ai].push_back(i);
		}
		for (int i = 0; i < n; i++) {
			int bi; scanf("%d", &bi); bi--;
			//int bi = (i==0)?-1:(rand()%i);
			//if (bi >= i) return 4;
			b[i] = bi;
			if (bi == -1) Br = i;
			else B[bi].push_back(i);
		}
		dfsA(Ar);
		//dfsB(Br);
		dfsB2(Br);
		//printf("%lld", res);
		for (int i = 0; i < n; i++){
			for (int j = 0; j < n; j++) {
				if (tin[i] < tin[j] && tout[j] < tout[i] &&
						tin2[i] < tin2[j] && tout2[j] < tout2[i]) {
					res++;
				}
			}
		}
		printf("%lld", res);
		/*if (res != 0) {
			for (int i = 0; i < n; i++)
				printf(" %d", a[i]);
			printf("\n");
			for (int j = 0; j < n; j++)
				printf(" %d", b[j]);
			return 0;
		}
		if (ii % 100 == 0) {
			printf("--\n");
			fflush(stdout);
		}
	}*/
	return 0;
}
