#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>
using namespace std;


#define int long long
struct vert{
	vert * lp, * rp;
	int key;
	int size;
	int sum;
	int val;
	int h;
	vert(int _key, int _val) {
		key = _key;
		val = _val;
		size = 1;
		sum = _val;
		h = rand();
		lp = rp = 0;
	}
};

void norm(vert * x) {
	if (x == 0) return;
	x->size = 1;
	x->sum = x->val;
	if (x->lp != 0) {x->size += x->lp->size; x->sum += x->lp->sum;}
	if (x->rp != 0) {x->size += x->rp->size; x->sum += x->rp->sum;}
}

vert * merge(vert * a, vert * b) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (a->h > b->h) {
		a->rp = merge(a->rp, b);
		norm(a);
		return a;
	} else {
		b->lp = merge(a, b->lp);
		norm(b);
		return b;
	}
}

pair<vert *, vert * > split(vert * r, int k) {
	if (r == 0) return make_pair(r, r);
	if (r->key <= k) {
		pair<vert*, vert*> buf = split(r->rp, k);
		r->rp = buf.first; norm(r);
		return make_pair(r, buf.second);
	} else {
		pair<vert*, vert*> buf = split(r->lp, k);
		r->lp = buf.second; norm(r);
		return make_pair(buf.first, r);
	}
}

#define MAXN 100100
vector<int> A[MAXN];
vector<int> B[MAXN];
int n;
int Ar, Br;
int tin[MAXN], tout[MAXN];
int t = 0;
long long res = 0;

void dfsA(int v) {
	tin[v] = t++;
	for (int i = 0; i < A[v].size(); i++)
		dfsA(A[v][i]);
	tout[v] = t++;
}

pair<int, vert*> sum(vert * rmq, int l, int r) {
	pair<vert*, vert*> buf = split(rmq, r);
	vert * rp = buf.second;
	buf = split(buf.first, l - 1);
	int res = (buf.second == 0)?0:buf.second->sum;
	rmq = merge(merge(buf.first, buf.second), rp);
	return make_pair(res, rmq);
}

vert* add(vert * x, vert * y) {
	pair<vert*, vert * > buf = split(x, y->key);
	return merge(merge(buf.first, y), buf.second);
}

vert * del(vert * x, int key) {
	pair<vert*, vert*> buf = split(x, key);
	vert * rp = buf.second;
	buf = split(buf.first, key - 1);
	return merge(buf.first, rp);
}

vert * stack = 0;

void dfsB(int v) {
	stack = add(stack, new vert(tin[v], 1));
	stack = add(stack, new vert(tout[v], -1));
	for (int i = 0; i < B[v].size(); i++)
		dfsB(B[v][i]);
	pair<int, vert*> buf = sum(stack, 0, tin[v] - 1);
	res = res + buf.first;
	stack = buf.second;
	stack = del(stack, tin[v]);
	stack = del(stack, tout[v]);
}

#undef int
int main() {
#define int long long
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%lld", &n);
	for (int i = 0; i < n; i++) {
		int ai; scanf("%lld", &ai); ai--;
		//ai = i - 1;
		if (ai == -1) Ar = i;
		else A[ai].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int bi; scanf("%lld", &bi); bi--;
		//bi = i - 1;
		if (bi == -1) Br = i;
		else B[bi].push_back(i);
	}
	dfsA(Ar);
	dfsB(Br);
	printf("%lld", res);

	return 0;
}
