#include <set>
#include <map>
#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;
#define HASHBASE 1000000007
#define MAXN 100000

map<long long, set<int> > h2n;
long long n2h[MAXN];
int ans[MAXN];

vector<long long> hc;
vector<int> hn;

long long modpow(int k) {
	long long r = 1, h = HASHBASE;
	while (k > 0) {
		if (k & 1) {
			k--;
			r = r * h;
		} else {
			k >>= 1;
			h = h * h;
		}
	}
	return r;
}

void change(int k, int mp) {
	hc.push_back(n2h[k]);
	hn.push_back(k);
	long long h = n2h[k];
	h2n[h].erase(k);
	h = h + modpow(mp);
	n2h[k] = h;
	h2n[h].insert(k);
	hc.push_back(n2h[k]);
}

void check(int k) {
	for (int i = 0; i < hn.size(); i++) {
		if (ans[hn[i]] == -1 && h2n[n2h[hn[i]]].size() == 1) {
			ans[hn[i]] = k;
		}
	}
	hn.clear();
	for (int i = 0; i < hc.size(); i++) {
		if (h2n[hc[i]].size() == 1 && ans[*(h2n[hc[i]].begin())] == -1) {
			ans[*(h2n[hc[i]].begin())] = k;
		}
	}
	hc.clear();
}

int main() {
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	int n, m, k;
	memset(ans, -1, sizeof ans);
	memset(n2h, 0, sizeof n2h);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		h2n[0].insert(i);
	for (int i = 0; i < m; i++) {
		int ki; scanf("%d", &ki);
		for (int j = 0; j < ki; j++) {
			int a; scanf("%d", &a); a--;
			change(a, i);
		}
		check(i);
	}
	for (int i = 0; i < n; i++)
		printf(" %d", ans[i] + 1);
	return 0;
}
