#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

#define MAXN 17

int n, k;
int body[MAXN];
int nwp[MAXN];
bool used[MAXN];
bool isbd[MAXN];
int ch[MAXN];

inline void nwpc(int k) {
	nwp[k] = 1;
	for (int i = 0; i < k; i++)
		if (ch[i] < ch[k])
			nwp[k] = max(nwp[k], nwp[i] + 1);
}

int pereb(int ni, int ki){
	if (ni == n) return 1;
	int res = 0;
	if (ki < k) {
		ch[ni] = body[ki];
		nwpc(ni);
		if (nwp[ni] > ki + 1) return 0;
		res = pereb(ni + 1, ki + 1);
	}
	for (int i = 0; i < n; i++) {
		if (!isbd[i] && !used[i]) {
			ch[ni] = i;
			used[i] = true;
			nwpc(ni);
			if (nwp[ni] <= k)
				res += pereb(ni + 1, ki);
			used[i] = false;
		}
	}
	return res;
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	scanf("%d%d", &n, &k);
	memset(used, 0, sizeof used);
	for (int i = 0; i < k; i++) {
		scanf("%d", body + i);
		body[i]--;
		isbd[body[i]] = true;
	}
	printf("%d", pereb(0, 0));
	return 0;
}
