PROGRAM Mosiac;
  Type TTree = array[0..262151] of LongInt;
  Var a, b, amin, bmin : TTree;
      n, i, k, j, x, y, olda, oldb, ca, cb, size : LongInt;
      found : Boolean;

  Function GetSize(a : LongInt): LongInt;
    Var s : LongInt;
  Begin
    s:=1;
    while s<a do s:=s*2;
    GetSize:=s
  End;

  Function Max(a, b : LongInt): LongInt;
  Begin
    if a>b then Max:=a else Max:=b
  End;

  Function Min(a, b : LongInt): LongInt;
  Begin
    if a<b then Min:=a else Min:=b
  End;

  Function GetMax(var tree : TTree; a, b : LongInt): LongInt;
    Var i, j, res : LongInt;
  Begin
    res:=-1;
    i:=a+size-1;
    j:=b+size-1;
    while i<j do
    begin
      if (i mod 2)=1 then
        res:=Max(res, tree[i]);
      if (j mod 2)=0 then
        res:=Max(res, tree[j]);
      i:=(i+1) div 2;
      j:=(j-1) div 2
    end;
    if i=j then
      res:=Max(res, tree[i]);
    GetMax:=res
  End;

  Function GetMin(var tree : TTree; a, b : LongInt): LongInt;
    Var i, j, res : LongInt;
  Begin
    res:=-1;
    i:=a+size-1;
    j:=b+size-1;
    while i<j do
    begin
      if (i mod 2)=1 then
        res:=Min(res, tree[i]);
      if (j mod 2)=0 then
        res:=Min(res, tree[j]);
      i:=(i+1) div 2;
      j:=(j-1) div 2
    end;
    if i=j then
      res:=Min(res, tree[i]);
    GetMin:=res
  End;

  Procedure MakeTree;
    Var i : LongInt;
  Begin
    for i:=size-1 downto 1 do
    begin
      a[i]:=Max(a[2*i], a[2*i+1]);
      b[i]:=Max(b[2*i], b[2*i+1]);
      amin[i]:=Min(amin[2*i], amin[2*i+1]);
      bmin[i]:=Min(bmin[2*i], bmin[2*i+1])
    end
  End;

  Procedure SolveDumb;
  Begin
    for i:=1 to k do
    begin
      found:=FALSE;
      ReadLn(x, y);
      x:=x+size-1;
      y:=y+size-1;
      for j:=x to y-1 do
        for k:=j+1 to y do
          if (a[j]<>a[k]) AND (b[j]<>b[k]) AND (NOT found) then
          begin
            WriteLn(j-size+1, ' ', k-size+1);
            found:=TRUE;
            break
          end;
      if NOT found then WriteLn('0 0')
    end
  End;

BEGIN
  Assign(input, 'mosaic.in');
  ReSet(input);
  Assign(output, 'mosaic.out');
  ReWrite(output);

  ReadLn(n);
  size:=GetSize(n);

  for i:=1 to n do
    ReadLn(a[i+size-1], b[i+size-1]);

  ReadLn(k);

  if (n<101) AND (k<101) then
  begin
    SolveDumb;
    Close(input);
    Close(output);
    Halt(0)
  end;

  MakeTree;

  for i:=1 to k do
  begin
    ReadLn(x, y);
    found:=FALSE;
    ca:=x;
    cb:=x;

    if (GetMin(amin, x, y)=GetMax(a, x, y)) OR (GetMin(bmin, x, y)=GetMax(b, x, y))
    then
      WriteLn('0 0')
    else
      for j:=x+1 to y do
      begin
        if (a[x]<>a[j]) AND (b[x]<>b[j]) then
        begin
          found:=TRUE;
          WriteLn(x, ' ', j);
          break
        end;
        if ((a[j-1]<>a[j]) AND (b[j-1]<>b[j])) then
        begin
          found:=TRUE;
          WriteLn(j-1, ' ', j);
          break
        end
      end;

    if NOT found then WriteLn('0 0')
  end;

  Close(input);
  Close(output)
END.