#include <iostream>
#include <stdio.h>
#include <string>

#define d_ebug

#define PP 13
#define PPP 17
#define maxn 100005

using namespace std;

string A, B;
int n, m;
long long sum[maxn];
int a[maxn], b[maxn];
unsigned long long hash1[maxn], hash2[maxn];
unsigned long long hash11[maxn], hash22[maxn];
unsigned long long p[maxn];
unsigned long long pp[maxn];

void init() {
	p[0] = 1;
	for (int i = 1; i < maxn; ++i)
		p[i] = p[i - 1] * PP;
}

void init2() {
	pp[0] = 1;
	for (int i = 1; i < maxn; ++i)
		pp[i] = pp[i - 1] * PPP;
}

void hashed(int *a, int len, unsigned long long *hash) {
	hash[0] = a[0] + 1;
	for (int i = 1; i < len; ++i)
		hash[i] = hash[i - 1] + (a[i] + 1) * p[i];
}

void hashed2(int *a, int len, unsigned long long *hash) {
	hash[0] = a[0] + 1;
	for (int i = 1; i < len; ++i)
		hash[i] = hash[i - 1] + (a[i] + 1) * pp[i];
}

unsigned long long getsum(int start, int end) {
	if (start > 0)
		return sum[end] - sum[start - 1];
	else
		return sum[end];
}

unsigned long long gethash(unsigned long long *hash, int start, int end, int len) {
	unsigned long long tmp = 0;
	if (start == 0)
		tmp = hash[end];
	else
		tmp = hash[end] - hash[start - 1];
	tmp *= p[len - end];
	return tmp;
}

unsigned long long gethash2(unsigned long long *hash, int start, int end, int len) {
	unsigned long long tmp = 0;
	if (start == 0)
		tmp = hash[end];
	else
		tmp = hash[end] - hash[start - 1];
	tmp *= pp[len - end];
	return tmp;
}

bool same(int i, int j, int x, int y) {
	if (j < i && y < x)
		return true;
	return (gethash(hash1, i, j, n) == gethash(hash2, x, y, m) * p[n - m])
		&& (gethash2(hash11, i, j, n) == gethash2(hash22, x, y, m) * pp[n - m]);
}

int main() {
	init();
	init2();

	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	cin >> A;
	cin >> B;
	n = A.length();
	m = B.length();
	for (int i = 0; i < n; ++i)
		a[i] = A[i] - '0';
	for (int i = 0; i < m; ++i)
		b[i] = B[i] - '0';

	sum[0] = a[0];
	for (int i = 1; i < n; ++i)
		sum[i] = sum[i - 1] + a[i];

	hashed(a, n, hash1);
	hashed(b, m, hash2);
	hashed2(a, n, hash11);
	hashed2(b, m, hash22);

#ifdef debug
	for (int i = 0;i < n; ++i)
		cout << hash1[i] << " ";
	cout << endl;
	for (int i = 0;i < m; ++i)
		cout << hash2[i] << " ";
	cout << endl;

	cout << gethash(hash1, 0, 0, n) << endl;
	cout << gethash(hash2, 0, 0, m) << endl;
#endif

	for (int start = 0; start < n; ++start) {
		int cur = 0;
		for (int len = 1; len <= 6; ++len)  {
			if (start + len > m)
				break;
			cur = cur * 10 + b[start + len - 1];
			if (len > 1 && cur == 0)
				break;
			for (int end = start; end < n; ++end) {
				if (getsum(start, end) == cur) {
					if (same(0, start - 1, 0, start - 1) && same(end + 1, n - 1, start + len, m - 1)) {
						cout << start + 1 << " " << end + 1 << endl;
						return 0;
					}
				}
			}
		}
	}
}