
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <ctime>
   
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++) 
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--) 
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++) 
   
using namespace std;
   
typedef long long int64;
typedef pair<int, int> pii;
  
const int dx[] = {-1, -1, -1, 0, 0, 0, 1, 1, 1};
const int dy[] = {-1, 0, 1, -1, 0, 1, -1, 0, 1};
const int INF = 1E9;
const int MAXN = 40;
  
int n, m, d, cx, cy, cid, mov, z[3];
bool call, can[2][MAXN][MAXN];
  
bool correct(int x, int y) {
    return (0 <= x) && (x < m) && (0 <= y) && (y < n);
}
  
int dist(int a, int b, int c, int d) {
    return abs(a - c) + abs(b - d);
}
  
void init() {
    cid = 0;
    forn(i, m)
        forn(j, n)
            can[0][i][j] = 1;
}
  
void change() {
    cid = 1 - cid;
    forn(i, m)
        forn(j, n) {
            can[cid][i][j] = correct(i - z[1], j - z[2]) && can[1 - cid][i - z[1]][j - z[2]];
        }
}
  
int route() {
	vector<pii> elem;
	elem.push_back(make_pair(0, 0));
	FORN(a, 0, cx)
		FORN(b, 0, cy)
			elem.back().first += can[cid][a][b];
	if (elem.back().first == 0)
		elem.pop_back();

	elem.push_back(make_pair(0, 1));
	FORN(a, cx, m - 1)
		FORN(b, 0, cy)
			elem.back().first += can[cid][a][b];
	if (elem.back().first == 0)
		elem.pop_back();

	elem.push_back(make_pair(0, 2));
	FORN(a, 0, cx)
		FORN(b, cy, n - 1)
			elem.back().first += can[cid][a][b];
	if (elem.back().first == 0)
		elem.pop_back();

	elem.push_back(make_pair(0, 3));
	FORN(a, cx, m - 1)
		FORN(b, cy, n - 1)
			elem.back().first += can[cid][a][b];
	if (elem.back().first == 0)
		elem.pop_back();

	sort(elem.begin(), elem.end());
	return elem.back().second;
}

void findnear(int a0, int a1, int b0, int b1) {
    int d = INF, nd;
    FORN(i, a0, a1)
        FORN(j, b0, b1)
            if (can[cid][i][j] && d > dist(cx, cy, i, j)) {
                d = dist(cx, cy, i, j);
                nd = INF;
                mov = 0;
                forn(l, 9)
                    if (correct(cx + dx[l], cy + dy[l]) && nd > dist(cx + dx[l], cy + dy[l], i, j)) {
                        mov = l;
                        nd = dist(cx + dx[l], cy + dy[l], i, j);
                    }
            }
}
  
int main() {
   
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
   
    cin >> n >> m;
    cin >> cx >> cy;
    cx--, cy--;
    init();
  
    mov = 4;
    call = 1;
    while (true) {
        cout << dx[mov] << ' ' << dy[mov] << ' ' << int(call) << '\n';
        cout.flush();
        cin >> z[0] >> z[1] >> z[2];
        if (z[0] == 1) return 0;
  
        if (call) can[cid][cx][cy] = 0;
        change();
		d = route();
		if (d == 0) findnear(0, cx, 0, cy);
        if (d == 1) findnear(cx, m - 1, 0, cy);
		if (d == 2) findnear(0, cx, cy, n - 1);
		if (d == 3) findnear(cx, m - 1, cy, n - 1);

        cx += dx[mov], cy += dy[mov];
        call = can[cx][cy];
    }
  
    return 0;
}