#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 10000;

vector< int > g1[maxn], g2[maxn];
vector< int > p1[maxn], p2[maxn];

void dfs1(int v) {
    for (int i = 0; i < g1[v].size(); ++i) {
        dfs1(g1[v][i]);
        p1[v].push_back(g1[v][i]);
        for (int j = 0; j < p1[g1[v][i]].size(); ++j)
            p1[v].push_back(p1[g1[v][i]][j]);
    }
}

void dfs2(int v) {
    for (int i = 0; i < g2[v].size(); ++i) {
        dfs2(g2[v][i]);
        p2[v].push_back(g2[v][i]);
        for (int j = 0; j < p2[g2[v][i]].size(); ++j)
            p2[v].push_back(p2[g2[v][i]][j]);
    }
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    int n;

    scanf("%d", &n);
    int root1, root2;
    for (int i = 1; i <= n; ++i) {
        int b;
        scanf("%d", &b);
        if (b == 0)
            root1 = i;
        else
            g1[b].push_back(i);
    }

    for (int i = 1; i <= n; ++i) {
        int b;
        scanf("%d", &b);
        if (b == 0)
            root2 = i;
        else
            g2[b].push_back(i);
    }

    dfs1(root1);
    dfs2(root2);

    for (int i = 1; i <= n; ++i) {
        sort(p1[i].begin(), p1[i].end());
        sort(p2[i].begin(), p2[i].end());
    }

    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        int l1 = 0, l2 = 0;
        while (l1 < p1[i].size() && l2 < p2[i].size()) {
            if (p1[i][l1] == p2[i][l2]) {
                ++ans;
                ++l1;
                ++l2;
            } else if (p1[i][l1] > p2[i][l2])
                ++l2;
            else
                ++l1;
        }
    }

    cout << ans;

    return 0;
}
