import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class Solution {
	private static BufferedReader reader;
	private static PrintWriter writer;
	private static StringTokenizer st;
	
	private static void initST() throws Exception {
		st = new StringTokenizer(reader.readLine());
	}
	
	private static int nextInt() {
		return Integer.parseInt(st.nextToken());
	}
	
	private static ArrayList<Integer>[] ch1, ch2;
	
	private static int timer;
	
	private static int[] tin1;
	private static int[] tout1;
	private static int[] tin2;
	private static int[] tout2;
	
	private static void dfs1(int v) {
		timer++;
		tin1[v] = timer;
		
		for (int next : ch1[v]) {
			dfs1(next);
		}
		
		timer++;
		tout1[v] = timer;
	}
	
	private static void dfs2(int v) {
		timer++;
		tin2[v] = timer;
		
		for (int next : ch2[v]) {
			dfs2(next);
		}
		
		timer++;
		tout2[v] = timer;
	}
	
	private static boolean canGo1(int a, int b) {
		return (tin1[a] < tin1[b] && tout1[a] > tout1[b]);
	}
	
	private static boolean canGo2(int a, int b) {
		return (tin2[a] < tin2[b] && tout2[a] > tout2[b]);
	}
	
	public static void main(String[] args) throws Exception {
		reader = new BufferedReader(new FileReader("virus.in"));
		writer = new PrintWriter("virus.out");
		
		initST();
		
		int n = nextInt();
		
		ch1 = new ArrayList[n];
		ch2 = new ArrayList[n];
		
		for (int i = 0; i < n; i++) {
			ch1[i] = new ArrayList<Integer>();
			ch2[i] = new ArrayList<Integer>();
		}
		
		initST();
		
		int root1 = -1;
		int root2 = -1;
		
		for (int i = 0; i < n; i++) {
			int parent = nextInt() - 1;
			
			if (parent == -1) {
				root1 = i;
			}
			else {
				ch1[parent].add(i);
			}
		}
		
		initST();
		
		for (int i = 0; i < n; i++) {
			int parent = nextInt() - 1;
			
			if (parent == -1) {
				root2 = i;
			}
			else {
				ch2[parent].add(i);
			}
		}
		
		tin1 = new int[n];
		tout1 = new int[n];
		tin2 = new int[n];
		tout2 = new int[n];
		
		dfs1(root1);
		dfs2(root2);
		
		int pairs = 0;
		
		for (int i = 0; i < n - 1; i++) {
			for (int j = i + 1; j < n; j++) {
				if (canGo1(i, j) && canGo2(i, j)) {
					pairs++;
				}
				else if (canGo1(j, i) && canGo2(j, i)) {
					pairs++;
				}
			}
		}
		
		writer.print(pairs);
		writer.close();
	}
}
