import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution {
	private static BufferedReader reader;
	private static PrintWriter writer;
	private static StringTokenizer st;
	
	private static void initST() throws Exception {
		st = new StringTokenizer(reader.readLine());
	}
	
	private static int nextInt() {
		return Integer.parseInt(st.nextToken());
	}
	
	private static int[] dp;
	
	private static int u, r;
	
	private static int get(int n) {
		if (n <= 2) return dp[n];
		if (dp[n] != 0) return dp[n];
		
		if (n % 2 == 0) dp[n] = get(n / 2) + u;
		else dp[n] = Integer.MAX_VALUE;
				
		for (int i = 1; i << 1 < n; i++) {
			int v1 = get(i) + u;
			
			int j = n - (i << 1);
			int v2 = get(j) + r;
			
			dp[n] = Math.min(dp[n], Math.max(v1, v2));
		}
		
		return dp[n];
	}
	
	public static void main(String[] args) throws Exception {
		reader = new BufferedReader(new FileReader("apricot.in"));
		writer = new PrintWriter("apricot.out");
		
		initST();
		
		int n = nextInt();
		r = nextInt();
		u = nextInt();
		
		dp = new int[n + 1];
		
		dp[0] = 0;
		dp[1] = 0;
		dp[2] = u;
		
		writer.print(get(n));
		writer.close();
	}

}
