import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution {
	private static BufferedReader reader;
	private static PrintWriter writer;
	private static StringTokenizer st;
	
	private static void initST() throws Exception {
		st = new StringTokenizer(reader.readLine());
	}
	
	private static int nextInt() {
		return Integer.parseInt(st.nextToken());
	}
	
	private static long[] dp;
	
	private static int u, r;
	
	private static void get(int n) {
		if (n < 2) return;
		if (dp[n] != 0) return;
		
		if (n % 2 == 0) dp[n] = dp[n / 2] + u;
		else dp[n] = Integer.MAX_VALUE;
		
		//System.out.println("cycle start " + n);
		//System.out.println("dp[n] = " + dp[n]);
		
		for (int i = 1; (i << 1) < n; i++) {
			long v1 = dp[i] + u;
			
			int j = n - (i << 1);
			long v2 = dp[j]+ r;
			
			//System.out.println(String.format("%.0f %d %d", Math.signum(v1 - v2), v1, v2));
			
			dp[n] = Math.min(dp[n], Math.max(v1, v2));
		}
		
		//System.out.println("dp[n] = " + dp[n]);
	}
	
	public static void main(String[] args) throws Exception {
		reader = new BufferedReader(new FileReader("apricot.in"));
		writer = new PrintWriter("apricot.out");
		
		initST();
		
		int n = nextInt();
		r = nextInt();
		u = nextInt();
		
		dp = new long[n + 1];
		
		dp[0] = 0;
		dp[1] = 0;
		
		for (int i = 2; i <= n; i++) get(i);
		
		writer.print(dp[n]);
		writer.close();
	}

}
