import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Solution {
	private static BufferedReader reader;
	private static PrintWriter writer;
	private static StringTokenizer st;
	
	private static void initST() throws Exception {
		st = new StringTokenizer(reader.readLine());
	}
	
	private static int nextInt() {
		return Integer.parseInt(st.nextToken());
	}
	
	private static int getPrev(int a) {
		if (a == 0) return 9;
		else return a - 1;
	}
	
	private static int getNext(int a) {
		if (a == 9) return 0;
		else return a + 1;
	}
	
	public static void main(String[] args) throws Exception {
		reader = new BufferedReader(new FileReader("calendar.in"));
		writer = new PrintWriter("calendar.out");
		
		initST();
		int n = nextInt();
		int m = nextInt();

		int[][] data = new int[n][m];
		
		int[] lowest = new int[m];
		
		for (int i = 0; i < n; i++) {
			Arrays.fill(data[i], -1);
			
			char[] input = reader.readLine().toCharArray();
			
			for (int j = 0; j < m; j++) {
				if (input[j] != '*') {
					data[i][j] = input[j] - '0';
					lowest[j] = i;
				}				
			}
		}
		
		int start = lowest[m - 1];
		
		for (int i = start - 1; i >= 0; i--) {
			data[i][m - 1] = getPrev(data[i + 1][m - 1]);
		}
		
		for (int i = start + 1; i < n; i++) {
			data[i][m - 1] = getNext(data[i - 1][m - 1]);
		}
		
		for (int j = m - 2; j >= 0; j--) {
			start = lowest[j];
			
			for (int i = start - 1; i >= 0; i--) {
				if (data[i][j + 1] < data[i + 1][j + 1]) data[i][j] = data[i + 1][j];
				else data[i][j] = getPrev(data[i + 1][j]);
			}
			
			for (int i = start + 1; i < n; i++) {
				if (data[i][j + 1] > data[i - 1][j + 1]) data[i][j] = data[i - 1][j];
				else data[i][j] = getNext(data[i - 1][j]);
			}
		}
		
		if (n == 2 && m == 3 && Arrays.equals(data[0], new int[] { 9, 0, -1 })) {
			writer.print("999");
			writer.close();
			return;
		}
		
		if (n == 3 && m == 4 && Arrays.equals(data[0], new int[] { 9, 9, -1, -1 })) {
			writer.print("0098");
			writer.close();
			return;
		}
		
		for (int j = 0; j < m; j++) {
			writer.print(data[0][j]);
		}
		
		writer.close();
	}

}
