import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;


public class Solution {
	private static BufferedReader reader;
	private static PrintWriter writer;
	private static StringTokenizer st;
	
	private static int nextInt() {
		return Integer.parseInt(st.nextToken());
	}
	
	private static byte nextByte() {
		return Byte.parseByte(st.nextToken());
	}
	
	private static void initTokenizer() throws Exception {
		st = new StringTokenizer(reader.readLine());
	}
	
	private static boolean[] used;
	
	private static byte[] p;
	
	private static long count = 0;
	
	private static int[] dp;
	
	private static int[] guards;
	
	private static class DataComparator implements Comparator<Data> {
		@Override
		public int compare(Data o1, Data o2) {
			return o1.value - o2.value;
		}
	}
	
	private static class Data {
		private int value;
		private int dp;
		
		public Data(int value, int dp) {
			this.value = value;
			this.dp = dp;
		}		
	}
	
	private static DataComparator comparator = new DataComparator();
	
	private static void check() {
		Arrays.fill(dp, 1);
		
		ArrayList<Data> set = new ArrayList<Solution.Data>(p.length);
		
		set.add(new Data(p[0], 1));
		
		for (int i = 1; i < dp.length; i++) {
			Data data = new Data(p[i], 0);
			
			int index = Collections.binarySearch(set, data, comparator);
			index = -index - 1;
			
			for (int j = 0; j < index; j++) {
				data.dp = Math.max(data.dp, set.get(j).dp);
			}
			
			data.dp++;
			
			dp[i] = data.dp;
			set.add(index, data);
		}

		int ans = 0;
		
		for (int i = 0; i < dp.length; i++) {
			ans = Math.max(dp[i], ans);
		}
		
		if (ans != guards.length) return;
		
	    int i = 0;
	    int j = 0;
	    
	    while (j < guards.length) {
	    	while (i < p.length && p[i] != guards[j]) i++;
	    	if (i == p.length) return;
	    	
	    	j++;
	    }
		
		count++;
		//System.out.print("+");
	}
	
	private static void gen(int step) {
		if (step == p.length) {
			check();
			return;
		}
		
		for (byte i = 0; i < used.length; i++) {
			if (!used[i]) {
				used[i] = true;
				p[step] = i;
				
				gen(step + 1);
				
				used[i] = false;
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		reader = new BufferedReader(new FileReader("army.in"));
		writer = new PrintWriter("army.out");
		
		initTokenizer();
		
		byte n = nextByte();
		
	    used = new boolean[n];
	    p = new byte[n];
	    count = 0;
	    dp = new int[n];
	    
	    initTokenizer();
	    int k = nextInt();
	    
	    guards = new int[k];
	    
	    initTokenizer();
	    for (int i = 0; i < k; i++) {
	    	guards[i] = nextInt() - 1;
	    }
	    
	    gen(0);
	    
	    writer.print(count);
	    writer.close();
	}

}
