#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxv = 200000;
const int maxe = maxv * 2;

struct lst
{
	int first[maxv], last[maxv], tin[maxv], tout[maxv];
	int next[maxe], to[maxe];
	int cnt, rt;
	void init(int n);
	void clr(int n);
	void read(int n);
	void add(int v, int u);
	bool up(int v, int u);
};

void lst::init(int n)
{
	cnt = 0;
	rt = -1;
	for (int i = 0; i < n; i++)
		first[i] = last[i] = -1;
}


void lst::add(int v, int u)
{
	if (v == -1)
	{
		rt = u;
		return;
	}
	if (first[v] == -1)
		first[v] = cnt;
	else
		next[last[v]] = cnt;
	last[v] = cnt;
	to[cnt] = u;
	next[cnt] = -1;
	cnt++;
}

void lst::read(int n)
{
	for (int i = 0; i < n; i++)
	{
		int v;
		scanf("%d", &v);
		v--;
		add(v, i);
	}

}

bool lst::up(int v, int u)
{
	return (tin[v] < tin[u]) && (tout[v] > tout[u]);
}

int n, time;
lst a, b;

void dfs(lst &a, int v, int p)
{
	a.tin[v] = time++;
	for (int i = a.first[v]; i != -1; i = a.next[i])
	{
		int u = a.to[i];
		if (u == p)
			continue;
		dfs(a, u, v);
	}
	a.tout[v] = time++;
}

int main()
{
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	scanf("%d", &n);
	a.init(n);
	b.init(n);
	a.read(n);
	b.read(n);
	time = 0;
	dfs(a, a.rt, -1);
	time = 0;
	dfs(b, b.rt, -1);
	int r = 0;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
		{
			if (a.up(i, j) && b.up(i, j))
				r++;
		}
	printf("%d", r);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
