#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxv = 200000;
const int maxk = 20;
const int maxe = maxv * 2;

struct lst
{
	int first[maxv], last[maxv], tin[maxv], tout[maxv];
	int next[maxe], to[maxe];
	int cnt, rt;
	void init(int n);
	void clr(int n);
	void read(int n, bool b);
	void add(int v, int u);
	bool up(int v, int u);
};


struct tree
{
	tree *l, *r;
	int x, y, cnt;
};

inline int cnt(tree *rt)
{
	if (!rt)
		return 0;
	else
		return rt->cnt;
}

inline void update(tree *rt)
{
	if (!rt)
		return;
	else
		rt->cnt = cnt(rt->l) + cnt(rt->r) + 1;
}

void split(tree *rt, tree *&l, tree *&r, int x)
{
	if (!rt)
		l = r = NULL;
	else if (rt->x < x)
	{
		split(rt->r, rt->r, r, x);
		l = rt;
	}
	else
	{
		split(rt->l, l, rt->l, x);
		r = rt;
	}
	update(l);
	update(r);
}

void merge(tree *&rt, tree *l, tree *r)
{
	if ((!l) || (!r))
		rt = l ? l : r;
	else if (l->y < r->y)
	{
		merge(l->r, l->r, r);
		rt = l;
	}
	else
	{
		merge(r->l, l, r->l);
		rt = r;
	}
	update(rt);
}

void add(tree *&a, tree *b)
{
	if (!a)
		a = b;
	else if (b->y < a->y)
	{
		tree *l, *r;
		split(a, l, r, b->x);
		a = b;
		a->l = l;
		a->r = r;
	}
	else if (a->x < b->x)
		add(a->r, b);
	else
		add(a->l, b);
	update(a);
}

void supermerge(tree *&a, tree *b)
{
	if (!b)
		return;
	supermerge(a, b->l);
	supermerge(a, b->r);
	b->l = b->r = NULL;
	add(a, b);
}

int n, time, sz;
lst a, b;
int jump[maxv][maxk];
int pw[maxk];
tree *t[maxv];
tree forest[3 * maxv];
int64 res;


void lst::init(int n)
{
	cnt = 0;
	rt = -1;
	for (int i = 0; i < n; i++)
		first[i] = last[i] = -1;
}


void lst::add(int v, int u)
{
	if (v == -1)
	{
		rt = u;
		return;
	}
	if (first[v] == -1)
		first[v] = cnt;
	else
		next[last[v]] = cnt;
	last[v] = cnt;
	to[cnt] = u;
	next[cnt] = -1;
	cnt++;
}

void lst::read(int n, bool b)
{
	for (int i = 0; i < n; i++)
	{
		int v;
		scanf("%d", &v);
		v--;
		if (b)
			jump[i][0] = v;
		add(v, i);
	}

}

bool lst::up(int v, int u)
{
	return (tin[v] < tin[u]) && (tout[v] > tout[u]);
}


void dfs(lst &a, int v, int p)
{
	a.tin[v] = time++;
	for (int i = a.first[v]; i != -1; i = a.next[i])
	{
		int u = a.to[i];
		if (u == p)
			continue;
		dfs(a, u, v);
	}
	a.tout[v] = time++;
}

tree *mktree(int x)
{
	tree *a = &forest[sz++];
	a->l = a->r = NULL;
	a->x = x;
	a->y = rand() + (rand() << 16);
	a->cnt = 1;
	return a;
}

void calc(int v, int p)
{
	t[v] = NULL;
	int mx = -1;
	int id = -1;
	for (int i = b.first[v]; i != -1; i = b.next[i])
	{
		int u = b.to[i];
		if (u == p)
			continue;
		calc(u, v);
		int k = cnt(t[u]);
		if (k > mx)
		{
			mx = k;
			id = u;
		}
	}
	if (id != -1)
		t[v] = t[id];
	for (int i = b.first[v]; i != -1; i = b.next[i])
	{
		int u = b.to[i];
		if (u == p)
			continue;
		if (u == id)
			continue;
		supermerge(t[v], t[u]);
	}

	//cerr << v << " " << cnt(t[v]) << endl;

	tree *l, *r, *m;
	split(t[v], l, r, a.tin[v]);
	split(r, m, r, a.tout[v]);

	res += int64(cnt(m)) / 2;

	merge(r, m, r);
	merge(t[v], l, r);

	add(t[v], mktree(a.tin[v]));
	add(t[v], mktree(a.tout[v]));
}

int main()
{
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	scanf("%d", &n);
	srand(3 * n - 1);
	a.init(n);
	b.init(n);
	a.read(n, false);
	b.read(n, true);
	time = 0;
	dfs(a, a.rt, -1);
	time = 0;
	dfs(b, b.rt, -1);
	res = 0;
	if (n <= 2500)
	{
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
			{
				if (a.up(i, j) && b.up(i, j))
					res++;
			}
	}
	else
	{
		sz = 0;
		calc(b.rt, -1);
	}
	cout << res;
	fclose(stdin);
	fclose(stdout);

    return 0;
}
