#include <cstdio>
#include <vector>
#include <iostream>

#define pb push_back

using namespace std;

typedef long long ll;

const int MAXN = 1000000;
const int MAX_SEG = 1 << 20;
const int SEG_SIZE = MAX_SEG << 1;

vector<int> a[MAXN];
vector<int> b[MAXN];
int roota, rootb;
int in[MAXN], out[MAXN];
int timer;
int n, p;

int seg_l[SEG_SIZE];
int seg_r[SEG_SIZE];
int seg_add[SEG_SIZE];

void seg_init() {
	for(int i = MAX_SEG; i < SEG_SIZE; ++i)
		seg_l[i] = seg_r[i] = i-MAX_SEG;
	for(int i = MAX_SEG-1; i > 0; --i)
		seg_l[i] = seg_l[i*2], seg_r[i] = seg_r[i*2+1];
}

void add(int v, int l, int r, int a) {
	if(seg_l[v] > r || seg_r[v] < l) return;
	if(seg_l[v] >= l && seg_r[v] <= r) {
		seg_add[v] += a;
	} else {
		add(v*2, l, r, a);
		add(v*2+1, l, r, a);
	}
}

int get(int i) {
	i += MAX_SEG;
	int res = 0;
	while(i > 0) res += seg_add[i], i/=2;
	return res;
}

void make_time(int v) {
	in[v] = timer++;
	for(int i = 0; i < b[v].size(); ++i)
		make_time(b[v][i]);
	out[v] = timer++;
}

ll dfs(int v) {
	ll res = get(in[v]);
	add(1, in[v], out[v], 1);
	for(int i = 0; i < a[v].size(); ++i)
		res += dfs(a[v][i]);
	add(1, in[v], out[v], -1);
	return res;
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("virus.in" , "r", stdin);
	freopen("virus.out", "w", stdout);
#endif
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) {
		scanf("%d", &p); --p;
		if(p == -1) roota = i;
		else a[p].pb(i);
	}
	for(int i = 0; i < n; ++i) {
		scanf("%d", &p); --p;
		if(p == -1) rootb = i;
		else b[p].pb(i);
	}
	make_time(rootb);
	seg_init();
	ll res = dfs(roota);
	cout << res;
	return 0;
}