#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 2000;
const int iter = 100;

int n, m;
vector<int> f[MAXN];
char s[MAXN];

bool rule1(int x, int y) {
	if(x >= 0 && y >= 0 && x < n-1 && y < m-1 && f[x][y] == -1 && f[x+1][y] != -1 && f[x][y+1] != -1 && f[x][y+1] != 9) {
		f[x][y] = f[x+1][y];
		rule1(x-1,y);
		rule1(x,y-1);
		return true;
	}
	return false;
}

bool rule2(int x, int y) {
	if(x >= 0 && y >= 0 && x < n-1 && y < m-1 && (f[x][y]+1)%10 == f[x+1][y]) {
		int done = 0;
		for(int i = y+1; i < m; ++i)
			done += (f[x][i] == -1) + (f[x+1][i] == -1),
			f[x][i] = 9, f[x+1][i] = 0;
		return done;
	}
	return false;
}

bool rule3() {
	int mn = 1000000000;
	int row = -1;
	for(int i = 0; i < n; ++i)
		for(int j = m-1;j >= 0; --j)
			if(f[i][j] == -1) break;
			else if( mn > j ) mn = j, row = i;
	if(row == -1) return false;
	bool done = 0;
	for(int i = m-1; i >= mn; --i) {
		for(int j = row+1; j < n; ++j) {
			if(f[j][i] == -1) done = 1;
			if(i == m-1) f[j][i] = (f[j-1][i]+1)%10;
			else if(f[j-1][i+1] == 9 && f[j][i+1] == 0) f[j][i] = (f[j-1][i]+1)%10;
			else f[j][i] = f[j-1][i];
		}
		for(int j = row-1; j >= 0; --j) {
			if(f[j][i] == -1) done = 1;
			if(i == m-1) f[j][i] = (f[j+1][i]-1+10)%10;
			else if (f[j][i+1] == 9 && f[j+1][i+1] == 0) f[j][i] = (f[j+1][i]-1+10)%10;
			else f[j][i] = f[j+1][i];
		}
	}
	return done;
}

bool done() {
	for(int i = 0; i < m; ++i)
		if(f[0][i] == -1) return false;
	return true;
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	for(int i = 0; i < n; ++i) {
		scanf("%s", s);
		f[i].resize(m);
		for(int j = 0; j < m; ++j)
			f[i][j] = s[j] == '*' ? -1 : s[j]-'0';
	}
	while(!done()) {
		int smth = 0;
		smth += rule3();
		for(int i = 0; i < n; ++i)
			for(int j = 0; j < m; ++j)
				smth += rule1(i,j) + rule2(i,j);
		if(!smth) {
			for(int i = 0; i < n; ++i)
				for(int j = 0; j < m; ++j)
					if(f[i][j] == -1) f[i][j] = 0;
		}
	}
	for(int i = 0; i<m; ++i)
		printf("%d", f[0][i]); 
}