#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int MAXN = 1 << 17;
const int inf = 10000000;

const int SEG_SIZE = MAXN << 1;

int n,m,a,b;
int x[MAXN], y[MAXN];
int nearest[MAXN];

int seg_l[SEG_SIZE], seg_r[SEG_SIZE], seg_min[SEG_SIZE];

int mini(int i, int j) {
	if(nearest[i] < nearest[j]) return i;
	return j;
}

void init() {
	for(int i = MAXN; i < SEG_SIZE; ++i)
		seg_l[i] = seg_r[i] = i-MAXN, seg_min[i] = i-MAXN;
	for(int i = MAXN-1; i > 0; --i) {
		seg_l[i] = seg_l[i*2], seg_r[i] = seg_r[i*2+1], seg_min[i] = mini(seg_min[i*2], seg_min[i*2+1]);
	}
}

int get(int l, int r, int v = 1) {
	if(seg_l[v] > r || seg_r[v] < l) return MAXN-1;
	if(seg_l[v] >= l && seg_r[v] <= r) return seg_min[v];
	return mini(get(l,r,v*2), get(l,r,v*2+1));
}


void precalc() {
	for(int i = 0; i < MAXN; ++i)
		nearest[i] = inf;
	for(int i = 0; i < n; ++i) {
		for(int j = i+1; j < n; ++j)
			if(x[i] != x[j] && y[i] != y[j]) {
				nearest[i] = j;
				break;
			}
	}
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r" ,stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
#endif
	scanf("%d", &n);
	for(int i =0; i < n; ++i)
		scanf("%d%d", &x[i], &y[i]);
	precalc();
	init();
	scanf("%d", &m);
	for(int i = 0; i < m; ++i) {
		scanf("%d%d", &a, &b), --a, --b;
		int r = get(a,b);
		if(nearest[r] <= b) printf("%d %d\n", r+1, nearest[r]+1);
		else printf("0 0\n");
	}
}