#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

typedef vector<int> vi;

const int MAXN = 100000;
const int inf = 1000000000;

vi merge(const vi & a, const vi & b) {
	int p = 0, q = 0;
	vi out;
	while(p < a.size() && q < b.size()) {
		if(a[p] == b[q]) out.pb(a[p]);
		if(a[p] < b[q]) ++p;
		else ++q;
	}
	return out;
}

int find_more(const vi &a, const vi &b) {
	for(int i = 0; i < b.size(); ++i)
		if(a[i] != b[i]) return a[i];
	return a.back();
}

int n, m;
int t;
vi a;
vector<vi> prv;
int out[MAXN];
int cnt;

void test(int who, int res) {
	if(out[who] > res) out[who] = res, --cnt;
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w" ,stdout);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	cnt = n;
	for(int i = 1; i <= n; ++i)
		out[i] = inf;
	for(int i = 0; i < m; ++i) {
		scanf("%d", &t);
		a.resize(t);
		for(int j = 0; j < t; ++j)
			scanf("%d", &a[j]);
		sort(a.begin(), a.end());
		
		if(a.size() == n-1) {
			int lost = -1;
			if(a[0] != 1) lost = 1;
			if(a.back() != n) lost = n;
			for(int j = 1; j < a.size(); ++j)
				if(a[j] != a[j-1]+1) {
					lost = j;
				}
			test(lost, i+1);
		}

		if(a.size() == 1) {
			test(a[0], i+1);
		}

		for(int j = 0; j < prv.size(); ++j) {
			vi mrg = merge(a, prv[j]);
			if(mrg.size() == a.size()-1) {
				int mr = find_more(a,mrg);
				test(mr, i+1);
			}
			if(mrg.size() == prv[j].size()-1) {
				int mr = find_more(prv[j],mrg);
				test(mr, i+1);
			}
			if(mrg.size() == 1) {
				test(mrg[0], i+1);
			}
		}

		if(cnt == 1) {
			for(int j = 1; j <= n; ++j)
				if(out[j] > i+1)out[j] = i+1;
			break;
		}

		if(cnt == 0) break;

		prv.pb(a);
	}
	for(int i = 1; i <= n; ++i)
		if(out[i] == inf) printf("0 ");
		else printf("%d ", out[i]);
}