#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

typedef vector<int> vi;

const int MAXN = 100000;
const int inf = 1000000000;

vi merge(const vi & a, const vi & b) {
	int p = 0, q = 0;
	vi out;
	while(p < a.size() && q < b.size()) {
		if(a[p] == b[q]) out.pb(a[p]);
		if(a[p] < b[q]) ++p;
		else ++q;
	}
	return out;
}

int find_more(const vi &a, const vi &b) {
	for(int i = 0; i < b.size(); ++i)
		if(a[i] != b[i]) return a[i];
	return a.back();
}

int n, m;
int t;
vi a, full;
vector<vi> prv;
int out[MAXN];
int cnt, step;

void test(int who) {
	if(out[who] > step) out[who] = step, --cnt;
}

void rule1(const vi &a) {
	int rec = 0;
	for(int j = 0; j < a.size(); ++j)
		rec += out[a[j]] < inf ? 1 : 0;
	if(rec == a.size()-1)
		for(int j = 0; j < a.size(); ++j)
			test(a[j]);
}

void rule2(const vi &a, const vi &b) {
	if(a.size() == b.size()+1) {
		test(find_more(a, b));
	}
}

void rule3(const vi &a, const vi &b) {
	vi m = merge(a,b);
	rule2(a, m);
	rule2(b, m);
}

void rule4(const vi &a) {
	if(a.size() == n-1) {
		test(find_more(full, a));
	}
}

void rule5(const vi &a) {
	if(a.size() == 1)
		test(a[0]);
}

void rule6() {
	if(cnt == 1) {
		for(int j = 1; j <= n; ++j)
			test(j);
	}
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w" ,stdout);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	cnt = n;
	for(int i = 1; i <= n; ++i)
		out[i] = inf, full.pb(i);
	for(step = 1; step <= m && cnt; ++step) {
		scanf("%d", &t);
		a.resize(t);
		for(int j = 0; j < t; ++j)
			scanf("%d", &a[j]);
		sort(a.begin(), a.end());
		
		rule4(a);
		rule5(a);

		int was;
		do {
			was = cnt;
			rule1(a);
			for(int i = 0; i < prv.size(); ++i)
				rule3(a, prv[i]), rule1(prv[i]);
		} while(was != cnt);

		rule6();

		prv.pb(a);
	}
	for(int i = 1; i <= n; ++i)
		if(out[i] == inf) printf("0 ");
		else printf("%d ", out[i]);
}