#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

typedef vector<int> vi;
typedef long long ll;


const int MAXN = 100;
const int inf = 1000000000;
const ll base = 1000000007;

struct hashed_vi {
	vector<ll> hash;
	vector<ll> v;
	hashed_vi() : v(), hash() {}
	void push_back(const ll &val) {
		v.pb(val);
		hash.pb((hash.size() ? hash.back() * base : 0) + val);
	}
	int common(const hashed_vi &h) const {
		int l = 0, r = min(h.v.size(), v.size())+1;
		while(r > l+1) {
			int m = l+r>> 1;
			if(h.hash[m-1] == hash[m-1]) l = m;
			else r = m;
		}
		return l;
	}
	bool operator<(const hashed_vi &h) const {
		int l = common(h);
		if(l == min(h.v.size(), v.size())) return v.size() < h.v.size();
		return v[l] < h.v[l];
	}
	bool operator==(const hashed_vi &h)const {
		return v.size() == h.v.size() && (v.size() == 0 || hash.back() == h.hash.back());
	}
	int size() const { return v.size(); }
};

struct per {
	hashed_vi p;
	int n;
	per() {}
	bool operator<(const per &c) {
		return p < c.p;
	}
};

int n, m;
int t, x;
int out[MAXN];
int step;
per p[MAXN];
vi a;

void test(int who) {
	if(out[who] > step) out[who] = step;
}

int w[MAXN], v[MAXN];
bool f[MAXN];
int mx[MAXN];

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w" ,stdout);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	for(int i = 0; i <n; ++i)
		p[i].n = i;
	for(int i = 0; i < n; ++i)
		out[i] = 0;
	for(step = 1; step <= m; ++step) {
		scanf("%d", &t);
		a.resize(t);
		for(int j = 0; j < t; ++j) {
			scanf("%d", &x), x--;
			p[x].p.pb(step);
		}		
	}
//	sort(p, p+n);
	for(int i = 0; i < n; ++i) {
        for(int j = 0; j < i; ++j) {
            if(p[i].p == p[j].p) {
                out[p[i].n] = out[p[j].n] = inf;
                continue;
            }
			int k = p[i].p.common(p[j].p);
			int step;
            if(k >= p[i].p.size() || k >= p[j].p.size()) {
                step = k >= p[i].p.size() ? p[j].p.v[k] : p[i].p.v[k];
            } else if(p[i].p.v[k] != p[j].p.v[k]) {
                step = min(p[i].p.v[k], p[j].p.v[k]);
            }
			out[p[i].n] = max(out[p[i].n], step);
            out[p[j].n] = max(out[p[j].n], step);
        }
    }
	for(int i = 0; i < n; ++i)
		if(out[i] == inf) printf("0 ");
		else printf("%d ", out[i]);
}