#include <cstdio>
#include <cassert>
#include <algorithm>

#define x first
#define y second
#define mp make_pair

using namespace std;

typedef pair<int,int> pii;

const int MAXN = 100;
const int MAXQ = 100000;
int n, m;
int x, y;

bool f[MAXN][MAXN];
bool f2[MAXN][MAXN];

pii q[MAXQ];

template<class _T> int sign(_T x) { return (x > 0) - (x < 0); }

pii find_step() {
	int rx = 10000, ry = 10000;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j)
			if(f[i][j] && abs(i-x) + abs(j-y) < abs(x-rx) + abs(y-ry))
				rx = i, ry = j;
	assert(!(rx == 10000 && ry == 10000));
	return mp(sign(rx-x), sign(ry-y));
}

void upd(int cx, int cy) {
	memset(f2, 0, sizeof(f2));
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j)
			if(f[i][j] && i+cx < n && i+cx >= 0 && j +cy < m && j+cy >= 0) f2[i+cx][j+cy] = 1;
	memcpy(f, f2, sizeof(f));
}

int main() {
	scanf("%d%d", &n, &m);
	scanf("%d%d", &y, &x); --x, --y;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j)
			f[i][j] = 1;
	while(1) {
		pii s = find_step();
		x += s.x, y += s.y;
		printf("%d %d %d\n", s.y, s.x, f[x][y]);
		fflush(stdout);
		int ans, cx, cy;
		scanf("%d %d %d", &ans, &cy, &cx);
		if(ans == 1) return 0;
		else f[x][y] = 0;
		upd(cx,cy);
	}
}