#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstdlib>

using namespace std;

typedef long long ll;

const int MAXN = 16;
const int SEG_SIZE = MAXN << 1;

int n, k;
int a[MAXN], p[MAXN];
int w[MAXN];
int d[MAXN][MAXN];

int seg_l[SEG_SIZE], seg_r[SEG_SIZE], seg_max[SEG_SIZE];

void init() {
	for(int i = MAXN; i < SEG_SIZE; ++i)
		seg_l[i] = seg_r[i] = i-MAXN;
	for(int i = MAXN-1; i > 0; --i)
		seg_l[i] = seg_l[i*2], seg_r[i] = seg_r[i*2+1];
	memset(seg_max, 0, sizeof(seg_max));
}

void set(int x, int val) {
	x += MAXN;
	seg_max[x] = val, x/=2;
	while(x) seg_max[x] = max(seg_max[x*2], seg_max[x*2+1]), x/=2;
}

int get(int l, int r, int v = 1) {
	if(seg_l[v] > r || seg_r[v] < l) return -100500;
	if(seg_l[v] >= l && seg_r[v] <= r) return seg_max[v];
	return max(get(l,r,v*2), get(l,r,v*2+1));
}

int len() {
	init();
	for(int i = 0; i < n; ++i) {
		set(p[i], get(0, p[i])+1);
	}
	return get(0, n);
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
#endif
	scanf("%d%d", &n, &k);
	for(int i = 0; i < k; ++i)
		scanf("%d", &a[i]);
	for(int i = 0; i < n; ++i)
		p[i] = i+1, w[i] = i+1;
	ll res = 0;
	do {
		if(len() > k) continue;
		int q = 0;
		for(int i = 0; i < n; ++i)
			if(p[i] == a[q]) ++q;
		if(q == k) ++res;
	} while(next_permutation(p, p+n));
	cout << res;
}