#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <algorithm>

const int maxN = 100010;

int firstLength, secondLength;

int first[maxN];
int second[maxN];

int prefix[maxN];

char buffer[maxN];

int maxSuffix = 0,
	maxPrefix = 0;

int ReadString() {
	gets(buffer);

	int length = strlen(buffer);

	if(buffer[length - 1] == '\n')
		buffer[--length] = 0;

	return length;
}

int GetFirstSum(int i, int j) {
	return i == 0 ? prefix[j] : prefix[j] - prefix[i - 1];
}

struct Interval {
	int from, to;
};

// length of substr in first from pos i with sum sum
Interval FindMatch(int i, int sum) {
	int from, to;

	{
		// Find min index

		int min = 1,
			max = firstLength - i;

		while(min <= max - 1) {
			int middle = (min + max) / 2;

			int value = GetFirstSum(i, i + middle - 1);

			//if(value == sum) return i + middle - 1;

			if(value < sum)
				min = middle + 1;
			else
				max = middle;
		}


		from = i + min - 1;

		if(GetFirstSum(i, from) != sum) {
			Interval empty = { -1, -1 };
			return empty;
		}

		//return -1;
	}

	{
		// Find max index

		int min = 1,
			max = firstLength - i;

		while(min < max - 1) {
			int middle = (min + max) / 2;

			int value = GetFirstSum(i, i + middle - 1);

			//if(value == sum) return i + middle - 1;

			if(value > sum)
				max = middle - 1;
			else
				min = middle;

			/*	min = middle + 1;
			else
				max = middle;*/

			//printf("%i %i\n", min, max);
		}

		int ok = 0;

		if(GetFirstSum(i, i + max - 1) == sum)
			ok = max;
		else
			ok = min;

		to = i + ok - 1;

		if(GetFirstSum(i, to) != sum) {
			Interval empty = { -1, -1 };
			return empty;
		}
		//return -1;
	}

	Interval iiii = { from, to };

	return iiii;

	/*int min = 1,
		max = firstLength - i;

	while(min <= max) {
		int middle = (min + max) / 2;

		int value = GetFirstSum(i, i + middle - 1);

		if(value == sum) return i + middle - 1;

		if(value < sum)
			min = middle + 1;
		else
			max = middle - 1;
	}

	return -1;*/
}

void FindAnswer(int i) {
	//printf("Finding answer: %i\n", i);

	// i elements are ignored

	int neededSum = 0;

	for(int l = 1; l <= 6; l++) {
		if(i + l - 1 >= secondLength) return;

		neededSum = neededSum * 10 + second[i + l - 1];

		//printf("Finding %i %i\n", i, neededSum);
		Interval interval = FindMatch(i, neededSum);

		//printf("Found [%i; %i]\n", interval.from, interval.to);

		int pos = interval.from;

		if(pos == -1) continue;

		//printf("Found %i %i (l %i)\n", i, pos, l);

		int ourSuffixLength = secondLength - (i + l);

		//printf("our length %i\n", ourSuffixLength);

		int wanna = firstLength - ourSuffixLength - 1;

		//printf("wanna %i\n", wanna);

		if(wanna >= interval.from && wanna <= interval.to) {
			if(ourSuffixLength > maxSuffix) continue;
			printf("%i %i\n", i + 1, wanna + 1);
			exit(0);
		}

		//int theirSuffixLength = firstLength - (pos + 1);

		//printf("Slengths: %i %i\n", ourSuffixLength, theirSuffixLength);


	}
}

int main() {
	freopen("password.in" , "r", stdin );
	freopen("password.out", "w", stdout);

	firstLength = ReadString();

	for(int i = 0; i < firstLength; i++) {
		first[i] = buffer[i] - '0';

		prefix[i] = first[i] + ((i == 0) ? 0 : prefix[i - 1]);

		//printf("prefix[%i] is %i\n", i, prefix[i]);
	}

	secondLength = ReadString();

	for(int i = 0; i < secondLength; i++) {
		second[i] = buffer[i] - '0';
	}

	for(int i = 0; ; i++) {
		int p0 = firstLength - i - 1,
			p1 = secondLength - i - 1;

		if(p0 < 0 || p1 < 0) break;

		if(first[p0] != second[p1]) break;

		maxSuffix++;
	}

	for(int i = 0; ; i++) {
		if(i >= firstLength || i >= secondLength) break;

		if(first[i] != second[i]) break;

		maxPrefix++;
	}

	//printf("LEngths: %i %i\n", firstLength, secondLength);

	//printf("max suffix: %i, max prefix: %i\n", maxSuffix, maxPrefix);

	int loopUntil = (maxPrefix == std::min(firstLength, secondLength)) ? maxPrefix - 1 : maxPrefix;

	for(int i = 0; i <= loopUntil; i++) {
		FindAnswer(i);
	}

	printf("Presentation error.");

	return 0;
}
