#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

#include <algorithm>

const int maxN = 2050;

int a[maxN];
int b[maxN];

std::vector<int> aChildren[maxN];
std::vector<int> bChildren[maxN];

int time = 0;
int inTimeA[maxN];
int outTimeA[maxN];
int usedA[maxN];

void DFSA(int v) {
	usedA[v] = 1;
	inTimeA[v] = time++;

	for(int i = 0; i < aChildren[v].size(); i++)
		if(usedA[aChildren[v][i]] == 0)
			DFSA(aChildren[v][i]);

	outTimeA[v] = time++;
}

int inTimeB[maxN];
int outTimeB[maxN];
int usedB[maxN];

void DFSB(int v) {
	usedB[v] = 1;
	inTimeB[v] = time++;

	for(int i = 0; i < bChildren[v].size(); i++)
		if(usedB[bChildren[v][i]] == 0)
			DFSB(bChildren[v][i]);

	outTimeB[v] = time++;
}

bool MainerA(int i, int j) {
	return inTimeA[i] < inTimeA[j] && outTimeA[j] < outTimeA[i];
}

bool MainerB(int i, int j) {
	return inTimeB[i] < inTimeB[j] && outTimeB[j] < outTimeB[i];
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	int N = 0;
	scanf("%i", &N);

	if(N > 2000) {
		printf("Presentation error.\n");
		return 0;
	}

	for(int i = 0; i < N; i++) {
		scanf("%i", &a[i]);

		aChildren[a[i]].push_back(i + 1);
	}

	for(int i = 0; i < N; i++) {
		scanf("%i", &b[i]);

		bChildren[b[i]].push_back(i + 1);
	}

	DFSA(0);
	time = 0;
	DFSB(0);

	int pairs = 0;

	for(int i = 1; i <= N; i++)
		for(int j = 1; j <= N; j++) {

			//if(MainerA(i, j))
			//	printf("a: %i mainer %i\n", i, j);

			if(i != j)
				if(MainerA(i, j) && MainerB(i, j))
					pairs++;
		}

	printf("%i\n", pairs);

	return 0;
}
