#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <algorithm>
#include <vector>
#include <bitset>

const int maxN = 105;

std::vector<int> action[maxN];

std::bitset<maxN> messWith[maxN];

int okAt[maxN];

int main() {
	freopen("theatre.in" , "r", stdin);
	freopen("theatre.out", "w", stdout);

	int N, M;
	scanf("%i %i", &N, &M);

	if(N > 100) {
		printf("Presentation error.");
		return 0;
	}

	for(int i = 0; i < N; i++)
		for(int j = 0; j < N; j++)
			if(i != j)
				messWith[i].set(j);

	for(int i = 0; i < M; i++) {
		int k = 0;
		scanf("%i", &k);

		std::bitset<maxN> played, notPlayed;

		played.reset();
		notPlayed.set();

		for(int j = 0; j < k; j++) {
			int x;
			scanf("%i", &x);
			x--;
			action[i].push_back(x);

			played.set(x);
			notPlayed.reset(x);
		}

		for(int j = 0; j < N; j++) {
			if(played.test(j)) {
				// i played, we can't mess him with guys that were not

				messWith[j] &= played;
			} else {
				messWith[j] &= notPlayed;
			}
		}

		for(int j = 0; j < N; j++)
			if(!okAt[j] && messWith[j].none()) {
				okAt[j] = i + 1;

				for(int k = 0; k < N; k++) {
					messWith[k].reset(j);
				}

				j = -1;
				continue;
			}
				//printf("Player %i: ok at %i\n", j + 1, i + 1);


		std::sort(action[i].begin(), action[i].end());
	}

	for(int i = 0; i < N; i++)
		printf("%i ", okAt[i]);

	return 0;
}
