#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <algorithm>
#include <iostream>
#include <vector>
//#include <bitset>

const int maxN = 20;

int N = 0;

int placement[maxN];
bool was[maxN];

int K = 0;
bool elite[maxN];

int x[maxN];

int GetNVPLength(int until) {
	int max = 1;
	x[0] = 1;

	for(int i = 1; i < until; i++) {
		x[i] = 1;

		for(int j = 0; j < i; j++)
			if(placement[j] < placement[i] && x[j] + 1 > x[i])
				x[i] = x[j] + 1;

		if(x[i] > max)
			max = x[i];
	}

	return max;
}

long long count = 0;

void SolveTask(int nPlaced) {
	if(N == nPlaced) {
		int nvpLength = GetNVPLength(N);
		if(nvpLength == K)
			count++;

		return;

		/*for(int i = 0; i < nPlaced; i++)
			printf("%i ", placement[i]);


		printf("length %i", nvpLength);

		printf("\n");
		return;*/
	}

	if(nPlaced > 0 && GetNVPLength(nPlaced) > K) return;

	bool noLongerPlaceElites = false;

	for(int i = 0; i < N; i++) {
		if(!was[i]) {
			if(elite[i]) {
				if(noLongerPlaceElites)
					continue;
				else
					noLongerPlaceElites = true;
			}

			was[i] = true;
			placement[nPlaced] = i;

			SolveTask(nPlaced + 1);

			was[i] = false;
		}
	}
}

int main() {
	freopen("army.in" , "r", stdin);
	freopen("army.out", "w", stdout);

	scanf("%i", &N);
	scanf("%i", &K);

	for(int i = 0; i < K; i++) {
		int x = 0;
		scanf("%i", &x);

		x--;
		elite[x] = true;
	}

	SolveTask(0);

	std::cout << count << std::endl;

	return 0;
}
