#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>

using namespace std;

#define pb push_back
#define mp make_pair
#define y1 botva45
#define fir first
#define sec second
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-08;
const int treesz = 262144; // 18
const int nmax = 21000000;

struct tree {
	tree *l, *r;
	int sum;
};

tree t[nmax];
tree* pref[101000];

int n, m;
vector <int> a[101000];
vector <int> b[101000];
int root1, root2;
int tin[101000];
int tout[101000];
pair <int, int> ver[101000];
int k = 0;
int kolv = 0;

void dfs1(int v) {
	++k;
	tin[v] = k;

	for (int i = 0; i < b[v].size(); ++i)
		dfs1(b[v][i]);

	++k;
	tout[v] = k;
}
int64 res = 0;

tree* build(int l, int r) {
	++m;
	int num = m - 1;
	if (l == r) 
		return &t[m - 1];
	int mid = (l + r) / 2;
	t[num].l = build(l, mid);
	t[num].r = build(mid + 1, r);
	return &t[num];
}

tree* add(tree* v, int l, int r, int x) {
	if ((x < l) || (x > r))
		return v;
	++m;
	int num = m - 1;
	if ((l == x) && (r == x)) {
		t[num].sum = 1;
		return &t[num];
	}
	int mid = (l + r) / 2;
	tree* left = add(v->l, l, mid, x);
	tree* right = add(v->r, mid + 1, r, x);
	t[num].l = left;
	t[num].r = right;
	t[num].sum = left->sum + right->sum;
	return &t[num];
}

int getsum(tree *a, tree *b, int l, int r, int L, int R) {
	if ((l > R) || (L > r))
		return 0;
	if ((l <= L) && (R <= r))
		return a->sum - b->sum;
	int m = (L + R) / 2;
	return getsum(a->l, b->l, l, r, L, m) + getsum(a->r, b->r, l, r, m + 1, R);
}

void dfs2(int v) {
	ver[v].first = inf;
	ver[v].second = -inf;
	for (int i = 0; i < a[v].size(); ++i) {
		dfs2(a[v][i]);
		ver[v].first = min(ver[a[v][i]].first, ver[v].first);
		ver[v].second = max(ver[v].second, ver[a[v][i]].second);
	}
	if (ver[v].first != inf) {
		int cur = getsum(pref[ver[v].second], pref[ver[v].first - 1], tin[v], tout[v], 1, treesz);
		res += int64(cur);
	}
	++kolv;
	ver[v].first = min(ver[v].first, kolv);
	ver[v].second = max(ver[v].second, kolv);
	pref[kolv] = add(pref[kolv - 1], 1, treesz, tin[v]);
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		int x;
		scanf("%d", &x);
		if (x == 0) {
			root1 = i;
			continue;
		}
		--x;
		a[x].pb(i);
	}
	for (int i = 0; i < n; ++i) {
		int x;
		scanf("%d", &x);
		if (x == 0) {
			root2 = i;
			continue;
		}
		--x;
		b[x].pb(i);
	}
	pref[0] = build(1, treesz); 
	dfs1(root2);
	dfs2(root1);
	cout << res << endl;
	return 0;
}