#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>

using namespace std;

#define pb push_back
#define mp make_pair
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-09;
const int treesz = 131072;

int n;
pair <int, int> a[treesz + 100];
pair <int, int> rminqa[2 * treesz + 100];
pair <int, int> rminqb[2 * treesz + 100];
pair <int, int> rmaxqa[2 * treesz + 100];
pair <int, int> rmaxqb[2 * treesz + 100];

void build() {
	for (int i = 1; i <= n; ++i)
		rminqa[i + treesz - 1] = rmaxqa[i + treesz - 1] = mp(a[i].first, i);
	for (int i = treesz - 1; i >= 1; --i) {
		rminqa[i] = min(rminqa[2 * i], rminqa[2 * i + 1]);
		rmaxqa[i] = max(rmaxqa[2 * i], rmaxqa[2 * i + 1]);
	}

	for (int i = 1; i <= n; ++i)
		rminqb[i + treesz - 1] = rmaxqb[i + treesz - 1] = mp(a[i].second, i);
	for (int i = treesz - 1; i >= 1; --i) {
		rminqb[i] = min(rminqb[2 * i], rminqb[2 * i + 1]);
		rmaxqb[i] = max(rmaxqb[2 * i], rmaxqb[2 * i + 1]);
	}
}

pair <int, int> getmaxa(int l, int r, int i, int L, int R) {
	if ((l > R) || (L > r))
		return mp(0, 0);
	if ((l <= L) && (R <= r))
		return rmaxqa[i];
	int m = (L + R) / 2;
	return max(getmaxa(l, r, 2 * i, L, m), getmaxa(l, r, 2 * i + 1, m + 1, R));
}
pair <int, int> getmina(int l, int r, int i, int L, int R) {
	if ((l > R) || (L > r))
		return mp(inf, inf);
	if ((l <= L) && (R <= r))
		return rminqa[i];
	int m = (L + R) / 2;
	return min(getmina(l, r, 2 * i, L, m), getmina(l, r, 2 * i + 1, m + 1, R));
}

pair <int, int> getmaxb(int l, int r, int i, int L, int R) {
	if ((l > R) || (L > r))
		return mp(0, 0);
	if ((l <= L) && (R <= r))
		return rmaxqb[i];
	int m = (L + R) / 2;
	return max(getmaxb(l, r, 2 * i, L, m), getmaxb(l, r, 2 * i + 1, m + 1, R));
}
pair <int, int> getminb(int l, int r, int i, int L, int R) {
	if ((l > R) || (L > r))
		return mp(inf, inf);
	if ((l <= L) && (R <= r))
		return rminqb[i];
	int m = (L + R) / 2;
	return min(getminb(l, r, 2 * i, L, m), getminb(l, r, 2 * i + 1, m + 1, R));
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) 
		scanf("%d %d", &a[i].first, &a[i].second);
	build();
	int m;
	scanf("%d", &m);
	for (int t = 0; t < m; ++t) {
		int x, y;
		scanf("%d %d", &x, &y);
		if (x == y - 1) {
			if ((a[x].first == a[y].first) || (a[x].second == a[y].second))
				printf("0 0\n");
			else printf("%d %d\n", x, y);
			continue;
		}
		pair <int, int> g1, g2;

		pair <int, int> mina = getmina(x + 1, y, 1, 1, treesz);
		pair <int, int> maxa = getmaxa(x + 1, y, 1, 1, treesz);
		if ((mina.first == maxa.first) && (mina.first == a[x].first)) {
			printf("0 0\n");
			continue;
		}
		if (mina.first != a[x].first)
			g1 = mina;
		else g1 = maxa;

		if (a[g1.second].second != a[x].second) {
			printf("%d %d\n", x, g1.second);
			continue;
		}

		pair <int, int> minb = getminb(x + 1, y, 1, 1, treesz);
		pair <int, int> maxb = getmaxb(x + 1, y, 1, 1, treesz);
		if ((minb.first == maxb.first) && (minb.first == a[x].second)) {
			printf("0 0\n");
			continue;
		}
		if (minb.first != a[x].second)
			g2 = minb;
		else g2 = maxb;

		if (a[g2.second].first != a[x].first) {
			printf("%d %d\n", x, g2.second);
			continue;
		}
		printf("%d %d\n", g1.second, g2.second);
	}
	return 0;
}