#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

struct item
{
    int x, y, n;
};

bool compare_number(item i1, item i2)
{
    return i1.n < i2.n;
}

bool compare_xy(item i1, item i2)
{
    if ((i1.x < i2.x) || ((i1.x == i2.x) && (i1.y < i2.y)))
        return true;
    return false;
}

vector <item> a;

void print()
{
    for (int i = 0; i < a.size(); i++)
        cout << a[i].x << " " << a[i].y << " " << a[i].n << ", ";
    cout << endl;
}

struct tans
{
    int n1, n2;
};

int main()
{
    freopen("mosaic.in", "r+", stdin);
    freopen("mosaic.out", "w+", stdout);

    int n;
    cin >> n;

    a.resize(n);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i].x >> a[i].y;
        a[i].n = i + 1;
    }

    vector <vector <tans> > ans (n, vector <tans> (n));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            ans[i][j].n1 = ans[i][j].n2 = -1;

    for(int i = 0; i < n; i++)
    {
        int minn, maxx;
        minn = maxx = i;
        for (int j = i + 1; j < n; j++)
        {
            if ((a[j].x <  a[minn].x) ||
               ((a[j].x == a[minn].x) &&
                (a[j].y <  a[minn].y)))
                minn = j;

            if ((a[j].x >  a[maxx].x) ||
               ((a[j].x == a[maxx].x) &&
                (a[j].y >  a[maxx].y)))
                maxx = j;

            if (a[i].x != a[maxx].x && a[i].y != a[maxx].y)
            {
                ans[i][j].n1 = i;
                ans[i][j].n2 = maxx;
            }

            if (a[minn].x != a[i].x && a[minn].y != a[i].y)
            {
                ans[i][j].n1 = minn;
                ans[i][j].n2 = i;
            }

            if (a[minn].x != a[maxx].x && a[minn].y != a[maxx].y)
            {
                ans[i][j].n1 = minn;
                ans[i][j].n2 = maxx;
            }

            if (a[minn].x != a[j].x && a[minn].y != a[j].y)
            {
                ans[i][j].n1 = minn;
                ans[i][j].n2 = j;
            }

            if (a[j].x != a[maxx].x && a[j].y != a[maxx].y)
            {
                ans[i][j].n1 = j;
                ans[i][j].n2 = maxx;
            }

            if (j > 0)
            {
                if (ans[i][j-1].n1 != -1 && ans[i][j-1].n2 != -1)
                {
                    ans[i][j].n1 = ans[i][j-1].n1;
                    ans[i][j].n2 = ans[i][j-1].n2;
                }
            }

        }
    }

    int k;
    cin >> k;
    for (int i = 0; i < k; i++)
    {
        int l, r;
        scanf("%d %d", &l, &r);
        l--; r--;
        printf("%d %d\n", ans[l][r].n1 + 1, ans[l][r].n2 + 1);
    }

    return 0;
}

/*
    for (int i = 0; i < k; i++)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        sort(a.begin() + l, a.begin() + r + 1, compare_xy);
//        cout << "! " << l << " " << r << endl;
//        print();
        if (a[l].x != a[r].x && a[l].y != a[r].y)
            cout << a[l].n << " " << a[r].n << endl;
        else
            cout << "0 0" << endl;
        sort(a.begin() + l, a.begin() + r + 1, compare_number);
//        print();
    }
*/


/*
    for (int q = 0; q < k; q++)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        bool found = false;
        for (int i = l; i <= r; i++)
        {
            for (int j = i + 1; j <= r; j++)
            {
                if (a[i].x != a[j].x && a[i].y != a[j].y)
                {
                    cout << a[i].n << " " << a[j].n << endl;
                    found = true;
                    break;
                }
            }
            if (found)
                break;
        }
        if (!found)
            cout << "0 0" << endl;
    }
*/
