#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "password"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;

const int MAXL = 1e5 + 1e3;
char s[MAXL + 1];
char t[MAXL + 1];

const int MAXLGRP = 8;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (scanf("%s%s", s, t) >= 1) {
    int l1 = strlen(s), l2 = strlen(t);
    vi s1(l1 + 1, 0);
    for (int i = 0; i < l1; i++) s1[i + 1] = s1[i] + (s[i] -= '0');
    for (int i = 0; i < l2; i++) t[i] -= '0';
    assert(l2 <= l1);

    int maxl = 0;
    while (maxl < l2 && s[maxl] == t[maxl]) maxl++;
    int minr = l2 - 1;
    while (minr > 0 && s[l1 - l2 + minr] == t[minr]) minr--;

    for (int l = 0; l <= maxl; l++) {
      int nsum = 0;
      for (int r = l; r < l2 && r <= l + MAXLGRP; r++) {
        nsum = nsum * 10 + t[r];
        if (r < minr) continue;
        eprintf("%d..%d; %d\n", l, r, nsum);

        int r2 = l1 - l2 + r;
        if (s1[r2 + 1] - s1[l] == nsum) {
          printf("%d %d\n", l + 1, r2 + 1);
          goto end;
        }
      }
    }

    assert(false);
    end:;
  }
  return 0;
}

