#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "virus"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

class fenv_tree {
  static int f(int x) { return x ^ (x & (x - 1)); }

  vll tr;

  public:
  fenv_tree(int n) : tr(n + 1, 0) {}
  ll get(int x) const {
    ll res = 0;
    for (x++; x > 0; x -= f(x))
      res += tr[x];
    return res;
  }
  ll get(int l, int r) const { return get(r) - get(l - 1); }
  void add(int x, int val) {
    for (x++; x < sz(tr); x += f(x))
      tr[x] += val;
  }
};

int n;
vvi es;
vi sts, ens;

int ctim;

void dfs(int v) {
  sts[v] = ctim++;
  for (int i = 0; i < sz(es[v]); i++)
    dfs(es[v][i]);
  ens[v] = ctim++;
}

struct Req {
  int x, y1, y2, k;
  bool operator<(const Req &r) const {
    if (x != r.x) return x < r.x;
    return !!k < !!r.k;
  }
};

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (scanf("%d", &n) >= 1) {
    vector<Req> rqs(3 * n);
    for (int i = 0; i < n; i++) {
      rqs[2 * i].k = -1;
      rqs[2 * i + 1].k = 1;
      rqs[2 * n + i].k = 0;
    }

    int maxx = 0, maxy = 0;
    for (int step = 0; step < 2; step++) {
      es = vvi(n);
      int root = -1;

      for (int i = 0; i < n; i++) {
        int x;
        scanf("%d", &x), x--;
        if (x < 0) root = i;
        else es[x].pb(i);
      }

      assert(root >= 0);
      ctim = 0;
      sts = vi(n, -1);
      ens = vi(n, -1);
      dfs(root);
      if (step == 0) maxx = ctim;
      else maxy = ctim;

      for (int i = 0; i < n; i++) {
        if (step == 0) {
          rqs[2 * n + i].x = ens[i];

          rqs[2 * i].x = sts[i];
          rqs[2 * i + 1].x = ens[i];
        } else {
          rqs[2 * n + i].y1 = ens[i];

          rqs[2 * i].y1 = sts[i];
          rqs[2 * i].y2 = ens[i];
          rqs[2 * i + 1].y1 = sts[i];
          rqs[2 * i + 1].y2 = ens[i];
        }
      }
    }

/*    for (int i = 0; i < n; i++) {
      eprintf("i=%d\n", i);
      eprintf("pt: %d %d\n", rqs[2 * n + i].x, rqs[2 * n + i].y1);
      eprintf("rq: %d %d - %d %d\n", rqs[2 * i].x + 1, rqs[2 * i].y1, rqs[2 * i + 1].x, rqs[2 * i + 1].y2);
    }*/

    ll ans = 0;
    sort(rqs.begin(), rqs.end());
    int ptr = 0;
    fenv_tree tr(maxy + 1);
    for (int x = 0; x <= maxx; x++) {
      while (ptr < sz(rqs) && rqs[ptr].x <= x) {
        if (rqs[ptr].k == 0) {
          tr.add(rqs[ptr].y1, 1);
        } else {
          ans += rqs[ptr].k * tr.get(rqs[ptr].y1, rqs[ptr].y2);
        }
        ptr++;
      }
    }
    assert(ans >= n);
    ans -= n;
    printf("%I64d\n", ans);
  }
  return 0;
}
