#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "apricot"
 
typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;
 
const ll INFLL = 1e16;
ll R, U;

const int MAXN = 1e6 + 1e3;

ll d[MAXN + 1];
ll func1(int x, int y) { return R + d[max(0, x - 2 * y)]; }
ll func2(int x, int y) { return U + d[y]; }
ll func(int x, int y) { return func1(x, y) - func2(x, y); }

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);
 
  int n;
  while (scanf("%d%I64d%I64d", &n, &R, &U) >= 1) {
    d[0] = -INFLL;
    d[1] = 0;
 
    for (int x = 2; x <= n; x++) {
      int L = 1, R = min(n / 2, x - 1);
      if (func(x, L) < 0) R = L;
      else if (func(x, R) >= 0) L = R;

      while (L + 1 < R) {
        int M = (L + R) / 2;
        if (func(x, M) >= 0) L = M;
        else R = M;
      }

      d[x] = INFLL;
      for (int y = L; y <= R; y++)
        d[x] = min(d[x], max(func1(x, y), func2(x, y)));
    }	
    printf("%I64d\n", d[n]);
  }
  return 0;
}
