#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "calendar"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MAXL = 1e5 + 1e5;
char s[MAXL + 1];

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int h, w;
  while (scanf("%d%d", &h, &w) >= 1) {
    vvi dat(w, vi(h, -1));
    for (int y = 0; y < h; y++) {
      scanf("%s", s);
      for (int x = 0; x < w; x++)
        if (s[x] != '*')
          dat[w - 1 - x][y] = s[x] - '0';
    }

    vector<vector<pii> > fr(w + 1, vector<pii>(h + 1, mp(-1, -1)));
    fr[0][1] = mp(0, 0);

    int step = 1;
    for (int x = 0; x < w; x++) {
      for (int dig = 0; dig < 10; dig++) {
        int lefta = 1, righta = min(step, h);
        for (int y = 0; y < h; y++) if (dat[x][y] >= 0) {
          int diff = dat[x][y] - dig - 1;
          if (diff < 0) diff += 10;

          int v1 = (y / step) % 10;
          int v2 = v1 + 9; if (v2 >= 10) v2 -= 10;
          int mina = y % step + 1;

          if (v1 == diff) {
            righta = min(righta, mina - 1);
          } else if (v2 == diff) {
            lefta = max(lefta, mina);
          } else {
            righta = -1;
          }
        }
        if (lefta > righta) continue;
        
        for (int fgo = lefta; fgo <= righta; fgo++) if (fr[x][fgo].first >= 0) {
          int nfgo = (9 - dig) * step + fgo;
          nfgo = min(nfgo, h);
          fr[x + 1][nfgo] = mp(fgo, dig);
        }
      }
      step = min(10 * step, h);
    }

    for (int fgo = 1; fgo <= h; fgo++) if (fr[w][fgo].first >= 0) {
      vi digs(w);
      for (int x = w; x > 0; x--) {
        digs[x - 1] = fr[x][fgo].second;
        fgo = fr[x][fgo].first;
        assert(fgo >= 0);
      }

      for (int i = w - 1; i >= 0; i--)
        printf("%d", digs[i]);
      printf("\n");
      goto end;
    }
    assert(false);

    end:;
  }
  return 0;
}
