#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "theatre"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int INF = 1e9;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n, m;
  while (scanf("%d%d", &n, &m) >= 1) {
    vi ans(n, INF);
    vi col(n, 0);

    vector<set<int> > ccols(1);
    ccols.reserve((n + m) * 2);
    for (int i = 0; i < n; i++)
      ccols[0].insert(i);

    for (int step = 0; step < m; step++) {
      int k;
      scanf("%d", &k);
      vector<pii> ocols(k);
      for (int i = 0; i < k; i++) {
        int x;
        scanf("%d", &x), x--;
        ocols[i] = mp(col[x], x);
      }

      sort(ocols.begin(), ocols.end());
      for (int i = 0; i < k; i++) {
        ccols[ocols[i].first].erase(ocols[i].second);
      }
      for (int i = 0; i < k; i++) {
        set<int> &ccnt = ccols[ocols[i].first];
        if (sz(ccnt) == 1) {
          ans[*ccnt.begin()] = min(ans[*ccnt.begin()], step);
        }
      }

      for (int i = 0; i < k;) {
        int en = i;
        while (en < k && ocols[i].first == ocols[en].first)
          en++;

        ccols.resize(sz(ccols) + 1);
        for (int i2 = i; i2 < en; i2++) {
          ocols[i2].first =
          col[ocols[i2].second] = sz(ccols) - 1;
          ccols[sz(ccols) - 1].insert(ocols[i2].second);
        }
        if (en - i == 1) {
          ans[ocols[i].second] = min(ans[ocols[i].second], step);
        }

        i = en;
      }
    }

    for (int i = 0; i < n; i++)
      printf("%d%c", ans[i] == INF ? 0 : ans[i] + 1, "\n "[i + 1 < n]);
  }
  return 0;
}
