#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int h, w;
int x, y;
int hx, hy;

const int INF = 1e9;

void go(int dx, int dy, bool call) {
  printf("%d %d %d\n", dx, dy, call);
  fflush(stdout);
  int res, rdx, rdy;
  scanf("%d%d%d", &res, &rdx, &rdy);
  if (res == 1) exit(0);
  hx += rdx; hy += rdy;
  x += dx; y += dy;
}

int main() {
  while (scanf("%d%d%d%d", &h, &w, &x, &y) >= 1) {
    x--, y--;
    int offx = 0, offy = 0;
    int minx = 0, miny = 0;
    int maxx = 0, maxy = 0;

    vvb was(h, vb(w, false));
    for (;;) {
      int bsans = INF, bsx = -1, bsy = -1;
      for (int sy = 0; sy < h; sy++)
      for (int sx = 0; sx < w; sx++) if (!was[sy][sx]) {
        int cd = abs(x - (offx + sx)) + abs(y - (offy + sy));
        if (cd < bsans) {
          bsans = cd;
          bsx = sx;
          bsy = sy;
        }
      }

      int sx = bsx, sy = bsy;
      if (sx < 0) break;

      was[sy][sx] = true;
      hx = sx + offx, hy = sy + offy;

      for (;;) {
        minx = min(minx, hx - sx);
        maxx = max(maxx, hx - sx);
        miny = min(miny, hy - sy);
        maxy = max(maxy, hy - sy);
        if (sx + minx < 0 || sy + miny < 0 || sx + maxx >= w || sy + maxy >= h)
          break;

        int bans = INF;
        int bdx = -2, bdy = -2;

        for (int dx = -1; dx <= 1; dx++)
        for (int dy = -1; dy <= 1; dy++) {
          int nx = x + dx, ny = y + dy;
          if (nx < 0 || ny < 0 || nx >= w || ny >= h) continue;
          int nd = abs(nx - hx) + abs(ny - hy);
          if (nd < bans) {
            bans = nd;
            bdx = dx;
            bdy = dy;
          }
        }
        go(bdx, bdy, bans == 0);
        if (bans == 0) break;
      }

      offx = hx - sx;
      offy = hy - sy;
    }
  }
  return 0;
}
