#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(log, __VA_ARGS__)
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int h, w;
int x, y;
int offx, offy;

const int INF = 1e9;

void go(int dx, int dy, bool call) {
  printf("%d %d %d\n", dx, dy, call);
  fflush(stdout);
  int res, rdx, rdy;
  scanf("%d%d%d", &res, &rdx, &rdy);
  if (res == 1) exit(0);
  offx += rdx; offy += rdy;
  x += dx; y += dy;
}

bool check(int x, int y) {
  return 0 <= x && x < w && 0 <= y && y < h;
}

FILE *log;

int main() {
  #ifdef DEBUG
  log = fopen("hedgehog.log", "w");
  #else
  log = stderr;
  #endif
  while (scanf("%d%d%d%d", &h, &w, &x, &y) >= 1) {
    x--, y--;
    offx = offy = 0;
    int minx = 0, miny = 0;
    int maxx = 0, maxy = 0;

    vvb was(h, vb(w, false));
    int lasx = -1, lasy = -1;
    for (;;) {
      minx = min(minx, offx);
      maxx = max(maxx, offx);
      miny = min(miny, offy);
      maxy = max(maxy, offy);

      int bans = INF;
      int bdx = -2, bdy = -2;
      int bsx = -1, bsy = -1;

      while (bdx < -1) {
/*        int nbebetter = INF;
        if (lasx >= 0) {
          for (int dx = -1; dx <= 1; dx++)
          for (int dy = -1; dy <= 1; dy++) {
            int nx = x + dx, ny = y + dy;
            if (!check(nx, ny)) continue;
            nbebetter = min(nbebetter, abs(lasx + offx - nx) + abs(lasy + offy - ny));
          }
        }*/

        for (int dx = -1; dx <= 1; dx++)
        for (int dy = -1; dy <= 1; dy++) {
          int nx = x + dx, ny = y + dy;
          if (!check(nx, ny)) continue;

          for (int sy = 0; sy < h; sy++)
          for (int sx = 0; sx < w; sx++) if (!was[sy][sx]) {
            if (!check(sx + minx, sy + miny) || !check(sx + maxx, sy + maxy)) {
              was[sy][sx] = false;
              continue;
            }

            int cd = abs(sx + offx - nx) + abs(sy + offy - ny);
/*            if (cd >= nbebetter && lasx >= 0) {
              if (sx != lasx || sy != lasy) continue;
            }*/
            if (cd < bans) {
              bans = cd;
              bdx = dx;
              bdy = dy;
              bsx = sx;
              bsy = sy;
            }
          }
        }
        if (bdx < -1) lasx = lasy = -1;
      }
//      eprintf("curs=%d %d %d\n", bsx, bsy, bans);
//      fflush(log);
      go(bdx, bdy, bans == 0);
      if (bans == 0) was[bsy][bsx] = true;
      lasx = bsx;
      lasy = bsy;
    }
  }
  return 0;
}
