#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "army"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MAXN = 15;
const int P = 29;

int n;

int k;
int ids[MAXN + 1];
bool isg[MAXN];
int was, lasg;

int cmlen[MAXN];
int curs[MAXN];

const int HSZ = 1 << 5;
int mem[1 << MAXN][HSZ];

struct Cache {
  int h; ll val;
  int ne;
};
vector<Cache> all;

int tmph[MAXN];

ll go(int pos) {
  if (pos == n) return 1;

  int h = 0;
  {
    int cval = 2e9;
    for (int i = n - 1; i > 0; i--) {
      cval = min(cval, tmph[i]);
      h = h * P + cval;
    }
  }
  int h2 = h & (HSZ - 1);

  int it = -1;
  for (it = mem[was][h2]; it >= 0; it = all[it].ne)
    if (all[it].h == h) break;
  if (it < 0) {
    it = sz(all);
    all.pb(Cache());
    all[it].h = h;
    all[it].ne = mem[was][h2];
    mem[was][h2] = it;
  } else
    return all[it].val;

  ll res = 0;
  for (int v = 0; v < n; v++) if (!(was & (1 << v))) {
    bool tmp = false;
    if (isg[v]) {
      if (ids[lasg] != v) continue;
      tmp = true;
    }

    int clen = 0;
    for (int pr = 0; pr < pos; pr++)
      if (curs[pr] < v)
        clen = max(clen, cmlen[pr]);

    if (++clen > k)
      continue;

    cmlen[pos] = clen;
    curs[pos] = v;

    was ^= 1 << v;
    if (tmp) lasg++;

    int oval = tmph[clen];
    if (tmph[clen] > v) tmph[clen] = v;

    res += go(pos + 1);

    tmph[clen] = oval;

    was ^= 1 << v;
    if (tmp) lasg--;
  }
  return all[it].val = res;
}

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (scanf("%d%d", &n, &k) >= 1) {
    all.clear();
    all.reserve(1000000);

    for (int i = 0; i < k; i++)
      scanf("%d", &ids[i]), ids[i]--;
    ids[k] = -1;

    memset(isg, 0, sizeof isg);
    for (int i = 0; i < k; i++) isg[ids[i]] = true;

    memset(tmph, 0x3F, sizeof tmph);

    was = 0; lasg = 0;
    memset(curs, 0, sizeof curs);
    memset(mem, -1, sizeof mem);

    eprintf("go\n");
    ll ans = go(0);
    eprintf("goed\n");

    eprintf("botva %d\n", sz(all));
    printf("%I64d\n", ans);
  }
  eprintf("%d\n", clock());
  assert(clock() < CLOCKS_PER_SEC);
  return 0;
}
