#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
using namespace std;

int N, M;
int dx = 0, dy = 0;
int xx0 = 0, yy0 = 0;
int Xmin = 0, Xmax = 0, Ymin = 0, Ymax = 0;
int Xval = 0, Yval = 0;
int otnPosX = 100, otnPosY = 100;

int PosXmin, PosXmax, PosYmin, PosYmax;

bool matrix[200][200];

string MakeStep() {
	otnPosX -= dx;
	otnPosY -= dy;
	Xval += dx;
	Yval += dy;
	if(Xval > Xmax) Xmax = Xval;
	if(Xval < Xmin) Xmin = Xval;
	if(Yval > Ymax) Ymax = Yval;
	if(Yval < Ymin) Ymin = Yval;
	bool check = false;
	int stepX = 0, stepY = 0;
	PosXmax = M - Xmax + Xval;
	PosXmin = 1 - Xmin + Xval;
	PosYmax = N - Ymax + Yval;
	PosYmin = 1 - Ymin + Yval;
	if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 >= PosYmin && yy0 <= PosYmax && !matrix[otnPosX+1][otnPosY]) stepX = 1;
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 >= PosYmin && yy0 <= PosYmax && !matrix[otnPosX-1][otnPosY]) stepX = -1;
	else if(xx0 >= PosXmin && xx0 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && !matrix[otnPosX][otnPosY+1]) stepY = 1;
	else if(xx0 >= PosXmin && xx0 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && !matrix[otnPosX][otnPosY-1]) stepY = -1;
	else if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && !matrix[otnPosX+1][otnPosY+1]) {
		stepX = 1;
		stepY = 1;
	}
	else if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && !matrix[otnPosX+1][otnPosY-1]) {
		stepX = 1;
		stepY = -1;
	}
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && !matrix[otnPosX-1][otnPosY+1]) {
		stepX = -1;
		stepY = 1;
	}
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && !matrix[otnPosX-1][otnPosY-1]) {
		stepX = -1;
		stepY = -1;
	}
	else if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 >= PosYmin && yy0 <= PosYmax && matrix[otnPosX+1][otnPosY]) stepX = 1;
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 >= PosYmin && yy0 <= PosYmax && matrix[otnPosX-1][otnPosY]) stepX = -1;
	else if(xx0 >= PosXmin && xx0 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && matrix[otnPosX][otnPosY+1]) stepY = 1;
	else if(xx0 >= PosXmin && xx0 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && matrix[otnPosX][otnPosY-1]) stepY = -1;
	else if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && matrix[otnPosX+1][otnPosY+1]) {
		stepX = 1;
		stepY = 1;
	}
	else if(xx0 + 1 >= PosXmin && xx0 + 1 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && matrix[otnPosX+1][otnPosY-1]) {
		stepX = 1;
		stepY = -1;
	}
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 + 1 >= PosYmin && yy0 + 1 <= PosYmax && matrix[otnPosX-1][otnPosY+1]) {
		stepX = -1;
		stepY = 1;
	}
	else if(xx0 - 1 >= PosXmin && xx0 - 1 <= PosXmax && yy0 - 1 >= PosYmin && yy0 - 1 <= PosYmax && matrix[otnPosX-1][otnPosY-1]) {
		stepX = -1;
		stepY = -1;
	}
	else if(!matrix[otnPosX][otnPosY] && xx0 >= PosXmin && xx0 <= PosXmax && yy0 >= PosYmin && yy0 <= PosYmax) {
		stepX = 0;
		stepY = 0;
	}
	else {
		if(xx0 < PosXmin) stepX = 1;
		if(xx0 > PosXmax) stepX = -1;
		if(yy0 < PosYmin) stepY = 1;
		if(yy0 > PosYmax) stepY = -1;
	}
	if(!matrix[otnPosX+stepX][otnPosY+stepY]) {
		if(xx0 + stepX >= PosXmin && xx0 + stepX <= PosXmax && yy0 + stepY >= PosYmin && yy0 + stepY <= PosYmax) check = true;
		matrix[otnPosX+stepX][otnPosY+stepY] = true;
	}
	xx0 += stepX;
	yy0 += stepY;
	otnPosX += stepX;
	otnPosY += stepY;
	string answer;
	if(stepX == -1) answer += "-1 ";
	else if(stepX == 0) answer += "0 ";
	else if(stepX == 1) answer += "1 ";
	if(stepY == -1) answer += "-1 ";
	else if(stepY == 0) answer += "0 ";
	else if(stepY == 1) answer += "1 ";
	if(check) answer += "1";
	else answer += "0";
	return answer;
}


int main() {
	for(int i = 0; i < 200; i++) 
		for(int j = 0; j < 200; j++) 
			matrix[i][j] = false;
	scanf("%d %d", &N, &M);
	PosXmin = 1;
	PosXmax = M;
	PosYmin = 1;
	PosYmax = N;
	scanf("%d %d", &xx0, &yy0);
	int result = 0;
	while(result != 1) {
		//printf("\n");
		//cout << PosXmin << " " << PosXmax << " " << PosYmin << " " << PosYmax << endl;
		//printf("\n");
		cout << MakeStep() << endl;
		cout.flush();
		scanf("%d", &result);
		scanf("%d %d", &dx, &dy);
	}
	return 0;
}