#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <string>
using namespace std;

const int MAXN = 100008;

string s, t, cur_s;
int A[MAXN];
const unsigned long long P = 31;
unsigned long long H[MAXN], pows[MAXN];


unsigned long long hsh(string a)
{
	unsigned long long h = 0;
	for(int i = 0; i < a.size(); i++)
		h += (a[i] - '0' + 1) * pows[i];
	return h;
}
string toStr(int n)
{
	string res, ans;
	if(n == 0)
		return "0";
	while(n)
	{
		res += n % 10 + '0';
		n /= 10;
	}
	for(int i = res.size() - 1; i >= 0; i--)
		ans += res[i];
	return ans;
}

int main()
{
	int cur;
	unsigned long long h;
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	cin >> s >> t;
	A[1] = s[0] - '0';
	H[0] = s[0] - '0' + 1;
	pows[0] = 1;
	for(int i = 1; i < s.size(); i++)
	{
		A[i + 1] = A[i] + s[i] - '0';
		pows[i] = pows[i - 1] * P;
		H[i] = H[i - 1] + (s[i] - '0' + 1) * pows[i];
	}
	h = hsh(t);
	for(int i = 0; i < s.size(); i++)
	{
		for(int j = 0; j < s.size(); j++)
		{
			cur = A[j + 1] - A[i];
			cur_s = toStr(cur);
			if((H[i - 1] + hsh(cur_s) * pows[i]) * pows[j - 1] + H[s.size() - 1] - H[j] == h * pows[j - 1])
			{
				cout << i + 1 << " " << j + 1;
				return 0;
			}
		}
	}
	return 0;
}