#include <cstdio>
#include <iostream>
#include <cmath>

using namespace std;

#define sz(x) ((int)(x).size())

typedef long long ll;

const ll P = 239;

const int maxn = 100 * 1000 + 5;
int sa[maxn], sb[maxn];
ll ha[maxn], hb[maxn];

int main()
{
	ios::sync_with_stdio(0);
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	
	string a, b; cin >> a >> b;
	for (int i = 0; i < sz(a); ++i) {
		a[i] -= '0';
		sa[i] = (i ? sa[i - 1] : 0) + a[i];
	}
	for (int i = 0; i < sz(b); ++i) {
		b[i] -= '0';
		sb[i] = (i ? sb[i - 1] : 0) + b[i];
	}
	
	for (int i = sz(a) - 1; i >= 0; --i) {
		ha[i] = (i < sz(a) - 1 ? ha[i + 1] : 0) * P + a[i];	
	}
	for (int i = sz(b) - 1; i >= 0; --i) {
		hb[i] = (i < sz(b) - 1 ? hb[i + 1] : 0) * P + b[i];	
	}
	
	int d = sz(a) - sz(b);

	for (int i = 0; i < min(sz(a), sz(b)); ++i) {
		int sum1 = 0, sum2 = 0;
		int pos1 = i, pos2 = i;
		if (d > 0) {
			sum1 = sa[i + d - 1] - (i ? sa[i - 1] : 0);
			pos1 += d;
		}
		else if (d < 0) {
			sum2 = sb[i + (-d) - 1] - (i ? sb[i - 1] : 0);
			pos2 += -d;
		}
		
		for (int j = 0; j < 8 && pos1 + j < sz(a) && pos2 + j < sz(b); ++j) {
			sum1 += a[pos1 + j];
			sum2 *= 10;
			sum2 += b[pos2 + j];
			
			if (!b[i] && j) {
				continue;	
			}
			
			//cerr << i << " " << sum1 << " " << sum2 << "\n";
			
			if (sum1 == sum2 && ha[pos1 + j + 1] == hb[pos2 + j + 1]) {
				cout << i + 1 << ' ' << j + pos1 + 1 << '\n';	
				return 0;
			}
		}
	
	}
	
	
	return 0;
}
