#include <cstdio>
#include <iostream>

using namespace std;

typedef long long ll;

const ll linf = 1LL << 60;
const int maxn = 1000 * 1000 + 5;

ll F[maxn];
bool used[maxn];

int N;

ll U, R;

ll find(int n)
{
	if (n <= 1) {
		return 0;	
	}
	if (used[n]) {
		return F[n];	
	}
	used[n] = 1;
	
	ll res = linf;
	
	if (n < 5) {
		for (int a = 1; a < n && a * 2 <= N; ++a) {
			ll res1 = U + find(a);
			ll res2 = R + find(n - a * 2);
			if (a * 2 < n) {
				res1 = max(res1, res2);
			}
			res = min(res, res1);
		}
		return F[n] = res;
	}

	if (n % 2 == 0 || n < N) {
		res = U + find((n + 1) / 2);
	}
	
	//cerr << "## " << res << endl;
	
	if (U + find(1) >= R + find(n - 1 * 2)) {
		return F[n] = min(res, U + find(1));
	}

	int l = 0, r = n / 2 + 1;
	
	//cerr << "# " << n << ": " << l + 1 << " " << r - 1 << " | " << res << endl;
	//cerr << U + find(1) << " " << R + find(n - 1 * 2) << " | " << U + find(r - 1) << " " << R + find(n - (r - 1) * 2) << endl;
	
	if (U + find(r - 1) <= R + find(n - (r - 1) * 2)) {
		return F[n] = min(res, R + find(n - (r - 1) * 2));
	}
	
	while (l + 1 < r) {
		int c = (l + r) >> 1;
		
		if (U + find(c) <= R + find(n - c * 2)) {
			l = c;
		}
		else {
			r = c;
		}
	}
	
	res = min(res, min(R + find(n - l * 2), U + find(l + 1)));
	//cerr << n << ": " << l << " | " << U + find(l) << " " << R + find(n - l * 2) << endl;

	
	return F[n] = res;
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	
	int n; cin >> n >> R >> U;
	N = n;
	ll res = find(n);
	
	/*for (int i = 0; i <= n; ++i) {
		cerr << i << ": " << F[i] << endl;
	}*/
	
	cout << res << '\n';
	
	return 0;
}
