#include <cstdio>
#include <iostream>

#include <algorithm>

using namespace std;

struct item
{
	int l, r;
	item(): l(1 << 30), r(1 << 30) {}
	item(int l, int r): l(l), r(r) {}
};

bool operator < (item a, item b)
{
	return a.r < b.r;
}

const int shft = 1 << 17;
const int maxt = shft << 1;

const int maxn = 100 * 1000 + 5;
int A[maxn][2], B[2][maxn], used[2][maxn];
item T[maxt];

int n;

int getc(int x, int t)
{
	return lower_bound(B[t], B[t] + n, x) - B[t];
}

void init()
{
	for (int i = shft - 1; i > 0; --i) {
		T[i] = min(T[i << 1], T[(i << 1) + 1]);
	}
}

item gmin(int lx, int rx, int v = 1, int l = 0, int r = shft - 1)
{
	if (lx > r || rx < l) {
		return item();
	}
	if (lx == l && rx == r) {
		return T[v];
	}
	int c = (l + r) >> 1;
	
	return min(gmin(lx, min(rx, c), v << 1, l, c), gmin(max(lx, c + 1), r, (v << 1) + 1, c + 1, r));
}

int main()
{
	ios::sync_with_stdio(0);
	
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> A[i][0] >> A[i][1];
		B[0][i] = A[i][0];
		B[1][i] = A[i][1];
	}
	sort(B[0], B[0] + n);
	sort(B[1], B[1] + n);
	
	for (int i = 0; i < n; ++i) {
		used[0][i] = used[1][i] = (1 << 30);
	}
	
	for (int i = n - 1; i >= 0; --i) {
		int a0 = getc(A[i][0], 0);
		int a1 = getc(A[i][1], 1);
		//cerr << a0 << " " << a1 << " | " << used[0][a0] << " " << used[1][a1] << endl;
		for (int j = i + 1; j < n; ++j) {
			if (A[j][0] != A[i][0] && A[j][1] != A[i][1]) {
				T[shft + i] = item(i, j);
				break;
			}
		}
		
		//T[shft + i] = item(i, min(used[0][a0], used[1][a1]));
		
		used[0][a0] = i;
		used[1][a1] = i;
	}
	
	init();
	
	int m; cin >> m;
	for (int i = 0; i < m; ++i) {
		int l, r; cin >> l >> r; --l, --r;
		item it = gmin(l, r); //cerr << "# " << it.l << " " << it.r << "\n";
		if (it.r > r) {
			cout << "0 0\n";
		}
		else {
			cout << it.l + 1 << ' ' << it.r + 1 << '\n';
		}
	}
	
	return 0;
}
