#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

string inttostr(int n)
{
	ostringstream ss;
	ss << n;
	return ss.str();
}

vector <int> pre_sum;
void precalc(string &a)
{
	pre_sum.resize(a.length());
	int cur = 0;
	for (int i = 0; i < (int)a.length(); i++)
	{
		cur += a[i] - '0';
		pre_sum[i] = cur;
	}
	return void();
}

bool encode_string(string &a, int i, int j, string &b)
{
	if (i == j)
		return (a == b);
	if ((int)b.length() < i || a.substr(0, i) != b.substr(0, i))
		// prefix
		return false;
	
	int symb = a.length() - j - 1;
	if ((int)b.length() < symb || a.substr(j + 1, symb) != b.substr(b.length() - symb, symb))
		// suffix
		return false;

	int result = pre_sum[j] - ((i == 0) ? 0 : pre_sum[i - 1]);

	string b_sub = b.substr(i, b.length() - i - symb);
	return inttostr(result) == b_sub;
}

void solve1(string &a, string &b)
{
	precalc(a);
	for (int i = a.length() - 1; i >= 0; i--)
	{
		for (int j = i; j < (int)a.length(); j++)
		{
			if (encode_string(a, i, j, b))
			{
				cout << i + 1 << " " << j + 1 << "\n";
				return void();
			}
		}
	}
	
#ifndef CUCUMBER
	throw -1;
#endif
	cout << "presentation error expected\n";
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
#else
	freopen("password.in", "r", stdin);
	freopen("password.out", "w+", stdout);
#endif

	string a, b;
	cin >> a >> b;

	solve1(a, b);

	return 0;
}