#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

pair <int, int> find_minmax_div(int n)
{
	pair <int, int> result = make_pair(-1, n);
	if (n % 2 == 0)
		result.first = 2;
	int root = floor(sqrt((double)n));
	for (int div = 3; div <= n / 2; div += 2)
		if (n % div == 0)
		{
			if (result.first == -1)
				result.first = div;
			result.second = div;
		}
	return result;
}

int int_log(int n)
{	return (int) floor(log((double)n) / log(2.0L)); }

int solve(int &n, int e, int d)
{
	if (n == 1)
		return 0;
	if (n == 2)
	{
		n = 1;
		return d;
	}
	if (n == 3)
	{
		n = 1;
		return max(e, d);
	}

	int answer = 0;
	pair <int, int> divs = find_minmax_div(n);
	if (divs.second == n)
		// n is simple
	{
		answer = int_log(n);
		n = 1;
	}
	else if (e > d)
	{
		answer = divs.first / 2 * d;
		n /= divs.first;
	}
	else 
	{
		answer = (divs.second / 2 - 1) * e + d;
		n /= divs.second;
	}
	return answer;
}

void solve1(int n, int e, int d)
{
	int answer = 0;
	while (n != 1)
		answer += solve(n, e, d);
	cout << answer << "\n";
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w+", stdout);
#endif

	int n, e, d;
	cin >> n >> e >> d;

	solve1(n, e, d);

	return 0;
}