#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

void die(pair <int, int> answer)
{
	cout << answer.first + 1 << " " << answer.second + 1 << "\n";
	exit(0);
}

bool harm(pair <int, int> &a, pair <int, int> &b)
{	return a.first == b.first || a.second == b.second; }

void solve_naive(vector <pair <int, int> > &a, pair <int, int> &q)
{
	for (int j = q.first; j <= q.second; j++)
		{
			for (int k = q.first; k < j; k++)
			{
				if (!harm(a[j], a[k]))
				{
					cout << j + 1 << " " << k + 1 << "\n";
					return void();
				}
			}
		}
	cout << "0 0\n";
}

void solve1(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	for (int i = 0; i < q.size(); i++)
	{
		solve_naive(a, q[i]);
	}
}

struct seg
{
	int beg, end;
	int left;
	int val;
	seg(int _beg, int _end, int _left, int _val = -1)
	{
		beg = _beg, end = _end, left = _left, val = _val;
	}
};
pair <set <pair <int, int> > , set <pair <int, int> > > segs;
void precalc(vector <pair <int, int> > &a)
{
	set <pair <int, int> > fst, sec;
	pair <int, int> last = a[0], beg = make_pair(0, 0);
	for (int i = 1; i < a.size(); i++)
	{
		// fst
		if (a[i].first != last.first)
		{
			fst.insert(make_pair(beg.first, i - 1));
			beg.first = i;
			last.first = a[i].first;
		}
		// sec
		if (a[i].second != last.second)
		{
			sec.insert(make_pair(beg.second, i - 1));
			beg.second = i;
			last.second = a[i].second;
		}
	}
	fst.insert(make_pair(beg.first, a.size() - 1));
	sec.insert(make_pair(beg.second, a.size() - 1));

	segs = make_pair(fst, sec);
	return void();
}

void solve2(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	precalc(a);

	for (int i = 0; i < q.size(); i++)
	{
		if (segs.first.find(q[i]) == segs.first.end() && segs.second.find(q[i]) == segs.second.end())
			cout << q[i].first + 1 << " " << q[i].second + 1 << "\n";
		else
			cout << "0 0\n";
	}
	return void();
}

int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w+", stdout);
#endif

	int n;
	cin >> n;
	vector <pair <int, int> > a(n), q;
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	cin >> n;
	q.resize(n);
	for (int i = 0; i < n; i++)
		cin >> q[i].first >> q[i].second, q[i].first--, q[i].second--;

#ifndef CUCUMBER
	if (n <= 200)
		solve1(a, q);
	else
		solve2(a, q);
#else
	solve2(a, q);
#endif

	return 0;
}