#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

void die(pair <int, int> answer)
{
	cout << answer.first + 1 << " " << answer.second + 1 << "\n";
	exit(0);
}

bool harm(pair <int, int> &a, pair <int, int> &b)
{	return a.first == b.first || a.second == b.second; }

void solve_naive(vector <pair <int, int> > &a, pair <int, int> &q)
{
	for (int j = q.first; j <= q.second; j++)
		{
			for (int k = q.first; k < j; k++)
			{
				if (!harm(a[j], a[k]))
				{
					cout << j + 1 << " " << k + 1 << "\n";
					return void();
				}
			}
		}
	cout << "0 0\n";
}

void solve1(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	for (int i = 0; i < q.size(); i++)
	{
		solve_naive(a, q[i]);
	}
}

struct seg
{
	int beg, end;
	int left;
	int val;
	seg(int _beg, int _end, int _left, int _val = -1)
	{
		beg = _beg, end = _end, left = _left, val = _val;
	}
};
vector <vector <int> > segs;
void precalc(vector <pair <int, int> > &a)
{
	segs.resize(4);
	pair <int, int> last = a[0], beg = make_pair(0, 0);
	for (int i = 1; i < a.size(); i++)
	{
		// fst
		if (a[i].first != last.first)
		{
			segs[0].push_back(beg.first);
			segs[1].push_back(i - 1);
			beg.first = i;
			last.first = a[i].first;
		}
		// sec
		if (a[i].second != last.second)
		{
			segs[2].push_back(beg.second);
			segs[3].push_back(i - 1);
			beg.second = i;
			last.second = a[i].second;
		}
	}
	segs[0].push_back(beg.first);
	segs[1].push_back(a.size() - 1);
	segs[2].push_back(beg.second);
	segs[3].push_back(a.size() - 1);

	return void();
}

bool fits(pair <int, int> q, int fst, int sec)
{
	bool st1 = false, st2 = false;
	if (0 <= fst && fst < segs[0].size())
		st1 = segs[0][fst] <= q.first && q.second <= segs[1][fst];
	if (0 <= sec && sec < segs[2].size())
		st2 = segs[2][sec] <= q.first && q.second <= segs[3][sec];
	return st1 || st2;
}

void solve2(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	precalc(a);

	for (int i = 0; i < q.size(); i++)
	{
		int fst, sec;
		fst = lower_bound(segs[0].begin(), segs[0].end(), q[i].first) - segs[0].begin();
		sec = lower_bound(segs[2].begin(), segs[2].end(), q[i].first) - segs[2].begin();
		if (fits(q[i], fst, sec) || fits(q[i], fst - 1, sec) || fits(q[i], fst, sec - 1) || fits(q[i], fst - 1, sec - 1))
		 {
			 cout << "0 0\n";
		 }
		else
		{
			int left = q[i].first, right = q[i].second;
			while (harm(a[left], a[right]))
				right--;
			cout << left + 1 << " " << right + 1 << "\n";
		}
	}
	return void();
}

vector <long long> sums1, sums2;
void precalc_sums(vector <pair <int, int> > &a)
{
	sums1.resize(a.size());
	sums2.resize(a.size());

	sums1[0] = a[0].first;
	sums2[0] = a[0].second;
	for (int i = 1; i < a.size(); i++)
	{
		sums1[i] = sums1[i - 1] + a[i].first;
		sums2[i] = sums2[i - 1] + a[i].second;
	}

	return void();
}

void solve3(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	precalc_sums(a);

	for (int i = 0; i < q.size(); i++)
	{
		long long sum1 = sums1[q[i].second] - ((q[i].first == 0) ? 0 : sums1[q[i].first - 1]);
		long long sum2 = sums2[q[i].second] - ((q[i].first == 0) ? 0 : sums2[q[i].first - 1]);
		if (sum1 % a[q[i].second].first == 0 && sum1 / a[q[i].second].first == q[i].second - q[i].first + 1
			||
			sum2 % a[q[i].second].second == 0 && sum2 / a[q[i].second].second == q[i].second - q[i].first + 1
		   )
			cout << "0 0\n";
		else
		{
			int left = q[i].first, right = q[i].second;
			while (harm(a[left], a[right]))
				right--;
			cout << left + 1 << " " << right + 1 << "\n";
		}
	}
}
int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w+", stdout);
#endif

	srand(1004);
	int maxd = 100000;
	for (int j = 0; j < 2; j++)
	{
		cerr << 500 << "\n";
		for (int i = 0; i < 500; i++)
		{
			int a = rand() % maxd, b = rand() % maxd;
			if (j == 1)
				 a %= 500, b %= 500;
			if (a > b)
				swap(a, b);
			cerr << ++a << " " << ++b << "\n";
		}
	}

	int n;
	cin >> n;
	vector <pair <int, int> > a(n), q;
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	cin >> n;
	q.resize(n);
	for (int i = 0; i < n; i++)
		cin >> q[i].first >> q[i].second, q[i].first--, q[i].second--;

#ifndef CUCUMBER
	if (n <= 200)
		solve1(a, q);
	else
		solve3(a, q);
#else
	solve3(a, q);
#endif

	return 0;
}