#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

const int maxn = 100005;

struct oint
{
	long long p1, p2, p3;
	oint (long long a = 0, long long b = 0, long long c = 0)
	{
		p1 = a, p2 = b, p3 = c;
	}
};
bool operator == (oint a, oint b)
{	return a.p1 == b.p1 && a.p2 == b.p2 && a.p3 == b.p3; }
oint operator + (oint a, oint b)
{	return oint(a.p1 + b.p1, a.p2 + b.p2, a.p3 + b.p3); }
oint operator * (oint a, oint b)
{	return oint(a.p1 * b.p1, a.p2 * b.p2, a.p3 * b.p3); }

const int b1 = 13, b2 = 443, b3 = 239;
oint ob = oint(b1, b2, b3);
vector <int> s1(maxn, -1), s2(maxn, -1), s3(maxn, -1);

oint pp(int n)
{
	if (n == 1)
		return oint(1, 1, 1);
	if (s1[n] != -1)
		return oint(s1[n], s2[n], s3[n]);
	else
		return pp(n - 1) * ob;
}

vector <int> answer;
int guess = 0;
void marquee(vector <oint> &pers, int round)
{
	for (int i = 0; i < pers.size(); i++)
	{
		if (answer[i] != -1)
			continue;
		bool found = false;
		for (int j = 0; j < pers.size(); j++)
		{
			if (i == j || answer[j] != -1)
				continue;
			if (pers[i] == pers[j])
			{
				found = true;
				break;
			}
		}
		if (!found)
		{
			answer[i] = round;
			guess++;
		}
	}
}

void solve1(vector <vector <int> > &act, int n)
{
	answer.resize(n, -1);
	vector <oint> pers(n, oint());
	for (int i = 0; i < act.size(); i++)
	{
		for (int j = 0; j < act[i].size(); j++)
		{
			pers[act[i][j]] = pers[act[i][j]] + pp(i + 1);
		}
		marquee(pers, i);
		if (guess == n)
			break;
	}

	for (int i = 0; i < n; i++)
	{
		cout << answer[i] + 1 << " ";
	}
}

int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w+", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vector <vector <int> > act(m);
	for (int i = 0; i < m; i++)
	{
		int size;
		cin >> size;
		act[i].resize(size);
		for (int j = 0; j < size; j++)
			cin >> act[i][j], act[i][j]--;
	}

	solve1(act, n);

	return 0;
}