#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cctype>
#include <cstring>
#include <string>
#include <cstdlib>
#include <set>
#include <map>

using namespace std;

const int MAXSIZE = 100001;
const double eps = 1e-7;

typedef pair < int, int > pii;
typedef long long ll;

const int base = 31;

int a[MAXSIZE], b[MAXSIZE];
int sumA[MAXSIZE], sumB[MAXSIZE];
char ss[MAXSIZE + 1];
int n, k;
int hashA[MAXSIZE], hashB[MAXSIZE];
int pow_h[MAXSIZE];

inline bool getVal(int L, int R, ll cur)
{
    long long ans = 0;
    for (int i = L; i <= R; i++)
    {
        ans = ans * 10LL + (ll)b[i];
        if (ans > cur)
            return false;
    }
    return (ans == cur);
}

inline void preCalc()
{
    int pp = 1;
    for (int i = 0; i < MAXSIZE; i++)
    {
        pow_h[i] = pp;
        pp *= base;
    }
}

inline int getSubstrA(int l, int r)
{
    if (l > r)
        return -1;
    return (hashA[r] - (l ? hashA[l - 1] : 0)) * pow_h[MAXSIZE - r - 1];
}

inline int getSubstrB(int l, int r)
{
    if (l > r)
        return -1;
    return (hashB[r] - (l ? hashB[l - 1] : 0)) * pow_h[MAXSIZE - r - 1];
}

inline bool extComp(int l, int r)
{
    //cerr << l << " " << r << endl;
    bool ans = true;
    ll sum = 0;
    for (int i = l; i <= r; i++)
    {
        sum += a[i];
    }
    ll dd = 0;
    bool isNull = true;
    for (int i = l; i <= k - (n - r - 1) - 1; i++)
    {
        if (isNull && b[i] == 0)
            return false;
        isNull = false;
        dd = dd * 10LL + (ll)b[i];
        if (dd > sum)
            return false;
    }
    if (dd != sum)
        return false;
    
    for (int i = 0; i < l; i++)
        ans &= (a[i] == b[i]);
    for (int i = n - 1, j = k - 1; i > r; i--, j--)
        ans &= (a[i] == b[j]);
    return ans;
}

int solve()
{
    preCalc();
    scanf("%s\n", ss);
    n = strlen(ss);
    for (int i = 0; i < n; i++)
    {
        a[i] = int(ss[i] - '0');
        hashA[i] = (i ? hashA[i - 1] : 0) + (a[i] + 1) * pow_h[i];
        sumA[i] = (i ? sumA[i - 1] : 0) + a[i];
    }
    scanf("%s\n", ss);
    k = strlen(ss);
    for (int i = 0; i < k; i++)
    {
        b[i] = int(ss[i] - '0');
        hashB[i] = (i ? hashB[i - 1] : 0) + (b[i] + 1) * pow_h[i];
        sumB[i] = (i ? sumB[i - 1] : 0) + b[i];
    }
    for (int i = 0; i < n; i++)
    {
        /*if (i == 192)
        {
            cerr << max(n + i - k, 0) << " " <<  min(n - 1, 10 + n + i - k) << endl;
        }*/
        for (int j = max(n + i - k, 0); j <= min(n - 1, 10 + n + i - k); j++) 
        //for (int j = i; j < n && n - j - 1 <= 10; j++)
        {
            if (getVal(i, k - (n - j - 1) - 1, (ll)(sumA[j] - (i ? sumA[i - 1] : 0))) && getSubstrA(0, i - 1) == getSubstrB(0, i - 1) 
                && getSubstrA(j + 1, n - 1) == getSubstrB(k - (n - j - 1), k - 1))
            {
                //cerr << getSubstrA(0, i - 1) << " " << getSubstrB(0, i - 1) << endl;
                //cerr << i << " " << j << " " << k - (n - j - 1) - 1 << endl;
                if (extComp(i, j))
                {
                    printf("%d %d\n", i + 1, j + 1);
                    return 0;
                }
            }
        }
    }
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
#endif
    
    solve();
    
    return 0;
}
