#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cctype>
#include <cstring>
#include <string>
#include <cstdlib>
#include <set>
#include <map>

using namespace std;

const int MAXSIZE = 100002;
const double eps = 1e-7;

typedef pair < int, int > pii;
typedef long long ll;

int n;
vector < int > g1[MAXSIZE], g2[MAXSIZE];
int a[MAXSIZE], b[MAXSIZE];
int ans = 0;
int tin1[MAXSIZE], tout1[MAXSIZE];
int tin2[MAXSIZE], tout2[MAXSIZE];
int timer = 0;
bool used[MAXSIZE];

void dfs1(int v)
{
    used[v] = true;
    tin1[v] = ++timer;
    for (int i = 0; i < g1[v].size(); i++)
    {
        int to = g1[v][i];
        if (!used[to])
            dfs1(to);
    }
    tout1[v] = timer++;
}

void dfs2(int v)
{
    used[v] = true;
    tin2[v] = ++timer;
    for (int i = 0; i < g2[v].size(); i++)
    {
        int to = g2[v][i];
        if (!used[to])
            dfs2(to);
    }
    tout2[v] = timer++;
}

bool can(int v1, int v2)
{
    return (tin1[v1] <= tin1[v2] && tout1[v1] >= tout1[v1] && tin2[v1] <= tin2[v2] && tout2[v1] >= tout2[v2]);
}

int solve()
{
    scanf("%d", &n);
    for (int i = 1; i <= n; i++)
    {
        scanf("%d", &a[i]);
        g1[a[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++)
    {
        scanf("%d", &b[i]);
        g2[b[i]].push_back(i);
    }
    fill(used, used + n + 1, false);
    dfs1(0);
    timer = 0;
    fill(used, used + n + 1, false);
    dfs2(0);
    /*for (int i = 1; i <= n; i++)
        cerr << tin1[i] << " " << tout1[i] << endl;
    for (int i = 1; i<= n; i++)
        cerr << tin2[i] << " " << tout2[i] << endl;*/
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i == j)
                continue;
            if (can(i, j))
                ans++;
        }
    }
    cout << ans << endl;
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
#endif
    solve();
    
    return 0;
}
