#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef pair < int, int > pii;
typedef long long ll;

const int MAXSIZE = 12;

int n, k, factN;
int a[MAXSIZE];
int d[MAXSIZE], b[MAXSIZE];
bool cnt[MAXSIZE];
int ans = 0;

inline int max(int a, int b)
{
    return (a > b ? a : b);
}

int getFactor(int n)
{
    int ans = 1;
    for (int i = 2; i <= n; i++)
        ans *= i;
    return ans;
}

int getMaxSubseq()
{
    fill(d, d + n, 0);
    for (int i = 0; i < n; i++)
    {
        d[i] = 1;
        for (int j = i - 1; j >= 0; j--)
        {
            if (a[i] > a[j])
                d[i] = max(d[i], d[j] + 1);
        }
    }
    
    int curAns = 0;
    for (int i = 0; i < n; i++)
        curAns = max(curAns, d[i]);
    return curAns;
}

int getMaxSubseq2()
{
    fill(d, d + k, 0);
    for (int i = 0; i < k; i++)
    {
        d[i] = 1;
        for (int j = i - 1; j >= 0; j--)
        {
            if (b[i] > b[j])
                d[i] = max(d[i], d[j] + 1);
        }
    }
    int curAns = 0;
    for (int i = 0; i < k; i++)
        curAns = max(curAns, d[i]);
    
    return curAns;
}

int solve()
{
    scanf("%d%d", &n, &k);
    factN = getFactor(n);
    
    for (int i = 0; i < k; i++)
    {
        int x;
        scanf("%d", &x);
        cnt[x] = true;
    }
    
    for (int i = 0; i < n; i++)
        a[i] = i + 1;
    
    for (int i = 0; i < factN; i++)
    {
        int curAns = getMaxSubseq();
        if (curAns != k)
        {
            next_permutation(a, a + n);
            continue;
        }
        
        int cur_size = 0;
        for (int j = 0; j < n; j++)
        {
            if (cnt[a[j]])
                b[cur_size++] = a[j];
        }
        
        int curAns2 = getMaxSubseq2();
        
        if (curAns != curAns2)
        {
            next_permutation(a, a + n);
            continue;
        }
        
        next_permutation(a, a + n);
            
        ans++;
    }
    printf("%d\n", ans);
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
    //freopen("log.txt", "w", stderr);
#else
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
#endif

    solve();
    
    return 0;
}
