#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

const int maxx=1<<18;
const int maxn=100005;

typedef long long ll;

struct ttree
{
    int add;
    ttree(){add=0;}
};

ttree tree[maxx*2];
int n,timer;
int p1[maxn],p2[maxn],in[maxn],out[maxn];
vector <int> gr1[maxn],gr2[maxn];
ll ans;

void addseg(int cur,int cl,int cr,int l,int r,int d)
{
//    cout << "in add " << cur << ' ' << cl << ' ' << cr << endl;
    if (cr<l) return;
    if (cl>r) return;
    if (cl>=l && cr<=r)
    {
//        cout << "adding " << cur << ' ' << cl << ' ' << cr << endl;
        tree[cur].add+=d;
        return;
    }
    int m=(cl+cr)/2;
    addseg(cur*2,cl,m,l,r,d);
    addseg(cur*2+1,m+1,cr,l,r,d);
}

inline void add(int l,int r,int d)
{
//    cout << "add " << l << ' ' << r << ' ' << d << endl;
    addseg(1,0,maxx-1,l,r,d);
}

inline int get(int x)
{
    int cur=1;
    int cl=0;
    int cr=maxx-1;
    ll curans=0;
    while (cr-cl>=1)
    {
        curans+=tree[cur].add;
//        cout << "in get " << cur << ' ' << tree[cur].add << ' ' << cl << ' ' << cr << endl;
        int cm=(cl+cr)/2;
        if (cm<x) cl=cm+1,cur=cur*2+1;
        else cr=cm,cur=cur*2;
    }
//    cout << "get " << x << ' ' << curans << endl;
    return curans;
}

void go1(int cur)
{
    timer++;
    in[cur]=timer;
    for (int i=0;i<gr1[cur].size();i++) go1(gr1[cur][i]);
    timer++;
    out[cur]=timer;
}

void go2(int cur)
{
    ans+=get(in[cur]);
    add(in[cur],out[cur],1);
    for (int i=0;i<gr2[cur].size();i++) go2(gr2[cur][i]);
    add(in[cur],out[cur],-1);
}

int main()
{
    freopen("virus.in","r",stdin);
    freopen("virus.out","w",stdout);
    int root1,root2;
    cin >> n;
    for (int i=0;i<n;i++)
    {
        int P;
        cin >> P;
        p1[i]=P-1;
        if (P==0) root1=i;
        else gr1[P-1].push_back(i);
    }
    for (int i=0;i<n;i++)
    {
        int P;
        cin >> P;
        p2[i]=P-1;
        if (P==0) root2=i;
        else gr2[P-1].push_back(i);
    }
    timer=0;
    go1(root1);
    ans=0;
    go2(root2);
    cout << ans << endl;
    return 0;
}
