#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>

using namespace std;

typedef long long ll;

struct tkey
{
    int x;
    ll h;
    tkey(){}
    tkey(int _x,ll _h){x=_x;h=_h;}
};

inline bool operator <(tkey a,tkey b)
{
    return (a.h<b.h)||((a.h==b.h)&&(a.x<b.x));
}

inline tkey next(tkey a)
{
    return tkey(a.x+1,a.h);
}

struct tnode
{
    int y;
    tkey x;
    tnode *l,*r;
};

typedef tnode* pnode;

const int maxn=1e5+5;
const ll hst=239017;

int a[maxn],ans[maxn];
pnode p[maxn];
ll h[maxn];
pnode root;
int n,m;

inline pnode newnode(tkey x)
{
    pnode p=new(tnode);
    p->y=(rand()<<16)+rand();
    p->x=x;
    p->l=NULL;
    p->r=NULL;
    return p;
}

inline void tonew(pnode &a,tkey x)
{
    a->x=x;
    a->l=NULL;
    a->r=NULL;
}

void print(pnode cur)
{
//    cout << "in print " << (cur==NULL ? "NULL" : "nonull") << endl;
    if (cur==NULL) return;
    print(cur->l);
    cout << "(" << cur->x.x << ' ' << cur->x.h << ") ";
    print(cur->r);
    return;
}

void split(pnode cur,tkey x,pnode &l,pnode &r)
{
    if (cur==NULL)
    {
        l=NULL;
        r=NULL;
        return;
    }
//    cout << "in split " << cur->x.x << endl;
    if (cur->x<x)
    {
        l=cur;
        split(cur->r,x,cur->r,r);
    } else
    {
        r=cur;
        split(cur->l,x,l,cur->l);
    }
}

pnode merge(pnode l,pnode r)
{
    if (l==NULL) return r;
    if (r==NULL) return l;
    if (l->y>r->y)
    {
        l->r=merge(l->r,r);
        return l;
    } else
    {
        r->l=merge(l,r->l);
        return r;
    }
}

void add(int cur,ll hcur)
{
    tkey x=tkey(cur,hcur);
    pnode m=newnode(x);
    pnode l,r;
    split(root,x,l,r);
    root=merge(merge(l,m),r);
}

void addnn(pnode m,int cur,ll hcur)
{
    tkey x=tkey(cur,hcur);
    tonew(m,x);
    pnode l,r;
    split(root,x,l,r);
    root=merge(merge(l,m),r);
}

pnode del(int cur,ll hcur)
{
    tkey x=tkey(cur,hcur);
    pnode l,r,m;
    split(root,x,l,m);
    split(m,next(x),m,r);
    root=merge(l,r);
    return m;
}

void check(int cur,ll hcur)
{
    tkey x1=tkey(-1,hcur);
    tkey x2=tkey(n+1,hcur);
    pnode l,r,m;
    split(root,x1,l,m);
    split(m,x2,m,r);
    if (m!=NULL && m->l==NULL && m->r==NULL)
    {
//        cout << "checked " << cur << endl;
        ans[m->x.x]=cur;
        root=merge(l,r);
        delete m;
    } else root=merge(merge(l,m),r);
}

int main()
{
    freopen("theatre.in","r",stdin);
    freopen("theatre.out","w",stdout);
    scanf("%d%d",&n,&m);
    root=NULL;
    for (int i=0;i<n;i++) h[i]=0;
    for (int i=0;i<n;i++) add(i,h[i]);
    memset(ans,0,sizeof(ans));
    for (int i=0;i<m;i++)
    {
//        cout << "i=" << i << endl;
        int k;
        scanf("%d",&k);
        for (int j=0;j<k;j++)
        {
            scanf("%d",&a[j]);
            a[j]--;
            if (ans[a[j]]!=0)
            {
                j--;
                k--;
            }
        }
        for (int j=0;j<k;j++) p[j]=del(a[j],h[a[j]]);
        for (int j=0;j<k;j++) check(i+1,h[a[j]]);
        for (int j=0;j<k;j++) h[a[j]]=h[a[j]]*hst+i+1;
        for (int j=0;j<k;j++) addnn(p[j],a[j],h[a[j]]);
        for (int j=0;j<k;j++) check(i+1,h[a[j]]);
    }
    for (int i=0;i<n;i++) cout << ans[i] << ' ';
    return 0;
}
