{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 30;
  MaxM = 30;

type
  int = longint;

var
  n, m, x, y, i, j: int;
  dhx, dhy: int;
  xh, yh: int;
  hb, hc: array[1..MaxN, 1..MaxM] of int;


procedure move_ej(dx, dy, q: int);
begin
  writeln(dy, ' ', dx, ' ', q);
  x := x + dx;
  y := y + dy;
  flush(output);
end;

function valid(x, y: int): boolean;
begin
  result := (1 <= x) and (x <= n) and (1 <= y) and (y <= m);
end;

function dist(x1, y1, x2, y2: int): int;
begin
  result := abs(x1 - x2) + abs(y1 - y2);
end;

procedure get_react;
var
  i, j: int;
  dx, dy, q: int;
begin
  readln(q, dy, dx);
  if q = 1 then
    halt(0);
  if valid(x - dhx, y - dhy) then
    hb[x - dhx, y - dhy] := 0;
  dhx := dhx + dx;
  dhy := dhy + dy;
  xh := xh + dx;
  yh := yh + dy;
  fillchar(hc, sizeof(hc), 0);
  for i := 1 to n do
    for j := 1 to m do begin
      if hb[i, j] = 1 then
        if not valid(i + dhx, j + dhy) then
          hb[i, j] := 0
        else
          hc[i + dhx, j + dhy] := 1;
    end;
end;

function def_horse: int;
var
  dx, dy: int;
  ok, i, j: int;
begin
  ok := 0;
  xh := 0;
  yh := 0;
  for i := 1 to n do
    for j := 1 to m do begin
      if hb[i, j] = 1 then begin
        inc(ok);
        xh := i;
        yh := j;
      end;
    end;
  result := ok;
  if ok = 1 then
    exit;
  if ok = 0 then halt(11);

  for dx := -1 to 1 do
    for dy := -1 to 1 do
      if valid(x + dx, y + dy) then
        if (hc[x + dx, y + dy] = 1) or (dist(x+dx, y+dx, xh, yh) < dist(x, y, xh, yh)) then begin
          if hc[x + dx, y + dy] = 0 then
            move_ej(dx, dy, 1)
          else
            move_ej(dx, dy, 1);
          get_react;
          exit;
        end;
end;

procedure find_horse;
var
  dx, dy: int;
begin
  while true do begin
    for dx := -1 to 1 do
      for dy := -1 to 1 do
        if valid(x + dx, y + dy) then
          if (hc[x + dx, y + dy] = 1) or (dist(x+dx, y+dx, xh, yh) < dist(x, y, xh, yh)) then begin
            if hc[x + dx, y + dy] = 0 then
              move_ej(dx, dy, 0)
            else
              move_ej(dx, dy, 1);
            get_react;
          end;
  end;
end;

begin

 readln(m, n);
 readln(y, x);
 for i := 1 to n do
   for j := 1 to n do begin
     hb[i, j] := 1;
     hc[i, j] := 1;
   end;

 repeat
 until def_horse = 1;
 find_horse;

end.
 