#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#pragma comment(linker, "/STACK:100000000")
using namespace std;
struct node {
	long a, b, summ, add;
	node *l, *r;
};
typedef node * pnode;
void create(pnode &p, long a, long b) {
	p = new node;
	p->l = p->r = 0;
	p->a = a;
	p->b = b;
	p->summ = p->add = 0;
}
void kill(pnode root) {
	if(root->a != root->b) {
		kill(root->l);
		kill(root->r);
	}
	delete root;
}
void init(pnode &root, long a, long b) {
	create(root, a, b);
	if(a != b) {
		long med = (a + b) / 2;
		init(root->l, a, med);
		init(root->r, med + 1, b);
	}
}
long sm(pnode p) {
	return p->summ + p->add * (p->b - p->a + 1);
}
void push(pnode p) {
	if(p->a == p->b)
		p->summ += p->add;
	else {
		p->l->add += p->add;
		p->r->add += p->add;
		p->summ = sm(p->l) + sm(p->r);
	}
	p->add = 0;
}
void upd(pnode root) {
	push(root);
	if(root->a != root->b)
		root->summ = sm(root->l) + sm(root->r);
}
void add(pnode root, long a, long b, long inc) {
	if(a > b)
		return;
	if(root->a == a && root->b == b)
		root->add += inc;
	else {
		push(root);
		long med = (root->a + root->b) / 2;
		add(root->l, a, min(b, med), inc);
		add(root->r, max(a, med + 1), b, inc);
		upd(root);
	}
}
long summ(pnode root, long a, long b) {
	if(a > b)
		return 0;
	if(root->a == a && root->b == b)
		return sm(root);
	push(root);
	long med = (root->a + root->b) / 2;
	return summ(root->l, a, min(b, med)) + 
		summ(root->r, max(a, med + 1), b);
}
long n;
vector < long > numb, l, r;
vector < vector < long > > g;
long long ans;
long dfs1(long v, long sm = 0) {
	long i;
	l[v] = sm;
	for(i = 0; i < g[v].size(); i++)
		sm = dfs1(g[v][i], sm);
	r[v] = sm;
	return numb[v] = ++sm;
}
void dfs2(long v, pnode tree) {
	ans += summ(tree, numb[v] - 1, numb[v] - 1);
	add(tree, l[v], r[v] - 1, 1);
	long i;
	for(i = 0; i < g[v].size(); i++)
		dfs2(g[v][i], tree);
	add(tree, l[v], r[v] - 1, -1);
}
int main() {
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	ans = 0;
	//cin >> n;
	scanf("%ld", &n);
	numb.assign(n, 0);
	l.assign(n, 0);
	r.assign(n, 0);
	g.assign(n, vector < long > ());
	long i, j, rt;
	for(i = 0; i < n; i++) {
		//cin >> j;
		scanf("%ld", &j);
		if(j)
			g[j - 1].push_back(i);
		else
			rt = i;
	}
	dfs1(rt);
	pnode tree;
	init(tree, 0, n - 1);
	g.assign(n, vector < long > ());
	for(i = 0; i < n; i++) {
		//cin >> j;
		scanf("%ld", &j);
		if(j)
			g[j - 1].push_back(i);
		else
			rt = i;
	}
	dfs2(rt, tree);
	//cout << ans << endl;
	kill(tree);
	printf("%lld", ans);
	return 0;
}