#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 100500
#define maxk 17
#define maxm 300000

using namespace std;

struct edge{int x, next;};

int n, num = 0, num_v = 0, cur_par;
int root, root_v;
int cur = 0, cur_v = 0;
edge sm[maxm], sm_v[maxm];
int beg[maxn], en[maxn];
int beg_v[maxn], en_v[maxn];
int x[maxn], y[maxn], l[maxn], r[maxn], p[maxn], q[maxn];
int tmp[maxn], tree[maxn][maxk];
bool used[maxn], used_v[maxn];
long long res = 0, currr;
int cur1;

int add_edge(const int &x, const int &y, int &number, int *beg_m, int *en_m, edge *sm_m){
    sm_m[number].x = y;
    sm_m[number].next = 0;
    if(beg_m[x] == 0)beg_m[x] = number;
    if(en_m[x] != 0)sm_m[en_m[x]].next = number;
    en_m[x] = number;
    ++number;
    return 0;
}

int DFS(const int &id){
    used[id] = true;
    ++cur; x[cur] = id;
    int tmpp = cur;
    //printf("id = %d, cur = %d\n", id, cur);
    int i = beg[id];
    l[cur] = cur + 1;
    while(i != 0){
        if(!used[sm[i].x])DFS(sm[i].x);
        i = sm[i].next;
    }
    r[tmpp] = cur;
    //printf("id = %d, cur = %d\n", id, cur);
    return 0;
}

int DFS1(const int &id){
    used_v[id] = true;
    ++cur_v; y[id] = cur_v;
    tmp[cur_v] = id;
    int tmpp = cur_v;
    int i = beg_v[id];
    p[cur_v] = cur_v + 1;
    while(i != 0){
        if(!used_v[sm_v[i].x])DFS1(sm_v[i].x);
        i = sm_v[i].next;
    }
    q[tmpp] = cur_v;
    return 0;
}

int make_tree(const int &l, const int &r, const int &lvl){
    if(l == r)tree[l][lvl] = tmp[l];
    else{
        int mid = (l + r) / 2;
        make_tree(l, mid, lvl + 1);
        make_tree(mid + 1, r, lvl + 1);
        int p = l, q = mid + 1, rr = l;
        while(rr <= r){
            if(p <= mid && (q > r || tree[p][lvl + 1] < tree[q][lvl + 1])){
                tree[rr][lvl] = tree[p][lvl + 1];
                ++p;
            }
            else{
                tree[rr][lvl] = tree[q][lvl + 1];
                ++q;
            }
            ++rr;
        }
    }
    return 0;
}

int find_here(const int &l, const int &r, const int &l1, const int &r1, const int &x, const int &lvl){
    //printf("l = %d, r = %d, 11 = %d, r1 = %d, x = %d, lvl = %d\n", l, r, l1, r1, x, lvl);
    int mid = (l1 + r1) / 2;
    if(max(l, l1) <= min(r, r1)){
        if(l <= l1 && r >= r1){
            int lf = l1 - 1, rf = r1 + 1;
            while(lf < rf - 1){
                int mf = (lf + rf) / 2;
                if(tree[mf][lvl] > x)rf = mf; else lf = mf;
            }
            return(max(0, lf - l1 + 1));
        }
        else return(find_here(l, r, l1, mid, x, lvl + 1) + find_here(l, r, mid + 1, r1, x, lvl + 1));
    }
    return 0;
}

int main(){
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);
    for(int i = 1; i <= n; ++i){
        scanf("%d", &cur_par);
        if(cur_par != 0){
            add_edge(i, cur_par, num, beg, en, sm);
            add_edge(cur_par, i, num, beg, en, sm);
        }
        else root = i;
    }
    for(int i = 1; i <= n; ++i){
        scanf("%d", &cur_par);
        if(cur_par != 0){
            add_edge(i, cur_par, num_v, beg_v, en_v, sm_v);
            add_edge(cur_par, i, num_v, beg_v, en_v, sm_v);
        }
        else root_v = i;
    }

    DFS(root);
    DFS1(root_v);
    make_tree(1, n, 0);
    /*for(int i = 0; i <= 3; ++i){
        printf("level %d:\n", i);
        for(int j = 1; j <= n; ++j)
            printf("%d ", tree[j][i]);
        printf("\n");
    }*/

    /*for(int i = 1; i <= n; ++i){
        printf("x[%d] = %d\n", i, x[i]);
        printf("y[%d] = %d\n", i, y[i]);
        printf("l[%d] = %d\n", i, l[i]);
        printf("r[%d] = %d\n", i, r[i]);
        printf("p[%d] = %d\n", i, p[i]);
        printf("q[%d] = %d\n\n", i, q[i]);
    }*/

    for(int i = 1; i <= n; ++i){
        int yy = y[x[i]];
        if(l[i] <= r[i] && p[yy] <= q[yy]){
            cur1 = find_here(p[yy], q[yy], 1, n, r[i], 0) - find_here(p[yy], q[yy], 1, n, l[i] - 1, 0);
            currr = cur1;
            res = res + currr;
        }
    }
    cout << res << endl;

    return 0;
}
