#define TASKNAME "password"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>
#include <string>
#include <cstring>
#include <ctime>
#include <cctype>
#include <fstream>
#include <windows.h>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define y1 dskjchkfjhf
#define y0 kjlasdkfjlk
#define eprintf(...) eprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e5) + 100;
const ll p = (ll)1e9 + 7;

char s[2][MaxN];
int len[2];
ll hash[2][MaxN], st[MaxN];

inline void precalc(int n)
{
  st[0] = 1;
  for (int i = 1; i <= n; i++)
    st[i] = st[i - 1] * p;
}

inline ll gethash(int num, int l, int r)
{
  if (l > r)
    return 0;
  return hash[num][r] - hash[num][l - 1] * st[r - l + 1]; 
}

inline int digits(int n)
{
  int res = 0;
  while (n)
    ++res, n /= 10;
  return res;
}

inline bool check(int pos, int num)
{
  int dig = digits(num);
  int i = pos + dig - 1;
  while (num)
  {
    if ((s[1][i] - '0') != num % 10)
      return 0; 
    num /= 10;
    --i;
  }
  return 1;
}

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  precalc(MaxN - 1);
  while (gets(s[0]))
  {
    gets(s[1]);
    for (int i = 0; i < 2; i++)
    {
      len[i] = strlen(s[i]);
      hash[i][0] = 0;
      for (int j = 0; j < len[i]; j++)
        hash[i][j + 1] = hash[i][j] * p + s[i][j];
    }   

    bool out = 0;
    for (int i = 0; i < len[0]; i++)
    {
      int sum = 0;
      for (int cnt = 1; cnt <= 6; cnt++)
      {
        int r = i + cnt - 1;
        if (r >= len[0])
          break;
        sum += s[0][r] - '0';
        int dig = digits(sum);
        if (gethash(0, 1, i) == gethash(1, 1, i) && check(i, sum) && gethash(0, r + 2, len[0]) == gethash(1, i + dig + 1, len[1]))
        {
          out = 1;
          printf("%d %d\n", i + 1, r + 1);
          break;
        }
      }
      if (out)
        break;              
    }
    assert(out);
  }
  return 0;
}
