#define TASKNAME "password"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>
#include <string>
#include <cstring>
#include <ctime>
#include <cctype>
#include <fstream>
#include <windows.h>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define y1 dskjchkfjhf
#define y0 kjlasdkfjlk
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e5) + 100;
const ll p = (ll)1e9 + 7;

char s[2][MaxN];
int len[2];
ll hash[2][MaxN], st[MaxN];
int pref[MaxN];

inline void precalc(int n)
{
  st[0] = 1;
  for (int i = 1; i <= n; i++)
    st[i] = st[i - 1] * p;
}

inline ll gethash(int num, int l, int r)
{
  if (l > r)
    return 0;
  return hash[num][r] - hash[num][l - 1] * st[r - l + 1]; 
}

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  precalc(MaxN - 1);
  while (gets(s[0]))
  {
    gets(s[1]);
    for (int i = 0; i < 2; i++)
    {
      len[i] = strlen(s[i]);
      hash[i][0] = 0;
      for (int j = 0; j < len[i]; j++)
        hash[i][j + 1] = hash[i][j] * p + s[i][j];
    }   

    if (len[0] <= 1000 && len[1] <= 1000)
    {
      for (int i = 0; i < len[0]; i++)
      {
        int sum = 0;
        for (int j = i; j < len[0]; j++)
        {
          sum += s[0][j] - '0';
          if (gethash(0, 1, i) != gethash(1, 1, i))
            break;
          int num = 0;
          for (int k = i; k < i + 6 && k < len[1]; k++)
          {
            num *= 10;
            num += s[1][k] - '0';
            if (num == sum && gethash(0, j + 2, len[0]) == gethash(1, k + 2, len[1]))
            {
              printf("%d %d\n", i + 1, j + 1);
              return 0;
            }
          }
        }
      } 
      assert(0);
      return 0;
    }

    pref[0] = 0;
    for (int i = 0; i < len[0]; i++)
      pref[i + 1] = pref[i] + (s[0][i] - '0');

    bool out = 0;
    for (int cnt = 1; cnt <= 6; cnt++)
    {    
      for (int i = 0; i < len[0]; i++)
      {
        if (gethash(0, 1, i) != gethash(1, 1, i))
          continue;

        int r = i + cnt - 1;
        if (r >= len[1])
          continue;

        int num = 0;
        for (int j = i; j <= r; j++)
          num *= 10, num += s[1][j] - '0';

        int left = i, right = len[0];
        while (left < right - 1)
        {
          int middle = (left + right) / 2;
          if (pref[middle + 1] - pref[i] <= num)
            left = middle;
          else
            right = middle;
        }

        //eprintf("%d %d %d %d %d\n", i, num, cnt, left, pref[left + 1] - pref[i]);
        
        if (pref[left + 1] - pref[i] == num && gethash(0, left + 2, len[0]) == gethash(1, i + cnt + 1, len[1]))
        {
          out = 1;
          printf("%d %d\n", i + 1, left + 1);
          break;
        }
      }
      if (out)
        break;              
    }
    assert(out);
    break;
  }
  return 0;
}
