#define TASKNAME "mosaic"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e5) + 100;

struct node
{
  int val, pos;
  inline node() {}
  inline node(int a, int b) {val = a, pos = b;}
};

inline bool operator < (const node &a, const node &b) {return a.val < b.val;}

struct SegTree
{
  vector <node> t;
  int n;

  inline SegTree()
  {
    t.clear();
    n = 0;
  }

  SegTree(const vector <node> &a)
  {
    int tmp = 1;
    int _n = sz(a);
    while (tmp < _n)
      tmp *= 2;
    n = tmp; 
    t.resize(2 * n);
    for (int i = n; i < 2 * n; i++)
      t[i] = ((i < n + _n) ? a[i - n] : node(INF, INF));
    for (int i = n - 1; i > 0; i--)
      t[i] = min(t[2 * i], t[2 * i + 1]);
  }

  inline node RMQ(int v, int a, int b, int l, int r)
  {
    if (r < a || b < l)
      return node(INF, INF);
    if (l <= a && b <= r)
      return t[v];
    int m = (a + b) / 2;
    return min(RMQ(2 * v, a, m, l, r), RMQ(2 * v + 1, m + 1, b, l, r));
  }

  inline node RMQ(int l, int r)
  {
    return RMQ(1, n, 2 * n - 1, l + n, r + n);
  }
};

int n;    	
pii a[MaxN];
int go[2][MaxN];
SegTree tree;
                
int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d", &n) >= 1)
  {
    vector <node> next(n, node(INF, INF));
    for (int i = 0; i < n; ++i)
    {
      scanf("%d%d", &a[i].fst, &a[i].snd);
      go[0][i] = go[1][i] = INF;
    }

    for (int i = 0; i < n;)
    {
      int pos = i + 1;
      while (pos < n && a[i].fst == a[pos].fst)
        ++pos;
      if (pos < n)
        for (int j = i; j < pos; j++)
          go[0][j] = pos;
      i = pos;
    }

    for (int i = 0; i < n;)
    {
      int pos = i + 1;
      while (pos < n && a[i].snd == a[pos].snd)
        ++pos;
      if (pos < n)
        for (int j = i; j < pos; j++)
          go[1][j] = pos;
      i = pos;
    } 

    for (int i = 0; i < n; ++i)
    {
      /*int pos = i + 1;
      while (pos < n && (a[i].fst == a[pos].fst || a[i].snd == a[pos].snd))
        ++pos;
      if (pos < n)
        next[i] = node(pos, i);*/
      int pos1 = i, pos2 = i;
      while (pos1 < n && pos2 < n)
      {
        pos1 = go[0][pos1];
        pos2 = go[1][pos2];
        int Max = max(pos1, pos2);
        if (Max < n && a[Max].fst != a[i].fst && a[Max].snd != a[i].snd)
        {
          next[i] = node(Max, i);
          break;
        }  
      }
    }

    tree = SegTree(next);

    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; ++i)
    {
      int l, r;
      scanf("%d%d", &l, &r);
      --l, --r;
      node find_min = tree.RMQ(l, r);
      //eprintf("%d %d %d\n", find_min.val, find_min.pos, find_min.pos == INF ? -1 : next[find_min.pos].val);
      if (find_min.val <= r)
        printf("%d %d\n", find_min.pos + 1, find_min.val + 1);
      else
        puts("0 0");
    }
    break;
  }
  return 0;
}

