#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <memory.h>
#include <limits>

using namespace std;

#define vv vector
#define in cin
#define out cout
#define px first
#define py second
#define mp make_pair

int n;
vv<int> c[2], first[2], last[2];
vv< vv<int> > g[2];
int root[2], time;

void dfs(int k, int v) {
	c[k][time] = v;
	first[k][v] = time++;
	for (size_t i = 0; i < g[k][v].size(); ++i) {
		int u = g[k][v][i];
		dfs(k, u);
	}
	c[k][time] = v;
	last[k][v] = time++;
}

struct SegTree {
	int N;
	vv< vv<int> > T;

	SegTree(vv<int> &a) {
		N = a.size();
		int len = 1;
		while (len < N) {
			len <<= 1;
		}
		len <<= 1;
		T.resize(len);
		build(a, 0, 0, N);
	}

	void build(vv<int> &a, int v, int l, int r) {
		if (l > r - 1) {
			return;
		}
		if (l == r - 1) {
			T[v] = vv<int>(1, a[l]);
			return;
		}
		int m = (l + r) / 2;
		build(a, 2 * v + 1, l, m);
		build(a, 2 * v + 2, m, r);
		T[v].resize(T[2 * v + 1].size() + T[2 * v + 2].size());
		merge(T[2 * v + 1].begin(), T[2 * v + 1].end(), T[2 * v + 2].begin(), T[2 * v + 2].end(), T[v].begin());
	}

	int get(int l, int r, int from, int to) {
		return get(0, 0, N, l, r + 1, from, to);
	}

	int get(int v, int l, int r, int L, int R, int from, int to) {
		if (r - 1 < L || R - 1 < l) {
			return 0;
		}
		if (L <= l && r <= R) {
			/*int res = 0;
			for (int i = 0; i < T[v].size(); ++i) {
				if (T[v][i] >= from && T[v][i] <= to) {
					++res;
				}
			}
			return res;*/
			int f = lower_bound(T[v].begin(), T[v].end(), from) - T[v].begin();
			if (f == T[v].size()) {
				return 0;
			}
			int t = lower_bound(T[v].begin(), T[v].end(), to + 1) - T[v].begin();
			if (t == T[v].size()) {
				return t - f;
			} else if (T[v][t] == to) {
				return t - f + 1;
			} else {
				return t - f;
			}
		}
		int m = (l + r) / 2;
		return get(2 * v + 1, l, m, L, R, from, to) + get(2 * v + 2, m, r, L, R, from, to);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);

	in >> n;
	for (int k = 0; k < 2; ++k) {
		g[k].resize(n);
		c[k].resize(2 * n);
		first[k].resize(n);
		last[k].resize(n);
	}

	int p;
	for (int k = 0; k < 2; ++k) {
		for (int i = 0; i < n; ++i) {
			in >> p;
			--p;
			if (p == -1) {
				root[k] = i;
			} else {
				g[k][p].push_back(i);
			}
		}
		time = 0;
		dfs(k, root[k]);
	}

	int ans = 0;
	vv<int> rel(2 * n);
	for (int i = 0; i < 2 * n; ++i) {
		rel[i] = first[1][c[0][i]];
	}
	SegTree T(rel);
	for (int v = 0; v < n; ++v) {
		int l[2], r[2];
		for (int k = 0; k < 2; ++k) {
			l[k] = first[k][v] + 1;
			r[k] = last[k][v] - 1;
		}
		if (l[0] > r[0] || l[1] > r[1]) {
			continue;
		}
		ans += T.get(l[0], r[0], l[1], r[1]);
	}
	out << ans / 2;

	return 0;
}