program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  Tcoor = record
    x, y: shortint;
  end;

var
  hedgehog, horse_in_shape: Tcoor;
  horse_dist_shape, Map: Tcoor;
  search_shape_begin, search_shape_end: Tcoor;
  Is_Horse_here: shortint;
  horse_dist: Tcoor;
  hedgehog_dist: Tcoor;


procedure Call_no_move;

begin
  write('0 0 1');
  Flush(output);
end;

procedure Hedgehog_listen;

begin
  read(Is_horse_here, horse_dist.x, horse_dist.y);
  if Is_Horse_here = 1 then
    halt(0);
end;

procedure refresh_search_shape;

begin
  search_shape_begin.x := horse_in_shape.x;
  search_shape_begin.y := horse_in_shape.y;
  search_shape_end.x := search_shape_begin.x + Map.x - horse_dist_shape.x;
  search_shape_end.y := search_shape_begin.y + Map.y - horse_dist_shape.y;
end;

procedure refresh_horse_pos;

begin
  horse_in_shape.x := horse_in_shape.x + horse_dist.x;
  horse_in_shape.y := horse_in_shape.y + horse_dist.y;

  if horse_in_shape.x > horse_dist_shape.x then begin
    inc(horse_dist_shape.x);
    refresh_search_shape;
  end;
  if horse_in_shape.x < 1 then begin
    inc(horse_dist_shape.x);
    inc(horse_in_shape.x);
    refresh_search_shape;
  end;

  if horse_in_shape.y > horse_dist_shape.y then begin
    inc(horse_dist_shape.y);
    refresh_search_shape;
  end;
  if horse_in_shape.x < 1 then begin
    inc(horse_dist_shape.y);
    inc(horse_in_shape.y);
    refresh_search_shape;
  end;

end;

function Is_Hedgehog_in_search_shape: boolean;

begin
  Result := true;
  if hedgehog.x > search_shape_end.x then
    Result := false;
  if hedgehog.x < search_shape_begin.x then
    Result := false;
  if hedgehog.y > search_shape_end.y then
    Result := false;
  if hedgehog.y < search_shape_begin.y then
    Result := false;
end;

procedure go_in_shape;

begin
  hedgehog_dist.x := 0;
  hedgehog_dist.y := 0;
  if hedgehog.x > search_shape_end.x then
    hedgehog_dist.x := -1;
  if hedgehog.x < search_shape_begin.x then
    hedgehog_dist.x := 1;
  if hedgehog.y > search_shape_end.y then
    hedgehog_dist.y := -1;
  if hedgehog.y < search_shape_begin.x then
    hedgehog_dist.y := 1;

  writeln('0 ', hedgehog_dist.x, ' ', hedgehog_dist.y);
  Flush(output);
end;

procedure refresh_hedgehog_pos;

begin
  hedgehog.x := hedgehog.x + hedgehog_dist.x;
  hedgehog.y := hedgehog.y + hedgehog_dist.y;
end;

procedure walk_in_shape;

begin
  randomize;
  repeat
    hedgehog_dist.x := random(2) - 1;
  until ((hedgehog.x + hedgehog_dist.x) >= search_shape_begin.x) and
        ((hedgehog.x + hedgehog_dist.x) <= search_shape_end.x);
  repeat
    hedgehog_dist.y := random(2) - 1;
  until ((hedgehog.y + hedgehog_dist.y) >= search_shape_begin.y) and
        ((hedgehog.y + hedgehog_dist.y) <= search_shape_end.y);
  writeln(hedgehog_dist.x, ' ', hedgehog_dist.y, ' 1');
  flush(output);
end;

procedure Init;

begin
  read(map.y, map.x);
  read(hedgehog.y, hedgehog.x);

  horse_in_shape.x := 1;
  horse_in_shape.y := 1;

  horse_dist_shape.x := 1;
  horse_dist_shape.y := 1;

  search_shape_begin.x := 1;
  search_shape_begin.y := 1;
  search_shape_end.x := map.x;
  search_shape_end.y := map.y;

end;

begin
  Init;
  Call_no_move;
  while (true) do begin
    Hedgehog_listen;
    refresh_horse_pos;
    if Is_Hedgehog_in_search_shape then
      walk_in_shape
    else
      go_in_shape;
    refresh_hedgehog_pos;
  end;
end.

