#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizoef(a))

const int MAXN = 100002;

struct dtree{
    int sz;
    int a, b, n;
    ll y;
    dtree *l, *r;
    dtree *mina, *minb, *maxa, *maxb;
};

inline void upd(dtree * rt) {
    if (rt == NULL)
        return;
    rt->mina = rt;
    rt->minb = rt;
    rt->maxa = rt;
    rt->maxb = rt;
    rt->sz = 1;
    if (rt->l != NULL) {
        rt->sz += rt->l->sz;
        if (rt->mina->a > rt->l->mina->a)
            rt->mina = rt->l->mina;
        if (rt->minb->b > rt->l->minb->b)
            rt->minb = rt->l->minb;
        if (rt->maxa->a < rt->l->maxa->a)
            rt->maxa = rt->l->maxa;
        if (rt->maxb->b < rt->l->maxb->b)
            rt->maxb = rt->l->maxb;
    }
    if (rt->r != NULL) {
        rt->sz += rt->r->sz;
        if (rt->mina->a > rt->r->mina->a)
            rt->mina = rt->r->mina;
        if (rt->minb->b > rt->r->minb->b)
            rt->minb = rt->r->minb;
        if (rt->maxa->a < rt->r->maxa->a)
            rt->maxa = rt->r->maxa;
        if (rt->maxb->b < rt->r->maxb->b)
            rt->maxb = rt->r->maxb;
    }
    return;
}

void split(dtree * rt, int x, dtree *& l, dtree *& r) {
    if (rt == NULL) {
        l = NULL;
        r = NULL;
        return;
    }
    dtree *wl, *wr;
    int w = 1 + ((rt->l == NULL)?(0):(rt->l->sz));
    if (w <= x) {
        split(rt->r, x - w, wl, wr);
        rt->r = wl;
        l = rt;
        r = wr;
    } else {
        split(rt->l, x, wl, wr);
        rt->l = wr;
        l = wl;
        r = rt;
    }
    upd(rt);
    return;
}

dtree * merge(dtree *l, dtree * r) {
    if (l == NULL)
        return r;
    if (r == NULL)
        return l;
    if (l->y > r->y) {//l->sz - 1 <= ((ll)rand()) * rand() %(l->sz + r->sz)) {
        l -> r = merge(l->r, r);
        upd(l);
        return l;
    } else {
        r -> l = merge(l, r -> l);
        upd(r);
        return r;
    }
}
dtree mem[MAXN];
int _free = 0;

inline dtree * add(dtree * rt, int a, int b, int n) {
    dtree * w = &mem[_free++];
    w->a = a;
    w->b = b;
    w->n = n;
    w->y = ((ll)rand()) * rand();
    w->mina = w;
    w->minb = w;
    w->maxa = w;
    w->maxb = w;
    w->sz = 1;
    w->l = NULL;
    w->r = NULL;
    return merge(rt, w);
}



int main()
{
    srand(time(NULL));
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    dtree * rt = NULL;
    FOR(i, n) {
        int a, b;
        scanf("%d%d", &a, &b);
        rt = add(rt, a, b, i + 1);
    }
    int k;
    scanf("%d", &k);
    FOR(i, k) {
        int l, r;
        scanf("%d%d", &l, &r);
        l--;
        dtree *wl, *wr;
        split(rt, l, wl, wr);
        dtree *wl1, *wr1;
        split(wr, r - l, wl1, wr1);
        dtree * a[4];
        a[0] = wl1->mina;
        a[1] = wl1->minb;
        a[2] = wl1->maxa;
        a[3] = wl1->maxb;
        bool ind = false;
        FOR(i, 4) {
            FOR(j, i) {
                if (a[i]->a != a[j]->a && a[i]->b != a[j]->b) {
                    printf("%d %d\n", a[i]->n, a[j]->n);
                    ind = true;
                    break;
                }
            }
            if (ind)
                break;
        }
        if (!ind)
            printf("%d %d\n", 0, 0);

        rt = merge(wl, merge(wl1, wr1));
        /*
        if (maxa->a == mina->a || maxb->b == minb ->b) {
            printf("%d %d\n", 0, 0);
            continue;
        }
        if (mina->b != maxa->b) {
            printf("%d %d\n", mina->n, maxa->n);
            continue;
        }
        if (minb->a != maxb->a) {
            printf("%d %d\n", minb->n, maxb->n);
            continue;
        }
        if (mina->b != minb->b || mina->a != minb->a) {
            printf("%d %d\n", mina->n, minb->n);
            continue;
        }
        if (mina->a != maxb->a || mina->b != maxb->a) {
            printf("%d %d\n", mina->n, maxb->n);
            continue;
        }
        printf("%d %d\n", maxa->n, maxb->n);
        */
    }

    return 0;
}
