#include <cstdio>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int maxn = 100020;

typedef vector <int> vi;
typedef vector <long long> vll;

void read(vi &x){
	char s[maxn];
	gets(s);
	int j = 0;
	while (s[j] != 0){
		x.push_back(s[j] - '0');
		j++;
	}
}

int st[7];

int gen(vi &x, int l, int r){
	int res = 0;
	for (int i = r - 1; i >= l; i--){
		res += x[i]*st[r - 1 - i];
	}
	return res;
}

long long step[100018];

void sum(vi &x, vi &s){
	s.push_back(0);
	s.resize(x.size() + 1);
	for (int i = 1; i < x.size() + 1; i++){
		s[i] = s[i - 1] + x[i - 1];
	}
}

void make_hash (vi &a, vll &h){
	h.resize(a.size() + 1);
	h[0] = 0;
	for (int i = 1; i < a.size() + 1; i++){
		h[i] = h[i - 1] + (a[i - 1]*step[i]);
	}
}

int main(){
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);

	vi a, b;
	read(a);
	read(b);

	st[0] = 1;
	for (int i = 1; i < 7; i++){
		st[i] = st[i - 1]*10;
	}

	step[0] = 1;
	for (int i = 1; i < 100018; i++){
		step[i] = step[i - 1]*37;
	}
	
	vll a_hash, b_hash;
	make_hash(a, a_hash);
	make_hash(b, b_hash);

	vi a_sum;
	sum(a, a_sum);

	for (int i = 0; i < b.size(); i++){
		int t;
		if (b[i] == 0){
			t = 1;
		}
		else{
			t = 6;
		}

		for (int k2 = 1; k2 <= t; k2++){
			if (i + k2 > b.size()) continue;
			int k1 = a.size() - b.size() + k2;
			if (i + k1 > a.size()) continue;

			if (gen(b, i, i + k2) == a_sum[i + k1] - a_sum[i] && a_hash[i] == b_hash[i] && (a_hash[a.size()] - a_hash[i + k1])*step[100018 - i - k1] == (b_hash[b.size()] - b_hash[i + k2])*step[100018 - i - k2]){
				printf("%d %d", i + 1, i + k1);
				return 0;
			}
		}
	}

	return 0;
}