#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>
using namespace std;

const int MAXN = 100100;

int N;
int a[MAXN], b[MAXN];

vector<int> va[MAXN], vb[MAXN];

int tina[MAXN], touta[MAXN];
int tinb[MAXN], toutb[MAXN];

inline bool isAncestorA(const int &x, const int &y) {
	return tina[x] < tina[y] && touta[y] < touta[x];
}

inline bool isAncestorB(const int &x, const int &y) {
	return tinb[x] < tinb[y] && toutb[y] < toutb[x];
}

int tmra, tmrb;

int bossa, bossb;

int ans;

void dfsa(int u) {
	tina[u] = ++tmra;
	for (int i = 0; i < va[u].size(); i++) {
		dfsa(va[u][i]);
	}
	touta[u] = ++tmra;
}

void dfsb(int u) {
	tinb[u] = ++tmrb;
	for (int i = 0; i < vb[u].size(); i++) {
		dfsb(vb[u][i]);
	}
	toutb[u] = ++tmrb;
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &N);
	for (int i = 1; i <= N; i++) {
		scanf("%d", &a[i]);
		if (a[i])
			va[a[i]].push_back(i);
		else
			bossa = i;
	}
	for (int i = 1; i <= N; i++) {
		scanf("%d", &b[i]);
		if (b[i])
			vb[b[i]].push_back(i);
		else
			bossb = i;
	}

	dfsa(bossa);
	dfsb(bossb);

	for (int i = 1; i <= N; i++) {
		for (int j = i + 1; j <= N; j++) {
			if (isAncestorA(i, j) && isAncestorB(i, j)) {
				ans++;
				continue;
			}

			if (isAncestorA(j, i) && isAncestorB(j, i)) {
				ans++;
				continue;
			}
		}
	}

	printf("%d\n", ans);
}