#pragma comment(linker, "/STACK:220000000")

#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>
using namespace std;

const int INF = 2e9;

typedef vector<int>::iterator viter;

struct SegmentTree {
	vector<vector<int> > v;
	inline void init(vector<int> &x) {
		int N = 1;
		while (N < x.size())
			N <<= 1;
		N <<= 1;
		v.resize(N);
		int sz = N >> 1;
		for (int i = 0; i < x.size(); i++)
			v[sz + i].push_back(x[i]);
		//for (int i = x.size() + sz; i < N; i++)
		//	v[i].push_back(INF);
		for (int i = sz - 1; i >= 1; i--) {
			v[i].resize(v[(i << 1)].size() + v[(i << 1) + 1].size());			
			//merge(v[(1 << i)].begin(), v[(1 << i)].end(), v[(1 << i) + 1].begin(), v[(1 << i) + 1].end(), v[i].begin());						
			viter vi = v[i].begin();
			viter v1 = v[(i << 1)].begin(), v2 = v[(i << 1) + 1].begin();
			while (v1 != v[(i << 1)].end() && v2 != v[(i << 1) + 1].end()) {
				if ((*v1) < (*v2)) {
					(*vi) = (*v1);
					v1++;
				} else {
					(*vi) = (*v2);
					v2++;
				}
				vi++;
			}

			while (v1 != v[(i << 1)].end()) {
				(*vi) = (*v1);
				v1++;
				vi++;
			}

			while (v2 != v[(i << 1) + 1].end()) {
				(*vi) = (*v2);
				v2++;
				vi++;
			}
		}
	}

	int go(int l, int r, int L, int R, int u, int val){
		if (r <= L || R <= l)
			return 0;
		if (l <= L && R <= r) {
			//pair<viter, viter> p = equal_range(v[u].begin(), v[u].end(), val);			
			//int val = (p.second - p.first);
			int vl = lower_bound(v[u].begin(), v[u].end(), val) - v[u].begin();
			return vl;
		}
		int vl = go(l, r, L, (L + R) >> 1, (u << 1), val) + go(l, r, (L + R) >> 1, R, (u << 1) + 1, val);
		return vl;
	}

	inline int get(int L, int R, int val) {
		return go(L, R + 1, 1, (v.size() + 1) >> 1, 1, val);
	}
};

const int MAXN = 100100;

int N;
int a[MAXN], b[MAXN];
vector<int> va[MAXN], vb[MAXN];
int bossA, bossB;

int tmra;
int tin[MAXN];

int l[MAXN], r[MAXN];
int f[MAXN], s[MAXN];

long long result;

vector<int> v;

pair<int, int> dfs(int u) {
	l[u] = 1e9, r[u] = -1e9;
	for (int i = 0; i < va[u].size(); i++) {
		pair<int, int> val = dfs(va[u][i]);
		l[u] = min(l[u], val.first);
		r[u] = max(r[u], val.second);
	}

	tin[u] = ++tmra;
	l[u] = min(l[u], tin[u]);
	r[u] = max(r[u], tin[u]);
	return make_pair(l[u], r[u]);
}

void dfs2(int u) {
	f[u] = v.size();
	v.push_back(tin[u]);
	for (int i = 0; i < vb[u].size(); i++)
		dfs2(vb[u][i]);
	s[u] = v.size();
	v.push_back(tin[u]);
}

SegmentTree st;

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &N);
	for (int i = 1; i <= N; i++) {
		scanf("%d", &a[i]);
		if (a[i])
			va[a[i]].push_back(i);
		else
			bossA = i;
	}
	for (int i = 1; i <= N; i++) {
		scanf("%d", &b[i]);
		if (b[i])
			vb[b[i]].push_back(i);
		else
			bossB = i;
	}

	dfs(bossA);
	dfs2(bossB);

	st.init(v);

	for (int i = 1; i <= N; i++) {
		result += (st.get(f[i] + 1, s[i] + 1, r[i]) - st.get(f[i] + 1, s[i] + 1, l[i] - 1)) >> 1;
	}
	cout << result << endl;
}