#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
using namespace std;

inline int mabs(int x) {
	return (x > 0 ? x : -x);
}

const int INF = 2e9;

int N, M;
int x, y;
int ddx, ddy;
int bx, by;
int dx, dy;
int curx, cury;
int dist, bestDist;
bool flag;

int inx, iny, inf;

vector<pair<int, int> > v;

void foolSolution() {	
	v.resize(N * M);
	for (int i = 1; i <= M; i++) {
		for (int j = 1; j <= N; j++) {
			v[(i - 1) * N + j - 1] = make_pair(i, j);
		}
	}

	do {
		bx = INF, by = INF, bestDist = INF;
		for (int i = -1; i <= 1; i++) {
			if (x + i <= 0 || x + i > M)
				continue;
			for (int j = -1; j <= 1; j++) {
				if (y + j <= 0 || y + j > N)
					continue;

				dist = 0;
				curx = i + x, cury = j + y;
				for (vector<pair<int, int> >::iterator k = v.begin(); k != v.end(); k++) {
					dist += mabs(curx - k->first) + mabs(cury - k->second);
				}

				if (dist < bestDist) {
					bestDist = dist;
					bx = i, by = j;
				}
			}
		}

		flag = false;
		x = x + bx, y = y + by;
		for (vector<pair<int, int> >::iterator i = v.begin(); i != v.end(); i++)
			if (i->first == x && i->second == y) {
				flag = true;
				break;
			}

		cout << bx << " " << by << " " << (flag ? 1 : 0) << "\n";
		cout.flush();

		cin >> inf >> inx >> iny;
		if (inf) {
			return;
		} else {
			for (vector<pair<int, int> >::iterator i = v.begin(); i != v.end(); i++) {
				if (i->first == x && i->second == y) {
					v.erase(i);
					break;
				}
			}
			vector<pair<int, int> > bb;
			for (vector<pair<int, int> >::iterator i = v.begin(); i != v.end(); i++) {
				i->first += inx;
				i->second += iny;
				if (i->first > 0 && i->first <= M && i->second > 0 && i->second <= N)
					bb.push_back(*i);					
			}		
			v = bb;
			bb.clear();
		}
	} while (true);
}

int main() {
	cin >> N >> M;
	cin >> x >> y;	

	foolSolution();
}