#include <iostream>
#include <deque>
#include <cmath>
#include <cstring>

using namespace std;

struct sp
{
	int x,y;
	sp(int a, int b) : x(a), y(b) {};
};

int main()
{
	int w,h;
	cin >> h >> w;
	int wmask = ~(0x7fffffffu << w);
	int hmask = ~(0x7ffffffu << h);
	
	int ex, ey;
	cin >> ex >> ey;
	ex--;
	ey--;

	int *phposs = new int[w];
	for(int i = 0; i < w; i++)
		phposs[i] = hmask;

	int hox = 0;
	int hoy = 0;

	cout << "0 0 1\n";
	cout.flush();

	bool *bfscont = new bool[w*h];

	while(true)
	{
		int hr, hdx, hdy;
		cin >> hr >> hdx >> hdy;
		if(hr)
			return 0; //yay

		hox += hdx;
		hoy += hdy;

		phposs[ex] &= ~(1<<ey);

		if(hdx)
		{
			if(hdx == -1)
			{
				for(int i = 0; i < w-1; i++)
					phposs[i] = phposs[i+1];
				phposs[w-1] = 0;
			} else {
				for(int i = w-1; i > 0; i--)
					phposs[i] = phposs[i-1];
				phposs[0] = 0;
			}
		} else if(hdy)
		{
			if(hdy == -1)
			{
				for(int i = 0; i < w; i++)
				{
					phposs[i] = phposs[i]>>1;
				}
			} else {
				for(int i = 0; i < w; i++)
				{
					phposs[i] = (phposs[i]<<1)&hmask;
				}
			}
		}

#define BFSY(a,b) if((a) >= 0 && (b) >= 0 && (a) < w && (b) < h && !bfscont[(a)+(b)*w]) {bfscont[(a)+(b)*w] = true; bfs.push_back(sp(a,b));}

		//first determine where to go in O(n*m)
		int tx = ex, ty = ey;
		deque<sp> bfs;
		bfs.push_back(sp(ex,ey));
		memset(bfscont,0,w*h*sizeof(bool));
		bfscont[ex+ey*w] = true;
		while(!bfs.empty())
		{
			sp cur = bfs.front();
			bfs.pop_front();
			//if(cur.x < 0 || cur.x >= w || cur.y < 0 || cur.y >= h)
			//	continue;
			if(phposs[cur.x]&(1<<cur.y))
			{
				tx = cur.x;
				ty = cur.y;
				break;
			}
			BFSY(cur.x-1,cur.y-1);
			BFSY(cur.x,cur.y-1);
			BFSY(cur.x-1,cur.y);
			BFSY(cur.x+1,cur.y-1);
			BFSY(cur.x-1,cur.y+1);
			BFSY(cur.x+1,cur.y);
			BFSY(cur.x,cur.y+1);
			BFSY(cur.x+1,cur.y+1);
		}

		/*for(int j = 0; j < h; j++)
		{
			for(int i = 0; i < w; i++)
			{
				if(phposs[i]&(1<<j))
				{
					tx = i;
					ty = j;
					goto cont1;
				}
			}
		}
		cont1:*/
		int dx = 0, dy = 0;
		if(ex < tx)
			dx = 1;
		else if(ex > tx)
			dx = -1;

		if(ey < ty)
			dy = 1;
		else if(ey > ty)
			dy = -1;

		ex = ex+dx;
		ey = ey+dy;

		if(phposs[ex]&(1<<ey))
			cout << dx << " " << dy << " 1\n";
		else
			cout << dx << " " << dy << " 0\n";
		cout.flush();
	}
}