program Project3;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  len = 262144;
  first = 131072;
  inf = maxlongint;

var
  n, k, i, l, r, j, m: integer;
  a: array[1..100000, 1..2] of integer;
  b, di: array[0..100000] of integer;
  d: array[1..len, 1..2] of integer;

procedure sort(var b: array of integer; c, l, r: integer);
var
  x, i, j, k: integer;
begin
  if l >= r then
    exit;
  i := l;
  j := r;
  x := b[random(r - l + 1) + l];
  while i <= j do begin
    while (a[b[i]][c] < a[x][c])or((a[b[i]][c] = a[x][c])and(b[i] < x)) do
      inc(i);
    while (a[b[j]][c] > a[x][c])or((a[b[j]][c] = a[x][c])and(b[j] > x)) do
      dec(j);
    if i <= j then begin
      k := b[i];
      b[i] := b[j];
      b[j] := k;
      dec(j);
      inc(i);
    end;
  end;
  sort(b, c, l, j);
  sort(b, c, i, r);
end;

procedure init;
var
  i: integer;
begin
  for i := 1 to len do
    d[i][2] := inf;
  for i := first to first + n - 1 do
    d[i][1] := i - first + 1;
end;

procedure push(pos, val: integer);
begin
  pos := pos + first - 1;
  d[pos][2] := val; 
  while pos > 1 do begin
    pos := pos div 2;
    if d[pos * 2][2] < d[pos * 2 + 1][2] then
      d[pos] := d[pos * 2]
    else
      d[pos] := d[pos * 2 + 1];
  end;    
end;

procedure get(l, r: integer; var pos, val: integer);
begin
  l := l + first - 1;
  r := r + first - 1;
  val := inf;
  pos := d[l][1];
  while l <= r do begin
    if l mod 2 = 1 then begin
      if val > d[l][2] then begin
        pos := d[l][1];
        val := d[l][2]
      end;
      inc(l);
    end;
    if r mod 2 = 0 then begin
      if val > d[r][2] then begin
        pos := d[r][1];
        val := d[r][2]
      end;
      dec(r);
    end;
    l := l div 2;
    r := r div 2; 
  end;    
end;

function search(ll, c, l, r: integer): integer;
var
  m: integer;
begin
  while l < r - 1 do begin
    m := (l + r)div 2;
    if(a[b[m]][c] = a[b[ll]][c])then
      if b[m] - b[ll] = m - ll then
        l := m
      else
        r := m
    else
      r := m;
  end;
  result := l; 
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');

  randomize;

  read(N);
  for i := 1 to n do begin
    read(a[i][1], a[i][2]);
    b[i] := i;
  end;
  read(k);
  init();
  sort(b, 1, 1, n);
  i := 1;
  while i < n do begin
    j := search(i, 1, i, n + 1);
    for m := i to j do
      di[b[m]] := b[j] + 1;
    i := j + 1;
  end;
  di[b[n]] := inf;
  sort(b, 2, 1, n);
  i := 1;
  while i < n do begin
    j := search(i, 2, i, n + 1);
    for m := i to j do
      di[b[m]] := max(b[j] + 1, di[b[m]]);
    i := j + 1;
  end;
  di[b[n]] := inf;
  for i := 1 to n do
    push(i, di[i]);
  for i := 1 to k do begin
    read(l, r);
    get(l, r, j, m);
    if m = inf then
      writeln('0 0')
    else if m <= r then
      writeln(j, ' ', m)
    else
      writeln('0 0');
    end;
end.
