#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
using namespace std;

#pragma comment(linker, "/STACK:67108864")
string a, b;
int l = 0, r = 0;
int maxsuf = 0;
vector <int> sum;

void read()
{
	cin >> a >> b;
	sum.resize(a.size() + 5);
}

int getsum(int ql, int qr) // Inclusive
{
	if (ql == 0)
		return sum[qr];
	return sum[qr] - sum[ql - 1];
}

int toint(int ql, int qr) // Inclusive
{
	int ans = 0;
	for (int i = ql; i <= qr; ++i)
	{
		ans *= 10;
		ans += b[i] - '0';
	}
	return ans;
}

void solve()
{
	int i = a.size() - 1, j = b.size() - 1, delta;
	while (i >= 0 && j >= 0 && a[i] == b[j])
	{
		maxsuf++;
		i--;
		j--;
	}
	sum[0] = a[0] - '0';
	for (int i = 1; i < a.size(); ++i)
		sum[i] = sum[i - 1] + a[i] - '0';
	delta = a.size() - b.size();
	if (a == b)
		return;
	for (int i = 0; i < a.size(); ++i)
	{
		if (b[i] == '0')
			continue;
		for (int j = 0; i + j < b.size() && j < 7; ++j)
		{
			if (toint(i, i + j) == getsum(i, i + j + delta) && b.size() - (i + j) - 1 <= maxsuf)
			{
				l = i, r = i + j + delta;
				return;
			}
		}
	}
}

void print()
{
	cout << l + 1 << " " << r + 1 << endl;
}

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}