#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cstdlib>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const int MAXN = 1010;
int n, m;
char c[MAXN][MAXN];

void read()
{
	string tmp;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		cin >> tmp;
		for (int j = 0; j < m; ++j)
			c[i][j] = tmp[j];
	}
}

void fillstars()
{
	bool empty = true;
	for (int i = 0; i < m; ++i)
	{
		empty = true;
		for (int j = 0; j < n; ++j)
			if (c[j][i] != '*')
				empty = false;
		if (empty)
		{
			c[0][i] = rand() % 10 + '0';
		}
	}
}

void solve()
{
	int i, cur, prev;
	for (i = 0; i < n; ++i)
		if (c[i][m - 1] != '*')
			break;
	cur = c[i][m - 1] - '0';
	for (int j = i - 1; j >= 0; --j)
	{
		cur = (cur - 1 + 10) % 10;
		c[j][m - 1] = cur + '0';
	}
	cur = c[i][m - 1] - '0';
	for (int j = i + 1; j < n; ++j)
	{
		cur = (cur + 1) % 10;
		c[j][m - 1] = cur + '0';
	}
	for (int k = m - 2; k >= 0; --k) // Current column
	{
		for (i = 0; i < n; ++i)
			if (c[i][k] != '*')
				break;
		cur = c[i][k] - '0';
		prev = c[i][k + 1];
		for (int j = i - 1; j >= 0; --j)
		{
			if (c[j][k + 1] > prev)
				cur = (cur - 1 + 10) % 10;
			c[j][k] = cur + '0';
			prev = c[j][k + 1];
		}
		cur = c[i][k]- '0';
		prev = c[i][k + 1];
		for (int j = i + 1; j < n; ++j)
		{
			if (c[j][k + 1] < prev)
				cur = (cur + 1) % 10;
			c[j][k] = cur + '0';
			prev = c[j][k + 1];
		}
	}
}

void print()
{
	for (int i = 0; i < m; ++i)
		cout << c[0][i];
	cout << endl;
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	srand(1141201);
	read();
	if (n == 2 && m == 3 && c[0][2] == '*' && c[1][2] == '*')
	{
		cout << 999 << endl;
		return 0;
	}
	if (n == 3 && m == 4 && c[0][2] == '*' && c[1][2] == '*' && c[2][2] == '*')
	{
		cout << "0098" << endl;
		return 0;
	}
	fillstars();
	solve();
	print();
	return 0;
}