#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cstdlib>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const int MAXN = 1010;
int n, m;
char c[MAXN][MAXN];

void read()
{
	string tmp;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		cin >> tmp;
		for (int j = 0; j < m; ++j)
			c[i][j] = tmp[j];
	}
}

void fillsteps() // fills x -- (x + 1) % 10 jumps
{
	for (int i = 0; i < n - 1; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			if ((c[i][j] == '9' && c[i+1][j] == '0') || (c[i][j] + 1 == c[i+1][j]))
			{
				for (int k = j + 1; k < m; ++k)
				{
					c[i][k] = '9';
					c[i + 1][k] = '0';
				}
				break;
			}
		}
	}
}

void fillstars()
{
	bool empty = true;
	for (int i = 0; i < m; ++i)
	{
		empty = true;
		for (int j = 0; j < n; ++j)
			if (c[j][i] != '*')
				empty = false;
		if (empty)
		{
			c[0][i] = rand() % 10 + '0';
		}
	}
}

void solve()
{
	int i, cur, prev;
	for (i = 0; i < n; ++i)
		if (c[i][m - 1] != '*')
			break;
	cur = c[i][m - 1] - '0';
	for (int j = i - 1; j >= 0; --j)
	{
		cur = (cur - 1 + 10) % 10;
		c[j][m - 1] = cur + '0';
	}
	cur = c[i][m - 1] - '0';
	for (int j = i + 1; j < n; ++j)
	{
		cur = (cur + 1) % 10;
		c[j][m - 1] = cur + '0';
	}
	for (int k = m - 2; k >= 0; --k) // Current column
	{
		for (i = 0; i < n; ++i)
			if (c[i][k] != '*')
				break;
		cur = c[i][k] - '0';
		prev = c[i][k + 1];
		for (int j = i - 1; j >= 0; --j)
		{
			if (c[j][k + 1] > prev)
				cur = (cur - 1 + 10) % 10;
			c[j][k] = cur + '0';
			prev = c[j][k + 1];
		}
		cur = c[i][k]- '0';
		prev = c[i][k + 1];
		for (int j = i + 1; j < n; ++j)
		{
			if (c[j][k + 1] < prev)
				cur = (cur + 1) % 10;
			c[j][k] = cur + '0';
			prev = c[j][k + 1];
		}
	}
}

void print()
{
	for (int i = 0; i < m; ++i)
		cout << c[0][i];
	cout << endl;
}

bool hasempty()
{
	bool empty = true;
	for (int i = 0; i < m; ++i)
	{
		empty = true;
		for (int j = 0; j < n; ++j)
			if (c[j][i] != '*')
				empty = false;
		if (empty)
			return true;
	}
	return false;
}

void euristic1() // 1 * * 2 -> 1 1 1 2 (in a column)
{
	bool bad = false;
	int j, k;
	for (int i = 0; i < m; ++i)
	{
		j = 0;
		while (j < n)
		{
			if (c[j][i] == '*')
				++j;
			else
			{
				k = j + 1;
				while (k < n)
				{
					if (c[k][i] == '*')
						++k;
					else
					{
						if ((c[j][i] - '0' + 1) % 10 == c[k][i] - '0')
						{
							for (int it = j; it < k; ++it)
								c[it][i] = c[j][i];
							goto a;
						}
						else
						{
							j = k;
							break;
						}
					}
				}
				if (k == n)
					break;
			}
		}
		if (0)
		{
a:
			return;
		}
	}
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	srand(1141201);
	read();
	fillsteps();
	if (hasempty())
	{
		euristic1();
		fillsteps();
	}
	fillstars();
	solve();
	print();
	return 0;
}