#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

#pragma comment(linker, "/STACK:67108864")
#define pb push_back
#define mp make_pair

const int MAXN = 10010;
int n, m;
vector <int> ans;
bool v[MAXN][MAXN];

void read()
{
	int k, tmp;
	cin >> n >> m;
	ans = vector <int> (n + 5, 0);
	for (int i = 0; i < m; ++i)
	{
		cin >> k;
		for (int j = 0; j < k; ++j)
		{
			cin >> tmp;
			v[i][tmp] = true;
		}
	}
}

bool eq(int i, int j, int k)
{
	for (int it = 0; it <= i; ++it)
	{
		if (v[it][j] != v[it][k])
			return false;
	}
	return true;
}

void solve()
{
	bool good = true;
	vector <int> un, in, out;
	in.reserve(n + 5);
	out.reserve(n + 5);
	for (int i = 0; i < m; ++i)
	{
		in.clear();
		out.clear();
		for (int j = 1; j <= n; ++j)
		{
			if (ans[j] == 0)
			{
				if (v[i][j])
					in.pb(j);
				else
					out.pb(j);
			}
		}
		if (out.size() == 1)
		{
			ans[out[0]] = i + 1;
			out.clear();
		}
		if (in.size() == 1)
		{
			ans[in[0]] = i + 1;
			in.clear();
		}
		for (int j = 1; j <= n; ++j)
		{
			good = true;
			if (ans[j] == 0)
			{
				for (int k = 1; k <= n && good; ++k)
				{
					if (j != k && eq(i, j, k))
						good = false;
				}
				if (good)
					ans[j] = i + 1;
			}
			if (out.size() == 1)
			{
				ans[out[0]] = i + 1;
				out.clear();
			}
			if (in.size() == 1)
			{
				ans[in[0]] = i + 1;
				in.clear();
			}
		}
	}
}

void print()
{
	for (int i = 1; i <= n; ++i)
		cout << ans[i] << " ";
}

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}