#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const int MAXN = 20;
const int INF = 100500;
vector <int> cur;
vector <int> good;
bool bg[MAXN];
int n, k, ans;
int d[MAXN];

void read()
{
	cin >> n >> k;
	cur.resize(n);
	good.resize(k);
	for (int i = 0; i < n; ++i)
		cur[i] = i + 1;
	for (int i = 0; i < k; ++i)
	{
		cin >> good[i];
		bg[good[i]] = true;
	}
}

int grslen()
{
	for (int i = 0; i < n; ++i)
		d[i] = 1;
	int ans = 1;
	d[0] = 1;
	for (int i = 1; i < n; ++i)
	{
		for (int j = 0; j < i; ++j)
		{
			if (cur[j] < cur[i])
			{
				d[i] = max(d[i], d[j] + 1);
				ans = max(ans, d[i]);
			}
		}
	}
	return ans;
}

bool correct()
{
	int idx = 0, prev, next;
	if (grslen() > k)
		return false;
	for (int i = 0; i < n; ++i)
	{
		if (bg[cur[i]] && (idx == k || good[idx] != cur[i]))
			return false;
		else if (bg[cur[i]])
			idx++;
		else
		{
			if (idx - 1 < 0)
				prev = -1;
			else
				prev = good[idx - 1];
			if (idx == k)
				next = INF;
			else
				next = good[idx];
			if (cur[i] > prev && cur[i] < next)
				return false;
		}
	}
	return true;
}

void solve()
{
	do
	{
		if (correct())
			ans++;
	}
	while (next_permutation(cur.begin(), cur.end()));
}

void print()
{
	cout << ans << endl;
}

int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}