#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cstring>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#pragma comment(linker, "/STACK:268435456")

const int MAXLEN = 100010;

string a, b;
vector< int > digit_sum;
vector< int > cumsum;
vector< bool > goodPref;
int tenpower[MAXLEN];

inline void init()
{
	tenpower[0] = 1;
	for (int i =  1; i < MAXLEN; i++)
		tenpower[i] = tenpower[i-1]*10;
};

inline int getSum(int l, int r)
{
	if (!l)
		return digit_sum[r];
	return digit_sum[r] - digit_sum[l-1];
}

inline int getCumSum(int l, int r)
{
	if (!l)
		return cumsum[r];
	return cumsum[r] - cumsum[l-1]*tenpower[r-l+1];
}

inline int getLength(int x)
{
	int res = 0;
	if (!x)
		return 1;
	while (x)
		res++, x/=10;
	return res;
}

int main()
{
	init();
	freopen("password.in","r", stdin);
	freopen("password.out","w", stdout);
	getline(cin, a);
	getline(cin, b);

	digit_sum.resize(a.size());
	digit_sum[0] = a[0]-'0';
	for (int i =  1; i < a.size(); i++)
		digit_sum[i] = digit_sum[i-1] + a[i]-'0';

	cumsum.resize(b.size());
	cumsum[0] = b[0] - '0';
	for (int i = 1; i < b.size(); i++)
		cumsum[i] = cumsum[i-1] * 10 + b[i] - '0';

	goodPref.resize(min(a.size(), b.size()) + 1);
	goodPref[0] = true;
	for (int i = a.size()-1, j=b.size()-1, l=1; i>=0 && j>=0; l++, i--, j--)
		goodPref[l] = goodPref[l-1] && a[i] == b[j];

	int needdelta = a.size() - b.size();

	bool ok = true;
	for (int i = 0; i < min(a.size(), b.size()); i++)
	{
		if (!ok)
			break;
		
		ok = a[i] == b[i];

		int bl = 0;
		int br = a.size() - i;
		while (bl < br - 1)
		{
			int bm = (bl + br) / 2;

			if (bm - getLength(getSum(i, i + bm - 1)) >= needdelta)
				br = bm;
			else
				bl = bm;
		}

		int curl = br;
		while (i + curl - 1 < a.size())
		{
			if (curl -  getLength(getSum(i, i + curl -1)) != needdelta)
				break;

			int sumlen = getLength(getSum(i, i+curl-1));

			if (i + sumlen - 1 >= b.size())
				break;

			if (getSum(i, i + curl - 1) == getCumSum(i, i + sumlen - 1) && goodPref[a.size() - (i + curl)])
			{
				cout << i + 1 << ' ' << i + curl -1 + 1 << endl;
				return 0;
			}

			curl++;
		}
	}
}