#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <queue>

using namespace std;

const int MAXN = 100010;

const int inf = 1<<30;

struct RMQ
{
	static const int l1 = 1<<3;
	static const int l2 = l1*2-1;

	pair<int, int> el[l2];

	RMQ()
	{
	}

	inline void init(vector< int > &a)
	{
		for (int i = 0, j = l1-1; i<a.size(); j++, i++)
			el[j] = make_pair(a[i], i);
		for (int j = l1-1 + (int)(a.size()); j < l2; j++)
			el[j] = make_pair(inf, j - (l1-1));

		for (int j = l1-2; j>=0; j--)
		{
			int l = (j+1)*2-1;
			int r = l+1;
			el[j] = min(el[l], el[r]);
		}
	}

	inline pair<int, int> getMin(int l, int r)
	{
		pair<int, int> res(inf, inf);

		l += l1-1;
		r += l1-1;
		while (l <= r)
		{
			if ((l & 1) == 0)
			{
				res = min(res, el[l]);
				l++;
			}
			if ((r & 1) == 1)
			{
				res = min(res, el[r]);
				r--;
			}

			l = ((l+1)>>1) - 1;
			r = ((r+1)>>1) - 1;
		}
		return res;
	}
};

vector< int > a, b;
vector< int > firstBad;
int n, m;

inline void obrab(set< pair<int, int> > &S, int curb, int curpos)
{
	set< pair<int, int> >::iterator lb = S.lower_bound(make_pair(curb, -inf));
	set< pair<int, int> >::iterator ub = S.upper_bound(make_pair(curb, inf));

	for (set< pair<int, int> >::iterator it = S.begin(); it != S.end() && it != lb;)
	{
		firstBad[it->second] = curpos;
		set< pair<int, int> >::iterator newit = it;
		newit++;
		S.erase(it);
		it = newit;
	}
	for (set< pair<int, int> >::iterator it = ub; it != S.end();)
	{
		firstBad[it->second] = curpos;
		set< pair<int, int> >::iterator newit = it;
		newit++;
		S.erase(it);
		it = newit;
	}
}

map<int, set< pair<int, int> > > S;
RMQ Q;


int main()
{
	//double start = clock();
	freopen("mosaic.in","r", stdin);
	freopen("mosaic.out","w", stdout);

	scanf("%d", &n);
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &a[i], &b[i]);
	}

	firstBad.assign(n, inf);
	for (int i = 0; i < n; i++)
	{
		map<int, set< pair<int, int> > >::iterator lb = S.lower_bound(a[i]);
		map<int, set< pair<int, int> > >::iterator ub = S.upper_bound(a[i]);

		for (map<int, set< pair<int, int> > >::iterator it = S.begin(); it != S.end() && it != lb;)
		{
			obrab(it->second, b[i], i);
			map<int, set< pair<int, int> > >::iterator newit = it;
			newit++;
			if (it->second.empty())
				S.erase(it);
			it = newit;
		}

		for (map<int, set< pair<int, int> > >::iterator it = ub; it != S.end();)
		{
			obrab(it->second, b[i], i);
			map<int, set< pair<int, int> > >::iterator newit = it;
			newit++;
			if (it->second.empty())
				S.erase(it);
			it = newit;
		}

		S[a[i]].insert(make_pair(b[i], i));
	}

	//cerr << (clock() - start) / CLOCKS_PER_SEC;

	Q.init(firstBad);

	scanf("%d", &m);
	for (int i = 0; i < m; i++)
	{
		//cerr << i << endl;
		int l, r;
		scanf("%d%d", &l, &r);
		l--, r--;
		pair<int, int> minval = Q.getMin(l, r);

		if (minval.first > r)
		{
			printf("0 0\n");
			continue;
		}
		else
		{
			printf("%d %d\n", minval.second + 1, firstBad[minval.second] + 1);
		}
	}
}