#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <queue>

#pragma comment(linker,"/STACK:268435456")

using namespace std;

const int inf  = 1<<30;

struct point
{
	int x, y;
};

point mypos;
point horse1, horse2;
int n, m;

inline bool isGood(int x, int y)
{
	return x>=0 && y>=0 && x < n && y < m;
}

inline int sq(int x)
{
	return x*x;
}

inline pair<int, int> getDirection()
{
	pair<int, int> best(0, 0);
	int bestdist = inf;
	for (int dx = -1; dx <= 1; dx++)
		for (int dy = -1; dy <= 1; dy++)
		{
			int newx = mypos.x + dx;
			int newy = mypos.y + dy;
			if (!isGood(newx, newy))
				continue;

			int hcx = (horse1.x + horse2.x) / 2;
			int hcy = (horse1.y + horse2.y) / 2;

			int dist = sq(newx - hcx) + sq(newy - hcy);
			if (dist < bestdist)
			{
				bestdist = dist;
				best = make_pair(dx, dy);
			}
		}
	return best;
};

int main()
{
	scanf("%d%d", &m, &n);
	scanf("%d %d", &mypos.x, &mypos.y);
	mypos.x--;
	mypos.y--;

	horse1.x = 0, horse1.y = 0;
	horse2.x = n-1, horse2.y = m-1;

	while (true)
	{
		pair<int, int> dir = getDirection();

		mypos.x += dir.first;
		mypos.y += dir.second;
		printf("1 %d %d\n", dir.first, dir.second);
		//cerr << "think " << horse1.x << ' ' << horse1.y << ' ' << horse2.x << ' ' << horse2.y << endl;
		fflush(stdout);

		int f, dhx, dhy;
		scanf("%d %d %d", &f, &dhx, &dhy);
		if (f)
		{
			return 0;
		}

		horse1.x += dhx;
		horse2.x += dhx;
		horse1.y += dhy;
		horse2.y += dhy;

		horse1.x = min(horse1.x, n-1);
		horse1.x = max(0, horse1.x);
		horse2.x = min(horse2.x, n-1);
		horse2.x = max(0, horse2.x);

		horse1.y = min(horse1.y, m-1);
		horse1.y = max(0, horse1.y);
		horse2.y = min(horse2.y, m-1);
		horse2.y = max(0, horse2.y);
	};
}