#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <queue>

#pragma comment(linker,"/STACK:268435456")

using namespace std;

const int MAXN = 32;
const int inf  = 1<<30;

struct point
{
	int x, y;
};

point mypos;
int n, m;

bool canBe[MAXN][MAXN];
bool canBe2[MAXN][MAXN];

inline bool isGood(int x, int y)
{
	return x>=0 && y>=0 && x < n && y < m;
}

inline int sq(int x)
{
	return x*x;
}

inline pair<int, int> getDirection()
{
	int minDist = inf;
	pair<int, int> best(0, 0);

	for (int dx = -1; dx <= 1; dx++)
		for (int dy = -1; dy  <= 1; dy++)
		{
			int newx = mypos.x + dx;
			int newy = mypos.y + dy;

			if (!isGood(newx, newy))
				continue;

			for (int x = 0;  x < n; x++)
				for (int y = 0; y < m; y++)
					if (canBe[x][y])
					{
						int dist = sq(x - newx) + sq(y - newy);
						if (dist < minDist)
						{
							minDist = dist;
							best = make_pair(dx, dy);
						}
					}
		}
	return best;
};

int main()
{
	scanf("%d%d", &m, &n);
	scanf("%d %d", &mypos.x, &mypos.y);
	mypos.x--;
	mypos.y--;

	for (int x = 0; x < n; x++)
		for (int y = 0; y < m; y++)
			canBe[x][y] = true;

	while (true)
	{
		pair<int, int> dir = getDirection();

		mypos.x += dir.first;
		mypos.y += dir.second;
		if (canBe[mypos.x][mypos.y])
			printf("%d %d 1\n", dir.first, dir.second);
		else
			printf("%d %d 0\n", dir.first, dir.second);
		fflush(stdout);

		int f, dhx, dhy;
		scanf("%d %d %d", &f, &dhx, &dhy);
		if (f)
		{
			return 0;
		}
		canBe[mypos.x][mypos.y] = false;
		memset(canBe2, 0, sizeof(canBe2));
		for (int x = 0; x < n; x++)
			for (int y = 0; y < m; y++)
			{
				if (!canBe[x][y])
					continue;
				int newx = x + dhx;
				int newy = y + dhy;

				if (!isGood(newx, newy))
					continue;

				canBe2[newx][newy] = true;
			}

		memcpy(canBe, canBe2, sizeof(canBe2));
	};
}