#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pair<int, int> > vii;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100100;

struct path {
	path() {}
	int start, end, len;
	int *t;
};

path all[maxn];
int pc = 0;
vi t1[maxn], t2[maxn];
int p2[maxn], fh[maxn], tpos[maxn], p1[maxn];
path *tnum[maxn];
int r1, r2;
int n;
int timer = 0;
long long ans = 0;

inline int fenvsum(path *p, int r) {
	int sum = 0;
	for(int i = r; i>=0; i = (i & (i + 1)) - 1) sum += p->t[i];
	return sum;
}

inline void fenvadd(path *p, int v, int k) {
	for(; v < p->len; v |= v + 1) p->t[v] += k;
}

inline void add(int v) {
	fenvadd(tnum[v], tpos[v], 1);
}

inline void remove(int v) {
	fenvadd(tnum[v], tpos[v], 1);
}

void calc(int v) {
	int cres = 0;
	while(v != -1) {
		cres += fenvsum(tnum[v], tpos[v]);
		v = p2[tnum[v]->start];
	}
	ans += cres;
}

void DFS(int v) {
	calc(v);
	add(v);
	forn(i, t1[v].size()) {
		int to = t1[v][i];
		DFS(to);
	}
	remove(v);
}

void dfs1(int v, int H = 0) {
	fh[v] = H;
	forn(i, t2[v].size()) {
		int to = t2[v][i];
		dfs1(to, H + 1);
	}
}

void preprocess() {
	dfs1(r2);
	vii vp;
	for(int i = 0; i<n; i++) {
		vp.pb(mp(fh[i], i));
	}
	sort(vp.begin(), vp.end());
	reverse(vp.begin(), vp.end());
	for(int k = 0; k<n; k++) {
		int i = vp[k].second;
		int v = i, cnt = 0, cur = 0, pred;
		if(tnum[v] == NULL) {
			all[pc++] = path();
			while(v != -1 && tnum[v] == NULL) {
				tnum[v] = &(all[pc - 1]);
				pred = v;
				v = p2[v];
				cnt++;
			}
			tnum[i]->end = i;
			tnum[i]->start = pred;
			tnum[i]->t = new int[cnt];
			for(int j = 0; j<cnt; j++) tnum[i]->t[j] = 0;
			v = tnum[i]->end;
			tpos[v] = cnt - 1;
			if(cnt != 1) {
				cur = 2;
				do {
					v = p2[v];
					tpos[v] = cnt - (cur++);

				} while(tnum[i]->start != v);
			}
			tnum[i]->len = cnt;
		}
	}
}

int main() {
	RedirectIO("virus");
	cin>>n;
	int pi;
	for(int i = 0; i<n; i++) {
		scanf("%d", &pi);
		if(pi == 0) r1 = i;
		--pi;
		t1[pi].pb(i);
		p1[i] = pi;
		tnum[i] = 0;
	}
	for(int i = 0; i<n; i++) {
		scanf("%d", &pi);
		if(pi == 0) r2 = i, p2[i] = -1;
		--pi;
		t2[pi].pb(i);
		p2[i] = pi;
	}
	preprocess();
	/*
	for(int i = 0; i<pc; i++) {
		cout<<all[i].start<<" "<<all[i].end<<" "<<all[i].len<<endl;
		for(int j = 0; j<all[i].len; j++) 
			cout<<all[i].t[j]<<" ";
		cout<<endl;
	}
	for(int i = 0; i<n; i++) cout<<tnum[i] - all<<" ";
	cout<<endl;
	for(int i = 0; i<n; i++) cout<<tpos[i]<<" ";
	cout<<endl;
	*////
	DFS(r1);
	for(int i = 0; i<pc; i++) {
		delete[] all[i].t;
	}
	cout<<ans;
	return 0;
}