#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;
const int cmax = 200000;

const char * fin = "virus.in";
const char * fout = "virus.out";

int n, r1, r2;
vector<vector<int> > g1, g2;
vector<int> eu, val;
vector<int> in1, out1, in2, out2;

int w = 0;

void dfs1(int v, int p = -1){
    in1[v] = len(eu);
    eu.pb(v);
    for (int i = 0; i < len(g1[v]); i++)
        if (g1[v][i] != p)
            dfs1(g1[v][i], v);
    out1[v] = len(eu);
    eu.pb(v);
}

void dfs2(int v, int p = -1){
    in2[v] = w++;
    for (int i = 0; i < len(g2[v]); i++)
        if (g2[v][i] != p)
            dfs2(g2[v][i], v);
    out2[v] = w++;
}

vector<int> rmq[cmax * 4];

void make_rmq(int i, int l, int r){
    if (l == r){
        rmq[i].pb(val[l]);
        return;
    }
    make_rmq(i*2, l, (l+r)/2);
    make_rmq(i*2+1, (l+r)/2+1, r);
    rmq[i].resize(len(rmq[i*2])+len(rmq[i*2+1]));
    merge(all(rmq[i*2]), all(rmq[i*2+1]), rmq[i].begin());
}

int m;

int seek(int i, int l, int r){
    int ll = lower_bound(all(rmq[i]), l) - rmq[i].begin(), rr = lower_bound(all(rmq[i]), r+1) - rmq[i].begin();
    return max(0, rr-ll);
}

int value(int i, int ll, int rr, int l, int r, int s, int f){
    if (ll == l && rr == r)
        return seek(i, s, f);
    if (ll <= l && r <= (ll+rr)/2)
        return value(i*2, ll, (ll+rr)/2, l, r, s, f);
    else if ((ll+rr)/2+1 <= l && r <= rr)
        return value(i*2+1, (ll+rr)/2+1, rr, l, r, s, f);
    else
        return value(i*2, ll, (ll+rr)/2, l, (ll+rr)/2, s, f) +
                value(i*2+1, (ll+rr)/2+1, rr, (ll+rr)/2+1, r, s, f);
}

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    cin >> n;
    g1.resize(n); g2.resize(n);
    for (int i = 0; i < n; i++){
        int t; cin >> t;
        if (t != 0)
            g1[--t].pb(i);
        else
            r1 = i;
    }
    for (int i = 0; i < n; i++){
        int t; cin >> t;
        if (t != 0)
            g2[--t].pb(i);
        else
            r2 = i;
    }
    in1.resize(n); out1.resize(n);
    in2.resize(n); out2.resize(n);
    dfs1(r1);
    dfs2(r2);
    m = len(eu);
    val.resize(len(eu));
    for (int i = 0; i < m; i++)
        val[i] = in2[eu[i]];
    make_rmq(1, 0, m-1);
    int64 res = 0;
    for (int i = 0; i < n; i++){
        int d = value(1, 0, m-1, in1[i], out1[i], in2[i], out2[i]);
        res += d;
    }
    cout << res / 2 - n << endl;
    return 0;
}
