#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "mosaic.in";
const char * fout = "mosaic.out";

const int cmax = 100000;

int n;
int a[cmax], b[cmax];
vector<pair<pair<int, int>, int> > tlst;

void read_info(){
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
}

int p[cmax * 2], num[cmax * 2];
int cur = 0;

void make_zip(){
    int ln = 0;
    for (int i = 0; i < n; i++){
        p[ln++] = a[i];
        p[ln++] = b[i];
    }
    sort(p, p+ln);
    cur = 0;
    for (int i = 0; i < ln; i++){
        if (i == 0 || p[i] != p[i-1])
            ++cur;
        num[i] = cur-1;
    }
    for (int i = 0; i < n; i++){
        int index = lower_bound(p, p+ln, a[i]) - p;
        a[i] = num[index];
        index = lower_bound(p, p+ln, b[i]) - p;
        b[i] = num[index];
    }
    tlst.resize(n);
    for (int i = 0; i < n; i++)
        tlst[i] = mp(mp(a[i], b[i]), i);
    sort(all(tlst));
}

vector<int> xlist[cmax * 2], ylist[cmax * 2];
int xpos[cmax * 2], ypos[cmax * 2];

bool cmp(int x, int y){
    return (a[x] < a[y]) || (a[x] == a[y] && b[x] < b[y]);
}

void make_list(){
    for (int i = 0; i < n; i++)
        xlist[a[i]].pb(i), ylist[b[i]].pb(i);
    for (int i = 0; i < cur; i++)
        sort(all(xlist[i])), sort(all(ylist[i]));
    for (int i = 0; i < cur; i++)
        for (int j = len(xlist[i])-1; j >= 0; j--)
            xpos[xlist[i][j]] = j;
    for (int i = 0; i < cur; i++)
        for (int j = len(ylist[i])-1; j >= 0; j--)
            ypos[ylist[i][j]] = j;
}

int lst[cmax];

int valx(int l, int r){
    int dx = a[l];
    int index = lower_bound(all(xlist[dx]), r+1) - xlist[dx].begin();
    return max(0, index - xpos[l] - 1);
}

int valy(int l, int r){
    int dy = b[l];
    int index = lower_bound(all(ylist[dy]), r+1) - ylist[dy].begin();
    return max(0, index - ypos[l] - 1);
}

int val(int l, int r){
    pair<pair<int, int>, int> cp1 = mp(mp(a[l], b[l]), l), cp2 = mp(mp(a[l], b[l]), r+1);
    int ll = lower_bound(all(tlst), cp1) - tlst.begin(), rr = lower_bound(all(tlst), cp2) - tlst.begin();
    return max(0, rr - ll - 1);
}

void make_lst(int x){
    int l = 0, r = n;
    while (r - l > 1){
        int m = (l + r) / 2;
        int d1 = valx(x, x+m-1), d2 = valy(x, x+m-1), d3 = val(x, x+m-1);
        if (d1 + d2 - d3 < m-1)
            r = m;
        else
            l = m;
    }
    lst[x] = x+r-1;
}

void make_lr(){
    for (int i = 0; i < n; i++)
        make_lst(i);
}

pair<int, int> rmq[cmax * 4];

void make_rmq(int i, int l, int r){
    if (l == r){
        rmq[i] = mp(lst[l], l);
        return;
    }
    make_rmq(i*2, l, (l+r)/2);
    make_rmq(i*2+1, (l+r)/2+1, r);
    rmq[i] = min(rmq[i*2], rmq[i*2+1]);
}

pair<int, int> value(int i, int ll, int rr, int l, int r){
    if (ll == l && rr == r)
        return rmq[i];
    if (ll <= l && r <= (ll+rr)/2)
        return value(i*2, ll, (ll+rr)/2, l, r);
    else if ((ll+rr)/2+1 <= l && r <= rr)
        return value(i*2+1, (ll+rr)/2+1, rr, l, r);
    else
        return min(value(i*2, ll, (ll+rr)/2, l, (ll+rr)/2), value(i*2+1, (ll+rr)/2+1, rr, (ll+rr)/2+1, rr));
}

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    read_info();
    make_zip();
    make_list();
    make_lr();
    make_rmq(1, 0, n-1);
    int m; cin >> m;
    for (int i = 0; i < m; i++){
        int l, r; cin >> l >> r;
        pair<int, int> d = value(1, 0, n-1, --l, --r);
        int a = d.fs, b = d.sc;
        if (l <= a && a <= r)
            printf("%d %d\n", a+1, b+1);
        else
            printf("0 0\n");
    }
    return 0;
}
