#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define FILE_NAME "theatre"
typedef long long ll;
typedef unsigned int uint;

typedef pair <int, int> pii;
const int N = 1e4 + 5;
const int K = 32;
const int T = 320;

struct mask
{
  uint m[T];
  int vers;
  mask()
  {
    vers = 1;
    for (int i = 0; i < T; i++)
      m[i] = 0;
  }
  mask Not()
  {
    mask ret;
    for (int i = 0; i < T; i++)
      ret.m[i] = ~m[i];
    return ret;
  }
  void add(int x)
  {
    x--;
    int w = x / K;
    int bit = x % K;
    m[w] |= (1LL<<bit);
  }
  bool eq(int x)
  {
    x--;
    int w = x / K;
    int bit = x % K;
    for (int i = 0; i < T; i++)
      if (i == w)
      {
        if (m[i] != (1LL<<bit)) return false;
      } else
      {
        if (m[i]) return false;
      }
    return true;
  }
};
mask And(mask a, mask b, int st)
{
  mask ret;
  ret.vers = a.vers;
  bool eq = true;
  for (int i = 0; i < T; i++)
  {
    ret.m[i] = a.m[i] & b.m[i];
    eq &= ret.m[i] == a.m[i];
  }
  if (!eq) ret.vers = st;
  return ret;
}

mask a[N];
int n, m, ans[N], use[N];

int main()
{
  freopen(FILE_NAME".in", "r", stdin);
  freopen(FILE_NAME".out", "w", stdout);
  cin >> n >> m;
  for (int i = 1; i <= n; i++)
    for (int j = 1; j <= n; j++) a[i].add(j);

  for (int step = 1; step <= m; step++)
  {
    int ki, x;
    scanf("%d", &ki);
    mask play, nPlay;
    for (int i = 1; i <= ki; i++)
    {
      scanf("%d", &x);
      use[x] = step;
      play.add(x);
    }
    nPlay = play.Not();
    for (int i = 1; i <= n; i++)
      if (use[i] == step) a[i] = And(a[i], play, step);
      else a[i] = And(a[i], nPlay, step);
  }
  for (int i = 1; i <= n; i++)
    if (a[i].eq(i)) cout << a[i].vers << " ";
    else cout << "0 ";
  /*
  3 3
  2 1 2
  2 3 2
  2 1 2

  5 3
  3 1 2 3
  3 2 3 1
  2 1 3

  4 3
  1 1
  1 3
  1 2

  5 4
  3 1 2 3
  3 1 2 4
  2 1 3
  2 2 4
  3 3 2 2 2

  2 1
  1 1
  */
  return 0;
}
