#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME ""

using namespace std;

typedef long long ll;

int check(int c, int lbound, int rbound)
{
	c = min(c, rbound);
	c = max(c, lbound);

	return c;
}

int n, m, x, y;
int dx, dy, hc, up, down, l, r;

bool infield(int cx, int cy)
{
	return (0 < cx && m + 1 > cx) && (0 < cy && n + 1 > cy);
}

bool isin(int cx, int cy)
{
	return (l < cx && r > cx) && (up < cy && down > cy);
}

int dist(int cx, int cy)
{
	return min(abs(cx - l), abs(cx -r)) + min(abs(cy - up), abs(cy - down));
}

int D[] = {-1, 0, 1};

int main()
{
	//freopen (FILE_NAME".in", "r", stdin);
	//freopen (FILE_NAME".out", "w", stdout);

	srand(238956382);

	scanf ("%d%d %d%d", &n, &m, &x, &y);

	printf ("0 0 1\n");
	fflush(stdout);

	up = l = 0;
	down = n + 1, r = m + 1;

	int tempx, tempy;
	int step;

	while (1)
	{
		scanf ("%d%d%d", &hc, &dx, &dy);		

		if (hc == 1)
			break;
		
		if (dx == 1)
			l++, r++;

		if (dx == -1)
			r--, l--;
		
		if (dy == 1)
			up++, down++;
		if (dy == -1)
			down--, up--;

		up = check(up, 0, n);
		down = check(down, 1, n + 1);

		l = check(l, 0, m);
		r = check(r, 1, m + 1);
		
		step = 0;				   	
		while (step < 100)
		{
			tempx = rand() % 3;
			tempy = rand() % 3;

			if (step < 5 && tempx == 1 && tempy == 1)
				continue;				

			if (!infield(x + D[tempx], y + D[tempy]))
				continue;

			if (isin(x + D[tempx], y + D[tempy]) || dist(x + D[tempx], y + D[tempy]) < dist(x, y))
			{
				//cerr << isin(x + D[tempx], y + D[tempy]) << endl;
				x += D[tempx], y += D[tempy];
				break;
			}

			step++;
		}

		if (!isin(x, y) || (D[tempx] == 0 && D[tempy] == 0))
		{
			printf ("%d %d 0\n", D[tempx], D[tempy]);
			fflush(stdout);
		}	
		else
		{
			printf ("%d %d 1\n", D[tempx], D[tempy]);
			fflush(stdout);
		}
	}

	return 0;
}