#include <fstream>
#include <iostream>
#include <string>
#include <vector>
#include <ctime>
#pragma comment(linker, "/STACK:67108864")
using namespace std;

ifstream fin("password.in");
ofstream fout("password.out");
string s1, s2;
int ansl, ansr;
const int x = 1000000007;
vector<int> cs, h1, h2, px;
const int MAXLEN = 1000000;
string IntToStrA[MAXLEN];
inline void Read()
{
	fin >> s1;
	fin >> s2;
	return;
}

inline string intToStr1(int n)
{
	string s;
	if(n == 0)
		return "0";
	while(n > 0)
	{
		s.push_back('0' + n % 10);
		n /= 10;
	}
	reverse(s.begin(), s.end());
	return s;
}

inline string intToStr(int n)
{
	return IntToStrA[n];
}

inline int getCs(int i)
{
	if(i < 0 || i > cs.size())
		return 0;
	return cs[i];
}

inline bool isStrLessInt(int l2, int r2, int sum)
{
	string sn = intToStr(sum);
	if(sn.size() > r2 - l2 + 1) return true;
	if(sn.size() < r2 - l2 + 1) return false;
	for(int i = 0; i < sn.size(); ++i)
		if(sn[i] > s2[l2 + i]) 
			return true;
	return true;
}

inline bool isEq(int l, int r, int l2, int r2)
{
	int sum = getCs(r) - getCs(l - 1);
	string sn = intToStr(sum);
	if(sn.size() != r2 - l2 + 1)
		return false;
	for(int i = 0; i < sn.size(); ++i)
		if(sn[i] != s2[l2 + i])
			return false;
	return true;
}

inline bool isLess(int l, int r, int l2, int r2)
{
	if(r2 - l2 + 1 > 9)
		return false;
	int sum = getCs(r) - getCs(l - 1);
	return isStrLessInt(l2, r2, sum);
}

inline int getH(int pos, vector<int> & h)
{
	if(pos < 0 || pos > h.size())
		return 0;
	return h[pos];
}

inline bool isEqH(int l1, int r1, int l2, int r2)
{
	bool ans1 = (getH(l1 - 1, h1) == getH(l2 - 1, h2));
	bool ans2 =  (px[r2]*(getH(h1.size() - 1, h1) - getH(r1, h1)) == px[r1]*(getH(h2.size() - 1, h2) - getH(r2, h2)));
	return (ans1 && ans2);
}

inline bool isGood(int l, int r)
{
	int bl = l - 1, bm, br = s2.size();
	while(br - bl > 1)
	{
		bm = (br + bl) / 2;
		if(isLess(l, r, l, bm)) // s2 < l r
			bl = bm;
		else
			br = bm;
	}
	return (isEq(l, r, l, bl) && isEqH(l, r, l, bl));
}

inline void bildCs()
{
	cs.resize(s1.size());
	cs[0] = s1[0] - '0';
	for(int i = 1; i < s1.size(); ++i)
		cs[i] = cs[i - 1] + s1[i] - '0';
	return;
}

inline void bildPx()
{
	px.resize(max(s1.size(), s2.size()));
	px[0] = 1;
	for(int i = 1; i < px.size(); ++i)
		px[i] = px[i - 1] * x;
	return;
}

inline void bildH1H2()
{
	h1.resize(s1.size());
	h2.resize(s2.size());
	bildPx();
	h1[0] = s1[0];
	h2[0] = s2[0];
	for(int i = 1; i < s1.size(); ++i)
		h1[i] = h1[i - 1] + s1[i]*px[i];
	for(int i = 1; i < s2.size(); ++i)
		h2[i] = h2[i - 1] + s2[i]*px[i];
}

inline void bildIntToStrA()
{
	IntToStrA[0] = "0";
	for(int i = 1; i < MAXLEN; ++i)
	{
		int cp = IntToStrA[i - 1].size() - 1;
		while(cp >= 0 && IntToStrA[i - 1][cp] == '9')
		{	
			IntToStrA[i].push_back('0');
			--cp;
		}
		if(cp == -1)
			IntToStrA[i].push_back('1');
		else
		{
			IntToStrA[i].push_back(IntToStrA[i - 1][cp] + 1);
			for(cp = cp - 1; cp >= 0; --cp)
				IntToStrA[i].push_back(IntToStrA[i - 1][cp]);
		}
		reverse(IntToStrA[i].begin(), IntToStrA[i].end());
	}
	return;
}

inline void SolveSq()
{
	bildCs();
	bildH1H2();
	bildIntToStrA();
	int ss = s1.size();
	for(int l = 0; l < ss; ++l)
	{
		for(int r = l; r < min(l + 8, ss); ++r)
		{
			if(isGood(l, r))
			{
				ansl = l;
				ansr = r;
				return;
			}
		}
	}
	return;
}

void Print()
{
	fout << ansl + 1<< " " << ansr  + 1<< endl;
	return;
}


int main()
{
	//clock();
	Read();
	SolveSq();
	Print();
	//cerr << (double) clock() / CLOCKS_PER_SEC;
	return 0;
}