#include <fstream>
#include <vector>
#include <map>

using namespace std;

struct ndRMQ{
	pair<int, int> bad;
	ndRMQ *left, *right;
	ndRMQ()
	{
		bad = make_pair(0, 0);
		left = right = NULL;
	}
};

ifstream fin("mosaic.in");
ofstream fout("mosaic.out");
int n, m;
ndRMQ *RMQ;
vector<pair<int, int> > v;
const pair<int, int> gp(0, 0); 

bool isBad(pair<int, int> p1, pair<int, int> p2)
{
	return (p1.first != p2.first && p1.second != p2.second);
}

pair<int, int> findBad(pair<int, int> p1, int pos, int l, int r)
{
	for(int i = l; i <= r; ++i)
	{
		if(isBad(p1, v[i]))
		{
			return make_pair(pos, i);
		}
	}
	return gp;
}
void bildRMQ(ndRMQ *root, int l, int r)
{
	if(l == r)
		return;
	int m = (l + r) / 2;
	root->left = new ndRMQ();
	root->right = new ndRMQ();
	bildRMQ(root->left, l, m);
	bildRMQ(root->right, m + 1, r);
	if(root->left->bad != gp)
	{
		root->bad = root->left->bad;
		return;
	}
	if(root->right->bad != gp)
	{
		root->bad = root->right->bad;
		return;
	}
	pair<int, int> bp1 = findBad(v[l], l, m + 1, r), bp2 = findBad(v[l + 1], l + 1, m + 1, r);
	if(bp1 != gp)
	{
		root->bad = bp1;
		return;
	}
	if(bp2 != gp)
	{
		root->bad = bp2;
		return;
	}
	return;
}

pair<int, int> getAns(ndRMQ *root, int l, int r, int ql, int qr)
{
	if(ql <= l && r <= qr)
		return root->bad;
	if(r < ql || qr < l)
		return gp;
	pair<int, int> ansl, ansr;
	int m = (l + r) / 2;
	ansl = getAns(root->left, l, m, ql, qr);
	ansr = getAns(root->right, m + 1, r, ql, qr);
	if(ansl != gp)
		return ansl;
	if(ansr != gp)
		return ansr;
	if(ql <= m && m <= qr)
	{
		pair<int, int> bp1 = findBad(v[ql], ql, ql, qr), bp2 = findBad(v[ql + 1], ql + 1, ql, qr);
		if(bp1 != gp)
			return bp1;
		if(bp2 != gp)
			return bp2;
	}
	return gp;
}

int main()
{
	fin >> n;
	v.resize(n);
	for(int i = 0; i < n; ++i)
	{
		int a, b;
		fin >> a >> b;
		v[i] = make_pair(a, b);
	}
	RMQ = new ndRMQ();
	bildRMQ(RMQ, 0, n - 1);
	fin >> m;
	int l, r;
	pair<int, int> ans;
	for(int i = 0; i < m; ++i)
	{
		fin >> l >> r;
		ans = getAns(RMQ, 0, n - 1, l - 1, r - 1);
		if(ans != gp)
			fout << ans.first + 1 << " " << ans.second + 1 << endl;
		else
			fout << 0 << " " << 0 << endl;
	}
	return 0;
}