#include <fstream>
#include <vector>
#include <cassert>
using namespace std;

ifstream fin("mosaic.in");
ofstream fout("mosaic.out");

struct ndRMQ{
	pair<int, int> min, max;
	ndRMQ *left, *right;
	ndRMQ()
	{
		min = max = make_pair(0, 0);
		left = right = NULL;
	}
};

int n, m;
ndRMQ *RMQh, *RMQw;
vector<pair<int, int> > h, w;
vector<int> bp;
const int INF = 1e9;
const pair<int, int> gp(0, 0);

void bildRMQ(ndRMQ *root, int l, int r, vector<pair<int, int> > & v)
{
	if(l == r)
	{
		root->max = root->min = v[l];
		return;
	}
	int m = (l + r) / 2;
	root->left = new ndRMQ();
	root->right = new ndRMQ();
	bildRMQ(root->left, l, m, v);
	bildRMQ(root->right, m + 1, r, v);
	root->max = max(root->left->max, root->right->max);
	root->min = min(root->left->min, root->right->min);
	return;
}

pair<pair<int, int>, pair<int, int> > getRMQ(ndRMQ *root, int l, int r, int ql, int qr)
{
	if(ql <= l && r <= qr)
		return make_pair(root->min, root->max);
	if(r < ql || qr < l)
		return make_pair(make_pair(INF, -1), make_pair(-INF, -1));
	pair<pair<int, int>, pair<int, int> > ansl, ansr, ans;
	int m = (l + r) / 2;
	ansl = getRMQ(root->left, l, m, ql, qr);
	ansr = getRMQ(root->right, m + 1, r, ql, qr);
	ans.first = min(ansl.first, ansr.first);
	ans.second = max(ansl.second, ansr.second);
	return ans;
}

bool isBad(int p1, int p2)
{
	return (h[p1].first != h[p2].first && w[p1].first != w[p2].first);
}

pair<int, int> findBad()
{
	for(int i = 0; i < 4; ++i)
		for(int j = i + 1; j < 4; ++j)
			if(isBad(bp[i], bp[j]))
				return make_pair(bp[i], bp[j]);
	assert(false);
}

pair<int, int> getAns(int l, int r)
{
	pair<pair<int, int>, pair<int, int> > rmqh = getRMQ(RMQh, 0, n - 1, l, r), rmqw = getRMQ(RMQw, 0, n - 1, l, r);
	if(rmqh.first.first != rmqh.second.first && rmqw.first.first != rmqw.second.first)
	{
		bp.clear();
		bp.resize(4);
		bp[0] = rmqh.first.second;
		bp[1] = rmqh.second.second;
		bp[2] = rmqw.first.second;
		bp[3] = rmqw.second.second;
		pair<int, int> ans = findBad();
		return ans;
	}
	return gp;
}

int main()
{
	fin >> n;
	int a, b;
	for(int i = 0; i < n; ++i)
	{
		fin >> a >> b;
		h.push_back(make_pair(a, i));
		w.push_back(make_pair(b, i));
	}
	RMQh = new ndRMQ();
	RMQw = new ndRMQ();
	bildRMQ(RMQh, 0, n - 1, h);
	bildRMQ(RMQw, 0, n - 1, w);
	fin >> m;
	int l, r;
	pair<int, int> p;
	for(int i = 0; i < m; ++i)
	{
		fin >> l >> r;
		p = getAns(l - 1, r - 1);
		if(p != gp)
			fout << p.first + 1 << " " << p.second + 1 << endl;
		else
			fout << "0 0" << endl;
	}
	return 0;
}