#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
ifstream fin("army.in");
ofstream fout("army.out");
int n, m;
vector<int> k, t, last, nk, lnk;
vector<int> d;
set<int> ks;
int ans;
inline void Read()
{
	fin >> n >> m;
	k.resize(m);
	for(int i = 0; i < m; ++i)
	{	
		fin >> k[i];
		ks.insert(k[i]);
	}
	t.resize(n);
	last.resize(n);
	for(int i = 0; i < n; ++i)
		t[i] = i + 1;
	for(int i = n; i >= 1; --i)
		last[n - i] = i;
	return;
}

inline bool haveOtr()
{
	int cp = 0;
	for(int i = 0; i < n; ++i)
	{
		if(ks.count(t[i]))
		{
			if(t[i] != k[cp])
				return false;
			cp++;
		}
	}
	return true;
}

inline void relax(int cp)
{
	int pans = 1;
	for(int i = 0; i < cp; ++i)
		if(t[cp] > t[i])
			pans = max(pans, d[i] + 1);
	d[cp] = pans;
	return;
}

inline int getMaxLenOtr()
{
	d.clear();
	d.resize(n);
	d[0] = 1;
	for(int i = 1; i < n; ++i)
		relax(i);
	int ans = -1;
	for(int i = 0; i < n; ++i)
		ans = max(ans, d[i]);
	return ans;
}

inline bool isGood()
{
	bool gp1 = haveOtr();
	if(!gp1)
		return false;
	int maxLenOtr = getMaxLenOtr();
	return (gp1 && maxLenOtr <= m);
}

void SolveSlow()
{
	if(m == n)
	{
		ans = 1;
		return;
	}
	sort(k.begin(), k.end());
	while(t != last)
	{
		next_permutation(t.begin(), t.end());
		ans += isGood();
	}
	return;
}

inline void bildNK()
{
	int cp = 0;
	for(int i = 1; i <= n; ++i)
	{
		if(cp < m && k[cp] != i)
			nk.push_back(i);
		else if(cp >= m)
			nk.push_back(i);
		else
			++cp;
	}
	return;
}

void bildLNK()
{
	lnk = nk;
	reverse(lnk.begin(), lnk.end());
	return;
}

bool isGoodp()
{
	return (getMaxLenOtr() <= m);
}

int pereb(int ck, int cnk)
{
	if(t.size() == n)
	{
		return isGoodp();
	}
	int pans = 0;
	t.push_back(0);
	if(ck < k.size())
	{
		t[t.size() - 1] = k[ck];
		pans += pereb(ck + 1, cnk);
	}
	if(cnk < nk.size())
	{
		t[t.size() - 1] = nk[cnk];
		pans += pereb(ck, cnk + 1);
	}
	t.resize(t.size() - 1);
 	return pans;
}

void Solve()
{
	sort(k.begin(), k.end());
	bildNK();
	bildLNK();
	t.clear();
	ans += pereb(0, 0);
	while(nk != lnk)
	{
		t.clear();
		ans += pereb(0, 0);
		next_permutation(nk.begin(), nk.end());
	}
	return;
}

void Print()
{
	fout << ans;
	return;
}

int main()
{
	Read();
	//if (n < 9)
		//SolveSlow();
	//else
		Solve();
	Print();
	return 0;
}