{$APPTYPE CONSOLE}
{$DEFINE DEBUG}
{$R+,Q+,S+}

uses SysUtils, Math;

type int = longint;
     integer = longint;

type pair = record
	fs,sc : int;
end;

const PROBLEMNAME = 'virus';
const eps = 1e-7;
const MAXN = 1000*100;

var a : array [1..MAXN] of int;
	n,m : int;

procedure debug(s : string);
begin
{$IFDEF DEBUG} writeln(s) {$ENDIF}
end;

procedure answer(s : string);
begin
	writeln(s);
	halt;
end;

procedure answer_int(s : int64);
begin
	writeln(s);
	halt;
end;

type
  pnode = ^tnode;
  tnode = record
    next : pnode;
    v : int;
  end;

var
	i,j,k,q : int;
	t1,t2,t3,t4,t5,t6,t7,t8,t9 : int;
	ans : int64;

  r1,r2 : integer;
  ch1, ch2 : array [1..2000] of pnode;

  mc : array [1..2000, 1..2000] of boolean;

function node(next : pnode; v : int) : pnode;
var p : pnode;
begin
  new(p);
  p^.next := next;
  p^.v := v;
  node := p;
end;

procedure append1(u,v : integer);
begin
  ch1[u] := node(ch1[u], v);
end;

procedure append2(u,v : integer);
begin
  ch2[u] := node(ch2[u], v);
end;

var rec : array [1..2000] of boolean;

procedure dfs1(v : integer);
var i : int;
    p : pnode;
begin
  for i := 1 to n do
    mc[v,i] := rec[i];
  rec[v] := true;
  p := ch1[v];
  while p <> nil do
    begin
      dfs1(p^.v);
      p := p^.next;
    end;
  rec[v] := false;
end;

procedure dfs2(v : integer);
var i : int;
    p : pnode;
begin
  for i := 1 to n do
    if rec[i] and mc[v,i] then inc(ans);
  rec[v] := true;
  p := ch2[v];
  while p <> nil do
    begin
      dfs2(p^.v);
      p := p^.next;
    end;
  rec[v] := false;
end;

begin
  if PROBLEMNAME <> '' then
    begin
	  assign(input, PROBLEMNAME + '.in'); reset(input);
	  assign(output, PROBLEMNAME + '.out'); rewrite(output);
	end;
  read(n);
  fillchar(ch1, sizeof(ch1), 0);
  fillchar(ch2, sizeof(ch2), 0);
  for i := 1 to n do
    begin
      read(t1);
      if t1 = 0 then r1 := i else
      append1(t1,i);
    end;
  for i := 1 to n do
    begin
      read(t1);
      if t1 = 0 then r2 := i else
      append2(t1,i);
    end;
  fillchar(rec, sizeof(rec), 0);
  dfs1(r1);
  dfs2(r2);
  writeln(ans);
end.
