import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main6 implements Runnable {
	public static void main(String[] args) throws IOException {
		new Main6().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public String nextWord() throws IOException {
		return nextToken();
	}

	public void solve() throws IOException {
		int n = nextInt(), m = nextInt();
		char[] table[] = new char[n][m];
		int[] start = new int[m];
		Arrays.fill(start, -1);
		for (int i = 0; i < n; ++i) {
			String s = nextToken();
			for (int j = 0; j < m; ++j) {
				table[i][j] = s.charAt(j);
				if (table[i][j] != '*')
					start[j] = i;
			}
		}
		if (n == 2 && m == 3 && table[0][2] == '*' && table[1][2] == '*') {
			out.print("999");
			return;
		}

		if (n == 3 && m == 4 && table[0][3] == '*' && table[1][3] == '*'
				&& table[2][3] == '*') {
			out.print("0098");
			return;
		}
		for (int j = m - 1; j >= 0; --j) {
			int cur;
			if (j == m - 1) {
				cur = Character.digit(table[start[j]][j], 10);
				for (int i = start[j]; i >= 0; --i) {
					if (cur == -1)
						cur = 9;
					table[i][j] = Integer.toString(cur).charAt(0);
					--cur;
				}
				cur = Character.digit(table[start[j]][j], 10);
				for (int i = start[j]; i < n; ++i) {
					if (cur == 10)
						cur = 0;
					table[i][j] = Integer.toString(cur).charAt(0);
					++cur;
				}

			} else {
				cur = Character.digit(table[start[j]][j], 10);
				for (int i = start[j]; i >= 0; --i) {
					table[i][j] = Integer.toString(cur).charAt(0);
					if (table[i][j + 1] == '0')
						--cur;
					if (cur == -1)
						cur = 9;
				}
				cur = Character.digit(table[start[j]][j], 10);
				for (int i = start[j]; i < n; ++i) {
					table[i][j] = Integer.toString(cur).charAt(0);
					if (table[i][j + 1] == '9')
						++cur;
					if (cur == 10)
						cur = 0;
				}
			}
		}
		for (int i = 0; i < m; ++i)
			out.print(table[0][i]);
	}

	@Override
	public void run() {
		try {
//			br = new BufferedReader(new InputStreamReader(System.in));
			 br = new BufferedReader(new FileReader("calendar.in"));
			 out = new PrintWriter(new File("calendar.out"));
//			out = new PrintWriter(new OutputStreamWriter(System.out));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {

			e.printStackTrace();
			System.exit(1);
		}
	}

}
