import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class Main implements Runnable {
	public static void main(String args[]) {
		new Main().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	static class Pair {
		int a, b;

		public Pair(int a, int b) {
			this.a = a;
			this.b = b;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		int[] b = new int[n];
		for (int i = 0; i < n; ++i) {
			a[i] = nextInt();
			b[i] = nextInt();
		}
		Pair[][] p = new Pair[n][n];
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (a[i] != a[j] && b[i] != b[j]) {
					p[i][j] = new Pair(i, j);
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (p[i][j] == null) {
					p[i][j] = p[i][j - 1];
				}
			}
		}
		int k = nextInt();
		for (int i = 0; i < k; ++i) {
			int v = nextInt() - 1, u = nextInt() - 1;
			if (p[v][u] == null) {
				out.printf("%d %d\n", 0, 0);
			} else {
				out.printf("%d %d\n", p[v][u].a + 1, p[v][u].b + 1);
			}
		}
	}

	@Override
	public void run() {
		try {
//			br = new BufferedReader(new InputStreamReader(System.in));
			 br = new BufferedReader(new FileReader("mosaic.in"));
//			out = new PrintWriter(new OutputStreamWriter(System.out));
			 out = new PrintWriter(new File("mosaic.out"));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}

