import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class Main implements Runnable {
	public static void main(String args[]) {
		new Main().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n + 1];
		int[] b = new int[n + 1];
		int l1, l2 = l1 = 0;
		int[] mark1 = new int[n + 1];
		int[] mark2 = new int[n + 1];
		for (int i = 1; i <= n; ++i) {
			a[i] = nextInt();
			b[i] = nextInt();
			if (i == 1 || a[i] != a[i - 1]) {
				l1 = i;
			}
			if (i == 1 || b[i] != b[i - 1]) {
				l2 = i;
			}
			mark1[i] = l1;
			mark2[i] = l2;
		}
		int k = nextInt();
		for (int i = 1; i <= k; ++i) {
			int t1 = nextInt(), t2 = nextInt();
			if (mark1[t2] == mark2[t2]) {
				if (mark1[t2] < t1) {
					out.println("0 0");
				} else {
					out.println((mark1[t2] - 1) + " " + t2);
				}				
			} else {
				if ((mark1[t2] <= t1) || (mark2[t2] <= t1)) {
					out.println("0 0");
				} else {
					if (mark1[t2] < mark2[t2]) {
						if (b[t2] != b[mark1[t2] - 1]) {
							out.println((mark1[t2] - 1) + " " + t2);
						} else {
							out.println((mark1[t2] - 1) + " " + (mark2[t2] - 1));
						}
					} else {
						if (a[t2] != a[mark2[t2] - 1]) {
							out.println((mark2[t2]) - 1 + " " + (t2));
						} else {
							out.println((mark2[t2] - 1) + mark1[t2] - 1);
						}
					}
				}
			}
		}
	}
		

	@Override
	public void run() {
		try {
//			 br = new BufferedReader(new InputStreamReader(System.in));
			br = new BufferedReader(new FileReader("mosaic.in"));
//			 out = new PrintWriter(new OutputStreamWriter(System.out));
			out = new PrintWriter(new File("mosaic.out"));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
