import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.EnumMap;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class B implements Runnable {
	public static void main(String args[]) {
		new B().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public int[] guard;
	public int point = 0;
	public int cnt = 0;

	public void swap(int l, int r, int[] a) {
		int tmp = a[l];
		a[l] = a[r];
		a[r] = tmp;
	}

	public boolean check(int[] a) {
		int[] d = new int[a.length];
		Arrays.fill(d, 1);
		for (int i = 0; i < a.length; ++i) {
			for (int j = i + 1; j < a.length; ++j) {
				if (a[i] < a[j])
					d[j] = Math.max(d[j], d[i] + 1);
			}
		}
		int max = -1;
		for (int i = 0; i < a.length; ++i) {
			max = Math.max(d[i], max);
		}
		if (max == guard.length)
			return true;
		return false;
	}

	public void gen(int l, int r, int[] a) {
		if (l == r) {
			for (int i = 0; i < a.length && point < guard.length; ++i) {
				if (a[i] == guard[point]) {
					++point;
				}
			}
			if (point == guard.length && check(a))
				++cnt;
			point = 0;
			return;
		} else {
			for (int i = l; i <= r; ++i) {
				swap(l, i, a);
				gen(l + 1, r, a);
				swap(l, i, a);
			}
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; ++i)
			a[i] = i;
		guard = new int[k];
		for (int i = 0; i < k; ++i) {
			guard[i] = nextInt() - 1;
		}
		gen(0, n - 1, a);
		out.print(cnt);
	}

	@Override
	public void run() {
		try {
			// br = new BufferedReader(new InputStreamReader(System.in));
			br = new BufferedReader(new FileReader("army.in"));
			// out = new PrintWriter(new OutputStreamWriter(System.out));
			out = new PrintWriter(new File("army.out"));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
