#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstring>
using namespace std;

const int maxn = 100005;

vector<int> edge[maxn];

int in[maxn], out[maxn];
int timer = 0;

void dfs1(int v)
{
	in[v] = timer++;
	for (size_t i = 0; i < edge[v].size(); ++i)
		dfs1(edge[v][i]);
	out[v] = timer++;
}

long long ans = 0;

int met[maxn*2];

void dfs2(int v)
{
	int before = 0;
	for (int i = in[v]; i < out[v]; ++i)
		before += met[i];
	for (size_t i = 0; i < edge[v].size(); ++i)
		dfs2(edge[v][i]);
	int after = 0;
	for (int i = in[v]; i < out[v]; ++i)
		after += met[i];
	ans += after - before;
	met[in[v]] = 1;
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	int n;
	cin >> n;

	int root = 0;
	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		if (x)
			edge[x-1].push_back(i);
		else
			root = i;
	}

	dfs1(root);

	for (int i = 0; i < n; ++i)
		edge[i].clear();

	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		if (x)
			edge[x-1].push_back(i);
		else
			root = i;
	}

	dfs2(root);

	cout << ans << endl;

	return 0;
}