#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstring>
using namespace std;
 
const int maxn = 100005;
 
vector<int> edge[maxn];
 
int in[maxn], out[maxn];
int timer = 0;

vector< pair<int, int> > st;
void dfs1(int root)
{
	st.push_back(make_pair(0, root));
	while (!st.empty())
	{
		int type = st.back().first;
		int v = st.back().second;
		st.pop_back();
		if (type == 0)
		{
		    in[v] = timer++;
			st.push_back(make_pair(1, v));
			for (size_t i = 0; i < edge[v].size(); ++i)
				st.push_back(make_pair(0, edge[v][i]));
		}
		else
			out[v] = timer++;
	}
}
 
long long ans = 0;
 
int met[maxn*2], before[maxn];

inline void inc(int v)
{
	v++;
	for (; v < maxn*2; v += (v&(-v)))
		met[v]++;
}

inline int get(int v)
{
	int ans = 0;
	v++;
	for (; v; v -= v&(-v))
		ans += met[v];
	return ans;
}

void dfs2(int root)
{
	st.push_back(make_pair(0, root));
	while (!st.empty())
	{
		int type = st.back().first;
		int v = st.back().second;
		st.pop_back();
		if (type == 0)
		{
			before[v] = get(out[v]) - get(in[v]);
			st.push_back(make_pair(1,v));
			for (size_t i = 0; i < edge[v].size(); ++i)
				st.push_back(make_pair(0, edge[v][i]));
		}
		else
		{
			int after = get(out[v]) - get(in[v]);
			ans += after - before[v];
			inc(in[v]);
		}
	}
}
 
int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
 
    int n;
    cin >> n;
 
    int root = 0;
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        if (x)
            edge[x-1].push_back(i);
        else
            root = i;
    }
 
    dfs1(root);
 
    for (int i = 0; i < n; ++i)
        edge[i].clear();
 
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        if (x)
            edge[x-1].push_back(i);
        else
            root = i;
    }
 
    dfs2(root);
 
    cout << ans << endl;
 
    return 0;
}