
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
 
const int maxn = 2005;
const long long inf = 1LL << 50;
 
long long dp[maxn];
long long segm[maxn][maxn];
long long eqcost, diffcost;

inline long long func(int i, int j)
{
	long long here = -1;
	if (j+j != i)
		here = eqcost + segm[i-j-j][i-1];
	here = max(here, diffcost + segm[j][i-1]);
	return here;
}

int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
 
    int n;
    cin >> n >> eqcost >> diffcost;
	if (n >= maxn)
		return 0;
 
    dp[0] = dp[1] = 0;
	segm[0][0] = segm[0][1] = segm[1][1] = 0;
//    dp[2] = diffcost;
//   dp[3] = max(eqcost, diffcost);
 
    for (int i = 2; i <= n; ++i)
    {
        dp[i] = inf;
		int l = 1, r = i / 2;
		while (r - l > 5)
		{
			int m1 = (l*2+r)/3;
			int m2 = (l+r*2)/3;
			if (func(i, m1) < func(i, m2))
				r = m2;
			else
				l = m1;
		}
		for (int j = l; j <= r; ++j)
			dp[i] = min(dp[i], func(i,j));
		segm[i][i] = dp[i];
		for (int j = 0; j < i; ++j)
			segm[j][i] = min(dp[i], segm[j][i-1]);
    }
 
    cout << dp[n] << endl;
//	for (int i = 0; i <= n; ++i)
//		cout << dp[i] << ' ';
//	cout << endl;
 
    return 0;
}