#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;

typedef unsigned long long ull;
const ull base = 1973, add = 761;

template <class T>
struct mymap
{
	struct node
	{
		node * next;
		ull key;
		T value;
		node() {}
		node(node *next, const ull &key, const T &value): next(next), key(key), value(value) {}
	};
	typedef node * nodep;

	static const int tablesize = 1753123;
	nodep root[tablesize];

	mymap()
	{
		memset(root, 0, sizeof root);
	}

	inline T& operator [] (const ull &h)
	{
		int a = h % tablesize;
		nodep ptr = root[a];
		while (ptr && h != ptr->key)
			ptr = ptr->next;
		if (!ptr)
			ptr = root[a] = new node(root[a], h, T());
		return ptr->value;
	}
};

mymap<unordered_set<int> > mp;
unordered_set<int> pot;
const int maxn = 100005;
ull actor[maxn];
int ans[maxn];

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	memset(ans, 0, sizeof ans);
	memset(actor, 0, sizeof actor);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		mp[0].insert(i);

	ull pow = 1;
	for (int i = 0; i < m; ++i)
	{
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j)
		{
			int x;
			cin >> x;
			x--;	

			if (ans[x])
				continue;

			unordered_set<int> &s = mp[actor[x]];
			s.erase(x);
			if (s.size() == 1)
				pot.insert(*s.begin());
			if (s.size() == 0)
				pot.erase(x);

			actor[x] = actor[x] + add * pow;
			unordered_set<int> &t = mp[actor[x]];
			if (t.size() == 1)
				pot.erase(*t.begin());
			t.insert(x);
			if (t.size() == 1)
				pot.insert(x);
		}

		for (unordered_set<int>::iterator it = pot.begin(); it != pot.end(); ++it)
		{
			ans[*it] = i+1;
			mp[actor[*it]].clear();
		}
		pot.clear();

		pow *= base;
	}

	for (int i = 0; i < n; ++i)
		cout << ans[i] << ' ';

	return 0;
}