#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;

const int dx[9] = {0, 1, 1, 1, 0, -1, -1, -1, 0};
const int dy[9] = {0, 1, 0, -1, -1, -1, 0, 1, 1};

vector< vector<int> > old, nxt;

int n, m;

inline bool ok(int x, int y)
{
	return x>=0 && y>=0 && x<n && y<m;
}

inline double score(int x, int y)
{
	double ret = 0.;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			ret += old[i][j] * pow(double(x-i)*(x-i) + (y-j)*(y-j), .2);
	return ret;
}

int main()
{
	cin >> m >> n;
	int x, y;
	cin >> x >> y;
	--x;
	--y;

	old.resize(n, vector<int>(m, 1));
	nxt = old;

	int last = 0;
	while (true)
	{
		double best = 1e18;
		int d = 0;
		if (last)
			d = score(x, y);
		for (int i = 1; i < 9; ++i)
		{
			double here = score(x+dx[i], y+dy[i]);
			if (here < best)
			{
				best = here;
				d = i;
			}
		}

		x += dx[d];
		y += dy[d];

		cout << dx[d] << ' ' << dy[d] << ' ';
		cout << old[x][y] << endl;
		cout.flush();

		int h;
		cin >> h;
		if (h)
			return 0;
		old[x][y] = 0;
		int ddx, ddy;
		cin >> ddx >> ddy;
		last = ddx||ddy;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				nxt[i][j] = (ok(i-ddx,j-ddy) ? old[i-ddx][j-ddy] : 0);
		old = nxt;
	}

	return 0;
}