#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <cstdlib>
using namespace std;

const int dx[9] = {0, 1, 1, 1, 0, -1, -1, -1, 0};
const int dy[9] = {0, 1, 0, -1, -1, -1, 0, 1, 1};

vector< vector<int> > old, nxt;

int n, m;

inline bool ok(int x, int y)
{
	return x>=0 && y>=0 && x<n && y<m;
}

int range[35][35];
inline int score(int x, int y)
{
	if (!ok(x, y))
		return 1 << 30;
	queue< pair<int, int> > q;
	q.push(make_pair(x, y));
	for (int i = 0; i< n; ++i)
		for (int j = 0; j < m; ++j)
			range[i][j] = 1 << 30;
	range[x][y] = 0;
	do
	{
		x = q.front().first;
		y = q.front().second;
		if (old[x][y])
			return range[x][y];
		q.pop();
		for (int i = 1; i < 9; ++i)
		{
			int nx = x + dx[i];
			int ny = y + dy[i];
			if (ok(nx, ny) && range[nx][ny] == 1 << 30)
			{
				q.push(make_pair(nx, ny));
				range[nx][ny] = range[x][y] + 1;
			}
		}
	} while (!q.empty());
	return 1 << 30;
}

int main()
{
	srand(5);

	cin >> m >> n;
	int x, y;
	cin >> x >> y;
	--x;
	--y;

	old.resize(n, vector<int>(m, 1));
	nxt = old;

	int last = 0;
	while (true)
	{
		int best = 1 << 30;
		int d = 0;
		vector<int> ds(1,0);
		if (last)
			best = score(x, y);
		for (int i = 1; i < 9; ++i)
		{
			int here = score(x+dx[i], y+dy[i]);
			if (here == best)
				ds.push_back(i);
			if (here < best)
			{
				best = here;
				ds.assign(1,i);
				d = i;
			}
		}

		d = ds[rand()%ds.size()];
		x += dx[d];
		y += dy[d];

		cout << dx[d] << ' ' << dy[d] << ' ';
		cout << old[x][y] << endl;
		cout.flush();

		int h;
		cin >> h;
		if (h)
			return 0;
		old[x][y] = 0;
		int ddx, ddy;
		cin >> ddx >> ddy;
		last = ddx||ddy;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				nxt[i][j] = (ok(i-ddx,j-ddy) ? old[i-ddx][j-ddy] : 0);
		old = nxt;
	}

	return 0;
}