#pragma comment(linker,"/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 100005;
char a[MAX_N] = {0};
char b[MAX_N] = {0};
int s[MAX_N] = {0};
bool eq_pre[MAX_N] = {0};
bool eq_suf[MAX_N] = {0};

int sum(int l, int r)
{
	return (s[r] - s[l - 1]);
}

int len_int(int x)
{
	if (x == 0)
		return 1;
	int k = 0;
	while (x > 0)
	{
		++k;
		x /= 10;
	}
	return k;
}

int len(int l, int r, int n)
{
	int len_pre = l - 1;
	int len_suf = n - r;
	int len_sum = len_int(sum(l, r));
	return len_pre + len_sum + len_suf;
}

bool x_is_b(int x, int pl)
{
	int k = len_int(x);
	bool ans = 1;
	for (int i = pl + k - 1; i >= pl; --i)
	{
		if ((x % 10) != (b[i - 1] - '0'))
			ans = 0;
		x /= 10;
	}
	return ans;
}
int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);

	
	cin >> a;
	int na = 0;
	while (a[na] != 0)
		++na;

	cin >> b;
	int nb = 0;
	while (b[nb] != 0)
		++nb;
    
	s[0] = 0;
	for (int i = 0; i < na; ++i)
		s[i + 1] = s[i] + a[i] - '0';

	eq_pre[0] = 1;
	for (int i = 0; i < min(na, nb); ++i)
		eq_pre[i + 1] = eq_pre[i] && (a[i] == b[i]);

	eq_suf[0] = 1;
	for (int i = 0; i < min(na, nb); ++i)
		eq_suf[i + 1] = eq_suf[i] && (a[na - i - 1] == b[nb - i - 1]);

	int ans_pl = -1;
	int ans_pr = -1;

	
	for (int pl = 1; ans_pl == -1; ++pl)
	{
		int l = pl;
		int r = na + 1;
		while ((r - l) > 1)
		{
			int m = (l + r) / 2;
			if (len(pl, m, na) >= nb)
				l = m;
			else
				r = m;
		}
		int pr = l;
		while ((len(pl, pr, na) == nb) && (pr >= pl))
		{
			if (eq_pre[pl] && eq_suf[na - pr] && x_is_b(sum(pl, pr), pl))
			{
				ans_pl = pl;
				ans_pr = pr;
			}
			--pr;
		}
	}

	cout << ans_pl << " " << ans_pr << endl;

    return 0;
}