#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <map>
#include <ctime>
#include <cstdio>
 
 
using namespace std;
 
const int maxn=100010;
const pair<int,int> nil=make_pair(-1,-1);
 
int n,k;
pair<int,int> a[maxn],o1,o2;
 
 
pair<int,int> t1[4*maxn],t2[4*maxn];
 
inline pair<int,int> smth1(pair<int,int> p1, pair<int,int> p2) {
    if (p1.first!=p1.second) return p1;
    else if (p2.first!=p2.second) return p2;
    else if (a[p1.first].first!=a[p2.first].first) return make_pair(p1.first,p2.first);
    else return p1;
}
 
inline pair<int,int> smth2(pair<int,int> p1, pair<int,int> p2) {
    if (p1.first!=p1.second) return p1;
    else if (p2.first!=p2.second) return p2;
    else if (a[p1.first].second!=a[p2.first].second) return make_pair(p1.first,p2.first);
    else return p1;
}
 
void build1(int v, int tl, int tr) {
    if (tl==tr) {
        t1[v]=make_pair(tl,tr);
        return;
    }
    int tm=(tl+tr)>>1;
    build1(v*2,tl,tm);
    build1(v*2+1,tm+1,tr);
    t1[v]=smth1(t1[v*2],t1[v*2+1]);
}
 
void build2(int v, int tl, int tr) {
    if (tl==tr) {
        t2[v]=make_pair(tl,tr);
        return;
    }
    int tm=(tl+tr)>>1;
    build2(v*2,tl,tm);
    build2(v*2+1,tm+1,tr);
    t2[v]=smth2(t2[v*2],t2[v*2+1]);
}
 
pair<int,int> get1(int v, int tl, int tr, int l, int r) {
    if (l>r) return nil;
    if (l==tl && r==tr) {
        return t1[v];
    }
    int tm=(tl+tr)>>1;
    pair<int,int> o1,o2;
    o1=get1(v*2,tl,tm,l,min(r,tm));
    o2=get1(v*2+1,tm+1,tr,max(l,tm+1),r);
    if (o1==nil) return o2;
    if (o2==nil) return o1;
    return smth1(o1,o2);
}
 
pair<int,int> get2(int v, int tl, int tr, int l, int r) {
    if (l>r) return nil;
    if (l==tl && r==tr) {
        return t2[v];
    }
    int tm=(tl+tr)>>1;
    pair<int,int> o1,o2;
    o1=get2(v*2,tl,tm,l,min(r,tm));
    o2=get2(v*2+1,tm+1,tr,max(l,tm+1),r);
    if (o1==nil) return o2;
    if (o2==nil) return o1;
    return smth2(o1,o2);
}
 
bool cmp(int i, int j) {
    return a[i].first==a[j].first || a[i].second==a[j].second;
}
 
int main() {
    freopen("mosaic.in","r",stdin);
    freopen("mosaic.out","w",stdout);
 
    scanf("%d",&n);
    for (int i=0; i<n; i++) 
        scanf("%d%d",&a[i].first,&a[i].second);
    build1(1,0,n-1);
    build2(1,0,n-1);
 
    scanf("%d",&k);
    for (int i=0; i<k; i++) {
        int x,y;
        scanf("%d%d",&x,&y);
        pair<int,int> o1,o2;
        o1=get1(1,0,n-1,x-1,y-1);
        o2=get2(1,0,n-1,x-1,y-1);
        if (!cmp(o1.first,o2.first)) {
            printf("%d %d\n",o1.first+1,o2.first+1);
            continue;
        }
        if (!cmp(o1.second,o2.first)) {
            printf("%d %d\n",o1.second+1,o2.first+1);
            continue;
        }
        if (!cmp(o1.first,o2.second)) {
            printf("%d %d\n",o1.first+1,o2.second+1);
            continue;
        }
        if (!cmp(o1.second,o2.second)) {
            printf("%d %d\n",o1.second+1,o2.second+1);
            continue;
        }
        printf("%d %d\n",0,0);
    }
 
 
	//cout << clock();

    return 0;
}