#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>

#define N 1000000
#define INF INT64_MAX
#define MINF INT64_MIN

int64_t minapri[N + 1];

int64_t inline min(int64_t a, int64_t b) { return (a < b) ? a : b; };
int64_t inline max(int64_t a, int64_t b) { return (a > b) ? a : b; };

int64_t val(int a, int i, int u, int r) {
	return max(u + minapri[a], r + minapri[i - (a << 1)]);
};

int main(void) {
	int n, r, u, i;
	int alow, ahigh, aup, adown;
	FILE * in, * out;
	in = fopen("apricot.in", "r");
	fscanf(in, "%d%d%d", &n, &r, &u);
	fclose(in);
	minapri[0] = MINF;
	minapri[1] = 0;
	for (i = 2; i <= n; i ++) {
		alow = 1;
		ahigh = i >> 1;
		while ((ahigh - alow) > 1) {
			adown = (ahigh + alow) >> 1;
			aup = adown + 1;
			if (val(aup, i, u, r) < val(adown, i, u, r))
				alow = aup;
			else
				ahigh = adown;
		};
		minapri[i] = min(val(alow, i, u, r), val(ahigh, i, u, r));
	};
	out = fopen("apricot.out", "w");
	fprintf(out, "%" PRId64 "\n", minapri[n]);
	fclose(out);
	return 0;
};
