#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>

#define N 1000000
#define INF INT64_MAX
#define MINF INT64_MIN
#include <math.h>

int64_t minapri[N + 1];

int64_t inline min(int64_t a, int64_t b) { return (a < b) ? a : b; };
int64_t inline max(int64_t a, int64_t b) { return (a > b) ? a : b; };


int main(void) {
	int n, r, u, i;
	int a;
	int64_t pts;
	FILE * in, * out;
	in = fopen("apricot.in", "r");
	fscanf(in, "%d%d%d", &n, &r, &u);
	fclose(in);
	minapri[0] = MINF;
	minapri[1] = 0;
	for (i = 2; i <= n; i ++) {
		minapri[i] = INF;
		for (pts = 2; pts <= (int) (sqrt(i) + 1); pts ++) {
			for (a = 1; a <= i / pts; a ++) {
				int64_t val = (pts - 2) * r + max(u + minapri[a],
						r + minapri[i - pts * a]);
				if (val < minapri[i]) {
					minapri[i] = val;
				};
			};
		};
	};
	out = fopen("apricot.out", "w");
	fprintf(out, "%" PRId64 "\n", minapri[n]);
	fclose(out);
	return 0;
};
