#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

char chread(FILE * in) {
	char c = getc(in);
	if (c == '*')
		return -1;
	return c - '0';
};
#define N 100000
#define NM 100000

const int p10[] = {1, 10, 100, 1000, 10000, 100000, 1000000};

inline int getp10(int i) {
	return (i < 7) ? p10[i] : p10[6];
};

char memory[NM];
char * chart[N];

int possibile[N];
#define MAXMASK ((1 << 10) - 1)

int main(void) {
	int n, m, i, j, k, l;
	FILE * in, * out;
	in = fopen("calendar.in", "r");
	fscanf(in, "%d%d", &n, &m);
	for (i = 0; i < m; i ++) {
		chart[i] = &memory[i * n];
		possibile[i] = MAXMASK;
	};
	while (getc(in) != '\n') ;
	for (i = 0; i < n; i ++) {
		for (j = 0; j < m; j ++) {
			chart[j][i] = chread(in);
		};
		assert(getc(in) == '\n');
	};
	for (i = 0; i < m - 1; i ++) {
		int lastidx;
		int p = getp10(m - i - 1);
		for (j = 0; j < n - 1; j ++) {
			if ((chart[i][j] != -1) && (chart[i][j + 1] != -1) &&
					(chart[i][j] != chart[i][j + 1])) {
				chart[i + 1][j] = 9;
				chart[i + 1][j + 1] = 0;
			};
		};
		for (j = 0; j < n; j ++)
			if (chart[i][j] != -1)
				break;
		if (j == n) {
			for (k = 0; k < 10; k ++)
				if (possibile[i] & (1 << k)) {
					chart[i][0] = k;
					break;
				};
			j = 0;
		};
		lastidx = j;
		if (lastidx) {
			int padme = ((dist - 1) / p) % 10, hum = ((dist - 2) / p + 1) % 10;
			int om = (chart[i][lastidx] + 10 - padme),
			    mani = (chart[i][lastidx] + 10 - hum);
			for (k = 0; k < n; k ++) {
				if ((k != om) && (k != mani))
					possibile[i] &= ~(1 << k);
			};
		};
		if ((possibile[i] & (possibile[i] - 1)) == 0)
			for (k = 0; k < 10; k ++)
				if (possibile[i] & (1 << k)) {
					chart[i][0] = k;
					break;
				};
		for (j ++; j < n; j ++) {
			if (chart[i][j] != -1) {
				int dist = j - lastidx - 1 - p * (chart[i][j] -
						chart[i][lastidx] + 9) % 10;
				for (l = i + 1; l < m; l ++) {
					int pm = getp10(m - l - 1);
					int bane = dist / pm;
					int shift = (lastidx / pm) % 10;
					dist = dist % pm;
					lastidx = lastidx % pm;
					for (k = 0; k < 9 - bane; k ++)
						possibile[l] &=
							~(1 << (k + 10 - shift) % 10);
				};
				lastidx = j;
			};
		};
	};
	for (i = m - 1; i >= 0; i --) {
		for (j = 0; j < n; j ++)
			if (chart[i][j] != -1)
				break;
		if (j == n) {
			for (k = 0; k < 10; k ++)
				if (possibile[i] & (1 << k)) {
					chart[i][0] = k;
					break;
				};
			j = 0;
		};
		for (k = j; k > 0; k --) {
			if ((i == m - 1) || ((chart[i + 1][k] == 0) &&
						(chart[i + 1][k - 1] == 9)))
				chart[i][k - 1] = (9 + chart[i][k]) % 10;
			else
				chart[i][k - 1] = chart[i][k];
		};
		for (k = j; k < n - 1; k ++) {
			if ((i == m - 1) || ((chart[i + 1][k] == 9) &&
						(chart[i + 1][k + 1] == 0)))
				chart[i][k + 1] = (1 + chart[i][k]) % 10;
			else
				chart[i][k + 1] = chart[i][k];
		};
	};
	out = fopen("calendar.out", "w");
	for (i = 0; i < m; i ++)
		putc(chart[i][0] + '0', out);
	putc('\n', out);
	fclose(out);
	return 0;
};
