#include <stdio.h>
#include <limits.h>
#include <assert.h>

int dist(int x1, int y1, int x2, int y2) {
	x2 -= x1;
	y2 -= y1;
	if (x2 < 0) x2 = -x2;
	if (y2 < 0) y2 = -y2;
	x1 = (x2 < y2) ? x2 : y2;
	return x2 + y2 - x1;
};

int main(void) {
	int posx, posy;
	int minx, maxx, miny, maxy;
	int w, h;
	scanf("%d %d %d %d", &h, &w, &posx, &posy);
	posx -= 1; posy -= 1;
	w -= 1; h -= 1;
	minx = miny = 0;
	maxx = w; maxy = h;
	while (1) {
		int dx, dy;
		int midx = (minx + maxx) >> 1, midy = (miny + maxy) >> 1;
		int mindist = INT_MAX;
		int mindx = -2, mindy = -2;
		int res;
		for (dx = -1; dx <= 1; dx ++)
			for (dy = -1; dy <= 1; dy ++) {
				if ((posx + dx > w) || (posx + dx < 0) ||
						(posy + dy > h) || (posy + dy < 0))
					continue;
				int d = dist(posx + dx, posy + dy, midx, midy);
				if (d < mindist) {
					mindist = d;
					mindx = dx;
					mindy = dy;
				};
			};
		posx += mindx;
		posy += mindy;
		assert((minx <= posx) && (posx <= maxx));
		assert((miny <= posy) && (posy <= maxy));
		printf("%d %d 1\n", mindx, mindy);
		fflush(stdout);
		scanf("%d %d %d", &res, &dx, &dy);
		if (res)
			break;
		minx += dx; if (minx < 0) minx = 0;
		miny += dy; if (miny < 0) miny = 0;
		maxx += dx; if (maxx > w) maxx = w;
		maxy += dy; if (maxy > h) maxy = h;
	};
	return 0;
};
