#include <stdio.h>
#include <limits.h>
#include <assert.h>
 
#define MAXN 30
 
int zdist(int x1, int y1, int x2, int y2) {
    x2 -= x1;
    y2 -= y1;
    if (x2 < 0) x2 = -x2;
    if (y2 < 0) y2 = -y2;
    x1 = (x2 < y2) ? x2 : y2;
    return x2 + y2 - x1;
};
 
int visited[MAXN][MAXN];
 
int mindist(int w0, int h0, int w, int h, int x, int y) {
    int d = INT_MAX;
    int i, j;
    for (i = w0; i <= w; i ++)
        for (j = h0; j <= h; j ++)
            if (!visited[i][j]) {
                int diag;
                int cd = zdist(i, j, x, y, &diag);
                if (cd < d) {
                    d = cd;
                };
            };
    return d;
};
 
int main(void) {
    int posx, posy;
    int minx, maxx, miny, maxy;
    int origx = 0, origy = 0;
    int w, h;
    int i, j;
    scanf("%d %d %d %d", &h, &w, &posx, &posy);
    posx -= 1; posy -= 1;
    w -= 1; h -= 1;
    minx = miny = 0;
    maxx = w; maxy = h;
    for (i = 0; i <= w; i ++)
        for (j = 0; j <= h; j ++)
            visited[i][j] = 0;
    while (1) {
        int dx, dy;
        int dist = INT_MAX;
        int mindx = 0, mindy = 0;
        int res;
        for (dx = -1; dx <= 1; dx ++)
            for (dy = -1; dy <= 1; dy ++) {
                if ((posx + dx > maxx) || (posx + dx < minx) ||
                        (posy + dy > maxy) || (posy + dy < miny))
                    continue;
                int d = mindist(minx - origx, miny - origy,
                        maxx - origx, maxy - origy,
                        posx + dx - origx, posy + dy - origy);
                if (d < dist) {
                    dist = d;
                    mindx = dx;
                    mindy = dy;
                };
            };
	assert(dist != INT_MAX);
        posx += mindx;
        posy += mindy;
        res = (!visited[posx - origx][posy - origy]) ? 1 : 0;
        visited[posx - origx][posy - origy] = 1;
        printf("%d %d %d\n", mindx, mindy, res);
        fflush(stdout);
        scanf("%d %d %d", &res, &dx, &dy);
        if (res)
            break;
        minx += dx; if (minx < 0) minx = 0;
        miny += dy; if (miny < 0) miny = 0;
        maxx += dx; if (maxx > w) maxx = w;
        maxy += dy; if (maxy > h) maxy = h;
        origx += dx; origy += dy;
    };
    return 0;
};
