#include <stdio.h>
#include <stdint.h>
#include <memory.h>

#define MAXN 15

typedef int (*test)(int, int*, int); 

int generate_all(int n, int prereq[n], test func, int arg) {
	int16_t _masks[n + 1], * masks = &_masks[1];
	int seq[n], cur[n];
	int fill = 0;
	int k;
	int res = 0;
	masks[-1] = 0;
	memset(cur, 0, sizeof(cur));
	while (fill >= 0) {
		if (fill == n) {
			res += func(n, seq, arg);
			fill -= 1;
		};
		masks[fill] = masks[fill - 1];
		for (k = cur[fill]; k < n; k ++) {
			int pmask = (1 << prereq[k]);
			if (!(masks[fill] & (1<<k)) && ((masks[fill] & pmask) == pmask))
				break;
		};
		if (k == n) {
			cur[fill] = 0;
			fill -= 1;
		} else {
			masks[fill] |= (1 << k);
			seq[fill] = k;
			cur[fill] = k + 1;
			fill += 1;
		};
	};
	return res;
};

int testmax(int n, int seq[n], int size) {
	int demonic[n];
	int i, j;
	demonic[0] = 1;
	for (i = 1; i < n; i ++) {
		demonic[i] = 0;
		for (j = 0; j < i; j ++)
			if ((seq[j] < seq[i]) && (demonic[j] > demonic[i]))
				       demonic[i] = demonic[j];
		demonic[i] += 1;
		if (demonic[i] > size)
			return 0;
	};
	return 1;
};

int main(void) {
	int prereq[MAXN];
	int i, k, p, q;
	int n;
	FILE * in, * out;
	in = fopen("army.in", "r");
	fscanf(in, "%d", &n);
	memset(prereq, -1, n * sizeof(int));
	fscanf(in, "%d", &k);
	p = -1;
	for (i = 0; i < k; i ++) {
		fscanf(in, "%d", &q);
		q -= 1;
		prereq[q] = p;
		p = q;
	};
	fclose(in);
	out = fopen("army.out", "w");
	fprintf(out, "%d\n", generate_all(n, prereq, testmax, k));
	fclose(out);
	return 0;
};
