#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

typedef long long int ll;

const int N = 100000;
int n;
vector<vector<int> > tree1 (N), tree2 (N);

int used1 [N];
int timeIn1 [N], timeOut1 [N];
int timer = 0;
void DFS1 (int vertex)
{
	timer++;
	timeIn1 [vertex] = timer;
	used1 [vertex] = 1;

	for (int i = 0; i < (int)tree1[vertex].size(); i++)
	{
		int to = tree1[vertex][i];
		if (!used1[to])
			DFS1(to);
	}

	timer++;
	timeOut1 [vertex] = timer;
}

bool isParent1 (int v1, int v2)
{
	return timeIn1 [v1] < timeIn1 [v2] && timeOut1 [v1] > timeOut1 [v2];
}

int used2 [N];
int timeIn2 [N], timeOut2 [N];
void DFS2 (int vertex)
{
	used2 [vertex] = 1;
	timer++;
	timeIn2 [vertex] = timer;

	for (int i = 0; i < (int)tree2 [vertex].size(); i++)
	{
		int to = tree2 [vertex][i];

		if (!used2 [to])
			DFS2 (to);
	}

	timer++;
	timeOut2 [vertex] = timer;
}

bool isParent2 (int v1, int v2)
{
	return timeIn2 [v1] < timeIn2 [v2] && timeOut2 [v1] > timeOut2 [v2];
}

int main ()
{
	freopen("virus.in", "r", stdin); freopen("virus.out", "w", stdout);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	scanf("%d", &n);
	int boss1;
	for (int i = 1; i <= n; i++)
	{
		int pred;
		scanf("%d", &pred);
		if (pred != 0)
			tree1 [pred].push_back(i);
		else
			boss1 = i;
	}

	int boss2;
	for (int i = 1; i <= n; i++)
	{
		int pred;
		scanf("%d", &pred);
		if (pred != 0)
			tree2 [pred].push_back(i);
		else
			boss2 = i;
	}

	DFS1 (boss1);
	DFS2 (boss2);

	ll ans = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			if (i == j)
				continue;

			if (isParent1 (i, j) && isParent2 (i, j))
				ans++;
		}
	}

	cout << ans;

	return 0;
}