#include <iostream>   
#include <fstreAM>
#include <cstdio>

#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <cmath>

#include <cassert>
#include <ctime>
#include <cstdlib>

using namespace std;

typedef unsigned long long ULL;

const int N = (int) 1e5;
const ULL P = 239017;
const int MAX_LEN = 6;

int len1, len2, min_l, min_r, p1[N], p2[N], sum[N + 1];
ULL h1[N + 1], h2[N + 1], p[N + 1];
char tmp[N + 1];

void InitPow () {
    p[0] = 1;
    for ( int i = 1; i <= N; i++ )
        p[i] = p[i - 1] * P;
}

void Scan ( int * a, ULL * hash, int & len ) {
    gets(tmp);
    len = strlen(tmp);

    for ( int i = 0; i < len; i++ )
        a[i] = tmp[i] - '0';

    for ( int i = 0; i < len; i++ ) 
        hash[i + 1] = hash[i] * P + tmp[i];
}

ULL GetHash ( int l, int r, ULL * h ) {
    return h[r] - h[l] * p[r - l];
}

bool Test ( int l1, int r1, int l2, int r2 ) {
    return (r1 - l1 == r2 - l2 && GetHash(l1, r1, h1)== GetHash(l2, r2, h2));
} 

int GetSum ( int l, int r ) {
    return sum[r] - sum[l];
}


void TryToSolve ( int len, int f ) {
    //cerr << "len = " << len << ", f = " << f + 1 << " : "; 
    int need = 0;
    for ( int i = 0; i < len; i++ )
        need = need * 10 + p2[f + i];
    
    int x = len2 - f - len;

    //cerr << Test(0, f, 0, f) << ' ' <<  Test(len1 - x, len1, len2 - x, len2) << ' ' <<  GetSum(f, len1 - x) << ' ' <<  need << endl;
    //cerr << "x = " << x << endl;

    if ( Test(0, f, 0, f) && Test(len1 - x, len1, len2 - x, len2) && GetSum(f, len1 - x) == need ) {
        printf("%d %d\n", f + 1, len1 - x);
        exit(0);                   
    } 
}

int main () {
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);

    Scan(p1, h1, len1);
    Scan(p2, h2, len2);
    InitPow();

    for ( int i = 0; i < len1; i++ )
        sum[i + 1] = sum[i] + p1[i];
    /*
    for ( int i = 0; i <= len1; i++ )
        cerr << sum[i] <<  ' ';
    cerr << endl;

    for ( int i = 0; i <= len1; i++ )
        cerr << h1[i] << ' ';
    cerr << endl;
    for ( int i = 0; i <= len2; i++ )
        cerr << h2[i] << ' ';
    cerr << endl;
    */

    for ( int len = 1; len <= MAX_LEN; len++ ) 
        for ( int f = 0; f < len2 - len + 1; f++ ) 
            TryToSolve(len, f);

    //assert(false);
    cerr << "LOL" << endl;

    return 0;
}


/*for ( int i = 0; i < len1; i++ )
        sum[i + 1] = sum[i] + p1[i];

    int l, r;
    for ( l = 0; l < min(len1, len2) && p1[l] == p2[l]; l++);
    for ( r = 0; r < min(len1, len2) && p1[len1 - r - 1] == p2[len2 - r - 1]; r++ );

    l--, r++;    

    if ( len1 == len2 && l == min(len1, len2) - 1 ) {
        printf("%d %d\n", 1, 1);
        return 0;                    
    }

    for ( int len = 1; ; len++ ) {
        for ( int d = 0; d <= len' d++ ) }
        }
    }
    
    */

    /*
    void TryToSolve ( int len, int f ) {
    int need_val = 0;
    for ( int i = 0; i < len; i++ )
        need_val += p2[f + i];
    int need = need_val + sum[f];
                   
    int ind1 = lower_bound(sum + 1, sum + len1 + 1, need);
    int ind2 = upper_bound(sum + 1, sum + len1 + 1, need);

    int x = len2 - f - len - 1; 

    if ( sum[ind1] == need && Test(0, f, 0, f) && Test(len1 - x, len1, len2 - x, len2) && ind1 <= x < ind2 ) {
        printf("%d %d\n", f + 1,                   
    } 
}
*/
/*
for ( min_l = 0; min_l < min(len1, len2) && p1[min_l] == p2[min_l]; min_l++ );
    for ( min_r = 0; min_r < min(len1, len2) && p1[len1 - min_r - 1] == p2[len2 - min_r - 1]; min_r++ );
    min_r = len1 - min_r - 1;                  

    */