#include <iostream>   
#include <fstreAM>
#include <cstdio>

#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <cmath>

#include <cassert>
#include <ctime>
#include <cstdlib>

using namespace std;

typedef long long LL;

const int N = (int) 1e5;

struct node {
    int in1, out1, in2, out2;    
};

int n, t, root1, root2;
LL dp[N];
vector <int> g1[N], g2[N];
node res[N];

void TopSort1 ( int v ) {
    cerr << "!";
    res[v].in1 = t++;

    for ( int i = 0; i < g1[v].size(); i++ ) 
        TopSort1(g1[v][i]);

    res[v].out1 = t++;
}

void TopSort2 ( int v ) {
    res[v].in2 = t++;

    for ( int i = 0; i < g2[v].size(); i++ ) 
        TopSort2(g2[v][i]);

    res[v].out2 = t++;
}

bool Test ( int v, int u ) {
    cerr << v + 1 << ' ' << u + 1 << ' ' << (res[v].in1 < res[u].in1 && res[v].out1 > res[u].out1 && 
            res[v].in2 < res[u].in2 && res[v].out2 > res[u].out2) << endl;

    return (res[v].in1 < res[u].in1 && res[v].out1 > res[u].out1 && 
            res[v].in2 < res[u].in2 && res[v].out2 > res[u].out2);                   
}

void SolveTask ( int v ) {
    dp[v] = 0;

    for ( int i = 0; i < g1[v].size(); i++ ) {
        int next = g1[v][i];
        SolveTask(next);

        if ( Test(v, next) )
            dp[v] += dp[next] + 1; 
    }
} 

int main () {
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);
    for ( int i = 0; i < n; i++ ) {
        int p;
        scanf("%d", &p);

        if ( p == 0 )
            root1 = i;
        else    
            g1[p - 1].push_back(i);
    }
    for ( int i = 0; i < n; i++ ) {
        int p;
        scanf("%d", &p);

        if ( p == 0 )
            root2 = i;
        else    
            g2[p - 1].push_back(i);
    }

    TopSort1(root1);
    t = 0;
    TopSort2(root2);

    //SolveTask(root1);

    LL ans = 0;
    for ( int i = 0; i < n; i++ )
        for ( int j = i + 1; j < n; j++ )
            if ( Test(i, j) || Test(j, i) )
                ans++;

    cout << ans << endl;        

    return 0;
}

