#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <utility>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

struct rect {
    int w, h;
};

struct event {
    int pos, num, t;

    event ( int pos, int num, int t ) {
        event :: pos = pos;
        event :: num = num;
        event :: t = t;
    }

    event ( int pos, int num ) {
        event :: pos = pos;
        event :: num = num;
    }
};

bool comp ( event a, event b ) {
    return (a.pos < b.pos);
}

const int N = (int) 1e5;

int n, k, L[N], R[N];
rect rt[N];
bool cur[N];
pair <int, int> ans[N];
vector <event> l, r;
 
bool Test ( int a, int b ) {
    return (rt[a].w == rt[b].w || rt[a].h == rt[b].h);
}

int main () {
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for ( int i = 0; i < n; i++ ) 
        scanf("%d%d", &rt[i].w, &rt[i].h);

    scanf("%d", &k);
    for ( int i = 0; i < k; i++ ) {
        scanf("%d%d", L + i, R + i);
        L[i]--;
    
        l.push_back(event(L[i], i));
        r.push_back(event(R[i], i));
    }

    sort(l.begin(), l.end(), comp);
    sort(r.begin(), r.end(), comp);

    for ( int i = 0, l_pos = 0, r_pos = 0; i < n; i++ ) {
        while ( l_pos < l.size() && l[l_pos].pos == i ) {
            cur[l[l_pos].num] = true;
            l_pos++;
        }
        while ( r_pos < r.size() && r[r_pos].pos == i ) {
            cur[r[r_pos].num] = false;
            r_pos++;
        }

        for ( int j = 0; j < i; j++ )
            if ( !Test(j, i) ) {
                for ( int m = 0; m < k; m++ )
                    if ( cur[m] && L[m] <= j ) {
                        ans[m] = make_pair(j + 1, i + 1); 
                    }
                break;
            }
    }

    for ( int i = 0; i < k; i++ )
        printf("%d %d\n", ans[i].first, ans[i].second);

    return 0;
}