#include <iostream>
#include <cstdio>

#include <vector>
#include <queue>
#include <string>
#include <cstring>
#include <algorithm>
#include <utility>
#include <set>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

struct rect {
    int w, h;
};

bool operator == ( rect a, rect b ) {
    return(a.w == b.w && a.h == b.h);
}

struct event {
    int pos, num, t;

    event ( int pos, int num, int t ) {
        event :: pos = pos;
        event :: num = num;
        event :: t = t;
    }
};

struct node {
    int w, h, l, r;

    node ( rect rt, int l, int r ) {
        w = rt.w;
        h = rt.h;
        node :: l = l;
        node :: r = r;
    }            
};

struct set_node {
    int l, num;

    set_node () { }
    set_node ( int l, int num ) {
        set_node :: l = l;
        set_node :: num = num;
    }
};

bool operator < ( set_node a, set_node b ) {
    return (a.l < b.l || a.l == b.l && a.num < b.num);
}

bool comp ( event a, event b ) {
    return (a.pos < b.pos);
}

const int N = (int) 1e5;

int n, k, L[N], R[N];
rect rt[N]; 
vector <node> v;
vector <int> col;
vector <event> e;
set <set_node> s;

pair <int, int> ans[N];

int GetType ( node a, node b ) {
    if ( a.w == b.w )
        return 1;
    else if ( a.h == b.h )
        return 2;
    else 
        return 3;
}

inline void MakeAns ( int f, int sec ) {
    while ( s.size() && (*s.begin()).l <= f ) {
        set<set_node> :: iterator cur = s.begin();
        ans[cur->num] = make_pair(f + 1, sec + 1);
        s.erase(cur);
    }
}

int main () {
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for ( int i = 0; i < n; i++ ) 
        scanf("%d%d", &rt[i].w, &rt[i].h);

    for ( int i = 0, j = 0; i < n; i = j ) {
        while ( j < n && rt[i] == rt[j] )
            j++;
        v.push_back(node(rt[i], i, j));
    }

    scanf("%d", &k);
    for ( int i = 0; i < k; i++ ) {
        scanf("%d%d", L + i, R + i);
        L[i]--;
    
        e.push_back(event(L[i], i, 1));
        e.push_back(event(R[i], i, -1)); 
    }

    sort(e.begin(), e.end(), comp);

    int type = 0, last = 0;
    for ( int i = 0, v_pos = 0, e_pos = 0; i < n; i++ ) {
        while ( e_pos < e.size() && e[e_pos].pos == i ) {
            event cur = e[e_pos];
            e_pos++;

            if ( cur.t == 1 ) 
                s.insert(set_node(i, cur.num));
            else {
                set <set_node> :: iterator iter = s.find(set_node(L[cur.num], cur.num));
                if ( iter != s.end() ) {
                    s.erase(iter);
                }
            }
        }

        if ( v_pos < v.size() && v[v_pos].r == i ) {
            int t = GetType(v[v_pos], v[v_pos + 1]);

            if ( t == 3 ) {
                MakeAns(i - 1, i);
                type = 0;
            }
            else if ( type == 0 || t == 1 ) {
                type = t;
                last = i - 1;
            }
            else {
                MakeAns(last, i);
                last = i - 1;                
            }
            
            v_pos++;
        }
    }

    for ( int i = 0; i < k; i++ )
        printf("%d %d\n", ans[i].first, ans[i].second);

    return 0;
}