#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <bitset>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

typedef unsigned long long ULL;

const int N = (int) 1e2;
const ULL P = 239017;

struct node {
    int c;
    int num;

    node () { }
    node ( int c, int num ) {
        node :: c = c;
        node :: num = num;
    }
};

bool comp ( node a, node b ) {
    return (a.c < b.c);
}

int n, m, c, color[N], cnt[N], ans[N];
node have[N];

void MakeAns ( int col, int num ) {
    for ( int i = 0; i < n; i++ )
        if ( color[i] == col && !ans[i] ) {
            ans[i] = num + 1;
        }     
}

int main () {
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d%d", &n, &m);

    cnt[0] = n;
    
    for ( int i = 0; i < m; i++ ) {
        int m_cnt;
        scanf("%d", &m_cnt);
    
        for ( int j = 0; j < m_cnt; j++ ) {
            int num;
            scanf("%d", &num);
            
            have[j] = node(color[num - 1], num - 1);
        }

        sort(have, have + m_cnt, comp);

        for ( int j = 0, k = 0; j < m_cnt; j = k ) { 
            while ( k < m_cnt && have[j].c == have[k].c )
                k++;

            int last = have[j].c, next = ++c;

            for ( int l = j; l < k; l++ )
                color[have[l].num] = next;

            cnt[last] -= k - j;
            cnt[next] = k - j;

            if ( cnt[last] == 1 )
                MakeAns(last, i);
            if ( cnt[next] == 1 )
                MakeAns(next, i);
        }             
        
        /*
        for ( int i = 0; i < n; i++ )
            cerr << color[i] << ' ';           
        cerr << endl;
        for ( int i = 0; i <= c; i++ )
            cerr << cnt[i] << ' ';
        cerr << endl << endl;               
        */
    }

    for ( int i = 0; i < n; i++ )
        cout << ans[i] << ' ';

    return 0;
}