#include <stdio.h>
#include <stdlib.h>

char **table;
int N, M;

int method1() {
	int i, j, src_pos;

	for (i = 0; i < N; i++)
		if (table[i][M - 1] != '*')
			break;
	src_pos = i;
	if (src_pos == N)
		return 0;
	for (i = src_pos - 1; i != -1; i--) {
		table[i][M - 1] = table[i + 1][M - 1] - 1;
		if (table[i][M - 1] < '0')
			table[i][M - 1] = '9';
	}
	for (i = src_pos + 1; i < N; i++) {
		table[i][M - 1] = table[i - 1][M - 1] + 1;
		if (table[i][M - 1] > '9')
			table[i][M - 1] = '0';
	}
	for (j = M - 2; j != -1; j--) {
		for (i = 0; i < N; i++)
			if (table[i][j] != '*')
				break;
		src_pos = i;
		if (src_pos == N)
			return 0;
		for (i = src_pos - 1; i != -1; i--) {
			table[i][j] = table[i + 1][j];
			if (table[i][j + 1] == '9' && table[i + 1][j + 1] == '0')
				table[i][j]--;
			if (table[i][j] < '0')
				table[i][j] = '9';
		}
		for (i = src_pos + 1; i < N; i++) {
			table[i][j] = table[i - 1][j];
			if (table[i][j + 1] == '0' && table[i - 1][j + 1] == '9')
				table[i][j]++;
			if (table[i][j] > '9')
				table[i][j] = '0';
		}
	}
	return 1;
}

int method2() {
	int i, j, found = 0, pos_i, pos_j;

	for (j = 0; j < M; j++) {
		for (i = 0; i < N - 1; i++) {
			if (table[i][j] != table[i + 1][j] && table[i][j] != '*' && table[i + 1][j] != '*') {
				found = 1;
				pos_i = i;
				pos_j = j;
				break;
			}
		}
		if (found)
			break;
	}
	if (!found)
		return 0;

	for (j = pos_j + 1; j < M; j++) {
		table[pos_i][j] = '9';
		table[pos_i + 1][j] = '0';
	}

	return method1();
}

int pow10(int x) {
	int res = 1, i;

	for (i = 0; i < x && res < 100001; i++)
		res *= 10;
	return res;
}

void method3() {
	int i, j, value;

	for (j = M - 2; j != -1; j--) {
		if (table[0][j] != '*')
			continue;
		for (i = 0; i < N; i++)
			if (table[i][j] != '*')
				break;
		if (i == N)
			continue;
		value = table[i][j] - '0';
		table[0][j] = (value + N * 10 - i / pow10(M - 1 - j)) % 10 + '0';
	}
}

void method4() {
	int i;

	for (i = 0; i < M; i++)
		if (table[0][i] == '*')
			table[0][i] = '0';
}

int main() {
	int i, ready = 0;
	
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	scanf("%d %d\n", &N, &M);
	table = (char **) malloc(N * sizeof (char *));
	for (i = 0; i < N; i++) {
		table[i] = (char *) malloc((M + 1) * sizeof (char));
		gets(table[i]);
	}
	
	// Full methods
	ready = method1();
	if (!ready)
		ready = method2();

	// Non-full methods
	if (!ready) {
		method3();
		method4();
	}

	puts(table[0]);
	return 0;
}