program task3;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  inf = 1000000000000000000;
  shift = 4096;

type
  tarr = array [0..4096] of int64;
  tarr1 = array [0..2 * shift] of int64;

var
  n, i: integer;
  r, u: int64;
  d: tarr;
  tree: tarr1;

procedure InitTree;
var
  i: integer;
begin
  for i := 1 to 2 * shift do
    tree[i] := inf;
end;

function GetMin(l, r: integer): int64;
begin
  inc(l);
  inc(r);
  inc(l, shift - 1);
  inc(r, shift - 1);
  Result := inf;
  while l <= r do begin
    if l mod 2 = 1 then begin
      Result := min(Result, tree[l]);
      inc(l);
    end;
    if r mod 2 = 0 then begin
      Result := min(Result, tree[r]);
      dec(r);
    end;
    if l > r then break;
    l := l div 2;
    r := r div 2;
  end;
end;

procedure Modify(i: integer; const x: integer);
begin
  inc(i);
  inc(i, shift - 1);
  tree[i] := x;
  while i > 1 do begin
    i := i div 2;
    tree[i] := min(tree[2 * i], tree[2 * i + 1]);
  end;
end;

function f(const x: integer): int64;
var
  a: integer;
begin
  if d[x] <> -1 then begin
    Result := d[x];
    Result := min(Result, GetMin(x + 1, n));
    exit;
  end;
  Result := max(f(1) + u, f(x - 2) + r);
  for a := 2 to x div 2 do
    Result := min(Result, max(f(a) + u, f(x - 2 * a) + r));
  if x mod 2 = 0 then
    Result := min(Result, f(x div 2) + u);
  d[x] := Result;
  Modify(x, Result);
end;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');
  read(n, r, u);
  if n > 4000 then
    halt(0);
  for i := 0 to 4000 do
    d[i] := -1;
  d[0] := 0;
  d[1] := 0;
  InitTree;
  Modify(0, 0);
  Modify(1, 0);
  writeln(f(n));
  {for i := 1 to n do
    write(i:8);
  writeln;
  for i := 1 to n do
    write(d[i]:8);}
end.
 