program task5;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..5000] of integer;
  tarr1 = array [1..5000, 1..5000] of word;

var
  n, i, k, l, r: integer;
  a, b, a1, b1: tarr;
  cnta, cntb: tarr;
  cntab, u, v: tarr1;

procedure swap(var a, b: integer);
var
  c: integer;
begin
  c := a;
  a := b;
  b := c;
end;

procedure QSort(var a: tarr; const l, r: integer);
var
  tl, tr, b, v: integer;
begin
  if l >= r then
    exit;
  tl := l;
  tr := r;
  v := random(r - l + 1) + l;
  b := a[v];
  while tl <= tr do begin
    while a[tl] < b do
      inc(tl);
    while b < a[tr] do
      dec(tr);
    if tl <= tr then begin
      swap(a[tl], a[tr]);
      inc(tl);
      dec(tr);
    end;
  end;
  QSort(a, l, tr);
  QSort(a, tl, r);
end;

function BinSearch(const a: tarr; const x: integer): integer;
var
  l, r, m: integer;
begin
  l := 1;
  r := n;
  while r - l > 1 do begin
    m := (l + r) div 2;
    if a[m] < x then
      l := m + 1
    else
      r := m;
  end;
  if a[l] = x then
    Result := l
  else
    Result := r;
end;

procedure FillCnt(const l, r: integer);
var
  i: integer;
begin
  for i := l to r do begin
    cnta[a[i]] := 0;
    cntb[b[i]] := 0;
    cntab[a[i], b[i]] := 0;
  end;
  for i := l to r do begin
    inc(cnta[a[i]]);
    inc(cntb[b[i]]);
    inc(cntab[a[i], b[i]]);
  end;
end;

procedure GetIndices(const l, r: integer; out u, v: word);
var
  i: integer;
begin
  u := 0;
  v := 0;
  for i := l to r do
    if u = 0 then begin
      if cnta[a[i]] + cntb[b[i]] - cntab[a[i], b[i]] <> r - l + 1 then
        u := i;
    end else begin
      if (a[u] <> a[i]) and (b[u] <> b[i]) then begin
        v := i;
        exit;
      end;
    end;
  if v = 0 then
    u := 0;
  if u = 0 then begin
    u := 65535;
    v := 65535;
  end;
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  randomize;
  readln(n);
  for i := 1 to n do
    readln(a[i], b[i]);
  a1 := a;
  b1 := b;
  QSort(a1, 1, n);
  QSort(b1, 1, n);
  for i := 1 to n do begin
    a[i] := BinSearch(a1, a[i]);
    b[i] := BinSearch(b1, b[i]);
  end;
  fillchar(u, sizeof(u), 0);
  readln(k);
  for i := 1 to k do begin
    readln(l, r);
    FillCnt(l, r);
    if u[l, r] = 0 then
      GetIndices(l, r, u[l, r], v[l, r]);
    if u[l, r] = 65535 then
      writeln('0 0')
    else
      writeln(u[l, r], ' ', v[l, r]);
  end;
end.
