#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define m_p make_pair
#define fi first
#define se second

const int maxn = 1e5 + 5, INF = 1e9;

int x[maxn], y[maxn];
vector<pair<int, int> > ans;
int n;

struct node
{
   int l, r, mn, mni, mx, mxi;
   node *L, *R;
   node(int ll, int rr)
   {
      if(ll == rr)
      {
         l = r = ll;
      }
      else
      {
         l = ll;
         r = rr;
         mn = INF; mx = -1;
         L = new node(ll, (ll + rr) / 2);
         R = new node((ll + rr) / 2 + 1, rr);
      }
   }
   int ADD(int y, int x)
   {
      if(l > x || r < x)
         return 0;
      if(l == x && r == x)
      {
         mn = mx = y;
         mni = mxi = x;
         return 0;
      }
      L -> ADD(y, x);
      R -> ADD(y, x);
      if(L -> mn < R -> mn){
         mn = L -> mn;
         mni = L -> mni;
      } else {
         mn = R -> mn;
         mni = R -> mni;
      }
      if(L -> mx > R -> mx) {
         mx = L -> mx;
         mxi = L -> mxi;
      } else {
         mx = R -> mx;
         mxi = R -> mxi;
      }
   }
   pair<int, int> MX(int ll, int rr)
   {
      if(r < ll || l > rr)
         return m_p(-1, 0);
      if(r <= rr && l >= ll)
         return m_p(mx, mxi);
      return max(L -> MX(ll, rr), R -> MX(ll, rr));
   }
   pair<int, int> MN(int ll, int rr)
   {
      if(r < ll || l > rr)
         return m_p(INF, 0);
      if(r <= rr && l >= ll)
         return m_p(mn, mni);
      return min(L -> MN(ll, rr), R -> MN(ll, rr));
   }
};

node nd0(0, maxn), nd1(0, maxn);

int main()
{
   ifstream cin("mosaic.in");
   ofstream cout("mosaic.out");
   cin >> n;
   for(int i = 0, a, b; i < n; i++)
   {
      cin >> a >> b;
      x[i] = a; y[i] = b;
      nd0.ADD(a, i); nd1.ADD(b, i);
   }
   int k;
   cin >> k;
   for(int i = 0; i < k; i++)
   {
      int x, y;
      cin >> x >> y;
      x--; y--;
      pair<int, int> a, b, c, d;
      a = nd0.MN(x, y);
      b = nd0.MX(x, y);
      c = nd1.MN(x, y);
      d = nd1.MX(x, y);
      if(a.fi == b.fi || x[a.se] == x[b.se] || y[c.se] == y[d.se] || c.fi == d.fi)
         ans.push_back(m_p(0, 0));
      else
         ans.push_back(m_p(d.se + 1, a.se + 1));
   }
   for(int i = 0; i < k; i++)
      cout << ans[i].fi << " " << ans[i].se << endl;
   return 0;
}
