
#include <stdio.h>
#include <tchar.h>
#include <math.h>
#include <string.h>
#include <vector>
using namespace std;

int* cfl; 
int* cfr;
bool isMax;

struct CONode
{
	int lb, rb;
	CONode* l, *r;
	int v;
	int cmax;
	int maxi;
	
	void makeL()
	{
		int c = (lb + rb) >> 1;
		l = new CONode();
		l->lb = lb;
		l->rb = c;
	}
	void makeR()
	{
		int c = (lb + rb) >> 1;
		r = new CONode();
		r->lb = c+1;
		r->rb = rb;
	}

	void insert(int ik, int iv)
	{
		if ( (ik < lb) || (ik > rb) ) return;
		if (lb == rb)
		{
			if (iv > cmax) 
			{
				cmax = iv;
				maxi = ik;
			}
			return;
		}
		int c = (lb + rb) / 2;
		if (ik > c)
		{
			if (!r) makeR();
			r->insert(ik, iv);
		} else {
			if (!l) makeL();
			l->insert(ik, iv);
		}
		if (iv > cmax) 
		{
			cmax = iv;
			maxi = ik;
		}
	}

	int getMax(int gl, int gr, int& out_i)
	{
		if ( (gl <= lb) && (gr >= rb) )
		{
			out_i = maxi;
			return cmax;
		} else {
			int c = (lb + rb) >> 1;
			int a = -99;
			if (gr > c && (r != NULL))
			{
				a = r->getMax(gl, gr, out_i);
			} 
			if (gl <= c && (l != NULL))
			{
				int c;
				int b = l->getMax(gl, gr, c);
				if (b > a)
				{
					a = b;
					out_i = c;
				}
			}
			return a;
		}
	}

	CONode()
	{
		l = NULL; r = NULL; cmax = -99;
	}
};

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	int n;
	scanf("%d", &n);
	cfl = new int[n]; cfr = new int[n];
	int * cx = new int[n]; int * cy = new int[n];
	
	int repX = 1;	int prevX = -1;
	int repY = 1;	int prevY = -1;
	for (int i = 0; i < n; i++)
	{
		int x,y;
		scanf("%d%d", &x, &y);
		cx[i] = x; cy[i] = y;
		if (i == 0)
		{
			cfl[i] = -1;
			prevX = x; prevY = y; continue;
		}
		if ((prevX != x) && (prevY != y))
		{
			cfl[i] = i - 1;
		} else {
			int j;
			for (j = i - 1; j >= 0; j--)
			{
				if ( (cx[j] != x) && (cy[j] != y))
				{
					break;
				}
			}
			cfl[i] = j;
		}
		prevX = x; prevY = y; 
	}
	
	for (int i = n-1; i >= 0; i--)
	{
		int x = cx[i]; int y = cy[i];
		if (i == n-1)
		{
			cfr[i] = n;
			prevX = x; prevY = y; continue;
		}
		if ((prevX != x) && (prevY != y))
		{
			cfr[i] = i + 1;
		} else {
			int j;
			for (j = i + 1; j < n; j++)
			{
				if ( (cx[j] != x) && (cy[j] != y))
				{
					break;
				}
			}
			cfr[i] = j;
		}
	}

	delete cx; delete cy;

	CONode* tL = new CONode();
	tL->lb = 0; tL->rb = n-1;
	CONode* tR = new CONode();
	tR->lb = 0; tR->rb = n-1;

	for (int i = 0; i < n; i++)
	{
		tL->insert(i, cfl[i]);
		tR->insert(i, n - cfr[i]);
	}

	int k;
	scanf("%d", &k);

	for (int i = 0; i < k ; i++)
	{
		int k1, k2;
		scanf("%d%d", &k1, &k2);
		int ili, iri;
		int il = tL->getMax(k1-1, k2-1, ili) + 1;
		int ir = tR->getMax(k1-1, k2-1, iri) + n + 1;
		if (il >= k1) 
		{
			printf("%d %d\n", ili+1, il);
		} else if (ir <= k2)
		{
			printf("%d %d\n", iri+1, ir);
		} else {
			printf("0 0\n");
		}
	}

	fclose(stdin); fclose(stdout);
	return 0;
}

