#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
const int maxn = 100009;

struct RMQ
{
	int count;
	vector< map<int, int> > vs, hs;
	vector< map< pair<int, int>, int > > ps;

	RMQ(int c)
	{
		count = c;
		vs.resize(4 * c);
		hs.resize(4 * c);
		ps.resize(4 * c);
	}

	void insert(int index, int v, int h)
	{ insert(index, v, h, 1, 0, count); }

	void insert(int index, int v, int h, int ind, int l, int r)
	{
		if (index < l || index >= r) return;
		if (r - l >= 2)
		{
			insert(index, v, h, ind * 2 + 0, l, (l + r) / 2);
			insert(index, v, h, ind * 2 + 1, (l + r) / 2, r);
		}
		if (vs[ind].count(v) == 0) vs[ind][v] = 1;
		else vs[ind][v]++;

		if (hs[ind].count(h) == 0) hs[ind][h] = 1;
		else hs[ind][h]++;

		pair<int, int> pvh = make_pair(v, h);
		if (ps[ind].count(pvh) == 0) ps[ind][pvh] = 1;
		else ps[ind][pvh]++;
	}

	int rightest(int rl, int rr, int v, int h)
	{ return rightest(rl, rr, v, h, 1, 0, count); }

	int rightest(int rl, int rr, int v, int h, int ind, int l, int r)
	{
		if (r <= rl || rr <= l) return -100;
		if (l + 1 == r)
		{
			if (vs[ind].count(v) > 0) return -100;
			if (hs[ind].count(h) > 0) return -100;
			return l;
		}
		// Base checking: if all pieces are good -> return -100
		int good = 0;
			
		if (vs[ind].count(v) != 0) good += vs[ind][v];
		if (hs[ind].count(h) != 0) good += hs[ind][h];
		pair<int, int> pvh = make_pair(v, h);
		if (ps[ind].count(pvh) != 0) good -= ps[ind][pvh];

		if (good >= r - l) return -100;
		// Base Checking end

		int r1 = rightest(rl, rr, v, h, ind * 2 + 1, (l + r) / 2, r);
		if (r1 >= 0) return r1;
		return rightest(rl, rr, v, h, ind * 2 + 0, l, (l + r) / 2);
	}
};

int n, k;
//int vs[maxn], hs[maxn];
int rl, rr;
int cv, ch;

int bpr[maxn]; // Best Pair Right
int crs[maxn]; // Current RighteSt

int main()
{
	for (int i = 0; i < maxn; i++)
		crs[i] = -1;
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	cin >> n;
	RMQ rmq(n);

	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &cv, &ch);
		rmq.insert(i, cv, ch);
		if (i == 0) { bpr[i] = 0, crs[i] = -1; continue; }

		//int cl = crs[ bpr[i - 1] ] + 1;
		int mayber = rmq.rightest(0, i, cv, ch);
		crs[i] = mayber;

		if (mayber > crs[ bpr[i - 1] ]) bpr[i] = i;
		else bpr[i] = bpr[i - 1];
	}
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		scanf("%d%d", &rl, &rr);
		rl--, rr--;
		int cBp = bpr[rr];
		int cLeft = crs[cBp];

		if (cLeft >= rl) printf("%d %d\n", cLeft + 1, cBp + 1);
		else printf("0 0\n");
	}

	return 0;
}