#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <stdlib.h>
using namespace std;
const int maxs = 32;

int n, m;
bool cb[maxs][maxs];
int ex, ey;

bool requested;

pair<int, int> qs[maxs * maxs];
int ql, qr;
bool used[maxs][maxs];

inline int dist(int x1, int y1, int x2, int y2)
{ return abs(x1 - x2) + abs(y1 - y2); }

inline void makeStep()
{
	bool found = false;
	int yy, xx;

	ql = qr = 0;
	qs[qr++] = make_pair(ex, ey);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			used[j][i] = false;

	while (ql < qr)
	{
		pair<int, int> cp = qs[ql++];
		xx = cp.first;
		yy = cp.second;
		if (cb[xx][yy]) break;

		for (int i = -1; i <= 1; i++)
			for (int j = -1; j <= 1; j++)
			{
				int npx = xx + j;
				int npy = yy + i;
				if (npx < 0 || m <= npx) continue;
				if (npy < 0 || n <= npy) continue;
				if (used[npx][npy]) continue;
				used[npx][npy] = true;
				qs[qr++] = make_pair(npx, npy);
			}
	}

	int dx, dy;
	if (xx < ex) dx = -1;
	else if (xx > ex) dx = 1;
	else dx = 0;
	ex += dx;

	if (yy < ey) dy = -1;
	else if (yy > ey) dy = 1;
	else dy = 0;
	ey += dy;

	printf("%d %d ", dx, dy);
	requested = ex == xx && ey == yy;
	if (requested) puts("1");
	else puts("0");

	fflush(stdout);
}

void getAnswer()
{
	int ans, dx, dy;
	scanf("%d%d%d", &ans, &dx, &dy);
	if (ans == 1) exit(0);
	if (requested) cb[ex][ey] = false;

	if (dx == 1)
		for (int yy = 0; yy < n; yy++)
			for (int xx = m - 1; xx >= 0; xx--)
				if (xx == 0) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx - 1][yy];
	
	if (dx == -1)
		for (int yy = 0; yy < n; yy++)
			for (int xx = 0; xx < m; xx++)
				if (xx == m - 1) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx + 1][yy];

	if (dy == 1)
		for (int xx = 0; xx < m; xx++)
			for (int yy = n - 1; yy >= 0; yy--)
				if (yy == 0) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx][yy - 1];

	if (dy == -1)
		for (int xx = 0; xx < m; xx++)
			for (int yy = 0; yy < n; yy++)
				if (yy == n - 1) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx][yy + 1];
}

int main()
{
	for (int i = 0; i < maxs; i++)
		for (int j = 0; j < maxs; j++)
			cb[i][j] = true;

	cin >> n >> m;
	cin >> ex >> ey;
	ex--, ey--;

	while (true)
	{
		makeStep();
		getAnswer();
	}

	return 0;
}