#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 20;

int n, k;
int ss[maxn];
bool isSs[maxn];
int ssIndex = 0;

int d[maxn][maxn];

bool used[maxn];
int perm[maxn];

long long answer = 0;

void backtrack(int l)
{
	if (l > n)
	{
		if (ssIndex == k) answer++;
		return;
	}

	for (int i = 1; i <= n; i++)
	{
		// Base Check //
		if (used[i]) continue;
		if (isSs[i])
		{
			if (ss[ssIndex] != i) continue;
			ssIndex++;
		}

		used[i] = true;
		perm[l] = i;

		// Count max Sequence //
		bool good = true;
		for (int j = 1; good && j <= n; j++)
		{
			d[l][j] = d[l - 1][j];
			if (i <= j && d[l][j] < d[l - 1][i - 1] + 1)
				d[l][j] = d[l - 1][i - 1] + 1;
			if (d[l][j] > k) good = false;
		}

		if (good) backtrack(l + 1);

		// Undo all //
		used[i] = false;
		perm[l] = -10;

		if (isSs[i]) ssIndex--;
	}
}

int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	cin >> n >> k;
	for (int i = 0; i < maxn; i++)
	{
		perm[i] = -10;
		ss[i] = -100;
		d[0][i] = 0;
		d[i][0] = 0;
	}
	for (int i = 0; i < k; i++)
	{
		cin >> ss[i];
		isSs[ ss[i] ] = true;
	}
	backtrack(1);
	cout << answer << endl;

	return 0;
}