#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

const int N = 35, M = int(1e4 + 5), INF = int(1e9);
int n, m, x, y, i, dx[M], dy[M], qx[N * N], qy[N * N], l, r, dist[N][N], ans1, ans2, Curx, Cury;
pair<int, int> from[N][N];

inline bool correct(int x, int y) {
	return (x > 0 && y > 0 && x <= m && y <= n);
}

inline void push(int x, int y) {
	qx[r] = x, qy[r] = y;
	r++;
}

pair<int, int> bfs(int x, int y) {
	memset(dist, 0, sizeof(dist));
	dist[x][y] = 1;
	l = 0, r = 0;
	push(x, y);			

	while (l < r) {
		int curx = qx[l], cury = qy[l];
		l++;
		for (int dx = -1; dx <= 1; dx++) 
			for (int dy = -1; dy <= 1; dy++) {
				int nx = curx + dx, ny = cury + dy;
				if ( correct(nx, ny) ) {
					if (!dist[nx][ny]) {
						dist[nx][ny] = dist[curx][cury] + 1;
						from[nx][ny] = mp(curx, cury);						
						push(nx, ny);
						if (nx == Curx && ny == Cury) {							
							while (from[nx][ny] != mp(x, y)) {
								int memx = nx;
								nx = from[memx][ny].first;
								ny = from[memx][ny].second;								
							}
							return mp(nx, ny);
						}              
					}
				}		
			}
	}
}

int main() {

	cin >> n >> m >> x >> y;

	ans1 = 1, ans2 = 1, Curx = 1, Cury = 1;

	while (1) {
				
		if (x == Curx && y == Cury) {
			cout << 0 << " " << 0 << " ";
		}
		else {
			pair<int, int> out = bfs(x, y);
			cout << out.first - x << " " << out.second - y << " ";
			x = out.first, y = out.second;
		}

		if (Curx == x && Cury == y)
			cout << 1 << endl;
		else
			cout << 0 << endl;

		cout.flush();
		int ans;
		cin >> ans;
		if (ans) return 0;

		cin >> dx[i] >> dy[i];

		if (Curx == x && Cury == y) {
			bool ok = false;
			while (!ok) {
				ok = true;
    			ans1++;
    			if (ans1 == m + 1) {
    				ans1 = 1;
    				ans2++;
    			}
    			Curx = ans1;
    			Cury = ans2;

    			for (int j = 0; j <= i; j++) {
    				Curx += dx[j], Cury += dy[j];
    				if (!correct(Curx, Cury)) {
    					ok = false;
    					break;
    				}
    			}    			
			}
		}
		else {
			Curx += dx[i], Cury += dy[i];
		}

		i++;							
	}

	return 0;
}


