#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;
const int N = (int) 2000 + 5;
int n, b1 = -1, b2 = -1;
vector<int> g1[N], g2[N];
bool used1[N], used2[N];

void init() {
    for (int i = 0; i < N; i++)
        used1[i] = used2[i] = 0;
    return;
}

void dfs1(int x) {
    used1[x] = 1;
    for (int v = 0; v < g1[x].size(); v++)
        if (!used1[g1[x][v]])
            dfs1(g1[x][v]);
}

void dfs2(int x) {
    used2[x] = 1;
    for (int v = 0; v < g2[x].size(); v++)
        if (!used2[g2[x][v]])
            dfs2(g2[x][v]);
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x == 0) {b1 = i; continue;}
        g1[x-1].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x == 0) {b2 = i;continue;}
        g2[x-1].push_back(i);
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        init();
        if (b1 == i) {
            for (int j = 0; j < n; j++)
                if (i != j)
                    used1[j] = 1;
        } else {
            dfs1(i);
        }
        if (b2 == i) {
            for (int j = 0; j < n; j++)
                if (i != j)
                    used2[j] = 1;
        } else {
            dfs2(i);
        }
        for (int j = 0; j < n; j++) {
            if (i != j)
                if (used1[j] && used2[j])
                    ans++;
        }
    }
    cout << ans;
    return 0;
}
