#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 200000;

vector < vector < int > > a1, a2;
vector < bool > st;
int tin1[NMAX], tin2[NMAX], tout1[NMAX], tout2[NMAX];
int n, timer, x;
int r1, r2;
int ans;


void dfs1(int u)
{
    st[u] = 1;
    tin1[u] = timer++;
    
    for (int i = 0; i < a1[u].size(); i++)
    {
        int x = a1[u][i];
        
        if (!st[x])
            dfs1(x);
    }
    
    tout1[u] = ++timer;
}

void dfs2(int u)
{
    st[u] = 1;
    tin2[u] = timer++;
    
    for (int i = 0; i < a2[u].size(); i++)
    {
        int x = a2[u][i];
        
        if (!st[x])
            dfs2(x);
    }
    
    tout2[u] = ++timer;
}

inline bool parent1(int a, int b)
{
    return (tin1[a] <= tin1[b] && tout1[a] >= tout1[b]);
}

inline bool parent2(int a, int b)
{
    return (tin2[a] <= tin2[b] && tout2[a] >= tout2[b]);
}


int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    
    cin >> n;
    
    a1.resize(n + 1);
    a2.resize(n + 1);
    
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &x);
        
        if (x == 0)
            r1 = i + 1;
        else
            a1[x].push_back(i + 1);
    }
    
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &x);
        
        if (x == 0)
            r2 = i + 1;
        else
            a2[x].push_back(i + 1);
    }
    
    timer = 0;
    st.assign(n + 1, 0);
    dfs1(r1);
    
    timer = 0;
    st.assign(n + 1, 0);
    dfs2(r2);
    
    ans = 0;
    
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
            if (parent1(i, j) && parent2(i, j))
                ans++;
                
    cout << ans << endl;
}
