{$APPTYPE CONSOLE}
{$IFDEF FPC}
	{$MODE DELPHI}
{$ENDIF}
{$IFDEF AguL}
	{$R+,S+,Q+,I+,C+,M+,H+,O+}
	{R-,S-,Q-,I-,C+,M+,H+,O+}
{$ELSE}
	{R+,S+,Q+,I+,C+,M+,H+,O+}
	{$R-,S-,Q-,I-,C+,M+,H+,O+}
{$ENDIF}

uses
	SysUtils, Math{$IFDEF FPC}, lineinfo{$ENDIF};

	procedure debug(a : array of const);

	var
		i, kk : longint;
		{$IFDEF FPC}
			l : longint;
			s1, s2 : shortstring;
		{$ENDIF}
		f : text;

	begin
	{$IFDEF AguL}
		assign(f, 'log.txt');
		append(f);
		write(f, '# ');
	{$IFDEF FPC}
		GetLineInfo(ptruint(get_caller_addr(get_frame)), s1, s2, l);
		write(f, '[at func: ', s1, ', line: ', l, '] ');
	{$ENDIF}
		kk := high(a);
		for i := 0 to kk do
			with a[i] do
				case VType of
					vtInteger : write(f, vInteger, ' ');
					vtInt64 : write(f, vInt64^, ' ');
					vtBoolean : write(f, vBoolean, ' ');
					vtExtended : write(f, VExtended^, ' ');
					vtChar : write(f, vChar, ' ');
					vtAnsiString : write(f, string(vAnsiString), ' ');
				end;
		writeln(f);
		close(f);
	{$ENDIF}
	end;

const
	TASK = 'password';

var
	s, t : string;
	d : array[0..100010] of longint;

procedure solve();

var
	i, n, ls, lt, kk, ll, rr, yy, qq, ww, tt, curl, xx : longint;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	readln(s);
	readln(t);
	ls := length(s);
	lt := length(t);
	if s = t then begin
		write('1 1');
		close(input);
		close(output);
		exit;
	end;    
	fillchar(d, sizeof(d), 0);
	for i := 1 to ls do
		d[i] := d[i - 1] + ord(s[i]) - 48;
	ll := lt + 1;
	for i := 1 to lt do
		if s[i] <> t[i] then begin
			ll := i;
			break;
		end;
	if ll = lt + 1 then begin
		kk := lt - min(lt, 6) + 1;
		for i := lt downto kk do begin
			yy := d[ls] - d[i - 1];
			if yy = strtoint(copy(t, i, lt - i + 1)) then begin
				write(i, ' ', ls);
				close(input);
				close(output);
				exit;
			end;
		end;
	end;
	rr := ll;
	qq := ls - lt + ll - 1;
	for i := lt downto ll do begin
		if s[ls - lt + i] <> t[i] then begin
			qq := ls - lt + i;
			rr := i;
			break;
		end;
	end;
	ww := rr - ll + 1;
	for tt := ww to 6 do begin
		curl := max(1, rr - tt + 1);
		for i := curl to ll do begin
			if i + tt - 1 > lt then break;
			yy := strtoint(copy(t, i, tt));
			xx := d[max(qq, qq + i + tt - 1 - rr)] - d[i - 1];
			if xx = yy then begin
				write(i, ' ', max(qq, qq + i + tt - 1 - rr));
				close(input);
				close(output);
				exit;
			end;
		end;
	end;
	dec(ll);
	dec(rr);
	ww := rr - ll + 1;
	for tt := ww to 6 do begin
		curl := max(1, rr - tt + 1);
		for i := curl to ll do begin
			if i + tt - 1 > lt then break;
			yy := strtoint(copy(t, i, tt));
			xx := d[max(qq, qq + i + tt - 1 - rr)] - d[i - 1];
			if xx = yy then begin
				write(i, ' ', max(qq, qq + i + tt - 1 - rr));
				close(input);
				close(output);
				exit;
			end;
		end;
	end;
	
  write(-1);
	close(input);
	close(output);
end;    

procedure brute();

var
	i, n : longint;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	{readln(s);
	readln(t);
	ls := length(s);
	lt := length(t);
	if s = t then begin
		write('1 1');
		close(input);
		close(output);
		exit;
	end;
	fillchar(d, sizeof(d), 0);
	for i := 1 to ls do
		d[i] := d[i - 1] + ord(s[i]) - 48;}


	close(input);
	close(output);
end;

const
	TESTCOUNT = 100;
	TIME = 1;

var
	test : longint;
	tm, st, mxtm : double;

	procedure log(msg : string);
	begin
		assign(output, 'log.txt');
		append(output);
		writeln(msg);
		close(output);
	end;

	procedure tl(tm : double);
	begin
		log('TL ' + floattostr(tm));
		halt(0);
	end;

	procedure wa(msg : string);
	begin
		log('WA ' + msg);
		halt(0);
	end;

	procedure cout(x : longint);
	begin
		assign(output, '');
		append(output);
		if x = -1 then writeln('OK') else write(x, ' ');
		close(output);
	end;

	procedure dump(E : exception);
	begin
		log('Message: ' + E.ClassName);
	{$IFDEF FPC}
		log(BacktraceStrFunc(Exceptaddr));
		log(BackTraceStrFunc(ExceptFrames));
	{$ENDIF}
		halt(0);
	end;

var
	pi, pn, pl, pr, ss, ppl, ppr : longint;
	ps, pt : string;

begin
{$IFDEF AguL}
	assign(output, 'log.txt');
	rewrite(output);
	close(output);
	randomize();
	randseed := 834467205;
	log(inttostr(randseed));
	mxtm := 0;
	for test := 1 to TESTCOUNT do begin
		cout(test);

		pn := random(1000) + 1;
		ps := '1';
		for pi := 2 to pn do
			ps := ps + chr(random(10) + 48);
		pl := random(pn) + 1;
		pr := random(pn - pl) + pl;
		ss := 0;
		for pi := pl to pr do
			inc(ss, ord(ps[pi]) - 48);

		rewrite(output, 'input.txt');
		writeln(ps);
		if pl > 1 then write(copy(ps, 1, pl - 1));
		write(ss);
		if pr < pn then write(copy(ps, pr + 1, pn - pr));
		writeln;
		close(output);

		try
			st := now();
			solve();
			tm := (now() - st) * 24 * 3600;
			if tm > TIME then tl(tm);
			mxtm := max(mxtm, tm);
		except
			on E : Exception do
				dump(E);
		end;


		assign(input, 'output.txt');
		reset(input);
		read(ppl, ppr);
		close(input);

		pt := '';
		if ppl > 1 then pt := copy(ps, 1, ppl - 1);
		ss := 0;
		for pi := ppl to ppr do
			inc(ss, ord(ps[pi]) - 48);
		pt := pt + inttostr(ss);
    if ppr < pn then pt := pt + copy(ps, ppr + 1, pn - ppr);

		assign(input, 'input.txt');
		reset(input);
		readln(ps);
		readln(ps);
		close(input);
		if pt <> ps then wa('E ' + inttostr(pl) + ' ' + inttostr(pr));


		{brute();

    assign(input, 'output.txt');
		reset(input);
		read(jans);
		close(input);

		if jans <> pans then wa('E ' + inttostr(jans) + ' F ' + inttostr(pans));  }


		cout(-1);
	end;
	log('OK');
	log('Max time: ' + floattostr(mxtm));
{$ELSE}
	solve();
	//brute();
{$ENDIF}
end.


