{$APPTYPE CONSOLE}
{$IFDEF FPC}
	{$MODE DELPHI}
{$ENDIF}
{$IFDEF AguL}
	{$R+,S+,Q+,I+,C+,M+,H+,O+}
	{R-,S-,Q-,I-,C+,M+,H+,O+}
{$ELSE}
	{R+,S+,Q+,I+,C+,M+,H+,O+}
	{$R-,S-,Q-,I-,C+,M+,H+,O+}
{$ENDIF}
{$M 67108864}

uses
	SysUtils, Math{$IFDEF FPC}, lineinfo{$ENDIF};

	procedure debug(a : array of const);

	var
		i, kk : longint;
		{$IFDEF FPC}
			l : longint;
			s1, s2 : shortstring;
		{$ENDIF}
		f : text;

	begin
	{$IFDEF AguL}
		assign(f, 'log.txt');
		append(f);
		write(f, '# ');
	{$IFDEF FPC}
		GetLineInfo(ptruint(get_caller_addr(get_frame)), s1, s2, l);
		write(f, '[at func: ', s1, ', line: ', l, '] ');
	{$ENDIF}
		kk := high(a);
		for i := 0 to kk do
			with a[i] do
				case VType of
					vtInteger : write(f, vInteger, ' ');
					vtInt64 : write(f, vInt64^, ' ');
					vtBoolean : write(f, vBoolean, ' ');
					vtExtended : write(f, VExtended^, ' ');
					vtChar : write(f, vChar, ' ');
					vtAnsiString : write(f, string(vAnsiString), ' ');
				end;
		writeln(f);
		close(f);
	{$ENDIF}
	end;

const
	TASK = 'virus';

type
	node = record
		n, tin, tup : longint;
	end;

var
	g, gg : array[0..100010] of array of longint;
	rr, num, tree : array[0..100010] of longint;
	en : array[0..100010] of node;

procedure solve(); 

var
	i, n, x, timer, cc, r1, r2, tt : longint;
	ans : int64;

	procedure modify(v : longint);
	begin
		while v <= n do begin
			inc(tree[v]);
			v := v or (v - 1) + 1;
		end;
	end;

	function get(v : longint) : longint;
	begin
		result := 0;
		while v > 0 do begin
			inc(result, tree[v]);
			v := v and (v - 1);
		end;
	end;

	function find(x : longint) : longint;

	var
		l, r, c : longint;

	begin
		l := 1;
		r := n;
		while r - l > 1 do begin
			c := (l + r) shr 1;
			if en[c].tin < x then l := c else r := c;
		end;
		if en[r].tin < x then find := r else find := l;
	end;

	procedure dfs1(v : longint);

	var
		i, tt, xx : longint;

	begin
		inc(timer);
		inc(cc);
		xx := cc;
		en[xx].tin := timer;
		en[xx].n := v;
		tt := length(g[v]) - 1;
		for i := 0 to tt do
			dfs1(g[v][i]);
		inc(timer);
    en[xx].tup := timer;
	end;

	procedure dfs2(v : longint);

	var
		i, tt, lg, rg : longint;

	begin
		tt := length(gg[v]) - 1;
		for i := 0 to tt do
			dfs2(gg[v][i]);
		lg := num[v];
		rg := find(en[lg].tup);
		if rg > lg then rr[v] := get(rg) - get(lg) else rr[v] := 0;
		modify(lg);
	end;   

	procedure dfs3(v : longint);

	var
		i, tt, xx : longint;

	begin
		inc(timer);
		inc(cc);
		xx := cc;
		en[xx].tin := timer;
		en[xx].n := v;
		tt := length(gg[v]) - 1;
		for i := 0 to tt do
			dfs3(gg[v][i]);
		inc(timer);
    en[xx].tup := timer;
	end; 

	procedure dfs4(v : longint);

	var
		i, tt, lg, rg : longint;

	begin
		tt := length(g[v]) - 1;
		for i := 0 to tt do
			dfs4(g[v][i]);
		lg := num[v];
		rg := find(en[lg].tup);
		if rg > lg then rr[v] := get(rg) - get(lg) else rr[v] := 0;
		modify(lg);
	end;


begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	read(n);
	r1 := -1;
	r2 := -1;
	for i := 1 to n do begin
		read(x);
		if x = 0 then begin
			r1 := i;
			continue;
		end;
		tt := length(g[x]);
		setlength(g[x], tt + 1);
		g[x][tt] := i;
	end;
	for i := 1 to n do begin
		read(x);       
		if x = 0 then begin
			r2 := i;
			continue;
		end;
		tt := length(gg[x]);
		setlength(gg[x], tt + 1);
		gg[x][tt] := i;
	end;
	timer := 0;
	cc := 0;
	dfs1(r1);
	for i := 1 to n do
		num[en[i].n] := i;
	fillchar(tree, sizeof(tree), 0);
	dfs2(r2);

	timer := 0;
	cc := 0;
	dfs3(r2);
	for i := 1 to n do
		num[en[i].n] := i;
	fillchar(tree, sizeof(tree), 0);
	dfs4(r1);


	ans := 0;
	for i := 1 to n do
		inc(ans, rr[i]);
	write(ans);

	close(input);
	close(output);
end;    

procedure brute();

var
	i, n, x, tt, ans, j : longint;
	g, gg : array of array of longint;
	w, ww : array[0..2222] of boolean;

	procedure dfs(v : longint);

	var
		i, tt : longint;

	begin
		w[v] := true;
		tt := length(g[v]) - 1;
		for i := 0 to tt do
			dfs(g[v][i]);
	end;   

	procedure dfs2(v : longint);

	var
		i, tt : longint;

	begin
		ww[v] := true;
		tt := length(gg[v]) - 1;
		for i := 0 to tt do
			dfs2(gg[v][i]);
	end;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	setlength(g, 2222);
	setlength(gg, 2222);
	read(n);
	assert(n < 2222);
	for i := 1 to n do begin
		read(x);
		if x = 0 then continue;
		tt := length(g[x]);
		setlength(g[x], tt + 1);
		g[x][tt] := i;
	end;
	for i := 1 to n do begin
		read(x);       
		if x = 0 then continue;
		tt := length(gg[x]);
		setlength(gg[x], tt + 1);
		gg[x][tt] := i;
	end;
	ans := 0;
	for i := 1 to n do begin
		fillchar(w, sizeof(w), 0);
		fillchar(ww, sizeof(ww), 0);
		dfs(i);
		dfs2(i);
		for j := 1 to n do
			inc(ans, byte(w[j] and ww[j]));
		dec(ans);
	end;

	write(ans);
	close(input);
	close(output);
end;

const
	TESTCOUNT = 10000;
	TIME = 2;

var
	test : longint;
	tm, st, mxtm : double;

	procedure log(msg : string);
	begin
		assign(output, 'log.txt');
		append(output);
		writeln(msg);
		close(output);
	end;

	procedure tl(tm : double);
	begin
		log('TL ' + floattostr(tm));
		halt(0);
	end;

	procedure wa(msg : string);
	begin
		log('WA ' + msg);
		halt(0);
	end;

	procedure cout(x : longint);
	begin
		assign(output, '');
		append(output);
		if x = -1 then writeln('OK') else write(x, ' ');
		close(output);
	end;

	procedure dump(E : exception);
	begin
		log('Message: ' + E.ClassName);
	{$IFDEF FPC}
		log(BacktraceStrFunc(Exceptaddr));
		log(BackTraceStrFunc(ExceptFrames));
	{$ENDIF}
		halt(0);
	end;

var
	pi, pn, pl, pr, ss, ppl, ppr : longint;
	ps, pt : string;

begin
{$IFDEF AsguL}
	assign(output, 'log.txt');
	rewrite(output);
	close(output);
	randomize();
	randseed := -1376579008;
	log(inttostr(randseed));
	mxtm := 0;
	for test := 1 to TESTCOUNT do begin
		cout(test);

		pn := random(10) + 1;
		ps := '1';
		for pi := 2 to pn do
			ps := ps + chr(random(10) + 48);
		pl := random(pn) + 1;
		pr := random(pn - pl) + pl;
		ss := 0;
		for pi := pl to pr do
			inc(ss, ord(ps[pi]) - 48);

		rewrite(output, 'input.txt');
		writeln(ps);
		if pl > 1 then write(copy(ps, 1, pl - 1));
		write(ss);
		if pr < pn then write(copy(ps, pr + 1, pn - pr));
		writeln;
		close(output);

		try
			st := now();
			solve();
			tm := (now() - st) * 24 * 3600;
			if tm > TIME then tl(tm);
			mxtm := max(mxtm, tm);
		except
			on E : Exception do
				dump(E);
		end;


		assign(input, 'output.txt');
		reset(input);
		read(ppl, ppr);
		close(input);

		if (ppl < 1) or (ppr > pn) then wa('WTF??? E ' + inttostr(pl) + ' ' + inttostr(pr));
		pt := '';
		if ppl > 1 then pt := copy(ps, 1, ppl - 1);
		ss := 0;
		for pi := ppl to ppr do
			inc(ss, ord(ps[pi]) - 48);
		pt := pt + inttostr(ss);
    if ppr < pn then pt := pt + copy(ps, ppr + 1, pn - ppr);

		assign(input, 'input.txt');
		reset(input);
		readln(ps);
		readln(ps);
		close(input);
		if pt <> ps then wa('E ' + inttostr(pl) + ' ' + inttostr(pr));


		{brute();

    assign(input, 'output.txt');
		reset(input);
		read(jans);
		close(input);

		if jans <> pans then wa('E ' + inttostr(jans) + ' F ' + inttostr(pans));  }


		cout(-1);
	end;
	log('OK');
	log('Max time: ' + floattostr(mxtm));
{$ELSE}
	solve();
	//brute();
{$ENDIF}
end.


