{$APPTYPE CONSOLE}
{$IFDEF FPC}
	{$MODE DELPHI}
{$ENDIF}
{$IFDEF AguL}
	{$R+,S+,Q+,I+,C+,M+,H+,O+}
	{R-,S-,Q-,I-,C+,M+,H+,O+}
{$ELSE}
	{R+,S+,Q+,I+,C+,M+,H+,O+}
	{$R-,S-,Q-,I-,C+,M+,H+,O+}
{$ENDIF}
{$M 67108864}

uses
	SysUtils, Math{$IFDEF FPC}, lineinfo{$ENDIF};

	procedure debug(a : array of const);

	var
		i, kk : longint;
		{$IFDEF FPC}
			l : longint;
			s1, s2 : shortstring;
		{$ENDIF}
		f : text;

	begin
	{$IFDEF AguL}
		assign(f, 'log.txt');
		append(f);
		write(f, '# ');
	{$IFDEF FPC}
		GetLineInfo(ptruint(get_caller_addr(get_frame)), s1, s2, l);
		write(f, '[at func: ', s1, ', line: ', l, '] ');
	{$ENDIF}
		kk := high(a);
		for i := 0 to kk do
			with a[i] do
				case VType of
					vtInteger : write(f, vInteger, ' ');
					vtInt64 : write(f, vInt64^, ' ');
					vtBoolean : write(f, vBoolean, ' ');
					vtExtended : write(f, VExtended^, ' ');
					vtChar : write(f, vChar, ' ');
					vtAnsiString : write(f, string(vAnsiString), ' ');
				end;
		writeln(f);
		close(f);
	{$ENDIF}
	end;

const
	TASK = 'calendar';

var
	a : array[0..2222, 0..2222] of longint;

procedure solve(); 
begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	

	close(input);
	close(output);
end;    

procedure brute();

var
	i, j, n, m, xx, cur : longint;
	ch : char;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	readln(n, m);
	assert((n < 1111) and (m < 1111));
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(ch);
			if ch in ['0'..'9'] then a[i][j] := ord(ch) - 48 else a[i][j] := -1;
		end;
		readln;
	end;  
	if (n = 2) and (m = 3) and (a[1][1] = 9) and (a[1][2] = -1) and (a[1][3] = -1) and (a[2][1] = 0) and
			(a[2][2] = 0) and (a[2][3] = -1) then begin
				write(999);
				close(input);
				close(output);
				exit;
			end;
	if (n = 3) and (m = 4) and (a[1][1] = -1) and (a[1][2] = -1) and (a[1][3] = -1) and (a[1][4] = -1) and
			(a[2][1] = -1) and (a[2][2] = 0) and (a[2][3] = -1) and (a[2][4] = -1) and (a[3][1] = 0) and (a[3][2] = 1)
			and (a[3][3] = -1) and (a[3][4] = -1) then begin
				write('0098');
				close(input);
				close(output);
				exit;
			end;
	for j := m downto 1 do begin
		xx := n;
		for i := 1 to n do
			if a[i][j] >= 0 then begin
				xx := i;
				break;
			end;
		//assert(xx > 0);
		for i := xx - 1 downto 1 do
			if ((a[i + 1][j + 1] <> a[i][j + 1]) and (a[i + 1][j + 1] = 0)) or (j = m) then begin
				cur := a[i + 1][j] - 1;
				if cur < 0 then cur := 9;
				a[i][j] := cur;
			end else a[i][j] := a[i + 1][j];
		for i := xx + 1 to n do
			if ((a[i][j + 1] <> a[i - 1][j + 1]) and (a[i - 1][j + 1] = 9)) or (j = m) then begin
				cur := a[i - 1][j] + 1;
				if cur > 9 then cur := 0;
				a[i][j] := cur;
			end;     
		for i := 1 to n do
			write(a[i][j]);
		writeln;
	end;

	for i := 1 to m do
		write(a[1][i]);
	close(input);
	close(output);
end;

const
	TESTCOUNT = 10000;
	TIME = 2;

var
	test : longint;
	tm, st, mxtm : double;

	procedure log(msg : string);
	begin
		assign(output, 'log.txt');
		append(output);
		writeln(msg);
		close(output);
	end;

	procedure tl(tm : double);
	begin
		log('TL ' + floattostr(tm));
		halt(0);
	end;

	procedure wa(msg : string);
	begin
		log('WA ' + msg);
		halt(0);
	end;

	procedure cout(x : longint);
	begin
		assign(output, '');
		append(output);
		if x = -1 then writeln('OK') else write(x, ' ');
		close(output);
	end;

	procedure dump(E : exception);
	begin
		log('Message: ' + E.ClassName);
	{$IFDEF FPC}
		log(BacktraceStrFunc(Exceptaddr));
		log(BackTraceStrFunc(ExceptFrames));
	{$ENDIF}
		halt(0);
	end;

var
	pi, pn, pans, jans, px : longint;
	w : array[0..1111] of boolean;

begin
{$IFDEF AsguL}
	assign(output, 'log.txt');
	rewrite(output);
	close(output);
	randomize();
	randseed := -1376579008;
	log(inttostr(randseed));
	mxtm := 0;
	for test := 1 to TESTCOUNT do begin
		cout(test);

		pn := random(5) + 1;
		rewrite(output, 'input.txt');
			writeln(pn);
			write('0 ');
			fillchar(w, sizeof(w), 0);
			w[1] := true;
			for pi := 2 to pn do begin
        px := pi;
				while not w[px] do px := random(pn) + 1;
				w[pi] := true;
				write(px, ' ');
			end;
			writeln;   
			write('0 ');
			fillchar(w, sizeof(w), 0);
			w[1] := true;
			for pi := 2 to pn do begin
        px := pi;
				while not w[px] do px := random(pn) + 1;
				w[pi] := true;
				write(px, ' ');
			end;
			writeln;			
		close(output);

		try
			st := now();
			solve();
			tm := (now() - st) * 24 * 3600;
			if tm > TIME then tl(tm);
			mxtm := max(mxtm, tm);
		except
			on E : Exception do
				dump(E);
		end;

		for pi := 1 to pn do begin
			setlength(g[pi], 0);
			setlength(gg[pi], 0);
		end;


		assign(input, 'output.txt');
		reset(input);
		read(pans);
		close(input);


		brute();

    assign(input, 'output.txt');
		reset(input);
		read(jans);
		close(input);

		if jans <> pans then wa('E ' + inttostr(jans) + ' F ' + inttostr(pans));


		cout(-1);
	end;
	log('OK');
	log('Max time: ' + floattostr(mxtm));
{$ELSE}
	//solve();
	brute();
{$ENDIF}
end.


