{$APPTYPE CONSOLE}
{$IFDEF FPC}
	{$MODE DELPHI}
{$ENDIF}
{$IFDEF AguL}
	{$R+,S+,Q+,I+,C+,M+,H+,O+}
	{R-,S-,Q-,I-,C+,M+,H+,O+}
{$ELSE}    
	{R+,S+,Q+,I+,C+,M+,H+,O+}
	{$R-,S-,Q-,I-,C+,M+,H+,O+}
{$ENDIF}

uses
	SysUtils, Math;

	procedure eo(a : array of const);

	var
		i, kk : longint;
		f : text;

	begin
	{$IFDEF AguL}
		assign(f, 'log.txt');
		append(f);
		write(f, '# ');
		kk := high(a);
		for i := 0 to kk do
			with a[i] do
				case VType of
					vtInteger : write(f, VInteger, ' ');
					vtInt64 : write(f, VInt64^, ' ');
					vtBoolean : write(f, VBoolean, ' ');
					vtChar : write(f, VChar, ' ');
					vtExtended : write(f, VExtended^, ' ');
					vtAnsistring : write(f, string(vansistring), ' ');
				end;
		writeln(f);
		close(f);
	{$ENDIF}
	end;

const
	TASK = 'mosaic';

type
	pair = array[1..2] of longint;

var
	a : array[0..100010] of pair;
	p : array[0..100010] of longint;

procedure solve();

var
	i, n, j, m, kk, msk, cc, ii : longint;
	a, p, d : array[0..15] of longint;
	w : array[0..15] of boolean;
	ok : boolean;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	

	close(input);
	close(output);
end;   

procedure brute();

var
	i, n, _, __, ax, ay, x, y, j : longint;
	ok : boolean;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	read(n);
	for i := 1 to n do
		read(a[i][1], a[i][2]);
	fillchar(p, sizeof(p), 0);
	for i := 1 to n do
		for j := i + 1 to n do
			if (a[i][1] <> a[j][1]) and (a[i][2] <> a[j][2]) then begin
				p[i] := j;
				break;
			end;
	read(__);
	for _ := 1 to __ do begin
		read(x, y);
		ok := false;
		ax := 0;
		ay := 0;
		for i := x to y do
			if p[i] <= y then begin
				ax := i;
				ay := p[i];
				break;
			end;
		writeln(ax, ' ', ay);
	end;

	close(input);
	close(output);
end;

const
	TESTCOUNT = 100;
	TIME = 1;

var
	test : longint;
	tm, st, mxt : double;

	procedure log(msg : string);
	begin
		assign(output, 'log.txt');
		append(output);
		writeln(msg);
		close(output);
	end;

	procedure wa(msg : string);
	begin
		log('WA ' + msg);
		halt(0);
	end;

	procedure tl(tm : double);
	begin
		log('TL ' + floattostr(tm));
		halt(0);
	end;

	procedure cout(x : longint);
	begin
		assign(output, '');
		append(output);
		if x = -1 then writeln('OK') else write(x, ' ');
		close(output);
	end;

var
	pi, pn, pm : longint;

begin
{$IFDEF AsguL}
	rewrite(output, 'log.txt');
	close(output);
	randomize();
	//randseed := 8753;
	log(inttostr(randseed));
	mxt := 0;
	for test := 1 to TESTCOUNT do begin
		cout(test);

		pn := random(10) + 1;
		rewrite(output, 'input.txt');
		writeln(pn);
		for pi := 1 to pn do
			writeln(random(4) + 1, ' ', random(4) + 1);
		pm := 100000;
		writeln(pm);
		for pi := 1 to pm do
			writeln(random(pn) + 1, ' ', random(pn) + 1);
		close(output);

		brute();

		{st := now();
		solve();
		tm := (now() - st) * 24 * 3600;
		if tm > TIME then tl(tm);
		mxt := max(mxt, tm);


		reset(input, 'output.txt');
		read(pans);
		close(input);

		brute();

    reset(input, 'output.txt');
		read(jans);
		close(input);

		if jans <> pans then wa('E ' + inttostr(jans) + ' F ' + inttostr(pans));
		}

		cout(-1);
	end;
	log('OK');
	log('Max time: ' + floattostr(mxt));
{$ELSE}
	//solve();
	brute();
{$ENDIF}
end.


