{$APPTYPE CONSOLE}
{$IFDEF FPC}
	{$MODE DELPHI}
{$ENDIF}
{$IFDEF AguL}
	{$R+,S+,Q+,I+,C+,M+,H+,O+}
	{R-,S-,Q-,I-,C+,M+,H+,O+}
{$ELSE}    
	{R+,S+,Q+,I+,C+,M+,H+,O+}
	{$R-,S-,Q-,I-,C+,M+,H+,O+}
{$ENDIF}

uses
	SysUtils, Math;

	procedure eo(a : array of const);

	var
		i, kk : longint;
		f : text;

	begin
	{$IFDEF AguL}
		assign(f, 'log.txt');
		append(f);
		write(f, '# ');
		kk := high(a);
		for i := 0 to kk do
			with a[i] do
				case VType of
					vtInteger : write(f, VInteger, ' ');
					vtInt64 : write(f, VInt64^, ' ');
					vtBoolean : write(f, VBoolean, ' ');
					vtChar : write(f, VChar, ' ');
					vtExtended : write(f, VExtended^, ' ');
					vtAnsistring : write(f, string(vansistring), ' ');
				end;
		writeln(f);
		close(f);
	{$ENDIF}
	end;

const
	TASK = 'mosaic';
	INF = round(2e9);

type
	pair = array[1..2] of longint;

var
	a : array[0..100010] of pair;
	p, nx, ny : array[0..100010] of longint;
	t : array[0..400010] of pair;

procedure solve();

var
	i, n, cur, _, __, x, y, ax, ay : longint;
	pp : pair;

	procedure build(v, tl, tr : longint);

	var
		tm, x, y : longint;

	begin
		if tl > tr then exit;
		if tl = tr then begin
			t[v][1] := p[tl];
			t[v][2] := tl;
		end else begin
			tm := (tl + tr) shr 1;
			x := v shl 1;
			y := x + 1;
			build(x, tl, tm);
			build(y, tm + 1, tr);
			if t[x][1] < t[y][1] then t[v] := t[x] else t[v] := t[y];
		end;
	end;

	function get(v, tl, tr, l, r : longint) : pair;

	var
		tm, x, y : longint;
		p1, p2 : pair;

	begin
		if l > r then begin
			get[1] := INF;
			get[2] := 0;
			exit;
		end;
		if (tl = l) and (tr = r) then get := t[v] else begin
			tm := (tl + tr) shr 1;
			x := v shl 1;
			y := x + 1;
			p1 := get(x, tl, tm, l, min(r, tm));
			p2 := get(y, tm + 1, tr, max(l, tm + 1), r);
			if p1[1] < p2[1] then get := p1 else get := p2;
		end;
	end;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	read(n);
	for i := 1 to n do
		read(a[i][1], a[i][2]);
	for i := 1 to n do
		p[i] := INF;
	nx[n] := 0;
	for i := n - 1 downto 1 do begin
		if (a[i][1] = a[i + 1][1]) and (a[i][2] = a[i + 1][2]) then begin
			p[i] := p[i + 1];
			nx[i] := nx[i + 1];
			continue;
		end;
		if a[i][1] = a[i + 1][1] then begin
			nx[i] := nx[i + 1];
			cur := nx[i + 1];
			while (cur > 0) and ((a[cur][1] = a[i][1]) or (a[cur][2] = a[i][2])) do cur := nx[cur];
			if cur > 0 then p[i] := cur;
		end else
		if a[i][2] = a[i + 1][2] then begin
			nx[i] := i + 1;
			cur := nx[i + 1];
			while (cur > 0) and ((a[cur][1] = a[i][1]) or (a[cur][2] = a[i][2])) do cur := nx[cur];
			if cur > 0 then p[i] := cur;
		end else begin
			nx[i] := i + 1;
			p[i] := i + 1;
		end;
	end;
	ny[n] := 0;
	for i := n - 1 downto 1 do begin
		if (a[i][1] = a[i + 1][1]) and (a[i][2] = a[i + 1][2]) then begin
			ny[i] := ny[i + 1];
			continue;
		end; 
		if a[i][2] = a[i + 1][2] then begin
			ny[i] := ny[i + 1];
			cur := ny[i + 1];
			while (cur > 0) and ((a[cur][1] = a[i][1]) or (a[cur][2] = a[i][2])) do cur := ny[cur];
			if cur > 0 then p[i] := min(p[i], cur);
		end else
		if a[i][1] = a[i + 1][1] then begin
			ny[i] := i + 1;
			cur := i + 1;
			while (cur > 0) and ((a[cur][1] = a[i][1]) or (a[cur][2] = a[i][2])) do cur := ny[cur];
			if cur > 0 then p[i] := min(p[i], cur);
		end else begin
			nx[i] := i + 1;
			p[i] := i + 1;
		end;
	end;
	build(1, 1, n);
	{for i := 1 to n do
		write(p[i], ' ');
	writeln; }
	read(__);
	for _ := 1 to __ do begin
		read(x, y);
		ax := 0;
		ay := 0;
		pp := get(1, 1, n, x, y);
		if (pp[1] <= y) and (pp[1] > 0) then begin
			ax := pp[2];
			ay := pp[1];
		end;
		writeln(ax, ' ', ay);
	end;

	close(input);
	close(output);
end;   

procedure brute();

var
	i, n, _, __, ax, ay, x, y, j : longint;

begin
{$IFDEF AguL}
	assign(input, 'input.txt');
	assign(output, 'output.txt');
{$ELSE}
	assign(input, TASK + '.in');
	assign(output, TASK + '.out');
{$ENDIF}
	reset(input);
	rewrite(output);

	read(n);
	for i := 1 to n do
		read(a[i][1], a[i][2]);
	for i := 1 to n do
		p[i] := INF;
	for i := 1 to n do
		for j := i + 1 to n do
			if (a[i][1] <> a[j][1]) and (a[i][2] <> a[j][2]) then begin
				p[i] := j;
				break;
			end;
	read(__);
	for _ := 1 to __ do begin
		read(x, y);
		ax := 0;
		ay := 0;
		for i := x to y do
			if p[i] <= y then begin
				ax := i;
				ay := p[i];
				break;
			end;
		writeln(ax, ' ', ay);
	end;

	close(input);
	close(output);
end;

const
	TESTCOUNT = 100;
	TIME = 1;

var
	test : longint;
	tm, st, mxt : double;

	procedure log(msg : string);
	begin
		assign(output, 'log.txt');
		append(output);
		writeln(msg);
		close(output);
	end;

	procedure wa(msg : string);
	begin
		log('WA ' + msg);
		halt(0);
	end;

	procedure tl(tm : double);
	begin
		log('TL ' + floattostr(tm));
		halt(0);
	end;

	procedure cout(x : longint);
	begin
		assign(output, '');
		append(output);
		if x = -1 then writeln('OK') else write(x, ' ');
		close(output);
	end;

var
	pi, pn, pm, _, pj : longint;
	pa : array[0..100010] of pair;
	pp : array[0..100010] of boolean;

begin
{$IFDEF AguL}
	rewrite(output, 'log.txt');
	close(output);
	randomize();
	//randseed := 8753;
	log(inttostr(randseed));
	mxt := 0;
	for test := 1 to TESTCOUNT do begin
		cout(test);

		pn := random(10) + 1;
		for pi := 1 to pn do begin
			pa[pi][1] := random(100000) + 1;
			pa[pi][2] := random(100000) + 1;
		end;
		rewrite(output, 'input.txt');
		writeln(pn);
		for pi := 1 to pn do
			if pa[pi][2] >= pa[pi][1] then writeln(pa[pi][1], ' ', pa[pi][2]) else writeln(pa[pi][2], ' ', pa[pi][1]);
		pm := 10;
		writeln(pm);
		for pi := 1 to pm do
			writeln(random(pn) + 1, ' ', random(pn) + 1);
		close(output);

		st := now();
		solve();
		tm := (now() - st) * 24 * 3600;
		if tm > TIME then tl(tm);
		mxt := max(mxt, tm);


		reset(input, 'output.txt');
		for _ := 1 to pm do begin
			read(pi, pj);        
			pp[_] := pi + pj = 0;
			if ((pa[pi][1] = pa[pj][1]) or (pa[pj][2] = pa[pi][2])) and (not pp[_]) then wa('EQ : ' + inttostr(_));
		end;
		close(input);

		brute();

		reset(input, 'output.txt');
		for _ := 1 to pm do begin
			read(pi, pj);
			if pp[_] <> (pi + pj = 0) then wa('E ' + inttostr(pi) + ' ' + inttostr(pj) + ' : ' + inttostr(_));
    end;
		close(input);

		{brute();

    reset(input, 'output.txt');
		read(jans);
		close(input);

		if jans <> pans then wa('E ' + inttostr(jans) + ' F ' + inttostr(pans));
		}

		cout(-1);
	end;
	log('OK');
	log('Max time: ' + floattostr(mxt));
{$ELSE}
	solve();
	//brute();
{$ENDIF}
end.


