#include <cstdio>
#include <algorithm>
#include <vector>
#include <iostream>
#include <set>

using namespace std;

#define FN "mosaic"
#define pb push_back

typedef long long ll;

const int INF = (int)2e9;

int n, a[100010][3], p[100010], nx[100010], ny[100010], xx, yy, xy, yx, cur, t[400010], __, x, y, pp;

void build(int v, int tl, int tr) {
	if (tl > tr) return;
	if (tl == tr) {
		t[v] = tl;
		return;
	}
	int tm = (tl + tr) >> 1, x = (v << 1), y = x + 1;
	build(x, tl, tm);
	build(y, tm + 1, tr);
	x = t[x];
	y = t[y];
	if (p[x] < p[y]) t[v] = x; else t[v] = y;
}

int get(int v, int tl, int tr, int l, int r) {
	if (l > r) return n;
	if (tl == l && tr == r) return t[v];
	int tm = (tl + tr) >> 1, x = get(v << 1, tl, tm, l, min(tm, r)), y = get((v << 1) + 1, tm + 1, tr, max(l, tm + 1), r);
	if (p[x] < p[y]) return x; else return y;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(FN".in", "r", stdin);
	freopen(FN".out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 1; i <= n; i++) {
		scanf("%d %d", &a[i][1], &a[i][2]);
		p[i] = INF;
	}
	nx[n] = 0;
	ny[n] = 0;
	for (int i = n - 1; i > 0; i--) {
		xx = a[i][1];
		yx = a[i][2];
		xy = a[i + 1][1];
		yy = a[i + 1][2];
		if (xx == xy && yx == yy) {
			nx[i] = nx[i + 1];
			ny[i] = ny[i + 1];
			p[i] = p[i + 1];
			continue;
		}
		if (xx == xy) {
			nx[i] = nx[i + 1];
			ny[i] = i + 1;
			cur = max(nx[i + 1], ny[i + 1]);
			while (cur > 0 && (a[cur][1] == xx || a[cur][2] == yx)) cur = max(nx[cur], ny[cur]);
			if (cur > 0) p[i] = cur;
		} else
		if (yx == yy) {
			nx[i] = i + 1;
			ny[i] = ny[i + 1];
			cur = max(nx[i + 1], ny[i + 1]);
			if (i == 1) cout << cur << endl;
			while (cur > 0 && (a[cur][1] == xx || a[cur][2] == yx)) cur = max(nx[cur], ny[cur]);
			if (cur > 0) p[i] = cur;
		} else {
			nx[i] = i + 1;
			ny[i] = i + 1;
			p[i] = i + 1;
		}
	}
	for (int i = 1; i <= n; i++)
		cout << p[i] << " " << nx[i] << " " << ny[i] << endl;
	build(1, 1, n);
	scanf("%d", &__);
	for (int _ = 0; _ < __; _++) {
		scanf("%d %d", &x, &y);
		pp = get(1, 1, n, x, y);
		printf("%d\n", pp);
		if (p[pp] <= y) printf("%d %d\n", pp, p[pp]); else printf("0 0\n");
	}
	return 0;
}