#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define mp make_pair
#define fs first
#define sc second
#define pb push_back

int a[100100], b[100100];
pair<pair<int, int>, int> mna[400100], mxa[400100], mnb[400100], mxb[400100];

void build(int v, int l, int r) {
	if (l == r - 1) {
		mna[v] = mxa[v] = mp(mp(a[l], b[l]), l);
		mnb[v] = mxb[v] = mp(mp(b[l], a[l]), l);
		return;
	}
	int ls = v << 1, rs = ls + 1, m = (l + r) >> 1;
	build(ls, l, m);
	build(rs, m, r);
	mna[v] = min(mna[ls], mna[rs]);
	mnb[v] = min(mnb[ls], mnb[rs]);
	mxa[v] = max(mxa[ls], mxa[rs]);
	mxb[v] = max(mxb[ls], mxb[rs]);
}

pair<pair<int, int>, int> getMna(int v, int L, int R, int l, int r) {
	if (r <= L || R <= l) {
		return mp(mp(2000000000, 2000000000), -1);
	}
	if (l <= L && R <= r) {
		return mna[v];
	}
	int ls = v << 1, rs = ls + 1, M = (L + R) >> 1;
	return min(getMna(ls, L, M, l, r), getMna(rs, M, R, l, r));
}

pair<pair<int, int>, int> getMnb(int v, int L, int R, int l, int r) {
	if (r <= L || R <= l) {
		return mp(mp(2000000000, 2000000000), -1);
	}
	if (l <= L && R <= r) {
		return mnb[v];
	}
	int ls = v << 1, rs = ls + 1, M = (L + R) >> 1;
	return min(getMnb(ls, L, M, l, r), getMnb(rs, M, R, l, r));
}

pair<pair<int, int>, int> getMxa(int v, int L, int R, int l, int r) {
	if (r <= L || R <= l) {
		return mp(mp(-2000000000, -2000000000), -1);
	}
	if (l <= L && R <= r) {
		return mxa[v];
	}
	int ls = v << 1, rs = ls + 1, M = (L + R) >> 1;
	return max(getMxa(ls, L, M, l, r), getMxa(rs, M, R, l, r));
}

pair<pair<int, int>, int> getMxb(int v, int L, int R, int l, int r) {
	if (r <= L || R <= l) {
		return mp(mp(-2000000000, -2000000000), -1);
	}
	if (l <= L && R <= r) {
		return mxb[v];
	}
	int ls = v << 1, rs = ls + 1, M = (L + R) >> 1;
	return max(getMxb(ls, L, M, l, r), getMxb(rs, M, R, l, r));
}

int main() {
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	int n;
	cin >> n;
	forn (i, n) {
		cin >> a[i] >> b[i];
	}
	build(1, 0, n);
	int k;
	cin >> k;
	forn (i, k) {
		int x, y;
		cin >> x >> y;
		--x;
		pair<pair<int, int>, int> p[4];
		p[0] = getMna(1, 0, n, x, y);
		p[1] = getMxa(1, 0, n, x, y);
		p[2] = getMnb(1, 0, n, x, y);
		p[3] = getMxb(1, 0, n, x, y);
		swap(p[2].fs.fs, p[2].fs.sc);
		swap(p[3].fs.fs, p[3].fs.sc);
		bool was = false;
		forn (i, 4) {
			forn (j, i) {
				if (p[i].sc != p[j].sc && p[i].fs.fs != p[j].fs.fs && p[i].fs.sc != p[j].fs.sc) {
					cout << p[i].sc + 1 << " " << p[j].sc + 1 << endl;
					was = true;
					break;
				}
			}
			if (was) {
				break;
			}
		}
		if (!was) {
			cout << "0 0\n";
		}
	}
}
