import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}
	
	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "password"; 
	private StringTokenizer tok = null;
	
	public ProblemA() throws Exception {
		init();
		solve();
		finish();
	}
	
	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}
	
	private void solve() throws Exception {
		char[] a = in.readLine().toCharArray();
		char[] b = in.readLine().toCharArray();
		boolean[] eq = new boolean[Math.min(a.length, b.length) + 1];
		eq[0] = true;
		for (int i = 1; a.length - i >= 0 && b.length - i >= 0; i++) {
			if (a[a.length - i] == b[b.length - i]) {
				eq[i] = true;
			} else {
				break;
			}
		}
		labelI:
		for (int i = 0; i < b.length; i++) {
			if (b[i] == '0') {
				continue;
			}
			int sumB = 0;
//			int sumB = b[i] - '0';
			int sumA = a[i] - '0';
			int lastIdx = i;
			for (int l = 1; l <= 6 && i + l - 1 < b.length; l++) {
				sumB = sumB * 10 + (b[i + l - 1] - '0');
//				if (b[i] == '0' && l != 1) {
//					break;
//				}
				while (sumA < sumB) {
					++lastIdx;
					if (lastIdx >= a.length) {
						continue labelI;
					}
					sumA += a[lastIdx] - '0';
				}
				while (b.length - (i + l - 1) < a.length - lastIdx &&
						a[lastIdx + 1] == '0') {
					++lastIdx;
				}
				while (b.length - (i + l - 1) > a.length - lastIdx &&
						lastIdx - 1 > i &&
						a[lastIdx - 1] == '0') {
					--lastIdx;
				}
				if (sumA == sumB && b.length - (i + l - 1) == a.length - lastIdx &&
						eq[a.length - lastIdx - 1]) {
					out.println((i + 1) + " " + (lastIdx + 1));
					return;
				}
			}
		}
		out.println("1 1");
	}
	
	private void finish() {
		out.close();
	}
	
	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
