import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}
	
	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "password"; 
	private StringTokenizer tok = null;
	
	public ProblemA() throws Exception {
		init();
		solve();
		finish();
	}
	
	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}
	
	private void solve() throws Exception {
		char[] a = in.readLine().toCharArray();
		char[] b = in.readLine().toCharArray();
		boolean[] eq = new boolean[Math.min(a.length, b.length) + 1];
		eq[0] = true;
        for (int i = 1; a.length - i >= 0 && b.length - i >= 0; i++) {
            if (a[a.length - i] == b[b.length - i]) {
                eq[i] = true;
            } else {
                break;
            }
        }
		int[] sum = new int[a.length + 1];
		for (int i = 0; i < a.length; i++) {
			sum[i + 1] = sum[i] + a[i] - '0';
		}
		for (int i = 0; i < b.length; i++) {
			int sumB = 0;
			for (int l = 1; l <= 6 && i + l - 1 < b.length; l++) {
				if (b[i] == '0' && l > 1) {
					break;
				}
				sumB = sumB * 10 + (b[i + l - 1] - '0');
				int last = a.length - (b.length - (i + l));
				if (eq[b.length - (i + l)] && last >= 0 && last < sum.length &&
						sumB == sum[last] - sum[i]) {
					out.println((i + 1) + " " + (a.length - (b.length - (i + l))));
					return;
				}
			}
		}
		out.println("1 1");
	}
	
	private void finish() {
		out.close();
	}
	
	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
