import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class ProblemB {
	public static void main(String[] args) throws Exception {
		new ProblemB();
	}

	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "virus";
	private StringTokenizer tok = null;

	public ProblemB() throws Exception {
		init();
		solve();
		finish();
	}

	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	int n;
	boolean[] was;
	ArrayList<Integer>[] edgesA, edgesB;
	int[] a, b;
	boolean[][] okA;
	long ans = 0;

	private void solve() throws Exception {
		n = nextInt();
		was = new boolean[n];
		okA = new boolean[n][n];
		a = new int[n];
		b = new int[n];
		edgesA = new ArrayList[n];
		edgesB = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			edgesA[i] = new ArrayList<Integer>();
			edgesB[i] = new ArrayList<Integer>();
		}
		int vA = -1;
		for (int i = 0; i < n; i++) {
			a[i] = nextInt() - 1;
			if (a[i] != -1) {
				edgesA[a[i]].add(i);
			} else {
				vA = i;
			}
		}
		int vB = -1;
		for (int i = 0; i < n; i++) {
			b[i] = nextInt() - 1;
			if (b[i] != -1) {
				edgesB[b[i]].add(i);
			} else {
				vB = i;
			}
		}
		dfsA(vA);
		dfsB(vB);
		out.println(ans);
	}

	void dfsA(int v) {
		for (int i = 0; i < n; i++) {
			if (was[i]) {
				okA[i][v] = true;
			}
		}
		was[v] = true;
		for (Integer u : edgesA[v]) {
			dfsA(u);
		}
		was[v] = false;
	}
	
	void dfsB(int v) {
		for (int i = 0; i < n; i++) {
			if (was[i]) {
				if (okA[i][v]) {
					++ans;
				}
			}
		}
		was[v] = true;
		for (Integer u : edgesB[v]) {
			dfsB(u);
		}
		was[v] = false;
	}

	private void finish() {
		out.close();
	}

	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
