import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemC {
	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "apricot";
	private StringTokenizer tok = null;

	public ProblemC() throws Exception {
		init();
		solve();
		finish();
	}

	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	long[] d;
	int n, r, u;

	private void solve() throws Exception {
		n = nextInt();
		r = nextInt();
		u = nextInt();
		d = new long[n + 1];
//		Arrays.fill(d, -1);
		d[0] = 0;
		d[1] = 0;
		d[2] = u;
//		out.println(go(n));
		for (int i = 3; i <= n; i++) {
			d[i] = Integer.MAX_VALUE;
			for (int j = 1; 2 * j <= i; j++) {
				d[i] = Math.min(d[i], Math.max(i- 2 * j == 0 ? 0 : r + d[i - 2 * j], u + d[j]));
			}
		}
		out.println(d[n]);
	}
	
	private long go(int k) {
		if (d[k] == -1) {
			if (k % 3 == 0) {
				d[k] = Math.max(r, u) + go(k / 3);
			} else {
				d[k] = Math.max(r, u) + go(k / 3 + 1);
			}
			if (k % 2 == 0) {
				d[k] = Math.min(d[k], u + go(k / 2));
			} else {
				d[k] = Math.min(d[k], Math.max(r, u + go(k / 2)));
			}
		}
		return d[k];
	}

	private void finish() {
		out.close();
	}

	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
