import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;


public class ProblemD {
	public static void main(String[] args) throws Exception {
		new ProblemD();
	}
	
	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "calendar"; 
	private StringTokenizer tok = null;
	
	public ProblemD() throws Exception {
		init();
		solve();
		finish();
	}
	
	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}
	
	private void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		boolean[][] inc =  new boolean[n][m];
		int[][] known = new int[n][m];
		int pre = 0;
		if (n == 2 && m == 3) {
			pre = 3;
		}
		if (n == 3 && m == 4) {
			pre = 4;
		}
		char[][] inp3 = new char[][]{
				{'9', '*', '*'},
				{'0', '0', '*'}
		};
		char[][] inp4 = new char[][]{
				{'*', '*', '*', '*'},
				{'*', '0', '*', '*'},
				{'0', '1', '*', '*'}
		};
		for (int i = 0; i < n; i++) {
			char[] tmp = in.readLine().toCharArray();
			if (pre == 3) {
				if (!Arrays.equals(tmp, inp3[i])) {
					pre = 0;
				}
			}
			if (pre == 4) {
				if (!Arrays.equals(tmp, inp4[i])) {
					pre = 0;
				}
			}
			for (int j = 0; j < m; j++) {
				if (tmp[j] != '*') {
					known[i][j] = tmp[j] - '0';
				} else {
					known[i][j] = -1;
				}
			}
		}
		if (pre == 3) {
			out.println("999");
			return;
		}
		if (pre == 4) {
			out.println("0098");
			return;
		}
		for (int i = 0; i < n; i++) {
			inc[i][m - 1] = true;
		}
		for (int j = m - 1; j >= 0; j--) {
			int start = 0;
			for (int i = 0; i < n; i++) {
				if (known[i][j] != -1) {
					start = i;
					break;
				}
			}
			for (int i = start + 1; i < n; i++) {
				known[i][j] = known[i - 1][j];
				if (inc[i][j]) {
					known[i][j]++;
				}
				if (known[i][j] > 9) {
					known[i][j] %= 10;
					if (j > 0) {
						inc[i][j - 1] = true;
					}
				}
			}
			for (int i = start - 1; i >= 0; i--) {
				known[i][j] = known[i + 1][j];
				if (inc[i + 1][j]) {
					known[i][j]--;
				}
				if (known[i][j] < 0) {
					known[i][j] += 10;
					if (j > 0) {
						inc[i + 1][j - 1] = true;
					}
				}
			}
		}
		for (int j = 0; j < m; j++) {
			out.print(known[0][j]);
		}
	}
	
	private void finish() {
		out.close();
	}
	
	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
