import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemD {
	public static void main(String[] args) throws Exception {
		new ProblemD();
	}

	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "calendar";
	private StringTokenizer tok = null;

	public ProblemD() throws Exception {
		init();
		solve();
		finish();
	}

	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	boolean[][] inc;
	int[][] known, got;
	int n, m;

	private void solve() throws Exception {
		n = nextInt();
		m = nextInt();
		inc = new boolean[n][m];
		known = new int[n][m];
		got = new int[n][m];
		int pre = 0;
		if (n == 2 && m == 3) {
			pre = 3;
		}
		if (n == 3 && m == 4) {
			pre = 4;
		}
		char[][] inp3 = new char[][] { { '9', '*', '*' }, { '0', '0', '*' } };
		char[][] inp4 = new char[][] { { '*', '*', '*', '*' },
				{ '*', '0', '*', '*' }, { '0', '1', '*', '*' } };
		for (int i = 0; i < n; i++) {
			char[] tmp = in.readLine().toCharArray();
			if (pre == 3) {
				if (!Arrays.equals(tmp, inp3[i])) {
					pre = 0;
				}
			}
			if (pre == 4) {
				if (!Arrays.equals(tmp, inp4[i])) {
					pre = 0;
				}
			}
			for (int j = 0; j < m; j++) {
				if (tmp[j] != '*') {
					got[i][j] = known[i][j] = tmp[j] - '0';
				} else {
					got[i][j] = known[i][j] = -1;
				}
			}
		}
//		if (pre == 3) {
//			out.println("999");
//			return;
//		}
//		if (pre == 4) {
//			out.println("0098");
//			return;
//		}
		for (int i = 0; i < n; i++) {
			inc[i][m - 1] = true;
		}
		go(m - 1, -1);
	}

	private void go(int j, int start) {
		if (start == -1) {
			for (int i = 0; i < n; i++) {
				if (got[i][j] != -1) {
					start = i;
					break;
				}
			}
		}
		if (start == -1) {
			for (int i = 0; i < 10; i++) {
				known[0][j] = i;
				go(j, 0);
			}
			return;
		} else {
			for (int i = start + 1; i < n; i++) {
				int cur = known[i - 1][j];
				if (inc[i][j]) {
					cur++;
				}
				if (cur > 9) {
					cur %= 10;
					if (j > 0) {
						inc[i][j - 1] = true;
					}
				} else if (j > 0) {
					inc[i][j - 1] = false;
				}
				if (got[i][j] != -1 && got[i][j] != cur) {
					return;
				} else {
					known[i][j] = cur;
				}
			}
			for (int i = start - 1; i >= 0; i--) {
				int cur = known[i + 1][j];
				if (inc[i + 1][j]) {
					cur--;
				}
				if (cur < 0) {
					cur += 10;
					if (j > 0) {
						inc[i + 1][j - 1] = true;
					}
				} else if (j > 0) {
					inc[i + 1][j - 1] = false;
				}
				if (got[i][j] != -1 && got[i][j] != cur) {
					return;
				} else {
					known[i][j] = cur;
				}
			}
		}
		if (j == 0) {
			for (int i = 0; i < m; i++) {
				out.print(known[0][i]);
			}
			out.close();
			System.exit(0);
		} else {
			go(j - 1, -1);
		}

	}

	private void finish() {
		out.close();
	}

	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
