import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;
	String fileName = "mosaic";

	public ProblemA() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}
	
	int n;
	int k;
	Elem[] a;
	int[] left;

	void solve() throws Exception {
		n = nextInt();
		a = new Elem[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Elem(nextInt(), nextInt());
		}
		left = new int[n];
		int curL = 0;
		int a1 = a[0].a;
		int a2 = 0;
		int b1 = a[0].b;
		int b2 = 0;
		int ca1 = 1;
		int ca2 = 0;
		int cb1 = 1;
		int cb2 = 0;
		for (int i = 1; i < n; i++) {
			boolean bad = false;
			if (a[i].a != a1) {
				if (a2 == 0) {
					a2 = a[i].a;
					ca2 = 1;
				} else if (a[i].a == a2) {
					ca2++;
				} else {
					bad = true;
				}
			} else {
				ca1++;
			}
			if (a[i].b != b1) {
				if (b2 == 0) {
					b2 = a[i].b;
					cb2 = 1;
				} else if (a[i].b == b2) {
					cb2++;
				} else {
					bad = true;
				}
			} else {
				cb1++;
			}
			while (ca2 > 0 && cb2 > 0) {
				if (a[curL].a == a1) {
					ca1--;
					if (ca1 == 0) {
						ca1 = ca2;
						ca2 = 0;
						a1 = a2;
						a2 = 0;
					}
				} else {
					ca2--;
					if (ca2 == 0) {
						a2 = 0;
					}
				}
				if (a[curL].b == b1) {
					ca1--;
					if (cb1 == 0) {
						cb1 = cb2;
						cb2 = 0;
						b1 = b2;
						b2 = 0;
					}
				} else {
					cb2--;
					if (cb2 == 0) {
						b2 = 0;
					}
				}
				curL++;
			}
			left[i] = curL;
		}
		
		
		
		k = nextInt();
		for (int i = 0; i < k; i++) {
			int l = nextInt() - 1;
			int r = nextInt() - 1;
			if (left[r] <= l) {
				out.println("0 0");
			} else {
				out.println(left[r] + " " + (r + 1));
			}
		}
	}
	

	class Elem {
		int a, b;

		public Elem(int a, int b) {
			this.a = a;
			this.b = b;
		}
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
