import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;
	String fileName = "mosaic";

	public ProblemA() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	int n;
	int k;
	Elem[] a;
	int[] leftA, leftB;

	void solve() throws Exception {
		n = nextInt();
		a = new Elem[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Elem(nextInt(), nextInt());
		}
		leftA = new int[n];
		leftB = new int[n];
		for (int i = 1; i < n; i++) {
			if (a[i].a == a[i - 1].a) {
				leftA[i] = leftA[i - 1];
			} else {
				leftA[i] = i;
			}
			if (a[i].b == a[i - 1].b) {
				leftB[i] = leftB[i - 1];
			} else {
				leftB[i] = i;
			}
		}
		k = nextInt();
		for (int i = 0; i < k; i++) {
			int l = nextInt() - 1;
			int r = nextInt() - 1;
			int min = Math.min(leftA[r], leftB[r]);
			if (l < min) {
				if (leftA[r] >= l) {
					if (leftA[r] - 1 >= l && !a[leftA[r]].ok(a[leftA[r] - 1])) {
						out.println((leftA[r] + 1) + " " + (leftA[r]));
					} else if (leftB[r] >= l && !a[leftA[r]].ok(a[leftB[r]])) {
						out.println((leftA[r] + 1) + " " + (leftB[r] + 1));
					} else if (leftB[r] - 1 >= l
							&& !a[leftA[r]].ok(a[leftB[r] - 1])) {
						out.println((leftA[r] + 1) + " " + (leftB[r]));
					}
				} else if (leftA[r] - 1 >= l) {
					if (leftB[r] >= l && !a[leftA[r] - 1].ok(a[leftB[r]])) {
						out.println((leftA[r]) + " " + (leftB[r] + 1));
					} else if (leftB[r] - 1 >= l
							&& !a[leftA[r] - 1].ok(a[leftB[r] - 1])) {
						out.println((leftA[r]) + " " + (leftB[r]));
					}
				} else if (leftB[r] >= l) {
					if (leftB[r] - 1 >= l && !a[leftB[r]].ok(a[leftB[r] - 1])) {
						out.println((leftB[r] + 1) + " " + (leftB[r]));
					}
				}

				// int[] pairs = { leftA[r], leftA[r] - 1, leftB[r], leftB[r] -
				// 1 };

				// for (int j = 0; j < pairs.length; j++) {
				// if (pairs[j] < l) {
				// continue;
				// }
				// for (int k = j + 1; k < pairs.length; k++) {
				// if (pairs[k] < l) {
				// continue;
				// }
				// if (!a[pairs[j]].ok(a[pairs[k]])) {
				// out.println((pairs[j] + 1) + " " + (pairs[k] + 1));
				// continue label;
				// }
				// }
				// }
				// out.println(leftA[r] + " " + leftB[r]);
			} else {
				out.println("0 0");
			}
		}
	}

	class Elem {
		int a, b;

		public Elem(int a, int b) {
			this.a = a;
			this.b = b;
		}

		boolean ok(Elem e) {
			return e.a == a || e.b == b;
		}
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
