import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;
	String fileName = "mosaic";

	public ProblemA() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	int n;
	int k;
	Elem[] a;
	int[] leftA, leftB;

	void solve() throws Exception {
		n = nextInt();
		a = new Elem[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Elem(nextInt(), nextInt());
		}
		leftA = new int[n];
		leftB = new int[n];
		for (int i = 1; i < n; i++) {
			if (a[i].a == a[i - 1].a) {
				leftA[i] = leftA[i - 1];
			} else {
				leftA[i] = i;
			}
			if (a[i].b == a[i - 1].b) {
				leftB[i] = leftB[i - 1];
			} else {
				leftB[i] = i;
			}
		}
		k = nextInt();
		for (int i = 0; i < k; i++) {
			int l = nextInt() - 1;
			int r = nextInt() - 1;
			int min = Math.min(leftA[r], leftB[r]);
			if (l < min) {
				int aa = leftA[r];
				int bb = leftA[r] - 1;
				int cc = leftB[r];
				int dd = leftB[r] - 1;
				if (aa >= l) {
					if (bb >= l && !a[aa].ok(a[bb])) {
						out.println((aa + 1) + " " + (bb + 1));
						continue;
					}
					if (cc >= l && !a[aa].ok(a[cc])) {
						out.println((aa + 1) + " " + (cc + 1));
						continue;
					}
					if (dd >= l && !a[aa].ok(a[dd])) {
						out.println((aa + 1) + " " + (dd + 1));
						continue;
					}
				}
				if (bb >= l) {
					if (cc >= l && !a[bb].ok(a[cc])) {
						out.println((bb + 1) + " " + (cc + 1));
						continue;
					}
					if (dd >= l && !a[bb].ok(a[dd])) {
						out.println((bb + 1) + " " + (dd + 1));
						continue;
					}
				}
				if (cc >= l) {
					if (dd >= l && !a[cc].ok(a[dd])) {
						out.println((cc + 1) + " " + (dd + 1));
						continue;
					}
				}
			}
			out.println("0 0");

		}
	}

	class Elem {
		int a, b;

		public Elem(int a, int b) {
			this.a = a;
			this.b = b;
		}

		boolean ok(Elem e) {
			return e.a == a || e.b == b;
		}
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
