import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Deque;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class ProbemB {
	public static void main(String[] args) throws Exception {
		new ProbemB();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;
	String fileName = "theatre";

	public ProbemB() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		int[] ans = new int[n];
		Set<Integer>[] sets = new Set[100000];
		ArrayList<Integer>[] queue = new ArrayList[sets.length];
		for (int i = 0; i < sets.length; i++) {
			sets[i] = new HashSet<Integer>();
			queue[i] = new ArrayList<Integer>();
		}
		Deque<Integer> emptySets = new ArrayDeque<Integer>();
		for (int i = 1; i < sets.length; i++) {
			emptySets.addLast(i);
		}
		int[] color = new int[n];
		for (int i = 0; i < n; i++) {
			sets[0].add(i);
		}
		for (int i = 1; i <= m; i++) {
			int k = nextInt();
			ArrayList<Integer> list = new ArrayList<Integer>(k);
			for (int j = 0; j < k; j++) {
				int a = nextInt() - 1;
				if (ans[a] != 0) {
					continue;
				}
				queue[color[a]].add(a);
				list.add(color[a]);
			}
			for (Integer q : list) {
				if (queue[q].isEmpty()) {
					continue;
				}
				if (queue[q].size() == 1) {
					ans[queue[q].get(0)] = i;
					sets[q].remove(queue[q].get(0));
				} else {
					int set = emptySets.pollFirst();
					for (Integer b : queue[q]) {
						sets[q].remove(b);
						sets[set].add(b);
						color[b] = set;
					}
				}
				queue[q].clear();
				if (sets[q].size() == 1) {
					for (Integer b : sets[q]) {
						ans[b] = i;
					}
					sets[q].clear();
				}
				if (sets[q].isEmpty()) {
					emptySets.addLast(q);
				}
				
			}
//			System.out.println(">>" + i + "<<");
//			for (int j = 0; j < 5; j++) {
//				System.out.println(j);
//				for (Integer kk : sets[j]) {
//					System.out.print(kk + " ");
//				}
//				System.out.println();
//			}
//			System.out.println(Arrays.toString(color));
		}
		for (int i = 0; i < n; i++) {
			out.print(ans[i] + " ");
		}
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
