import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemC {
	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;

	public ProblemC() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
	}

	int n, m;
	int x, y;
	int xl, yl;
	int tmpX, tmpY;
	int minX, minY, maxX, maxY;
	boolean atStart = false;
	boolean realX = false;
	boolean realY = false;
	boolean straight = false;
	int step = 0;

	void solve() throws Exception {
		n = nextInt();
		m = nextInt();
		x = nextInt();
		y = nextInt();
		boolean[][] mask = new boolean[m * 2 + 1][n * 2 + 1];
		mask[m][n] = true;
		tmpX = minX = maxX = m;
		tmpY = minY = maxY = n;
		while (true) {
			step++;
			if (step % 119 == 0) {
				out.println("0 0 0");
				out.flush();
			} else if (!atStart) {
				toStart();
			} else if (!realX && !realY) {
				scan();
			} else if (realX && !realY) {
				if (x < tmpX) {
					out.print("1 ");
				} else if (x > tmpX) {
					out.print("1 ");
				} else {
					out.print("0 ");
				}
				int dy = straight ? 1 : -1;
				if (y + dy < 1 || y + dy > n) {
					straight = !straight;
					dy = straight ? 1 : -1;
				}
				out.println(dy + " 1");
				out.flush();
			} else if (!realX && realY){
				int dx = straight ? 1 : -1;
				if (x + dx < 1 || x + dx > m) {
					straight = !straight;
					dx = straight ? 1 : -1;
				}
				out.print(dx + " ");
				if (y < tmpY) {
					out.print("1 ");
				} else if (y > tmpY) {
					out.print("1 ");
				} else {
					out.print("0 ");
				}
				out.println("1");
				out.flush();
			} else {
				toPoint(tmpX, tmpY);
			}
			int t = nextInt();
			int dx = nextInt();
			int dy = nextInt();
			if (t == 1) {
				return;
			}
			tmpX += dx;
			tmpY += dy;
			minX = Math.min(minX, tmpX);
			maxX = Math.max(maxX, tmpX);
			minY = Math.min(minY, tmpY);
			maxY = Math.max(maxY, tmpY);
			if (!realX && maxX - minX + 1 == m) {
				realX = true;
				tmpX -= minX;
			}
			if (!realY && maxY - minY + 1 == n) {
				realY = true;
				tmpY -= minY;
			}
		}
	}

	void toStart() {
		if (x > 1) {
			out.print("-1 ");
		} else {
			out.print("0 ");
		}
		if (y > 1) {
			out.print("-1 ");
		} else {
			out.print("0 ");
		}
		out.println("1");
		out.flush();
		if (x == 1 && y == 1) {
			atStart = true;
		}
	}

	void scan() {
		int dx = y % 2 == 0 ? 1 : -1;
		int dy = 0;
		if (x + dx < 1 || x + dx > m) {
			dx = 0;
			dy = 1;
		}
		if (y + dy > n) {
			atStart = false;
			toStart();
			return;
		}
		out.println(dx + " " + dy + " 1");
		out.flush();
	}
	
	void toPoint(int x0, int y0) {
		if (x < x0) {
			out.print("1 ");
		} else if (x > x0) {
			out.print("-1 ");
		} else {
			out.print("0 ");
		}
		if (y < y0) {
			out.print("1 ");
		} else if (y > y0) {
			out.print("-1 ");
		} else {
			out.print("0 ");
		}
		out.println("1");
		out.flush();
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
