import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemC {
	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;

	public ProblemC() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
	}

	int n, m;
	int x, y;
	int xl, yl;
	int tmpX, tmpY;
	int minX, minY, maxX, maxY;
	boolean atStart = false;
	boolean realX = false;
	boolean realY = false;
	boolean straight = false;
	int step = 0;

	void solve() throws Exception {
		n = nextInt();
		m = nextInt();
		x = nextInt();
		y = nextInt();
//		boolean[][] mask = new boolean[m * 2 + 1][n * 2 + 1];
//		mask[m][n] = true;
		tmpX = minX = maxX = m;
		tmpY = minY = maxY = n;
		while (true) {
			step++;
			if (step % 119 == 0) {
				move(0, 0, 0);
				out.flush();
			} else if (!atStart) {
				toStart();
			} else if (!realX && !realY) {
				scan();
			} else if (realX && !realY) {
				int dx = dir(x, tmpX);
				int dy = straight ? 1 : -1;
				if (y + dy < 1 || y + dy > n) {
					straight = !straight;
					dy = straight ? 1 : -1;
				}
				move(dx, dy, 1);
			} else if (!realX && realY){
				int dx = straight ? 1 : -1;
				if (x + dx < 1 || x + dx > m) {
					straight = !straight;
					dx = straight ? 1 : -1;
				}
				x += dx;
				int dy = dir(y, tmpY);
				move(dx, dy, 1);
			} else {
				toPoint(tmpX, tmpY);
			}
			int t = nextInt();
			int dx = nextInt();
			int dy = nextInt();
			if (t == 1) {
				return;
			}
			tmpX += dx;
			tmpY += dy;
			minX = Math.min(minX, tmpX);
			maxX = Math.max(maxX, tmpX);
			minY = Math.min(minY, tmpY);
			maxY = Math.max(maxY, tmpY);
			if (!realX && maxX - minX + 1 == m) {
				realX = true;
				tmpX -= minX;
			}
			if (!realY && maxY - minY + 1 == n) {
				realY = true;
				tmpY -= minY;
			}
		}
	}
	
	int dir(int x1, int x2) {
		if (x1 < x2) {
			return 1;
		} else if (x1 > x2) {
			return -1;
		} else {
			return 0;
		}
	}

	void toStart() {
		toPoint(1, 1);
		if (x == 1 && y == 1) {
			atStart = true;
		}
	}

	void scan() {
		int dx = y % 2 == 0 ? 1 : -1;
		int dy = 0;
		if (x + dx < 1 || x + dx > m) {
			dx = 0;
			dy = 1;
		}
		if (y + dy > n) {
			atStart = false;
			toStart();
			return;
		}
		move(dx, dy, 1);
	}
	
	void toPoint(int x0, int y0) {
		int dx = dir(x, x0);
		int dy = dir(y, y0);
		move(dx, dy, 1);
	}
	
	void move(int dx, int dy, int t) {
		out.println(dx + " " + dy + " " + t);
		out.flush();
		x += dx;
		y += dy;
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
