import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemC {
	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;

	public ProblemC() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
	}

	int N, M;
	int x, y;
	int xl, yl;
	int tmpX, tmpY;
	int minX, minY, maxX, maxY;
	boolean back = false;
	int step = 0;

	void solve() throws Exception {
		N = nextInt();
		M = nextInt();
		x = nextInt();
		y = nextInt();
		tmpX = minX = maxX = M;
		tmpY = minY = maxY = N;
		while (step < 10000) {
			step++;
			if (step % 119 == 0) {
				move(0, 0, 0);
			} else {
				scan(tmpX - minX + 1, tmpY - minY + 1, M - (maxX - tmpX), N
						- (maxY - tmpY));
			}
			int t = nextInt();
			int dx = nextInt();
			int dy = nextInt();
			if (t == 1) {
				return;
			}
			tmpX += dx;
			tmpY += dy;
			minX = Math.min(minX, tmpX);
			maxX = Math.max(maxX, tmpX);
			minY = Math.min(minY, tmpY);
			maxY = Math.max(maxY, tmpY);
		}
		int ML = 10000;
		int[][] ML2 = new int[ML][ML];
	}

	int dir(int x1, int x2) {
		if (x1 < x2) {
			return 1;
		} else if (x1 > x2) {
			return -1;
		} else {
			return 0;
		}
	}

	void scan(int xl, int yl, int xr, int yr) {
		if (x < xl || y < yl || x > xr || y > yr) {
			toPoint((xl + xr) / 2, (yl + yr) / 2, 2);
			return;
		}
		int dx = !back ? ((y - yl) % 2 == 0 ? 1 : -1) : ((yr - y) % 2 == 0 ? -1
				: 1);
		int dy = 0;
		if (x + dx < xl || x + dx > xr) {
			dx = 0;
			dy = !back ? 1 : -1;
		}
		if (y + dy > yr || y + dy < yl) {
			back = !back;
			scan(xl, yl, xr, yr);
			return;
		}
		move(dx, dy, 1);
	}

	void toPoint(int x0, int y0, int t) {
		int dx = dir(x, x0);
		int dy = dir(y, y0);
		move(dx, dy, t == 0 || (t == 2 && (x + dx != x0 || y + dy != y0)) ? 0
				: 1);
	}

	void move(int dx, int dy, int t) {
		out.println(dx + " " + dy + " " + t);
		out.flush();
		x += dx;
		y += dy;
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
