import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemD {
	public static void main(String[] args) throws Exception {
		new ProblemD();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = null;
	String fileName = "army";

	public ProblemD() throws Exception {
		init();
		solve();
		finish();
	}

	void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	int n, k;
	int[] t;
	int[] cur;
	boolean[] was;
	int[] min;
	long ans = 0;
	int[] ch;
	int[] toChoose;
	
	void solve() throws Exception {
		n = nextInt();
		k = nextInt();
		t = new int[k];
		toChoose = new int[n - k];
		cur = new int[n];
		was = new boolean[n];
		ch = new int[n + 1];
		for (int i = 0; i < k; i++) {
			t[i] = nextInt();
		}
		int tmp = 0;
		l:
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j < k; j++) {
				if (i == t[j]) {
					continue l;
				}
			}
			toChoose[tmp++] = i;
		}
		go1(0, 0);
		out.println(ans);
	}
	
	void go1(int pos, int tel) {
//		System.out.println("go1 " + pos + " " + tel);
		if (pos == n) {
			return;
		}
		go1(pos + 1, tel);
		cur[pos] = t[tel];
		was[t[tel] - 1] = true;
		if (tel == t.length - 1) {
			go2(0);
		} else {
			go1(pos + 1, tel + 1);
		}
		was[t[tel] - 1] = false;
		cur[pos] = 0;
	}
	
	void go2(int pos) {
		if (pos == n) {
			check();
			return;
		}
		if (cur[pos] != 0) {
			go2(pos + 1);
			return;
		}
		for (int i = 1; i <= n; i++) {
			if (!was[i - 1]) {
				cur[pos] = i;
				was[i - 1] = true;
				go2(pos + 1);
				was[i - 1] = false;
				cur[pos] = 0;
			}
		}
	}
	
	void check() {
//		System.out.println(Arrays.toString(cur));
		Arrays.fill(ch, n + 1);
		ch[0] = 0;
		int max = 0;
		for (Integer i : toChoose) {
			int l = 0;
			int r = n + 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (ch[m] < cur[i]) {
					l = m;
				} else {
					r = m;
				}
			}
			ch[l + 1] = cur[i];
			max = Math.max(l + 1, max);
			if (max > k) {
				return;
			}
		}
		ans++;
	}

	void finish() {
		out.close();
	}

	String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
