import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;

public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	public ProblemA() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("password.in"));
		PrintWriter out = new PrintWriter("password.out");
		String s = in.readLine();
		while (s != null) {
			String a = s;
			String b = in.readLine();
			initH(a, b);
			int n = a.length();
			int m = b.length();
			int[][] sumL = new int[n][6];
			for (int i = 0; i < n; i++) {
				sumL[i][0] = a.charAt(i) - '0';
			}
			for (int j = 1; j < 6; j++) {
				sumL[n - 1][j] = a.charAt(n - 1) - '0';
				for (int i = n - 2; i >= 0; i--) {
					sumL[i][j] = sumL[i + 1][j - 1] + a.charAt(i) - '0';
				}
			}
			int resL = -1;
			int resR = -1;
			for (int i = 0; i < n && resL == -1; i++) {
				for (int len = 0; len < 6 && i + len < n && resL == -1; len++) {
					System.out.println(i + " " + (i + len));
					int sum = sumL[i][len];
					System.out.println(" sum: " + sum);
					String sumS = sum + "";
					boolean eq = true;
					for (int ind = i; ind - i < sumS.length(); ind++) {
						System.out.println("   " + ind);
						if (sumS.charAt(ind - i) != b.charAt(ind)) {
							eq = false;
						}
					}
					if (eq
							&& a.length() - len - 1 == b.length()
									- sumS.length()
							&& (i == 0 || getHA(0, i - 1) == getHB(0, i - 1))
							&& (i + len + 1 == a.length() || getHA(i + len + 1,
									a.length() - 1) == getHB(i + sumS.length(),
									b.length() - 1))) {
						resL = i;
						resR = i + len;
					}
				}
			}
			out.println((resL + 1) + " " + (resR + 1));
			s = in.readLine();
		}
		out.close();
	}

	private int getHA(int i, int j) {
		if (i == 0) {
			return hashA[j];
		}
		return hashA[j] - hashA[i - 1] * powP[j - i + 1];
	}

	private int getHB(int i, int j) {
		if (i == 0) {
			return hashB[j];
		}
		return hashB[j] - hashB[i - 1] * powP[j - i + 1];
	}

	int[] hashA;
	int[] hashB;
	final int P = 1000000007;
	int[] powP;

	private void initH(String a, String b) {
		powP = new int[100010];
		powP[0] = 1;
		for (int i = 1; i < powP.length; i++) {
			powP[i] = powP[i - 1] * P;
		}
		hashA = new int[a.length()];
		hashA[0] = a.charAt(0);
		for (int i = 1; i < a.length(); i++) {
			hashA[i] = hashA[i - 1] * P + a.charAt(i);
		}
		hashB = new int[a.length()];
		hashB[0] = b.charAt(0);
		for (int i = 1; i < b.length(); i++) {
			hashB[i] = hashB[i - 1] * P + b.charAt(i);
		}
	}
}
