#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <ctime>

using namespace std;

#define ll long long
#define mp make_pair
#define st first
#define nd second

ll prime = 1e9 + 9;

const int MAX_SIZE = 1e5 + 10;

int get_num(const string & s, int l, int r){
	if(s[l] == '0')
		return -1;
	int res = 0;
	bool f = 1;
	for(int i = l; i <= r; ++i)
		res = res * 10 + s[i] - '0';
	return res;
}

int get_sum(const string & s, int l, int r){
	int res = 0;
	for(int i = l; i <= r; ++i)
		res += s[i] - '0';
	return res;
}

ll calc_hash(vector<ll> & hash, vector<ll> & p, int l, int r){
	return (hash[r] - (l ? hash[l - 1] : 0)) * p[MAX_SIZE - l - 1];
}

pair<int, int> solution(const string & s1, const string & s2){
	int len1 = s1.length(), len2 = s2.length();

	vector<ll> p(MAX_SIZE);
	vector<ll> hash1(len1), hash2(len2);
	p[0] = 1;
	for(int i = 1; i < MAX_SIZE; ++i)
		p[i] = p[i - 1] * prime;
	hash1[0] = s1[0];
	hash2[0] = s2[0];
	for(int i = 1; i < len1; ++i)
		hash1[i] = hash1[i - 1] + s1[i] * p[i];
	for(int i = 1; i < len2; ++i)
		hash2[i] = hash2[i - 1] + s2[i] * p[i];

	vector<int> sum(len1);
	sum[0] = s1[0] - '0';
	for(int i = 1; i < len1; ++i)
		sum[i] = sum[i - 1] + s1[i] - '0';

	for(int j = 0; j < len2; ++j)
		for(int k = 0; k < 10 && j + k < len2; ++k){
			if( (!j || hash1[j - 1] == hash2[j - 1]) && 
				(j + k == len2 - 1 || (calc_hash(hash2, p, j + k + 1, len2 - 1) == calc_hash(hash1, p, len1 - (len2 - (j + k)) + 1, len1 - 1))) &&
				(get_num(s2, j, j + k) == sum[len1 - len2 + j + k] - (j ? sum[j - 1] : 0))){
					return mp(j + 1, len1 - (len2 - (j + k)) + 1);
			}
		}
	return mp(-1, -1);
}

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);
#endif
	string s1, s2;
	cin >> s1 >> s2;
	pair<int, int> ans = solution(s1, s2);
	cout << ans.st << ' ' << ans.nd << endl;
	/*srand( time(0) );
	for(int i = 0; i < 1000; ++i){
		int x1 = max(10, rand() % int(1e9));
		string s1;
		char * buf = new char[100];
		sprintf(buf, "%d", x1);
		s1 = buf;
		int l = rand() % (s1.length()), r = max((int)1, (int)min( rand() % 10, int(s1.length() - 1)));
		int a = get_sum(s1, l, r);
		sprintf(buf, "%d", a);
		string s2 = s1.substr(0, l) + buf + s1.substr(r + 1);
		pair<int, int> ans = solution(s1, s2);
		if(ans.st != l + 1 || ans.nd != r + 1){
			cout << s1 << endl << s2 << endl;
			cout << ans.st << ' ' << ans.nd << endl;
			return 0;
		}
	}*/
	return 0;
}