#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define ll long long

ll prime = 37;

const int MAX_SIZE = 1e5 + 10;

void make_p(vector<ll> & p){
	p = vector<ll>(MAX_SIZE);
	p[0] = 1;
	for(int i = 1; i < MAX_SIZE; ++i)
		p[i] = p[i - 1] * prime;
}

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);
#endif
	int n, m;
	scanf("%d%d", &n, &m);

	vector<ll> hash(n, 0), p;
	make_p(p);
	map<ll, set<int>> played;
	for(int i = 0; i < n; ++i)
		played[0].insert(i);
	vector<bool> used(n, 0);
	vector<int> count(n, 0), ans(n, 0);
	set<int> cur;

	for(int q = 0; q < m; ++q){
		cur.clear();
		int k, a;
		scanf("%d", &k);
		for(int i = 0; i < k; ++i){
			scanf("%d", &a), --a;
			if(used[a])
				continue;

			played[hash[a]].erase(a);
			if(played[hash[a]].size() == 1){
				cur.insert(*played[hash[a]].begin());
			} else if(played[hash[a]].size() == 0){
				cur.erase(a);
			}

			hash[a] += p[count[a]++] * (q + 1);

			played[hash[a]].insert(a);
			if(played[hash[a]].size() == 1){
				cur.insert(a);
			} else if(played[hash[a]].size() == 2){
				if(*played[hash[a]].begin() == a)
					cur.erase(*played[hash[a]].rbegin());
				else
					cur.erase(*played[hash[a]].begin());
			}
		}

		for(auto j = cur.begin(); j != cur.end(); ++j){
			used[*j] = 1;
			played[hash[*j]].erase(*j);
			ans[*j] = q + 1;
		}
	}

	for(int i = 0; i < n; ++i)
		printf("%d ", ans[i]);
	return 0;
}