#include <cstdio>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

#ifdef _WIN32
#define lld "%I64d"
#else
#define lld "%lld"
#endif
#define N 100010

struct vertex {
	int st, fin;
};

struct node {
	int sum;
	int b;
};

int n, nk;
node tree[4 * N];
vector<int> g1[N], g2[N];
int root1, root2;
vertex vs[N];
int pos[N], spos;
long long cnt = 0;

void read() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		int a;
		scanf("%d", &a);
		if (a == 0) {
			root1 = i;
			continue;
		}
		g1[--a].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int a;
		scanf("%d", &a);
		if (a == 0) {
			root2 = i;
			continue;
		}
		g2[--a].push_back(i);
	}
}

void dfs1(int v) {
	pos[spos++] = v;
	vs[v].st = spos;
	for (int i = 0; i < g1[v].size(); i++)
		dfs1(g1[v][i]);
	vs[v].fin = spos;
}
           
void init() {
	spos = 0;
	nk = 1;
	while (nk < n)
		nk = nk << 1;
	for (int i = 1; i < 2 * nk; i++)
		tree[i].b = tree[i].sum = 0;
}

void push(int v, int l, int r) {
	if (v >= nk) {
		tree[v].sum += tree[v].b;
		tree[v].b = 0;
		return;
	}
	int t = tree[v].b;
	tree[v].b = 0;
	tree[2 * v].b += t;
	tree[2 * v + 1].b += t;
	tree[v].sum += t * (r - l);
}

void update(int v) {
	tree[v].sum = tree[v * 2].sum + tree[v * 2 + 1].sum;
}

int get(int v, int l, int r, int lq, int rq) {
	if (rq <= l || r <= lq)
		return 0;
	push(v, l, r);
	if (lq <= l && r <= rq)
		return tree[v].sum; 
	int m = (r + l) / 2;
	int a1 = get(v * 2, l, m, lq, rq);
	int a2 = get(v * 2 + 1, m, r, lq, rq);
	return a1 + a2;
}

void put(int v, int l, int r, int lq, int rq, int key) {
	if (rq <= l || r <= lq)
		return;
	if (lq <= l && r <= rq) {
		tree[v].b += key; 
		return;
	}
	push(v, l, r);
	int m = (r + l) / 2;
	put(2 * v, l, m, lq, rq, key);
	put(2 * v + 1, m, r, lq, rq, key);
	update(v);
}

void dfs2(int v) {
	cnt += get(1, 0, nk, vs[v].st - 1, vs[v].st);
	put(1, 0, nk, vs[v].st, vs[v].fin, 1);
	for (int i = 0; i < g2[v].size(); i++)
		dfs2(g2[v][i]);
	put(1, 0, nk, vs[v].st, vs[v].fin, -1);
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	read();
	init();
	dfs1(root1);
	dfs2(root2);
	printf(lld "\n", cnt);
	return 0;
}
