#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair

int l1[100005];
int r1[100005];
int l2[100005];
int r2[100005];

vector<int> k1[100005];
vector<int> k2[100005];
int timer;
void dfs1(int i, int p)
{
	l1[i] = timer++;
	for (int j = 0; j < k1[i].size(); j++)
		if (k1[i][j] != p) dfs1(k1[i][j], i);
	r1[i] = timer++;	
}

void dfs2(int i, int p)
{
	l2[i] = timer++;
	for (int j = 0; j < k2[i].size(); j++)
		if (k2[i][j] != p) dfs2(k2[i][j], i);
	r2[i] = timer++;	
}


const int sz = 300005;
int fenw[sz];

void inc(int i, int v)
{
   i++;
   for (; i < sz; i += -i & i) fenw[i]+=v;
}


int sum(int i)
{
   int ans = 0;
   i++;
	for (; i > 0; i &= i-1) ans+=fenw[i];
	return ans;
}

int sum(int i, int j)
{
	if (i == 0) return sum(j);
	return sum(j) - sum(i-1);
}

struct event
{
	int type; //0 - open 1 - close
	int l, r, x, num;
	event(){}
	event(int type, int l, int r, int x, int num):type(type), l(l), r(r), x(x), num(num) {}
};

inline bool operator <(const event &a, const event &b)
{
	if (a.x < b.x) return 1;
	if (a.x > b.x) return 0;
	if (a.type < b.type) return 1;
	if (a.type > b.type) return 0;
	return (a.r - a.l) < (b.r - b.l);
}

int main()
{

	freopen("virus.in","r",stdin);
	freopen("virus.out","w",stdout);
	int n,p;
	cin >> n;
	int root1, root2;
	for (int i = 0; i < n; i++)
	{   
		cin >> p;
		p--;
		if (p != -1) k1[p].pb(i);
		else root1 = i;
	}
	for (int i = 0; i < n; i++)
	{   
		cin >> p;
		p--;
		if (p != -1) k2[p].pb(i);
		else root2 = i; 
	}

	timer = 1;
	dfs1(root1, -1);
	timer = 1;
	dfs2(root2, -1);

//	for (int i = 0; i < n; i++)
//		cout << l1[i] << ".." << r1[i] << "; " << l2[i] << ".." << r2[i] << endl;

	vector<event> ev;
	for (int i = 0; i < n; i++)
	{
		ev.pb(event(0, l2[i], r2[i], l1[i], i));
		ev.pb(event(1, l2[i], r2[i], r1[i], i));
	}

	sort(ev.begin(), ev.end());
//	for (int i = 0; i < ev.size(); i++)
//	{
//		cout << ev[i].x << endl;
//		cout << ev[i].l << ".." << ev[i].r << endl;
//
//		cout << ev[i].type << endl;
//	}
	vector<int> ans(n);
	for (int i = 0; i < ev.size(); i++)
	{
		if (ev[i].type == 0)
		{
			ans[ev[i].num] -= sum(ev[i].l, ev[i].r);
			inc(ev[i].l, 1);
		}
		else
		{
		   //inc(ev[i].l, -1);
			ans[ev[i].num] += sum(ev[i].l, ev[i].r) - 1;
			
		}
	}

	long long sum = 0ll;
	for (int i = 0; i < n; i++)
		sum += (long long) ans[i];
	cout << sum << endl;
	return 0;

}