#include <cstdio>
#include <vector>
#include <cstring>

#define TASKNAME "hear"

using std::vector;

void addNumber(vector <int> & v, int num, int f)
{
    if (num == 0)
        return ;
    if (num >= 100)
        v.push_back(num - num % 100);
    num %= 100;
    if (num / 10 == 1)
        v.push_back(num);
    else
    {
        if (num / 10 != 0)
            v.push_back(num - num % 10);
        if (num % 10 != 0)
            v.push_back(num % 10);
    }
    if (f != 1)
        v.push_back(f);
}

void addNumber(vector <int> & v, int num)
{
    for (int i = 1000000; i >= 1; i /= 1000)
    {
        addNumber(v, num / i, i);
        num %= i;
    }
}

vector < vector <int> > ans;
vector < int > nums;
vector < int > cur;

int length(int num)
{
    int len = 0;
    while (num)
    {
        ++len;
        num /= 10;
    }
    return len;
}

int getNumber(int l, int r)
{
    int res = 0;
    int part = 0;
    for (int i = l; i <= r; ++i)
    {
        if (nums[i] >= 1000)
        {
            if (part == 0)
                return -1;  
            res += part * nums[i];
            part = 0;
        }
        else
        {
            if (part != 0 && length(nums[i - 1]) <= length(nums[i]))
                return -1;
            part += nums[i];
        }
    }
    return res + part;
}

void brute(int k)
{
    if (k == int(nums.size()))
    {
        ans.push_back(cur);
        return ;
    }

    for (int l = k; l < int(nums.size()); ++l)
    {
        int curNum = getNumber(k, l);
        if (curNum == -1)
            break;
        cur.push_back(curNum);
        brute(l + 1);
        cur.pop_back();
    }
}

char s[20];

int main()
{
    freopen(TASKNAME ".in", "rb", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    while (1)
    {
        scanf("%[0-9]", s);
        int len = strlen(s);

        int d;
        sscanf(s, "%d", &d);
        addNumber(nums, d);

        char ch;
        scanf("%c", &ch);
        if (ch != '-')
            break;
    }

    brute(0);

    printf("%d\n", int(ans.size()));
    for (int i = 0; i < int(ans.size()); ++i)
    {
        printf("%d", ans[i][0]);
        for (int j = 1; j < int(ans[i].size()); ++j)
            printf("-%d", ans[i][j]);
        printf("\n");
    }

    return 0;
}