import java.io.*;
import java.util.Locale;

public class parade_sm_slow_2n {

    void solve() {
        int n = in.nextInt();
        in.nextLine();
        assert 1 <= n && n <= 100000;
        int[] h = new int[n];
        for (int i = 0; i < h.length; i++) {
            h[i] = in.nextInt();
            assert 1 <= h[i] && h[i] <= 1e9;
        }
        for (int mask = 0; mask < (1 << n); mask++) {
            if (check(h, mask, 1) && check(h, ((1 << n) - 1) ^ mask, -1)) {
                out.println(Integer.bitCount(mask));
                for (int i = 0; i < n; i++) {
                    if ((mask & (1 << i)) > 0) {
                        out.print((i + 1) + " ");
                    }
                }
                out.println();
                return;
            }
        }
        out.println("Impossible");
    }

    boolean check(int[] h, int mask, int sign) {
        int prev = -1;
        for (int i = 0; i < h.length; i++) {
            if ((mask & (1 << i)) > 0) {
                if (prev != -1) {
                    if (h[prev] * sign >= h[i] * sign) {
                        return false;
                    }
                }
                prev = i;
            }
        }
        return true;
    }


    Scanner in;
    PrintWriter out;

    void run() throws IOException {
        in = new Scanner(new File("parade.in"));
        out = new PrintWriter("parade.out");
        solve();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new parade_sm_slow_2n().run();
    }


//----------------- just for validation ------------------

    /**
     * Strict scanner to veryfy 100% correspondence between input files and input file format specification.
     * It is a drop-in replacement for {@link java.util.Scanner} that could be added to a soulution source
     * (cut-and-paste) without breaking its ability to work with {@link java.util.Scanner}.
     */
    private static class Scanner {
        private final BufferedReader in;
        private String line = "";
        private int pos;
        private int lineNo;
        private boolean localeset;

        public Scanner(File source) throws FileNotFoundException {
            in = new BufferedReader(new FileReader(source));
            nextLine();
        }

        public Scanner(InputStream inputStream) throws FileNotFoundException {
            in = new BufferedReader(new InputStreamReader(inputStream));
            nextLine();
        }

        public void close() {
            assert line == null : "Extra data at the end of file";
            try {
                in.close();
            } catch (IOException e) {
                throw new AssertionError("Failed to close with " + e);
            }
        }

        public void nextLine() {
            assert line != null : "EOF";
            assert pos == line.length() : "Extra characters on line " + lineNo;
            try {
                line = in.readLine();
            } catch (IOException e) {
                throw new AssertionError("Failed to read line with " + e);
            }
            pos = 0;
            lineNo++;
        }

        public String next() {
            assert line != null : "EOF";
            assert line.length() > 0 : "Empty line " + lineNo;
            if (pos == 0)
                assert line.charAt(0) > ' ' : "Line " + lineNo + " starts with whitespace";
            else {
                assert pos < line.length() : "Line " + lineNo + " is over";
                assert line.charAt(pos) == ' ' : "Wrong whitespace on line " + lineNo;
                pos++;
                assert pos < line.length() : "Line " + lineNo + " is over";
                assert line.charAt(0) > ' ' : "Line " + lineNo + " has double whitespace";
            }
            StringBuilder sb = new StringBuilder();
            while (pos < line.length() && line.charAt(pos) > ' ')
                sb.append(line.charAt(pos++));
            return sb.toString();
        }

        public int nextInt() {
            String s = next();
            assert s.length() == 1 || s.charAt(0) != '0' : "Extra leading zero in number " + s + " on line " + lineNo;
            assert s.charAt(0) != '+' : "Extra leading '+' in number " + s + " on line " + lineNo;
            try {
                return Integer.parseInt(s);
            } catch (NumberFormatException e) {
                throw new AssertionError("Malformed number " + s + " on line " + lineNo);
            }
        }

        public long nextLong() {
            String s = next();
            assert s.length() == 1 || s.charAt(0) != '0' : "Extra leading zero in number " + s + " on line " + lineNo;
            assert s.charAt(0) != '+' : "Extra leading '+' in number " + s + " on line " + lineNo;
            try {
                return Long.parseLong(s);
            } catch (NumberFormatException e) {
                throw new AssertionError("Malformed number " + s + " on line " + lineNo);
            }
        }

        public double nextDouble() {
            assert localeset : "Locale must be set with useLocale(Locale.US)";
            String s = next();
            assert s.length() == 1 || s.startsWith("0.") || s.charAt(0) != '0' : "Extra leading zero in number " + s + " on line " + lineNo;
            assert s.charAt(0) != '+' : "Extra leading '+' in number " + s + " on line " + lineNo;
            // at most two digits
            assert s.indexOf('.') < 0 || s.indexOf('.') >= s.length() - 3;
            try {
                return Double.parseDouble(s);
            } catch (NumberFormatException e) {
                throw new AssertionError("Malformed number " + s + " on line " + lineNo);
            }
        }

        public void useLocale(Locale locale) {
            assert locale == Locale.US;
            localeset = true;
        }
    }

}
