import java.util.*;
import java.io.*;


public class sideslip_ab {
    public static void main(String[] arg) {
        new sideslip_ab().run();
    }

    StrictScanner in;
    PrintWriter out;

    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAX = (int)1e6;

    void solve() throws Exception {
    	int v = assertBetween(1, in.loadLine().nextInt(), MAX, "v");
    	int x = assertBetween(1, in.skipSpace().nextInt(), MAX, "x");
    	int y = assertBetween(1, in.skipSpace().nextInt(), MAX, "y");
    	int a = assertBetween(1, in.skipSpace().nextInt(), MAX, "a");
    	int b = assertBetween(1, in.skipSpace().nextInt(), MAX, "b");
    	out.println(calc(v, b, x) + calc(v, a, y));
    }
    
    double calc(double v, double a, double y) {
    	if (v * v < 2 * a * y) {
    		return v / 2 / a + y / v;
    	} else {
    		return Math.sqrt(2 * y / a);
    	}
    }
    
    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
