import java.io.*;
import java.util.*;

public class sideslip_va implements Runnable {
	public static void main(String[] args) {
		new Thread(new sideslip_va()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public double get_time(long v, long x, long a) {
		double time = 1.0 * v / a;

		if (a * v * v > x * a * a * 2) { // (a * time * time / 2 > x)
			return Math.sqrt(2.0 * x / a);
		}

		double last_distance = x - a * time * time / 2;
		time += last_distance / v;

		return time;
	}

	public void solve() throws IOException {
		int v = nextInt();
		int x = nextInt();
		int y = nextInt();
		int a = nextInt();
		int b = nextInt();

		double t = get_time(v, x, b) + get_time(v, y, a);
		out.println(t);
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("sideslip.in"));
			out = new PrintWriter("sideslip.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
