import java.io.*;
import java.util.*;
import java.math.*;

public class tea_aa {

	String FNAME = "tea";

	final int MAXM = 100000;
	final int MAXV = 1000;
	final int MAXN = 1000;
	final int MAXC = 1000;
	final int MAXT = 1000000;

	private void solve() throws IOException {
		int m = nextBoundedInt(1, MAXM, "m");
		int v = nextBoundedInt(1, MAXV, "v");
		int n = nextBoundedInt(1, MAXN, "N");
		int c = nextBoundedInt(1, MAXC, "c");
		Person[] a = new Person[m];
		for (int i = 0; i < a.length; i++) {
			a[i] = new Person();
			a[i].n = i;
			a[i].t = nextBoundedInt(1, MAXT, "t_" + (i + 1));
			a[i].a = nextBoundedInt(1, v, "a_" + (i + 1));
		}
		Arrays.sort(a, new Comparator<Person>() {

			@Override
			public int compare(Person o1, Person o2) {
				return o1.t - o2.t;
			}
		});
		int volume = 0;
		double temperature = 0;
		double time = 0;
		int index = 0;
		Queue<Person> q = new ArrayDeque<Person>();
		while (index < a.length || !q.isEmpty()) {
			while (index < a.length && (q.isEmpty() || time > a[index].t)) {
				q.add(a[index++]);
			}
			Person p = q.poll();
			if (p.t > time) {
				temperature -= (p.t - time) * c;
				temperature = Math.max(temperature, 20);
				time = p.t;
			}
			if (volume < p.a) {
				temperature = (temperature * volume + (v - volume) * 20) / v;
				volume = v;
			}
			time += (100 - temperature) * volume / n;
			temperature = 100;
			volume -= p.a;
			p.ans = time;
		}
		double[] ans = new double[m];
		for (Person p : a) {
			ans[p.n] = p.ans;
		}
		for (double t : ans) {
			out.println(t);
		}
	}

	class Person {
		int t;
		int a;
		int n;
		double ans;
	}

	public static void main(String[] args) {
		new tea_aa().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(745231);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	int nextBoundedInt(int l, int r, String name) {
		int x = nextInt();
		myAssert(l <= x && x <= r, name + " = " + x + " not  in [" + l + ".."
				+ r + "]");
		return x;
	}

}
