#include <cstdio>
#include <algorithm>
#include <deque>
#include <vector>
using namespace std;

#define sz(a) ((int) (a).size())
#define all(a) (a).begin(), (a).end()
#define fs first
#define sc second

const double startT = 20;
const double endT = 100;
const int max_n = 100000;
const double eps = 1e-10;
const double inf = 1e100;

struct water {
	int v;
	double t;
	water(int v = 0, double t = 0): v(v), t(t) {}
	double get_time();
};

water operator + (water a, water b) {
	a.t = (a.v * a.t + b.v * b.t) / (a.v + b.v);
	a.v += b.v;
	return a;
}

int V, N, C, n, t[max_n], v[max_n];
double res[max_n], cur_time;
water cur;
deque<int> who;

double water::get_time() {
	return ((endT - t) * v) / N;
}

void process_all(double until) {
	while (until > cur_time + eps) {
		cur.t = endT;
		while ((sz(who) > 0) && (cur.v >= v[who.front()])) {
			cur.v -= v[who.front()];
			res[who.front()] = cur_time;
			who.pop_front();
		}
		if (sz(who) > 0) {
			cur = cur + water(V - cur.v, startT);
			cur_time = cur_time + cur.get_time();
		} else {
			cur.t = max(startT, cur.t - (until - cur_time) * C);
			cur_time = until;
		}
	}
}

int main() {
	freopen("tea.in", "r", stdin);
	freopen("tea.out", "w", stdout);
	scanf("%d%d%d%d", &n, &V, &N, &C);
	vector< pair<int, int> > events;
	for (int i = 0; i < n; ++i)
		scanf("%d%d", &t[i], &v[i]), events.push_back(make_pair(t[i], i));
	sort(all(events));
	cur_time = events[0].fs;
	cur = water(V, startT);
	for (int i = 0; i < n; ++i) {
		process_all(events[i].fs);
		if (sz(who) > 0) who.push_back(events[i].sc); else {
			if (cur.v < v[events[i].sc]) cur = cur + water(V - cur.v, startT);
			cur_time = events[i].fs + cur.get_time();
			who.push_back(events[i].sc);
		}
	}
	process_all(inf);
	for (int i = 0; i < n; ++i)
		printf("%.10lf\n", res[i]);
	return 0;
}
