import java.io.*;
import java.util.*;
import java.math.*;

public class teams_aa {

	String FNAME = "teams";

	int MAXN = 100;

	private void solve() throws IOException {
		int n = nextBoundedInt(1, MAXN, "n");
		int[] a = new int[2 * n];
		int[] cnt = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextBoundedInt(1, n, "a_" + (i + 1)) - 1;
			cnt[a[i]]++;
		}
		for (int i = 0; i < cnt.length; i++) {
			myAssert(cnt[i] == 2, "Number " + (i + 1) + " appears " + cnt[i]
					+ " times");
		}
		Arrays.fill(cnt, 0);
		int[][] b = new int[n][2];
		for (int i = 0; i < a.length; i++) {
			b[a[i]][cnt[a[i]]++] = i;
		}
		Graph g = new Graph(2 * n + 2);
		for (int i = 0; i < n; i++) {
			g.addEdge(0, i + 1, 1, 0);
			g.addEdge(n + i + 1, 2 * n + 1, 1, 0);
			for (int j = 0; j < n; j++) {
				int price = Math.abs(b[i][0] - j) + Math.abs(b[i][1] - j - n);
				g.addEdge(1 + i, 1 + n + j, 1, price);
			}
		}
		g.minCostMaxFlow(0, 2 * n + 1);
		int[] pos = new int[n];
		for (int i = 0; i < pos.length; i++) {
			for (Edge edge : g.verteces[i + 1].edges) {
				if (edge.flow == 1) {
					pos[i] = edge.destination.number - n - 1;
				}
			}
		}
		int[] rev = new int[pos.length];
		for (int i = 0; i < pos.length; i++) {
			rev[pos[i]] = i;
		}
		for (int i = 0; i < 2 * rev.length; i++) {
			if (i > 0) {
				out.print(" ");
			}
			out.print(rev[i % n] + 1);
		}
		out.println();
	}

	class Graph {
		public Graph(int n) {
			verteces = new Vertex[n];
			for (int i = 0; i < verteces.length; i++) {
				verteces[i] = new Vertex(i);
			}
		}

		public void minCostMaxFlow(int s, int t) {
			while (true) {
				for (Vertex vertex : verteces) {
					vertex.distance = Integer.MAX_VALUE / 2;
					vertex.previous = null;
				}
				verteces[s].distance = 0;
				for (int i = 0; i < verteces.length - 1; i++) {
					boolean flag = false;
					for (Vertex vertex : verteces) {
						for (Edge edge : vertex.edges) {
							flag |= edge.relax();
						}
					}
					if (!flag) {
						break;
					}
				}
				if (verteces[t].previous == null) {
					break;
				}
				Edge edge = verteces[t].previous;
				while (edge != null) {
					edge.flow++;
					edge.reverse.flow--;
					edge = edge.source.previous;
				}
			}
		}

		public void addEdge(int x, int y, int c, int p) {
			Edge edge = new Edge(verteces[x], verteces[y], c, p);
			Edge edgeReversed = new Edge(verteces[y], verteces[x], 0, -p);
			edge.reverse = edgeReversed;
			edgeReversed.reverse = edge;
			verteces[x].edges.add(edge);
			verteces[y].edges.add(edgeReversed);
		}

		Vertex[] verteces;
	}

	class Edge {
		public Edge(Vertex x, Vertex y, int c, int p) {
			source = x;
			destination = y;
			price = p;
			capacity = c;
			flow = 0;
		}

		public boolean relax() {
			if (capacity - flow > 0
					&& destination.distance > source.distance + price) {
				destination.distance = source.distance + price;
				destination.previous = this;
				return true;
			}
			return false;
		}

		Vertex source, destination;
		int price, capacity, flow;
		Edge reverse;
	}

	class Vertex {
		public Vertex(int i) {
			number = i;
			edges = new ArrayList<teams_aa.Edge>();
			distance = Integer.MAX_VALUE / 2;
			previous = null;
		}

		int distance;
		int number;
		Edge previous;
		ArrayList<Edge> edges;
	}

	public static void main(String[] args) {
		new teams_aa().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(745231);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	int nextBoundedInt(int l, int r, String name) {
		int x = nextInt();
		myAssert(l <= x && x <= r, name + " = " + x + " not  in [" + l + ".."
				+ r + "]");
		return x;
	}

}
