import java.util.*;
import java.io.*;


public class teams_ab {
    public static void main(String[] arg) {
        new teams_ab().run();
    }

    StrictScanner in;
    PrintWriter out;

    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAXN = 100; 

    void solve() throws Exception {
    	int n = assertBetween(1, in.loadLine().nextInt(), MAXN, "n");
    	int[] s = new int[2 * n];
    	int[] cnt = new int[n];
    	for (int i = 0; i < s.length; ++i) {
    		s[i] = assertBetween(1, (i == 0 ? in.loadLine() : in.skipSpace()).nextInt(), n, "a_{" + (i + 1) + "}") - 1;
    		++cnt[s[i]];
    	}
    	for (int i = 0; i < n; ++i) {
    		assert cnt[i] == 2;
    	}
    	int[][] g = new int[n + 1][n];
    	for (int i = 0; i < s.length; ++i) {    		
    		int sh = cnt[s[i]] == 2 ? 0 : n;
    		for (int p = 0; p < n; ++p) {
    			g[s[i]][p] += Math.abs(p + sh - i);
    		}    		
    		--cnt[s[i]];
    	}
    	
    	boolean[] u = new boolean[n + 1];
    	int[] d = new int[n + 1];
    	int[] phi = new int[n + 1];
    	int[] dw = new int[n];
    	int[] p = new int[n];
    	int[] fl = new int[n + 1];
    	int[] fr = new int[n + 1];
    	Arrays.fill(p, n);
    	int ans = 0;
    	for (int step = 0; step < n; ++step) {
    		Arrays.fill(u, true);
    		Arrays.fill(fl, -1);
    		Arrays.fill(fr, -1);
    		Arrays.fill(d, 0);
    		for (int i : p) {
    			d[i] = INF;
    		}    		
    		while (true) {
    			int a = -1;
    			for (int i = 0; i < d.length; ++i) {
    				if (u[i] && (a == -1 || d[i] < d[a])) {
    					a = i;
    				}
    			}
    			if (a == -1) break;
    			u[a] = false;
    			for (int j = 0; j < g[a].length; ++j) {
    				int b = p[j];
    				int w = g[a][j] + dw[j] + phi[a] - phi[b];
    				if (d[b] > d[a] + w) {
    					d[b] = d[a] + w;
    					fl[b] = a;
    					fr[b] = j;
    				}
    			}
    		}
    		for (int i = n; fl[i] != -1; i = fl[i]) {
    			p[fr[i]] = fl[i];
    			dw[fr[i]] = -g[fl[i]][fr[i]];
    		}
    		for (int i = 0; i < d.length; ++i) {
    			phi[i] += d[i];
    		}
//    		ans += phi[n];
    	}
//    	System.out.println(ans);
    	for (int i = 0; i < 2 * n; ++i) {
    		if (i > 0) {
    			out.print(" ");
    		}
    		out.print(p[i % n] + 1);
    	}
    	out.println();    	
    }
    
    final int INF = Integer.MAX_VALUE / 2;
 
    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
