#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "teams"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
int a[205];
vector <int> pos[105];

void Load()
{
	assert(scanf("%d", &n) == 1);
	assert(1 <= n && n <= 100);

	for (int i = 0; i < 2 * n; i++)
	{
		assert(scanf("%d", &a[i]) == 1);
		assert(1 <= a[i] && a[i] <= n);
		pos[a[i]].pb(i);
	}

	for (int i = 1; i <= n; i++)
		assert(pos[i].size() == 2);
}

const int maxv = 205;
const int maxe = maxv * maxv;

int edges = 0;
int src = maxv - 2, snk = maxv - 1;
int fst[maxv];
int nxt[maxe];
int end[maxe];
int cap[maxe];
int cst[maxe];

inline void addEdge(int u, int v, int c, int cost, bool rev = true)
{
	if (rev)
	{
		addEdge(u, v, c, cost, false);
		addEdge(v, u, 0, -cost, false);
	}
	else
	{
		nxt[edges] = fst[u];
		end[edges] = v;
		cap[edges] = c;
		cst[edges] = cost;
		fst[u] = edges++;
	}
}

int d[maxv];
int pr[maxv];
int u[maxv];
bool was[maxv];

inline int dijkstra(int s, int t)
{
	memset(d, 0x7F, sizeof(d));
	memset(was, false, sizeof(was));
	d[s] = 0;

	while (true)
	{
		int mdst = 0x7F7F7F7F;
		int v = -1;
		for (int i = 0; i < maxv; i++)
			if (!was[i] && d[i] < mdst)
			{
				mdst = d[i];
				v = i;
			}
	   	if (v == -1) break;
		was[v] = true;
		for (int i = fst[v]; i != -1; i = nxt[i])
			if (cap[i] > 0 && d[end[i]] > d[v] + cst[i] + u[v] - u[end[i]])
			{
				d[end[i]] = d[v] + cst[i] + u[v] - u[end[i]];
				pr[end[i]] = i;
			}
	}

	return d[t] + u[t];
}

inline int mincost(int src, int snk)
{
	int res = 0, cur;
	while ((cur = dijkstra(src, snk)) < 0x7F7F7F7F)
	{
		res += cur;
		for (int i = snk; i != src; i = end[pr[i] ^ 1])
		{
			cap[pr[i]]--;
			cap[pr[i] ^ 1]++;
		}
		for (int i = 0; i < maxv; i++)
			u[i] += d[i];
	}
	return res;
}

int b[205];

void Solve()
{
	memset(fst, -1, sizeof(fst));
	//for (int i = 1; i <= n; i++)
	//	eprintf("i = %d pos = [%d, %d]\n", i, pos[i][0], pos[i][1]);

	for (int i = 0; i < n; i++)
	{
		addEdge(src, i, 1, 0);
		for (int j = 1; j <= n; j++)
		{
			int cost = abs(i - pos[j][0]) + abs(i + n - pos[j][1]);
			addEdge(i, j + n, 1, cost);
		}
	}

	for (int i = 1; i <= n; i++)
		addEdge(i + n, snk, 1, 0);

   	eprintf("cost = %d\n", mincost(src, snk));

	for (int i = 0; i < n; i++)
	{
		for (int j = fst[i]; j != -1; j = nxt[j])
		{
			int v = end[j];
			if (cap[j] != 0 || !(1 <= v - n && v - n <= n)) continue;
			b[i] = b[i + n] = v - n;
			break;
		}
	}

	for (int i = 0; i < 2 * n; i++)
		printf("%d ", b[i]);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
