#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "teams"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
int a[205];
vector <int> pos[105];

void Load()
{
    scanf("%d", &n);

	for (int i = 0; i < 2 * n; i++)
	{
		scanf("%d", &a[i]);
		pos[a[i]].pb(i);
	}
}

struct State
{
	int n;
	int a[105];
	int b[205];
	int energy;

	inline State() {};

	inline State(int n)
	{
		this->n = n;
		for (int i = 0; i < n; i++)
			a[i] = i + 1;
		for (int i = 0; i < n; i++)
			b[i] = b[i + n] = a[i];
		energy = countEnergy();
	}

	inline void shuffle()
	{
		random_shuffle(a + 0, a + n);
		for (int i = 0; i < n; i++)
			b[i] = b[i + n] = a[i];
		energy = countEnergy();
	}
	
	inline int countEnergy()
	{
		int res = 0;
		vector <int> cnt(n + 1, 0);
		for (int i = 0; i < 2 * n; i++)
		{
			res += abs(i - pos[b[i]][cnt[b[i]]]);
			cnt[b[i]]++;
		}	
		return res;
	}

	inline void operator = (const State &st)
	{
		n = st.n;
		for (int i = 0; i < n; i++)
			a[i] = st.a[i];
		for (int i = 0; i < 2 * n; i++)
			b[i] = st.b[i];
		energy = st.energy;	
	}
};

const double maxt = 45.0;
const double mint = 0.05;
const double changet = 0.98;
const int maxIt = 200;

void Solve()
{
	srand(257834503);
	State cur(n), best(n);
	State work = cur;
	for (double t = maxt; t > mint; t *= changet)
	{
		for (int it = 0; it < maxIt; it++)
		{
			work.shuffle();
			bool better = false;
			if (work.energy <= cur.energy)
			{
				better = true;
			}
			else
			{
				double q = (double)rand() / RAND_MAX;
				double p = exp(((double)(cur.energy - work.energy) / t));
				if (p > q) better = true;
			}
			if (better)
			{
				cur = work;
				if (work.energy < best.energy)
					best = work;
			}
			else work = cur;
		}
	}
	eprintf("energy = %d\n", best.energy);
	for (int i = 0; i < 2 * n; i++)
		printf("%d ", best.b[i]);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
