import java.io.*;
import java.math.*;
import java.util.*;

public class teams_ni_java {
	MyScanner in;
	PrintWriter out;

	class Edge {
		int to;
		int cap;
		int cost;
		
		Edge(int to, int cap, int cost) {
			this.to = to;
			this.cap = cap;
			this.cost = cost;
		}
	}
	
	final int maxv = 2005;
	final int maxe = maxv * maxv;
	
	int cntEdges = 0;
	int src = maxv - 2, snk = maxv - 1;
	int fst[] = new int[maxv];
	int nxt[] = new int[maxe];
	Edge edges[] = new Edge[maxe];
	
	void addEdge(int u, int v, int cap, int cost, boolean rev) {
		if (rev) {
			addEdge(u, v, cap, cost, false);
			addEdge(v, u, 0, -cost, false);
		} else {
			nxt[cntEdges] = fst[u];
			edges[cntEdges] = new Edge(v, cap, cost);
			fst[u] = cntEdges++;
		}
	}
	
	int n;
	int a[];
	ArrayList<Integer> pos[];
	
	@SuppressWarnings("unchecked")
	
	void Load() throws Exception {
		n = in.nextInt();
		a = new int[2 * n];
		pos = new ArrayList[n + 1];
		for (int i = 1; i <= n; i++) {
			pos[i] = new ArrayList<Integer>();
		}
		for (int i = 0; i < 2 * n; i++) {
			a[i] = in.nextInt();
			pos[a[i]].add(i);
		}
	}

	int d[];
	int u[];
	int pr[];

	int dijkstra(int src, int snk) {
		boolean was[] = new boolean[maxv];
		Arrays.fill(d, Integer.MAX_VALUE);
		d[src] = 0;
		while (true) {
			int mdst = Integer.MAX_VALUE;
			int v = -1;
			for (int i = 0; i < maxv; i++) {
				if (!was[i] && d[i] < mdst) {
					mdst = d[i];
					v = i;
				}
			}
			
			if (v == -1) {
				break;
			}
			
			was[v] = true;
			for (int i = fst[v]; i != -1; i = nxt[i]) {
				int to = edges[i].to;
				if (edges[i].cap > 0 && d[to] > d[v] + edges[i].cost + u[v] - u[to]) {
					d[to] = d[v] + edges[i].cost + u[v] - u[to];
					pr[to] = i;
				}
			}
			
		}
		
		return d[snk] == Integer.MAX_VALUE ? -1 : d[snk] + u[snk];
	}
	
	int mincost(int src, int snk) {
		d = new int[maxv];
		pr = new int[maxv];
		u = new int[maxv];
		int res = 0;
		for (int cur = dijkstra(src, snk); cur != -1; cur = dijkstra(src, snk)) {
			res += cur;
			for (int i = snk; i != src; i = edges[pr[i] ^ 1].to) {
				edges[pr[i] ^ 1].cap++;
				edges[pr[i]].cap--;
			}
			for (int i = 0; i < maxv; i++) {
				u[i] += d[i];
			}
		}
		return res;
	}
	
	void Solve() throws Exception {
		Arrays.fill(fst, -1);
		
		for (int i = 0; i < n; i++) {
			addEdge(src, i, 1, 0, true);
			for (int j = 1; j <= n; j++) {
				int pos1 = pos[j].get(0);
				int pos2 = pos[j].get(1);
				addEdge(i, j + n, 1, Math.abs(pos1 - i) + Math.abs(pos2 - n - i), true);
			}
		}
		
		for (int i = 1; i <= n; i++) {
			addEdge(i + n, snk, 1, 0, true);
		}
		
		System.out.println("result = " + mincost(src, snk));
		
		int b[] = new int[2 * n];
		for (int i = 0; i < 2 * n; i++) {
			for (int j = fst[i]; j != -1; j = nxt[j]) {
				int to = edges[j].to;
				if (edges[j].cap != 0 || !(n + 1 <= to && to <= n + n)) {
					continue;
				}
				b[i] = b[i + n] = to - n;
				break;
			}
		}
		for (int i = 0; i < 2 * n; i++) {
			out.print(b[i] + " ");
		}
	}

	final String Problem = "teams";

	public void run() {
		try {
			in = new MyScanner(Problem + ".in");
			out = new PrintWriter(Problem + ".out");
			Load();
			Solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(42);
		}
	}

	public static void main(String[] args) {
		new teams_ni_java().run();
	}

	class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		MyScanner(String file) {
			try {
				br = new BufferedReader(new FileReader(new File(file)));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.exit(42);
			}
		}

		MyScanner() {
			try {
				br = new BufferedReader(new InputStreamReader(System.in));
			} catch (Exception e) {
				e.printStackTrace();
				System.exit(42);
			}
		}

		String nextToken() {
			while (st == null || (!st.hasMoreTokens())) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.exit(42);
				}
			}
			return st.nextToken();
		}

		int nextInt() throws Exception {
			return Integer.parseInt(nextToken());
		}

		double nextDouble() throws Exception {
			return Double.parseDouble(nextToken());
		}

		long nextLong() throws Exception {
			return Long.parseLong(nextToken());
		}

		BigInteger nextBigInteger(int radix) throws Exception {
			return new BigInteger(nextToken(), radix);
		}
	}

}
