class Edge:
	rev = None
	def __init__(self, to, cap, cost):
		self.to = to
		self.cap = cap
		self.cost = cost
	
class Graph:
	inf = 4242424242424242

	def __init__(self, n):
		self.n = n
		self.edges = [[] for i in range(n)]
	
	def addEdge(self, u, v, cap, cost):
		e = Edge(v, cap, cost)
		er = Edge(u, 0, -cost)
		e.rev = er
		er.rev = e
		self.edges[u].append(e)
		self.edges[v].append(er)

	def dijkstra(self, src, snk):
		self.d = [self.inf for i in range(self.n)]
		self.d[src] = 0
		self.pr = [None for i in range(self.n)]
		self.was = [False] * self.n
		while (True):
			mdst = self.inf
			v = -1
			for i in range(self.n):
				if self.was[i] == False and self.d[i] < mdst:
					mdst = self.d[i]
					v = i
			if v == -1: break
			self.was[v] = True
			for e in self.edges[v]:
				if e.cap > 0 and self.d[e.to] > self.d[v] + self.u[v] - self.u[e.to] + e.cost:
					self.d[e.to] = self.d[v] + self.u[v] - self.u[e.to] + e.cost
					self.pr[e.to] = e

		return self.d[snk] + self.u[snk]
			
	def minCost(self, src, snk):
		self.u = [0] * self.n
		res = 0
		cur = self.dijkstra(src, snk)
		while cur < self.inf:
			res += cur

			v = snk
			while v != src:
				e = self.pr[v]
				e.cap -= 1
				e.rev.cap += 1
				v = e.rev.to

			for i in range(self.n):
				self.u[i] += self.d[i]
			
			cur = self.dijkstra(src, snk)
		return res

inf = open("teams.in", "r")
n = int(inf.readline())

pos = [[] for i in range(n + 1)]
a = [int(i) for i in inf.readline().rstrip().split()]
for i in range(2 * n):
	pos[a[i]].append(i)

g = Graph(2 * n + 2)

for i in range(n):
	g.addEdge(2 * n, i, 1, 0)
	for j in range(1, n + 1):
		cost = abs(i - pos[j][0]) + abs(i + n - pos[j][1])
		g.addEdge(i, j + n - 1, 1, cost)

for j in range(1, n + 1):
	g.addEdge(n + j - 1, 2 * n + 1, 1, 0)

print("cost = " + str(g.minCost(2 * n, 2 * n + 1)))

b = [0] * (2 * n)
for i in range(n):
	for e in g.edges[i]:
		if e.cap != 0:
			continue
		to = e.to
		if n <= to and to < 2 * n:
			b[i], b[i + n] = to - n + 1, to - n + 1
			break

print(" ".join([str(i) for i in b]), file = open("teams.out", "w"))