#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "teams"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
int a[200];
int cnt[201];

void Load()
{
	assert(scanf("%d", &n) == 1);
	assert(1 <= n && n <= 100);

	for (int i = 0; i < 2 * n; i++)
	{
		assert(scanf("%d", &a[i]) == 1);
		assert(1 <= a[i] && a[i] <= n);
		cnt[a[i]]++;
	}

	for (int i = 1; i <= n; i++)
		assert(cnt[i] == 2);
}

int b[200];

bool g[200][201];
int pl[201];
int pr[201];
bool was[201];

bool dfs(int v)
{
	if (was[v]) return false;
	was[v] = true;
	for (int i = 1; i <= n; i++)
		if (g[v][i] && (pr[i] == -1 || dfs(pr[i])))
		{
			pr[i] = v;
			pl[v] = i;
			return true;
		}
	return false;	
}

void matching()
{
	memset(pl, -1, sizeof(pl));
	memset(pr, -1, sizeof(pr));

	for (int i = 0; i < n; i++)
	{
		memset(was, false, sizeof(was));
		dfs(i);
	}
}

void Solve()
{
	memset(g, false, sizeof(g));

	for (int i = 0; i < n; i++)
	{
		if (a[i] == a[i + n])
			b[i] = b[i + n] = a[i];
		else
		{
			g[i][a[i]] = 1;
			g[i][a[i + n]] = 1;
		}	
	}

	matching();

	for (int i = 0; i < n; i++)
	{
		if (pl[i] == -1) continue;
		b[i] = b[i + n] = pl[i];
	}

	for (int i = 0; i < 2 * n; i++)
		printf("%d ", b[i]);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
