#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "teams"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = 0x7F7F7F7F;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
int a[200];
vector <int> pos[201];

void Load()
{
	assert(scanf("%d", &n) == 1);
	assert(1 <= n && n <= 100);

	for (int i = 0; i < 2 * n; i++)
	{
		assert(scanf("%d", &a[i]) == 1);
		assert(1 <= a[i] && a[i] <= n);
		pos[a[i]].pb(i);
	}

	for (int i = 1; i <= n; i++)
		assert(pos[i].size() == 2);
}

inline int cost(int i, int j)
{
	return abs(i - pos[j][0]) + abs(i + n - pos[j][1]);
}

int b[200];

int g[200][201];
bool used[2001];

void Solve()
{
	memset(g, 0x7F, sizeof(g));
	memset(used, false, sizeof(used));

	for (int i = 0; i < n; i++)
	{
		if (a[i] == a[i + n])
			b[i] = b[i + n] = a[i];
		else
		{
			g[i][a[i]] = cost(i, a[i]);
			g[i][a[i + n]] = cost(i, a[i + n]);
		}	
	}

	for (int i = 0; i < n; i++)
	{
		int mj = 0;
		int bst = inf;
		for (int j = 1; j <= n; j++)
			if (!used[j] && g[i][j] < bst)
			{
				bst = g[i][j];
				mj = j;
			}
		if (mj > 0)
		{
			used[mj] = true;
			b[i] = b[i + n] = mj;
		}
	}

	for (int i = 0; i < 2 * n; i++)
		printf("%d ", b[i]);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
