import java.util.*;
import java.io.*;

public class trains_as {
    FastScanner in;
    PrintWriter out;

    long[] cat;
    private boolean DEBUG_PRINT_ALL = false;

    public void solve(int n, long k) throws IOException {

        cat = new long[n + 1];
        cat[0] = 1;
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < i; j++) {
                cat[i] += cat[j] * cat[i - j - 1];
            }
        }

        if (k >= cat[n]) {
            out.println(-1);
        } else {
            int[] ans = create(0, n, k);
            for (int i = 0; i < ans.length; i++) {
                out.print(ans[i] + 1);
                if (i < ans.length - 1) {
                    out.print(" ");
                }
            }
            out.println();
        }
    }

    int[] create(int l, int r, long k) {
        if (l == r) {
            return new int[0];
        }
        int[] res = new int[r - l];
        for (int p = l; p < r; p++) {
            if (k < cat[p - l] * cat[r - p - 1]) {
                int[] r1 = create(l, p, k / cat[r - p - 1]);
                int[] r2 = create(p + 1, r, k % cat[r - p - 1]);
                res[0] = p;
                System.arraycopy(r1, 0, res, 1, p - l);
                System.arraycopy(r2, 0, res, p - l + 1, r - p - 1);
                return res;
            } else {
                k -= cat[p - l] * cat[r - p - 1];
            }
        }
        return null;
    }

    public void run() {
        try {
            in = new FastScanner(new File("trains.in"));
            out = new PrintWriter(new File("trains.out"));

            int n = in.nextInt();
            long k = in.nextLong();
            k--;
            solve(n, k);

            if (DEBUG_PRINT_ALL) {
                for (n = 1; n < 10; n++) {
                    for (k = 0; true; k++) {
                        solve(n, k);
                        if (k >= cat[n]) {
                            break;
                        }
                    }
                }
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] arg) {
        new trains_as().run();
    }
}