#include <cstdio>
#include <iostream>

using std::cin;

typedef long long ll;

const int N = 30;
ll cnt[N + 1];

void printAnswer(int l, int r, ll k)
{
    int n = r - l + 1;
    if (n == 0)
    {
        if (k != 0)
            throw 42;
        return ;
    }
    for (int i = l; i <= r; ++i)
    {
        ll a = cnt[i - l];
        ll b = cnt[r - i];
        ll cur = a * b;
        if (cur > k)
        {
            printf("%d ", i);
            printAnswer(l, i - 1, k / b);
            printAnswer(i + 1, r, k % b);
            return ;
        }
        k -= cur;
    }
}

int main()
{
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);

    int n;
    ll k;
    cin >> n >> k;
    cnt[0] = 1;
    for (int i = 1; i <= n; ++i)
    {
        cnt[i] = 0;
        for (int j = 1; j <= i; ++j)
            cnt[i] += cnt[j - 1] * cnt[i - j];
    }

    if (k > cnt[n])
    {
        printf("-1\n");
        return 0;
    }

    printAnswer(1, n, k - 1);

    return 0;
}
