#include <iostream>
#include <stack>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "trains"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
LL sk;
LL k;

void Load()
{
	assert(scanf("%d%I64d", &n, &k) == 2);
	assert(1 <= n && n <= 30);
	assert(1 <= k && k <= 1000000000000000000LL);
}

const LL bound = 3000000000000000000LL;

inline LL mul(LL a, LL b)
{
	ldb res = (ldb)a * (ldb)b;
	if (res >= bound)
		return bound;
	else
		return (LL)res; 	
}

LL c[205];

inline void calcCatalan(int n)
{
	c[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j < i; j++)
		{
			c[i] += mul(c[j], c[i - j - 1]);
			if (c[i] > bound)
				c[i] = bound;
		}
	}
}

void rec(int l, int r, LL k, vector <int> &ans)
{
	ans.resize(r - l + 1, 0);
	if (l > r)
		return;
 	for (int i = l; i <= r; i++)
 	{
 		LL cur = mul(c[i - l], c[r - i]);
 		if (k < cur)
 		{
 			vector <int> lpart, rpart;
 			rec(l, i - 1, k / c[r - i], lpart);
 			rec(i + 1, r, k % c[r - i], rpart);
 			ans[0] = i;
 			for (int j = 0; j < (int)lpart.size(); j++)
 				ans[j + 1] = lpart[j];
 			for (int j = 0; j < (int)rpart.size(); j++)
 				ans[(int)lpart.size() + j + 1] = rpart[j];	
 			return;
 		}
 		else
 			k -= cur;	
 	}
}

void Solve()
{
	calcCatalan(n);
	if (k > c[n])
	{
		printf("-1");
		return;
	}
	vector <int> ans;
	rec(0, n - 1, k - 1, ans);
	for (int i = 0; i < n; i++)
		printf("%d ", ans[i] + 1);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
