#include <iostream>
#include <stack>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "trains"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
LL k;

void Load()
{
	assert(scanf("%d%I64d", &n, &k) == 2);
	assert(1 <= n && n <= 100);
	assert(1 <= k && k <= 1000000000000000000LL);
}

inline vector <int> stackSort(const vector <int> &p)
{
	int n = p.size();
	vector <int> res(n);
	int ptr = 0;
	stack <int> st;
	for (int i = 0; i < n; i++)
	{
		while (!st.empty() && st.top() < p[i])
		{
			res[ptr++] = st.top();
			st.pop();
		}
		st.push(p[i]);
	}
	while (!st.empty())
	{
		res[ptr++] = st.top();
		st.pop();
	}
	return res;
}

inline bool check(const vector <int> &p)
{
	vector <int> np = stackSort(p);
	for (int i = 0; i < n; i++)
		if (np[i] != i + 1) return false;
	return true;	
}

void Solve()
{
	vector <int> p(n);
	for (int i = 0; i < n; i++)
		p[i] = i + 1;
	do
	{
		if (check(p))
			k--;
		if (k == 0)
		{
			for (int i = 0; i < n; i++)
				printf("%d ", p[i]);
			return;	
		}
	} while (next_permutation(p.begin(), p.end()));
	printf("-1");
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
