#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;
#define pb push_back
#define sz(a) ((int) (a).size())
#define all(a) (a).begin(), (a).end()
#define r(x, a, b) (((a) <= (x)) && ((x) <= (b)))

const int N = (int) 1e5;
const int M = (int) 1e5;
const int H = (int) 1e9;
vector<int> adj[N], ver[N];
int h[N], in[N], out[N], cur_time;
bool used[N];

void dfs(int v) {
	assert(!used[v]);
	used[v] = true;
	in[v] = cur_time++;
	ver[h[v]].pb(in[v]);
	for (int j = 0; j < sz(adj[v]); ++j) {
		h[adj[v][j]] = h[v] + 1;
		dfs(adj[v][j]);
	}
	out[v] = cur_time++;
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int n, v, qh, m, root = -1;
	assert(scanf("%d", &n) == 1);
	assert(r(n, 1, N));
	for (int i = 0; i < n; ++i) {
		assert(scanf("%d", &v) == 1);
		if (v == -1) {
			assert(root == -1);
			root = i;
		} else {
			assert(r(v, 1, n));
			adj[v - 1].pb(i);
		}
	}
	assert(root != -1);
	dfs(root);
	for (int i = 0; i < n; ++i)
		assert(used[i]);
	assert(scanf("%d", &m) == 1);
	assert(r(m, 1, M));
	for (int i = 0; i < m; ++i) {
		assert(scanf("%d%d", &v, &qh) == 2);
		assert(r(v, 1, n));
		assert(r(qh, 1, H));
		v--;
		qh += h[v];
		if (qh >= n)
			printf("0\n");
		else
			printf("%d\n", upper_bound(all(ver[qh]), out[v]) - lower_bound(all(ver[qh]), in[v]));
	}
	return 0;
}