#include <cstdio>
#include <vector>
using namespace std;
#define pb push_back
#define sz(a) ((int) (a).size())

const int N = (int) 1e5;
vector<int> adj[N];
int rh[N];

int dfs(int v, int h) {
	if (h > rh[v]) return 0;
	if (h == 0) return 1;
	if (h < 0) return 0;
	int sum = 0;
	for (int j = 0; j < sz(adj[v]); ++j)
		sum += dfs(adj[v][j], h - 1);
	return sum;
}

void calc(int v) {
	rh[v] = 0;
	for (int j = 0; j < sz(adj[v]); ++j) {
		calc(adj[v][j]);
		rh[v] = max(rh[v], 1 + rh[adj[v][j]]);
	}
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int n, m, v, h, root;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &v);
		if (v != -1) adj[v - 1].pb(i); else root = i;
	}
	calc(root);
	scanf("%d", &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &v, &h);
		printf("%d\n", dfs(v - 1, h));
	}
	return 0;
}
