#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "tree"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

const int maxv = 100005;

int edges = 0;
int fst[maxv];
int nxt[maxv];
int end[maxv];

inline void addEdge(int u, int v)
{
	nxt[edges] = fst[u];
	end[edges] = v;
	fst[u] = edges++;
}

int n;
int root;

void Load()
{
	memset(fst, -1, sizeof(fst));
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		int p;
		scanf("%d", &p);
		if (p == -1)
			root = i;
		else
			addEdge(p, i);
	}
}

int tim = 0;
int tin[maxv];
int tout[maxv];
int depth[maxv];

vector <int> age[maxv];

void dfs(int v, int h)
{
	depth[v] = h;
	tin[v] = tim++;
	age[h].pb(tin[v]);
	for (int i = fst[v]; i != -1; i = nxt[i])
		dfs(end[i], h + 1);
	tout[v] = tim++;
}

void Solve()
{
	dfs(root, 0);
	int m;
	scanf("%d", &m);
	while (m --> 0)
	{
		int v, k;
		scanf("%d%d", &v, &k);
		k += depth[v];
		printf("%d\n", (k >= n ? 0 : lower_bound(age[k].begin(), age[k].end(), tout[v]) - upper_bound(age[k].begin(), age[k].end(), tin[v])));
	}
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
