import java.io.*;
import java.math.*;
import java.util.*;

public class tree_ni {
	MyScanner in;
	PrintWriter out;

	int n;
	int root;
	
	ArrayList<Integer> edg[];
	
	@SuppressWarnings("unchecked")
	void Load() throws Exception {
		n = in.nextInt();
		if (!(1 <= n && n <= 100000)) {
			System.err.println("n is not between 1 and 100000");
			throw new AssertionError();
		}
		edg = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			edg[i] = new ArrayList<Integer>();
		}
		root = -1;
		for (int i = 0; i < n; i++) {
			int p = in.nextInt();
			if (p == -1) {
				if (root != -1) {
					System.err.println("we alredy have one root (" + root + ")");
					throw new AssertionError();
				}
				root = i;
			} else {
				if (!(1 <= p && p <= n)) {
					System.err.println("p is not between 1 and " + n);
					throw new AssertionError();
				}
				edg[p - 1].add(i);
			}
		}
	}

	int time = 0;
	int depth[];
	int tin[];
	int tout[];
	boolean was[];
	ArrayList<Integer> age[];
	
	void dfs(int v, int h) {
		if (was[v]) {
			System.err.println("we already visited vertex " + (v + 1));
			throw new AssertionError();
		}
		depth[v] = h;
		was[v] = true;
		tin[v] = time++;
		age[h].add(tin[v]);
		for (int u : edg[v]) {
			dfs(u, h + 1);
		}
		tout[v] = time++;
	}
	
	int lowerBound(ArrayList<Integer> ar, int key) {
		int l = -1, r = ar.size();
		while (r - l > 1) {
			int md = (l + r) / 2;
			if (ar.get(md) < key) {
				l = md;
			} else {
				r = md;
			}
		}
		return r;
	}
	
	int upperBound(ArrayList<Integer> ar, int key) {
		int l = -1, r = ar.size();
		while (r - l > 1) {
			int md = (l + r) / 2;
			if (ar.get(md) <= key) {
				l = md;
			} else {
				r = md;
			}
		}
		return r;
	}
	
	@SuppressWarnings("unchecked")
	void Solve() throws Exception {
		depth = new int[n];
		tin = new int[n];
		tout = new int[n];
		was = new boolean[n];
		age = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			age[i] = new ArrayList<Integer>();
		}
		
		dfs(root, 0);
		for (int i = 0; i < n; i++) {
			if (!was[i]) {
				System.err.println("We didn't visit vertex " + (i + 1));
				throw new AssertionError();
			}
		}
		
		int m = in.nextInt();
		for (int i = 0; i < m; i++) {
			int v = in.nextInt();
			int k = in.nextInt();
			if (!(1 <= v && v <= n)) {
				System.err.println("v is not between 1 and " + n);
				throw new AssertionError();
			}
			if (!(1 <= k && k <= 1000000000)) {
				System.err.println("k is not between 1 and 1000000000");
				throw new AssertionError();
			}
			--v;
			k += depth[v];
			if (k >= n) {
				out.println("0");
			} else {
				out.println(lowerBound(age[k], tout[v]) - upperBound(age[k], tin[v]));
			}
		}
	}

	final String Problem = "tree";

	public void run() {
		try {
			in = new MyScanner(Problem + ".in");
			out = new PrintWriter(Problem + ".out");
			Load();
			Solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(42);
		}
	}
	
	public static void main(String[] args) {
		new tree_ni().run();
	}

	class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		MyScanner(String file) {
			try {
				br = new BufferedReader(new FileReader(new File(file)));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.exit(42);
			}
		}

		MyScanner() {
			try {
				br = new BufferedReader(new InputStreamReader(System.in));
			} catch (Exception e) {
				e.printStackTrace();
				System.exit(42);
			}
		}

		String nextToken() {
			while (st == null || (!st.hasMoreTokens())) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.exit(42);
				}
			}
			return st.nextToken();
		}

		int nextInt() throws Exception {
			return Integer.parseInt(nextToken());
		}

		double nextDouble() throws Exception {
			return Double.parseDouble(nextToken());
		}

		long nextLong() throws Exception {
			return Long.parseLong(nextToken());
		}

		BigInteger nextBigInteger(int radix) throws Exception {
			return new BigInteger(nextToken(), radix);
		}
	}

}
