#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;

#define pb push_back
#define sz(a) (int)a.size()
#define zero(a) memset (a, 0, sizeof(a))
#define mp make_pair

#define taskname "tree"


const int MAXN = 110000;
const int MAXN_assert = 100000;

vector<pair<int,int> > req[MAXN];
vector<int> g[MAXN];
int res[MAXN];



struct myset{
	map<int,int> s;
	int add;


	void swap(myset& r){
		s.swap(r.s);
		::swap(add,r.add);
	}

	void addval(int a,int b){
		if (s.find(a-add) != s.end())
			s[a-add] += b;
		else
			s[a-add] = b;
	}

	void merge(myset& r){
		if (s.size() < r.s.size())
			swap(r);
		for (map<int,int>::iterator iter = r.s.begin(); iter != r.s.end(); ++iter)
			addval(iter->first + r.add, iter->second);
	} 

	int get(int val){
		if (s.find(val - add) == s.end())
			return 0;
		return s[val - add];
	}
};


myset result[MAXN];

void dfs(int v){
	result[v].addval(0,1);
	for (int i = 0; i < (int)g[v].size(); i++){
		dfs(g[v][i]);
		result[g[v][i]].add += 1;
		result[v].merge(result[g[v][i]]);
	}
	for (int i = 0; i < (int)req[v].size(); i++)
		res[req[v][i].second] = result[v].get(req[v][i].first);	 
}


int main (void)
{
  assert(freopen (taskname".in", "r", stdin));
  freopen (taskname".out", "w", stdout);
  int n;
  assert(scanf("%d",&n) == 1);
  assert(1 <= n && n <= MAXN_assert);

  int root = -1;
  for (int i = 0; i < n; i++){
  	int par;
  	assert(scanf("%d",&par));
    assert((1 <= par && par <= n) || par == -1);
    par --;
  	if (par == -2){
  		assert(root == -1);
  		root = i;
  	}
  	else
  		g[par].pb(i);
  }

  assert(root != -1);

  int m;
  assert(scanf("%d",&m));
  assert(1 <= m && m <= MAXN_assert);
  for (int i = 0; i < m; i++){
  	int a,b;
  	assert(scanf("%d %d",&a,&b) == 2);
  	--a;
  	assert( 0 <= a && a < n);
  	assert( 1 <= b && b <= 1000000000);
  	req[a].pb(mp(b,i));
  }

  dfs(root);

  for (int i = 0; i < m; i++)
  	printf("%d\n",res[i]);

  return 0;
}

