import java.io.*;
import java.util.*;

public class printing_av {
	int magic = 50000;

	void solve() throws Exception {
		int n = nextInt();
		int k = nextInt();
		long[] best = new long[magic + 1];
		long[] cost = new long[201];
		long inf = Long.MAX_VALUE / 2;
		Arrays.fill(cost, inf);
		for (int i = 0; i < n; i++) {
			int c = nextInt();
			int p = nextInt();
			cost[p] = Math.min(cost[p], c);
		}

		
		Arrays.fill(best, inf);
		best[0] = 0;
		for (int i = 1; i < 201; i++) {
			if (cost[i] == inf)
				continue;
			for (int j = i; j <= magic; j++) {
				best[j] = Math.min(best[j], best[j - i] + cost[i]);
			}
		}
		if (k <= magic) {
			if (best[k] != inf) {
				out.println(best[k]);
			} else {
				out.println(-1);
			}
			return;
		}
		long ans = inf;
		for (int i = 1; i <= magic; i++) {
			if (best[i] == inf)
				continue;
			int rmn = k % i;
			long cnt = k / i;
			while (rmn <= magic) {
				if (best[rmn] != inf) {
					long t = (cnt * (long) best[i]) + ((long) best[rmn]);
					ans = Math.min(t, ans);
				}
				rmn += i;
				cnt--;
			}
		}
		if (ans != inf) {
			out.println(ans);
		} else {
			out.println(-1);
		}
	}

	void run() {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			// in = new BufferedReader(new InputStreamReader(System.in));
			// out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;
	final String filename = new String("Printing").toLowerCase();

	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

	public static void main(String[] args) {
		new printing_av().run();
	}

}
