import java.io.*;
import java.util.*;

public class printing_va_slow implements Runnable {
	public static void main(String[] args) {
		new Thread(new printing_va_slow()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public class cartridge implements Comparable<cartridge> {
		int c, p;

		public cartridge(int c, int p) {
			this.p = p;
			this.c = c;
		}

		public int compareTo(cartridge o) {
			return c * o.p - o.c * p;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();

		cartridge[] a = new cartridge[n];

		for (int i = 0; i < n; i++) {
			a[i] = new cartridge(nextInt(), nextInt());
		}

		long[] d = new long[k + 1];

		Arrays.fill(d, Long.MAX_VALUE);

		d[0] = 0;
		for (int i = 0; i < d.length; i++) {
			for (int j = 0; j < n; j++) {
				if (i + a[j].p < d.length && d[i] != Long.MAX_VALUE) {
					d[i + a[j].p] = Math.min(d[i + a[j].p], d[i] + a[j].c);
				}
			}
		}

		if (d[k] == Long.MAX_VALUE) {
			out.println(-1);
		} else {
			out.println(d[k]);
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("printing.in"));
			out = new PrintWriter("printing.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
