import java.io.*;
import java.util.*;

public class printing_va_wa implements Runnable {
	public static void main(String[] args) {
		new Thread(new printing_va_wa()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public class cartridge implements Comparable<cartridge> {
		int c, p;

		public cartridge(int c, int p) {
			this.p = p;
			this.c = c;
		}

		public int compareTo(cartridge o) {
			return c * o.p - o.c * p;
		}
	}

	public static int MAX_P = 200;

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();

		int[] min = new int[MAX_P + 1];

		Arrays.fill(min, Integer.MAX_VALUE);

		cartridge[] a = new cartridge[MAX_P];

		for (int i = 0; i < n; i++) {
			int c = nextInt();
			int p = nextInt();

			min[p] = Math.min(min[p], c);
		}

		int l = 0;
		for (int i = 1; i < min.length; i++) {
			if (min[i] != Integer.MAX_VALUE) {
				a[l++] = new cartridge(min[i], i);
			}
		}

		a = Arrays.copyOf(a, l);

		n = l;

		Arrays.sort(a);

		int ans = 0;
		for (int i = 0; i < n; i++) {
			ans += k / a[i].p * a[i].c;
			k %= a[i].p;
		}

		if (k > 0) {
			out.println(-1);
		} else {
			out.println(ans);
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("printing.in"));
			out = new PrintWriter("printing.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
