import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class printing_vd {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};

	long cost[];
	long res[];
	int nmax=50000;

	void precalc() {
		res = new long[nmax];
		res[0] = 0;
		for (int i = 1; i < nmax; i++) {
			res[i] = Integer.MAX_VALUE / 2;
			for (int j = 1; j <= 200; j++)
				if ((i >= j) && (cost[j] != 0))
					res[i] = Math.min(res[i], res[i - j] + cost[j]);
		}
	}

	long solv(long k, long opt) {
		long rs = Long.MAX_VALUE;
		for (int i = 0; i <nmax; i++) {
			if (k - i < 0)
				break;
			if (res[i] == Integer.MAX_VALUE / 2)
				continue;
			if ((k - i) % opt != 0)
				continue;
			rs = Math.min(rs,  (k - i) / opt * cost[(int)opt]
					+ res[i]);
		}
		if (rs == Long.MAX_VALUE)
			return -1;
		return rs;
	}

	void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		cost = new long[201];
		for (int i = 0; i < n; i++) {
			int cs = nextInt();
			int dln = nextInt();
			if ((cost[dln] == 0) || (cost[dln] > cs))
				cost[dln] = cs;
		}
		precalc();
		int opt = 1;
		while (cost[opt] == 0)
			opt++;
		int kt = opt;
		for (int j = kt + 1; j <= 200; j++) {
			if (cost[j] == 0)
				continue;
			if (cost[j] * opt < j * cost[opt])
				opt = j;
		}
		out.println(solv(k, opt));

	};

	void run() throws IOException {

		in = new BufferedReader(new FileReader("printing.in"));
		out = new PrintWriter("printing.out");
		solve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new printing_vd().run();
	}

}
