import java.io.*;
import java.util.*;

public class quadro_av {

	int n, k;
	int[][] a;
	int inf = Integer.MAX_VALUE / 2;

	int count(int x1, int y1, int x2, int y2) {
		x2--;
		y2--;
		int res = sum[x2][y2];
		if (x1 > 0)
			res -= sum[x1 - 1][y2];
		if (y1 > 0)
			res -= sum[x2][y1 - 1];
		if (x1 > 0 && y1 > 0)
			res += sum[x1 - 1][y1 - 1];
		return res;
	}

	int g(int n) {
		if (n == 1)
			return 1;
		return 4 * g(n / 2) + 1;
	}

	int[] get(int x1, int y1, int x2, int y2) {
		if (x1 == x2 - 1) {
			if (a[x1][y1] == 0)
				return new int[] { 1, 1 };
			else
				return new int[] { 1, 1 };
		}

		int midx = (x1 + x2) / 2;
		int midy = (y1 + y2) / 2;
		int[] ll = get(x1, y1, midx, midy);
		int[] lr = get(x1, midy, midx, y2);
		int[] rl = get(midx, y1, x2, midy);
		int[] rr = get(midx, midy, x2, y2);
		int len = (x2 - x1) * (y2 - y1);
		int[] res = new int[len + 1];
		int inf = g(x2 - x1) - 1;
		int[] prev = new int[len + 1];
		Arrays.fill(prev, inf);
		prev[0] = 0;
		int[] cur = new int[len + 1];
		Arrays.fill(cur, inf);
		for (int i = 0; i <= len; i++) {
			for (int j = 0; j < Math.min(i + 1, ll.length); j++) {
				cur[i] = Math.min(cur[i], prev[i - j] + ll[j]);
			}
		}

		prev = cur;
		cur = new int[len + 1];
		Arrays.fill(cur, inf);
		for (int i = 0; i < len + 1; i++) {
			for (int j = 0; j < Math.min(i + 1, lr.length); j++) {
				cur[i] = Math.min(cur[i], prev[i - j] + lr[j]);
			}
		}

		prev = cur;
		cur = new int[len + 1];
		Arrays.fill(cur, inf);
		for (int i = 0; i < len + 1; i++) {
			for (int j = 0; j < Math.min(i + 1, rl.length); j++) {
				cur[i] = Math.min(cur[i], prev[i - j] + rl[j]);
			}
		}

		prev = cur;
		cur = new int[len + 1];
		Arrays.fill(cur, inf);
		for (int i = 0; i < len + 1; i++) {
			for (int j = 0; j < Math.min(i + 1, rr.length); j++) {
				cur[i] = Math.min(cur[i], prev[i - j] + rr[j]);
			}
		}

		int s = count(x1, y1, x2, y2);
		cur[len - s] = 0;
		cur[s] = 0;

		for (int i = 0; i <= len; i++) {
			cur[i]++;
		}

		return cur;
	}

	int[][] sum;

	void solve() throws Exception {
		n = nextInt();
		k = nextInt();
		a = new int[n][n];
		for (int i = 0; i < n; i++) {
			String s = nextToken();
			for (int j = 0; j < n; j++)
				a[i][j] = s.charAt(j) - '0';
		}
		sum = new int[n][n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				sum[i][j] = a[i][j];
				if (i > 0)
					sum[i][j] += sum[i - 1][j];
				if (j > 0)
					sum[i][j] += sum[i][j - 1];
				if (i > 0 && j > 0)
					sum[i][j] -= sum[i - 1][j - 1];
			}
		}
		int[] ans = get(0, 0, n, n);
		int res = inf;
		for (int i = 0; i <= k; i++) {
			res = Math.min(res, ans[i]);
		}
		out.println(res);
	}

	void run() {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			// in = new BufferedReader(new InputStreamReader(System.in));
			// out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;
	final String filename = new String("Quadro").toLowerCase();

	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

	public static void main(String[] args) {
		new quadro_av().run();
	}

}
