import java.io.*;
import java.util.*;

public class quadro_va implements Runnable {
	public static void main(String[] args) {
		new Thread(new quadro_va()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	int[][] table;

	public int[] get_ans(int n, int x1, int y1, int x2, int y2) {
		if (n == 1) {
			if (table[x1][y1] == 1)
				return new int[] { 1, 0 };
			return new int[2];
		}

		int[][] a = new int[4][];

		a[0] = get_ans(n / 2, x1, y1, (x1 + x2) / 2, (y1 + y2) / 2);
		a[1] = get_ans(n / 2, (x1 + x2) / 2 + 1, y1, x2, (y1 + y2) / 2);
		a[2] = get_ans(n / 2, (x1 + x2) / 2 + 1, (y1 + y2) / 2 + 1, x2, y2);
		a[3] = get_ans(n / 2, x1, (y1 + y2) / 2 + 1, (x1 + x2) / 2, y2);

		int len = a[0].length + a[1].length + a[2].length + a[3].length - 2;
		int[] ans = new int[len];

		Arrays.fill(ans, Integer.MAX_VALUE);

		for (int i = 1; i < a[0].length; i++) {
			ans[i] = a[0][i];
		}

		len = a[0].length;
		for (int i = 1; i < a.length; i++) {
			int[] aa = new int[len + a[i].length - 1];
			Arrays.fill(aa, Integer.MAX_VALUE);
			for (int j = 1; j < len; j++) {
				if (ans[j] == Integer.MAX_VALUE)
					continue;

				for (int k = 1; k < a[i].length; k++) {
					if (a[i][k] == Integer.MAX_VALUE)
						continue;
					aa[k + j] = Math.min(aa[k + j], ans[j] + a[i][k]);
				}
			}
			ans = aa;
			len += a[i].length - 1;
		}

		ans = Arrays.copyOf(ans, ans.length + 1);

		for (int i = ans.length - 1; i > 0; i--) {
			ans[i] = ans[i - 1];
		}

		ans[0] = 0;
		for (int i = 0; i < 4; i++) {
			ans[0] += a[i][0];
		}

		ans[1] = Math.min(n * n - ans[0], ans[0]);

		return ans;
	}

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();

		table = new int[n][n];

		for (int i = 0; i < n; i++) {
			char[] c = nextToken().toCharArray();
			for (int j = 0; j < n; j++) {
				if (c[j] == '1') {
					table[i][j] = 1;
				}
			}
		}

		int[] ans = get_ans(n, 0, 0, n - 1, n - 1);

		for (int i = 1; i < ans.length; i++) {
			if (ans[i] <= k) {
				out.println(i);
				return;
			}
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("quadro.in"));
			out = new PrintWriter("quadro.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
