#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>

#define N int(1e5 + 5)
#define eps (1e-9)
#define eps2 (1e-5)
#define eps3 (1e-6)

using namespace std;

struct car {
	double a, v, t;

	void read() {
		scanf("%lf %lf", &a, &v);
	}
};

bool operator < (car a, car b) {
	return a.a < b.a;
}

car a1[N], a2[N];
int n, m;
double x;

int f1(double mid) {
	int j = 0, mx = 0, k = -1;
   	for (int i = 0; i < n; i++) {
   		int k1 = int(a1[i].t / x);
   		if ( fabs(a1[i].t - (k1 + 1) * x) < eps) {
   			continue;
   		}							
   		if (k != k1) {
   			if (mx < j)
   				mx = j;				
   			j = 0;
   			k = k1;				
   		}
   		if (a1[i].t - k1 * x - mid > eps + eps2) 
   			j++;				
   	}
   	if (j > mx)
   		mx = j;
	return mx;
}

int f2(double mid) {
	int mx2 = 0, j = 0, k = -1;
   	for (int i = 0; i < m; i++) {
   		int k1 = int(a2[i].t / x);							
   	if ( fabs(a2[i].t - (k1 + 1) * x) < eps) {
   			continue;
   		}
   		if (k != k1) {
   			if (mx2 < j)
   				mx2 = j;				
   			j = 0;
   			k = k1;				
   		}
   		if ( k1 * x + mid - a2[i].t > - eps + eps2) 
   			j++;				
   	}
   	if (j > mx2)
   		mx2 = j;

	return mx2;
}

int f(double mid) {
	return f1(mid) - f2(mid);
}

int main() {
	freopen("traffic.in", "r", stdin);
	freopen("traffic.out", "w", stdout);

	scanf("%lf %d", &x, &n);

	for (int i = 0; i < n; i++) 
		a1[i].read();

	scanf("%d", &m);

	for (int i = 0; i < m; i++) 
		a2[i].read();
	
	sort(a1, a1 + n);	
	sort(a2, a2 + m);

	for (int i = 0; i < n; i++) {		
		a1[i].t = a1[i].a / a1[i].v;
		if (i) {
			if (a1[i - 1].t - a1[i].t > eps)
				a1[i].t = a1[i - 1].t;
		}		
//		cout.precision(20);
//		cout << fixed << a1[i].t << endl;
	}

	for (int i = 0; i < m; i++) {		
		a2[i].t = a2[i].a / a2[i].v;
		if (i) {
			if (a2[i - 1].t - a2[i].t > eps)
				a2[i].t = a2[i - 1].t;
		}
//		cout.precision(20);
//		cout << fixed << a2[i].t << endl;
	}

	double l = 0, r = x;
	int val0 = f(0);

	while (r - l > eps) {
		double mid = (l + r) / 2;
		int val = f(mid);
		if ((long long)(val) * val0 > 0 || val == 0)
			l = mid;
		else
			r = mid;			 				
	}

	cout.precision(6);
	//cout << f1(0) << endl;
	//cout << f1(x) << endl;
//	cout << f(l) << endl;		

//	cout.precision(20);
//	cout << fixed << l << endl;


	cout << f1(l) << endl;
	cout << fixed << l << " ";
	cout << fixed << x - l << endl;

	return 0;
}