#define FNAME "printing"

#include<cstdio>
#include<cmath>
#include<algorithm>
#include<vector>
using namespace std;

#define forn(i,N) for(int i=0;i<(N);++i)
typedef long long LL;


const int
	MAX_P=200,
	INF=1e9,
	CON=4e4;
const LL
	BIG_INF=4e18;
int Z[MAX_P+1];
vector<pair<int,int> > K;
LL D[CON+100];

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int N,Pages;
	scanf("%d%d",&N,&Pages);
	for(int i=1;i<=MAX_P;++i)
		Z[i]=INF;

	int c,p;
	forn(i,N){
		scanf("%d%d",&c,&p);
		Z[p]=min(Z[p],c);
	}

	for(int i=1;i<=MAX_P;++i)
		if(Z[i]!=INF)
			K.push_back(make_pair(i,Z[i])); //pages, price

	double T=0,t;
	int best=0;
	int CountKart=K.size();
	for(int i=0;i<CountKart;++i)
		if((t=K[i].first*1.0/K[i].second)>T)
			T=t, best=i;

	LL Answer=0;
	if(Pages>CON){
		LL cnt=ceil((Pages-CON)*1.0/K[best].first);
		Pages-=cnt*K[best].first;
		Answer+=cnt*K[best].second;
	}


	D[0]=0;
	for(int i=1;i<=Pages;++i){
		D[i]=BIG_INF;
		for(int j=0;j<CountKart;++j)
			if(i>=K[j].first)
				D[i]=min(D[i],D[i-K[j].first]+K[j].second);
	}

	if(D[Pages]==BIG_INF)
		puts("-1");
	else
		printf("%I64d\n",Answer+D[Pages]);

	return 0;
}