import java.io.*;
import java.util.*;


public class garden {

	public static void main(String[] args) {
		Scanner in = null;
		PrintWriter out = null;
		try {
			in = new Scanner(new File("garden.in"));
			out = new PrintWriter(new File("garden.out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		int n = in.nextInt();
		long days = in.nextInt();
		long required = in.nextLong();
		Bamboo[] arr = new Bamboo[n];
		for(int i = 0; i < n; i++)
			arr[i] = new Bamboo(in.nextInt(), in.nextInt());
		for(int i = 1; i < days; i++)
			for(Bamboo x : arr)
				x.grow();
		if(required > minHeight(arr)){
			out.println(-1);
			in.close();
			out.close();
			return;
		}
		if(canSkip(arr, required)){
			out.println(0);
			in.close();
			out.close();
			return;
		}
		out.println(1);
		in.close();
		out.close();
	}

	private static long minHeight(Bamboo[] a){
		long result = Integer.MAX_VALUE;
		for(Bamboo i : a){
			long x = i.height();
			result = (x < result) ? x : result;
		}
		return result;
	}
	
	private static boolean canSkip(Bamboo[] a, long required){
		for(Bamboo i : a){
			if(i.height() != required){
				return false;
			}
		}
		return true;
	}
}

class Bamboo {
	private long height;
	private final int grow;
	
	Bamboo(int a, int b){
		height = a;
		grow = b;
	}
	
	public long height(){
		return height;
	}
	
	void grow(){
		height += grow;
	}
}