import java.io.*;
import java.util.*;


public class garden {

	public static void main(String[] args) throws IOException {
		Scanner in = null;
		PrintWriter out = null;
		try {
			in = new Scanner(new File("garden.in"));
			out = new PrintWriter(new File("garden.out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		int n = in.nextInt();
		long days = in.nextInt();
		long required = in.nextLong();
		Bamboo[] arr = new Bamboo[n];
		for(int i = 0; i < n; i++){
			arr[i] = new Bamboo(in.nextInt(), in.nextInt());
		}
		for(int i = 1; i < days; i++)
			for(Bamboo x : arr)
				x.grow();
		if(required > minHeight(arr)){
			out.println(-1);
			in.close();
			out.close();
			return;
		}
		if(canSkip(arr, required)){
			out.println(0);
			in.close();
			out.close();
			return;
		}
		out.println(1);
		in.close();
		out.close();
	}

	private static long minHeight(Bamboo[] a){
		long result = Integer.MAX_VALUE;
		for(Bamboo i : a){
			long x = i.height();
			result = (x < result) ? x : result;
		}
		return result;
	}
	
	private static boolean canSkip(Bamboo[] a, long required){
		for(Bamboo i : a){
			if(i.height() != required){
				return false;
			}
		}
		return true;
	}
}

class Bamboo {
	private long height;
	private final int grow;
	
	Bamboo(int a, int b){
		height = a;
		grow = b;
	}
	
	public long height(){
		return height;
	}
	
	void grow(){
		height += grow;
	}
}

class Scanner implements Closeable {
	private BufferedReader reader;
	private StringTokenizer tokenizer;
	
	public Scanner(File f) throws FileNotFoundException{
		this(new FileInputStream(f));
	}
	
	public Scanner(InputStream in){
		reader = new BufferedReader(new InputStreamReader(in));
		try {
			tokenizer = new StringTokenizer(reader.readLine());
		} catch (IOException e){
			throw new NumberFormatException();
		}
	}
	
	private void refresh(){
		if(!tokenizer.hasMoreTokens()){
			try {
				tokenizer = new StringTokenizer(reader.readLine());
			} catch (IOException e){
				throw new NumberFormatException();
			}
		}
	}
	
	public boolean hasNext(){
		refresh();
		return tokenizer.hasMoreTokens();
	}
	
	public long nextLong(){
		String s = next();
		long result = 0;
		for(char a : s.toCharArray()){
			result += a - '0';
			result *= 10;
		}
		return result / 10;
			
	}
	
	public int nextInt(){
		return (int) nextLong();
	}
	
	public String next(){
		return tokenizer.nextToken();
	}

	@Override
	public void close() throws IOException {
		reader.close();
	}
}