import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemA {

	String fileName = "chronicle";
	boolean debugOn = false;
	String delim = "/ ";

	public void start() throws Exception {
		int a = nextInt();
		int b = nextInt();
		int c = nextInt();
		check(a, b, c);
		check(a, c, b);
		check(b, a, c);
		check(b, c, a);
		check(c, a, b);
		check(c, b, a);
		if (count == 0)
			out.print("No such date");
	}

	int[] days = { 31, -1, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	int count = 0;

	int[] dayses = new int[10];
	int[] months = new int[10];
	int[] years = new int[10];
	int next = 0;

	void check(int d, int m, int y) {
		for (int i = 0; i < next; i++) {
			if (dayses[i] == d && months[i] == m && years[i] == y)
				return;
		}
		dayses[next] = d;
		months[next] = m;
		years[next] = y;
		next++;
		int year;
		if (y == 0)
			year = 2100;
		else
			year = 2000 + y;

		if (year % 4 == 0 && year % 100 != 0) {
			days[1] = 29;
		} else {
			days[1] = 28;
		}
		if (year <= 2100 && year > 2000 && m <= 12 && m > 0 && d >= 1
				&& d <= days[m - 1]) {
			count++;
			out.println(toDate(d) + "/" + toDate(m) + "/" + toDate(y));
		}
	}

	String toDate(int a) {
		if (a < 10) {
			return "0" + a;
		} else
			return a + "";
	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	public ProblemA() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
