#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "chronicle"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

bool leap(int y) {
  if (y % 400 == 0) return true;
  return (y % 4 == 0) && (y % 100 != 0);
}

const int ds[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
bool check(int d, int m, int y) {
  if (!y) y = 2100;
  else y = 2000 + y;

  if (m < 1 || m > 12) return false;
  int dcnt = ds[m - 1];
  if (leap(y) && m == 2) dcnt++;
  return 1 <= d && d <= dcnt;
}

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int a, b, c;
  while (scanf("%d/%d/%d", &a, &b, &c) >= 3) {
    vi vs;
    vs.pb(a);
    vs.pb(b);
    vs.pb(c);
    sort(vs.begin(), vs.end());

    bool was = false;
    do {
      if (check(vs[0], vs[1], vs[2])) {
        printf("%02d/%02d/%02d\n", vs[0], vs[1], vs[2]);
        was = true;
      }
    } while (next_permutation(vs.begin(), vs.end()));
    if (!was)
      printf("No such date\n");
  }
  return 0;
}
