#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "printing"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MAXV = 201;
const int MAGICC = 8000;

ll dyn[MAGICC + 1];

const ll INFLL = 0x3F3F3F3F3F3F3F3F;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n, k;
  while (scanf("%d%d", &n, &k) >= 2) {
    vi cs(MAXV, INF);
    int bp = -1, bc = 1;
    for (int i = 0; i < n; i++) {
      int c, p;
      scanf("%d%d", &c, &p);
      cs[p] = min(cs[p], c);

      // p / c > bp / bc
      // p * bc > bp * c
      if (p * bc > bp * c) {
        bp = p;
        bc = c;
      }
    }
    ll ans = 0;
    if (k > MAGICC) {
      int cnt = (k - MAGICC + bp - 1) / (bp);
      ans += ll(cnt) * bc;
      k -= cnt * bp;
    }
//    eprintf("%I64d %d\n", ans, k);
    assert(k <= MAGICC);

    memset(dyn, 0x3F, sizeof dyn);
    dyn[0] = 0;
    for (int step = 0; step <= 200; step++)
      for (int i = 1; i <= 200; i++) if (cs[i] < INF) {
        for (int cur = 0; cur + i <= k; cur++)
          dyn[cur + i] = min(dyn[cur + i], dyn[cur] + cs[i]);
      }
    if (dyn[k] < INFLL)
      printf("%I64d\n", ans + dyn[k]);
    else
      printf("-1\n");
  }
  return 0;
}
