#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
//#define INF int(1e9)
#define TASKNAME "quadro"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

vector<pii> ord;
vvi lens;

int quadro(int x1, int x2, int y1, int y2, int ch) {
  if (x1 + 1 == x2 && y1 + 1 == y2) {
    ord.pb(mp(x1, y1));
    lens.pb(vi(1, ch));
    return sz(ord) - 1;
  }
  int xm = (x1 + x2) / 2;
  int ym = (y1 + y2) / 2;

  int fir = quadro(x1, xm, y1, ym, ch - 1);
  lens[fir].pb(ch);
  quadro(xm, x2, y1, ym, ch - 1);
  quadro(x1, xm, ym, y2, ch - 1);
  quadro(xm, x2, ym, y2, ch - 1);
  return fir;
}

const short INF = -32768;

char buf[1024];
int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int t, k;
  while (scanf("%d%d", &t, &k) >= 1) {
    vvi _vals(t, vi(t));
    for (int y = 0; y < t; y++) {
      scanf("%s", buf);
      for (int x = 0; x < t; x++)
        _vals[y][x] = 
        buf[x] == '1';
    }

    int n = t * t;
    if (k >= n / 2) {
      printf("1\n");
      continue;
    }

    int srch = 0;
    while ((1 << (2 * srch)) < n) srch++;
    assert((1 << (2 * srch)) == n);
 
    lens.clear();
    ord.clear();
    quadro(0, t, 0, t, srch);

    vi vals(n);
    for (int i = 0; i < n; i++) {
      vals[i] = _vals[ord[i].second][ord[i].first];
    }

    vi sums(n + 1, 0);
    for (int i = 0; i < n; i++)
      sums[i + 1] = sums[i] + vals[i];

    vi f(srch + 1, 1);
    f[0] = 0;
    for (int i = 1; i <= srch; i++)
      f[i] += 4 * f[i - 1];

    vector<vector<short> > d(n + 1);
    d[n] = vector<short>(k + 1, 0);

    deque<int> cur;
    int ccnt = 1;

    for (int i = n - 1; i >= 0; i--) {
      d[i] = vector<short>(k + 1, -INF);
      ccnt++;
      for (int lid = 0; lid < sz(lens[i]); lid++) {
        int lk = lens[i][lid];
        int clen = 1 << (2 * lk);
        assert(i + clen <= n);

        int csum = sums[i + clen] - sums[i];
        assert(csum <= clen);
        int cres = min(csum, clen - csum);

        for (int rem = cres; rem <= k; rem++) {
          assert(sz(d[i + clen]));
          d[i][rem] = max(d[i][rem], short(d[i + clen][rem - cres] + f[lk] - 1));
        }
      }

      if (i > 0)
      for (int x = i; x % 4 == 0; x /= 4)
        for (int step = 0; step < 3; step++) { 
          assert(sz(cur));
          assert(sz(d[cur.back()]));
          ccnt--;
          d[cur.back()].clear();
          cur.pop_back();
        }
      cur.pb(i);
    }
    printf("%d\n", f[srch] - d[0][k]);
  }
  return 0;
}
