#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(2e9)
#define TASKNAME "swords"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n, k;
  while (scanf("%d%d", &n, &k) >= 1) {
    vector<pii> as(n);
    for (int i = 0; i < n; i++) {
      scanf("%d", &as[i].first), as[i].second = i;
      as[i].first = 1e9 - as[i].first;
    }

    vector<pii> oas = as;
    sort(as.begin(), as.end());

    try {
      vi ans(n, -1);
      vi rem(n, 2);

      set<pii> good;
      good.insert(as[0]);

      for (int i = 1; i < n; i++) {
        if (!sz(good)) throw 0;

        set<pii>::iterator it = good.upper_bound(mp(as[i].first - k, INF));
//        if (it != good.end())
//          assert(it->first > as[i].first - k);
        if (it == good.begin()) throw 0;
        it--;

        int id = it->second;

        ans[as[i].second] = id;
        rem[id]--;
        assert(rem[id] >= 0);
        if (!rem[id]) {
          good.erase(oas[id]);
        }
        good.insert(as[i]);
      }

      for (int i = 0; i < n; i++)
        printf("%d%c", ans[i] + 1, "\n "[i + 1 < n]);
    } catch (...) {
      printf("-1\n");
    }
  }
  return 0;
}
