#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-5)
#define eps (1e-9)
#define INF int(1e9)
#define TASKNAME "traffic"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int maxn = 100000;
int n[2];
pair<double, double> a[2][maxn];
double t[2][maxn];
double g[2 * maxn + 2];
pair<double, int> ps[2][maxn];

const int maxl = (int)1e4;
int val[2][maxl];

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  double x;
  while (scanf("%lf", &x) >= 1) {
    for (int it = 1; it >= 0; it--) {
    	scanf("%d", &n[it]);
    	for (int i = 0; i < n[it]; i++) {
    		double a1, v;
    		scanf("%lf%lf", &a1, &v);
    		a[it][i] = mp(a1, v);
    	}

    	sort(a[it], a[it] + n[it]);

    	for (int i = 0; i < n[it]; i++)
    		t[it][i] = max(a[it][i].first / a[it][i].second, i ? t[it][i - 1] : -1);
    	
    	double now = 0;
    	int nowcnt = 0;
    	for (int i = 0; i < n[it]; i++) {
    	  ps[it][i] = mp(t[it][i] - now, nowcnt);
 			 	while (ps[it][i].first - x >= 0)
  				ps[it][i].first -= x, ps[it][i].second++, now += x, nowcnt++;	
    	}
    	sort(ps[it], ps[it] + n[it]);
    }         

    
    int k = 0;
  
    double now = 0;
    for (int i = 0; i < n[0]; i++) {
    	g[k++] = t[0][i] - EPS - now;
    	while (g[k - 1] - x >= 0)
    		g[k - 1] -= x, now += x;	
    	if (g[k - 1] - 2 * EPS < eps || g[k - 1] + 2 * EPS > x - eps)
    		k--;
    }
    
    now = 0;
    for (int i = 0; i < n[1]; i++) {
    	g[k++] = t[1][i] + EPS - now;
    	while (g[k - 1] - x >= 0)
    		g[k - 1] -= x, now += x;	
    	if (g[k - 1] - 2 * EPS < eps || g[k - 1] + 2 * EPS > x - eps)
    		k--;
    }
  
    g[k++] = 2 * EPS;
    g[k++] = x - 2 * EPS;
  
    sort(g, g + k);
  
    memset(val, 0, sizeof(val));
    multiset<int> S;
    for (int i = 0; i < 2 * maxl; i++)
    	S.insert(0);
  
    multiset<int>::iterator it;
  
    for (int i = 0; i < n[1]; i++)
    	if (ps[1][i].first > 3 * EPS + eps && ps[1][i].first < x - EPS - eps) {
    		int num = ps[1][i].second;
    		it = S.find(val[1][num]);
    		assert(it != S.end());
    		S.erase(it);
    		val[1][num]++;
    		S.insert(val[1][num]);
     	}
  
    it = S.end();
    it--;
    int ans = *it;
    double gans = 2 * EPS;
  
    int iter[2] = {0, 0};
    for (int e = 1; e < k; e++) {
  		double l = g[e - 1] - EPS, r = g[e] - EPS;
			// [l, r)
			while (iter[0] < n[0] && ps[0][iter[0]].first < l - eps)
				iter[0]++;
			while (iter[0] < n[0] && ps[0][iter[0]].first < r - eps) {
	  		int num = ps[0][iter[0]].second;
    		it = S.find(val[0][num]);
    		assert(it != S.end());
    		S.erase(it);
    		val[0][num]++;
    		S.insert(val[0][num]);
  			iter[0]++;
			}
	
  		l = g[e - 1] + EPS, r = g[e] + EPS;
			// (l, r]    -!!!!!!
	
  		while (iter[1] < n[1] && ps[1][iter[1]].first < l + eps)
				iter[1]++;
			while (iter[1] < n[1] && ps[1][iter[1]].first < r + eps) {
	  		int num = ps[1][iter[1]].second;
    		it = S.find(val[1][num]);
    		assert(it != S.end());
    		S.erase(it);
    		val[1][num]--;
    		S.insert(val[1][num]);
  			iter[1]++;
			}
			
			it =  S.end();
			it--;
			int ansn = *it;
			
	  	if (ans > ansn) {
    		ans = ansn;
    		gans = g[e];
    	}
    }
  
    printf("%d\n%.6lf %.6lf\n", ans, gans, x - gans);
	}
  return 0;
}
