import java.io.*;
import java.util.*;

public class swords implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new swords()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("swords.in"));
			out = new PrintWriter(new FileWriter("swords.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		int k = nextInt();
		ArrayList<sword> arr = new ArrayList<sword>();
		for (int i = 0; i < n; i++) {
			arr.add(new sword(i, nextInt()));
		}
		Collections.sort(arr, new compareSwords());
		ArrayList<sword> queue = new ArrayList<sword>();
		int[] parents = new int[n];
		queue.add(arr.get(0));
		queue.add(arr.get(0));
		parents[arr.get(0).i] = -1;
		boolean flag = false;
		int pos = 0;
		for (int i = 1; i < arr.size(); i++) {
			if (pos >= queue.size()) {
				flag = true;
				break;
			}
			sword nq = queue.get(pos);
			pos++;
			if (nq.age - arr.get(i).age >= k) {
				parents[arr.get(i).i] = nq.i;
				queue.add(arr.get(i));
				queue.add(arr.get(i));
			} else {
				flag = true;
				break;
			}
		}
		if (flag) {
			out.print(-1);
		}
		else {
			for (int i=0;i<n;i++) {
				out.print(parents[i]+1 + " ");
			}
		}
	}
}

class sword {
	int i;
	int age;
	public sword(int _i, int _age) {
		i = _i;
		age = _age;
	}
}

class compareSwords implements Comparator<sword> {
	public int compare(sword s1, sword s2) {
		return s2.age - s1.age;
	}
}