import java.io.*;
import java.util.*;

public class swords_av {

	class Sword implements Comparable<Sword> {
		int age, ind, rmn;

		public Sword(int a, int i, int r) {
			age = a;
			ind = i;
			rmn = r;
		}

		@Override
		public int compareTo(Sword arg0) {
			if (age != arg0.age)
				return arg0.age - age;
			if (rmn != arg0.rmn)
				return arg0.rmn - rmn;
			return arg0.ind - ind;
		}
		
		@Override
		public String toString() {
			return age + " " + ind + " " + rmn;
		}
	}

	void solve() throws Exception {
		int n = nextInt();
		int k = nextInt();
		Sword[] a = new Sword[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Sword(nextInt(), i, 2);
		}
		Arrays.sort(a);
		int[] ans = new int[n];
		TreeSet<Sword> ts=  new TreeSet<Sword>();
		ts.add(a[0]);
		for (int i = 1; i < n; i++) {
			Sword t = ts.pollFirst();
			if (a[i].age + k <= t.age) {
				ans[a[i].ind] = t.ind + 1;
				ts.add(a[i]);
				if (t.rmn > 1)
					ts.add(new Sword(t.age, t.ind, t.rmn - 1));
			} else {
				out.println(-1);
				return;
			}
		}
		for (int i = 0; i < n; i++) {
			out.print(ans[i] + " ");
		}
	}

	void run() {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			// in = new BufferedReader(new InputStreamReader(System.in));
			// out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;
	final String filename = new String("swords").toLowerCase();

	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

	public static void main(String[] args) {
		new swords_av().run();
	}

}
