#include <iostream>
#include <cmath>
#include <cassert>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "swords"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

struct Sword
{
	int age, id;

	Sword() {};
	Sword(int age_, int id_): age(age_), id(id_) {};
};

bool operator < (const Sword &a, const Sword &b)
{
	if (a.age != b.age) return a.age > b.age;
	return a.id > b.id;
}

int n, k;
int a[100005];
set <Sword> h;

void Load()
{
	assert(scanf("%d%d", &n, &k) == 2);
	assert(1 <= n && n <= 100000);
	assert(1 <= k && k <= 100000000);
	for (int i = 0; i < n; i++)
	{
		assert(scanf("%d", &a[i]) == 1);
		assert(0 <= a[i] && a[i] <= 1000000000);
		h.insert(Sword(a[i], i));
	}
}

int getNext(int v)
{
	if (h.empty()) return -1;
	int u = h.begin()->id;
	if (a[u] <= a[v] - k)
	{
		h.erase(h.begin());
		return u;
	}
	return -1;
}

int ans[100005];

void rec(int v)
{
	vector <int> nxt;
	nxt.pb(getNext(v));
	nxt.pb(getNext(v));
	for (int i = 0; i < (int)nxt.size(); i++)
	{
		int u = nxt[i];
		if (u == -1) continue;
		ans[u] = v;
		rec(nxt[i]);
	}
}

void Solve()
{
	int v = h.begin()->id;
	ans[v] = -1;
	h.erase(h.begin());
	rec(v);
	if (!h.empty())
		printf("-1");
	else
	{
		for (int i = 0; i < n; i++)
			printf("%d ", ans[i] + 1);
	}	
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
