import java.io.*;
import java.util.*;

public class swords_pk {
	public static void main(String[] args) {
		new swords_pk().run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	class Sword implements Comparable<Sword> {

		int old, num, par;

		Sword(int Num, int Old) {
			num = Num;
			old = Old;
		}

		@Override
		public int compareTo(Sword t) {
			return t.old - old;
		}

	}

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		assert ((1 <= n) && (n <= 100000));
		assert ((1 <= k) && (k <= 1e8));

		Sword[] a = new Sword[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Sword(i, nextInt());
			assert ((a[i].old >= 0) && (a[i].old <= 1e9));
		}
		Arrays.sort(a);
		int[] ans = new int[n];
		ans[a[0].num] = 0;
		for (int i = 1; i < n; i++) {
			if (a[(i - 1) / 2].old < a[i].old + k) {
				out.println(-1);
				return;
			}
			ans[a[i].num] = a[(i - 1) / 2].num + 1;
		}
		for (int i = 0; i < n; i++)
			if (i < n - 1)
				out.print(ans[i] + " ");
			else
				out.println(ans[i]);
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("swords.in"));
			out = new PrintWriter("swords.out");
			// br = new BufferedReader(new InputStreamReader(System.in));
			// out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}