import java.io.*;
import java.util.*;

public class swords_va implements Runnable {
	public static void main(String[] args) {
		new Thread(new swords_va()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public class Spear implements Comparable<Spear> {
		int day, ind;

		public Spear(int day, int ind) {
			this.day = day;
			this.ind = ind;
		}

		public int compareTo(Spear o) {
			return day - o.day;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();

		int max = 0;
		Spear[] a = new Spear[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Spear(nextInt(), i);
			max = Math.max(a[i].day, max);
		}

		for (int i = 0; i < n; i++) {
			a[i].day = max - a[i].day;
		}

		Arrays.sort(a);
		int[] ans = new int[n];

		for (int i = 0; i < n; i++) {
			if (i == 0) {
				ans[a[i].ind] = -1;
			} else {
				if (a[(i + 1) / 2 - 1].day + k > a[i].day) {
					out.println(-1);
					return;
				}
				ans[a[i].ind] = a[(i + 1) / 2 - 1].ind;
			}
		}

		for (int i = 0; i < ans.length; i++) {
			out.print(++ans[i] + " ");
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("swords.in"));
			out = new PrintWriter("swords.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
