import java.util.*;
import java.io.*;
import java.util.regex.Matcher;

public class traffic_as {
    FastScanner in;
    PrintWriter out;

    long PREC = 1000;

    class Car {
        long a;
        long v;

        Frac t;
        Frac tM;

        int bucket;

        Car(double aD, double vD) {
            this.a = Math.round(aD * PREC * PREC);
            this.v = Math.round(vD * PREC);
        }
    }

    static long gcd(long x, long y) {
        while (y != 0) {
            long t = x % y;
            x = y;
            y = t;
        }
        return x;
    }

    static class Frac implements Comparable<Frac>, Cloneable {
        long n;
        long d;

        Frac(long n, long d) {
            long a = gcd(n, d);
            this.n = n / a;
            this.d = d / a;
        }

        public int compareTo(Frac f) {
            long v = n * f.d - f.n * d;
            return v < 0 ? -1 : v > 0 ? 1 : 0;
        }

        public Frac clone() {
            return new Frac(n, d);
        }

        Frac sub(Frac v) {
            return new Frac(n * v.d - v.n * d, d * v.d);
        }
    }

    long x;

    void calcT(Car[] v) {
        Frac max = new Frac(0, 1);
        Car prev = null;
        int buckN = 0;
        for (Car car : v) {
            Frac carT = new Frac(car.a, car.v);
            if (carT.compareTo(max) > 0) {
                max = carT;
            }
            car.t = max.clone();
            car.tM = new Frac(car.t.n % (car.t.d * x), car.t.d);

            if (prev == null || car.t.n / (car.t.d * x) > prev.t.n / (prev.t.d * x)) {
                buckN++;
            }
            car.bucket = buckN - 1;
            prev = car;
        }
    }

    class RMQ {
        int n;
        int[] v;

        RMQ(int n) {
            this.n = n;
            v = new int[4 * n];
        }

        public void update(int p, int d) {
            update(0, 0, n, p, d);
        }

        private void update(int i, int l, int r, int p, int d) {
            if (l == r - 1) {
                v[i] += d;
                return;
            }
            int m = (l + r) / 2;
            if (p < m) {
                update(2 * i + 1, l, m, p, d);
            } else {
                update(2 * i + 2, m, r, p, d);
            }
            v[i] = Math.max(v[2 * i + 1], v[2 * i + 2]);
        }

        public int max() {
            return v[0];
        }
    }

    public void solve() throws IOException {
        x = Math.round(in.nextDouble() * PREC);
        int n = in.nextInt();
        Car[] a = new Car[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Car(in.nextDouble(), in.nextDouble());
        }
        Comparator<Car> compDist = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a < o2.a ? -1 : o1.a > o2.a ? 1 : 0;
            }
        };

        Arrays.sort(a, compDist);

        int m = in.nextInt();
        Car[] b = new Car[m];
        for (int i = 0; i < m; i++) {
            b[i] = new Car(in.nextDouble(), in.nextDouble());
        }
        Arrays.sort(b, compDist);

        calcT(a);
        calcT(b);

        Comparator<Car> compMod = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.tM.compareTo(o2.tM);
            }
        };

        int abn = a[a.length - 1].bucket + 1;
        int bbn = b[b.length - 1].bucket + 1;
        RMQ armq = new RMQ(abn);
        RMQ brmq = new RMQ(bbn);
        for (Car c : a) {
            if (c.tM.n != 0) {
                armq.update(c.bucket, +1);
            }
        }

        int ans = armq.max();
        Frac optT = new Frac(0, 1);

        Arrays.sort(a, compMod);
        Arrays.sort(b, compMod);

        int ap = 0;
        int bp = 0;

        Frac last = new Frac(0, 1);
        Frac min = new Frac(1000000, 1);
        while (ap < n || bp < m) {
            int aq = ap;
            int bq = bp;
            if (ap < n && (bp == m || a[ap].tM.compareTo(b[bp].tM) <= 0)) {
                while (aq < n && a[ap].tM.compareTo(a[aq].tM) == 0) {
                    if (a[aq].tM.n != 0) {
                        armq.update(a[aq].bucket, -1);
                    }
                    aq++;
                }

                Frac dif = a[ap].tM.sub(last);
                if (dif.compareTo(new Frac(0, 1)) != 0 && dif.compareTo(min) < 0) {
                    min = dif;
                }
                last = a[ap].tM;
            }

            int v = Math.max(armq.max(), brmq.max());
            if (v < ans) {
                ans = v;
                if (ap < n && (bp == m || a[ap].tM.compareTo(b[bp].tM) <= 0)) {
                    optT = a[ap].tM;
                } else {
                    optT = b[bp].tM;
                }
            }

            if (bp < m && (ap == n || b[bp].tM.compareTo(a[ap].tM) <= 0)) {
                while (bq < m && b[bp].tM.compareTo(b[bq].tM) == 0) {
                    if (b[bq].tM.n != 0) {
                        brmq.update(b[bq].bucket, +1);
                    }
                    bq++;
                }

                Frac dif = b[bp].tM.sub(last);
                if (dif.compareTo(new Frac(0, 1)) != 0 && dif.compareTo(min) < 0) {
                    min = dif;
                }
                last = b[bp].tM;
            }

            ap = aq;
            bp = bq;
        }

        System.err.println(0.001 * min.n / min.d);

        out.println(ans);
        double g = 0.001 * optT.n / optT.d;
        out.println(g + " " + (x / 1000.0 - g));
    }

    public void run() {
        try {
            in = new FastScanner(new File("traffic.in"));
            out = new PrintWriter(new File("traffic.out"));

            solve();

            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public static void main(String[] arg) {
        Locale.setDefault(Locale.US);
        new traffic_as().run();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        void close() throws IOException {
            br.close();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

}