#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld eps = 1e-4;


vector<ld> t1,t2;

int n1,n2;

ld x;

ld ldmod(ld a){
	return a - ((int)(a/x + eps))*x;
}

int lddiv(ld a){
	return int(a/x+eps);
}


bool comp(ld a,ld b){
	return ldmod(a) < ldmod(b) - eps;
}
               
map<int,int> cnt;
set<pair<int,int> > s;

void update(int v,int add){
	if (cnt.find(v) != cnt.end()){
		s.erase(mp(cnt[v],v));
	}
	else
		cnt[v] = 0;
	cnt[v] += add;
	s.insert(mp(cnt[v],v));		
}

int get(){
	if (s.size())
		return (--s.end())->first;
	return 0;
}


int main(){
    freopen("traffic.in","r",stdin);
    freopen("traffic.out","w",stdout);
    double _x;
    scanf("%lf %d",&_x,&n1);
    x = _x;
    ld last = -1;
    for (int i = 0; i < n1; i++){
    	double x,v;
    	scanf("%lf %lf",&x,&v);
    	ld res = x/v;
    	res = max(res,last);
    	last = res;
    	if (ldmod(res) > eps)
	    	t1.pb(res);
	    else
	    	--n1,--i;	
    }

    scanf("%d",&n2);
    last = -1;
    for (int i = 0; i < n2; i++){
    	double x,v;
    	scanf("%lf %lf",&x,&v);
    	ld res = x/v;
    	res = max(res,last);
    	last = res;  
    	if (ldmod(res) > eps)
	    	t2.pb(res);
	    else
	      	--n2,--i;
    }


    sort(t1.begin(),t1.end(),comp);
    sort(t2.begin(),t2.end(),comp);


    set<pair<int,int> > s;
	for (int i = 0; i < n1; i++)
		update(2*lddiv(t1[i]),1);

	ld g = 0;    
	int ans = get();


	int ptr1 = 0,ptr2 = 0;

	for (;ptr1 < n1; ++ptr1){
		ld curg = ldmod(t1[ptr1]);
		update(2*lddiv(t1[ptr1]),-1);

		for (;ptr2 < n2 && ldmod(t2[ptr2]) < curg - eps;ptr2++)
			update(2*lddiv(t2[ptr2])+1,1);
		
		if (get() < ans){
			ans = get();
			g = curg;
		}
	}


    
    cout.precision(15);
    cout << ans << " "<<fixed << g <<" "<<x - g << endl;
	return 0;
}