#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ld> a;
vector<ld> b;

vector<ld> vars;

const ld eps = 1e-5;

ld x;

ld ldmod(ld a){
	return a - ((int)(a/x + eps))*x;
}

int lddiv(ld a){
	return int(a/x+eps);
}

int get(ld g){
	vector<int> stay;
	for (int i = 0; i < (int)a.size(); i++){
		ld temp = ldmod(a[i]);
		if (temp > g + eps && temp < x - eps)
			stay.pb(lddiv(a[i]));
	}

	sort(stay.begin(),stay.end());
	int ans = 0;

	for (int i = 0; i < (int)stay.size(); ){
		int j = i;
		for (; j < (int)stay.size() && stay[j] == stay[i]; j++);
		ans = max(ans,j-i);
		i = j;	
	}
	stay.clear();

	for (int i = 0; i < (int)b.size(); i++){
		ld temp = ldmod(b[i]);
		if (temp < g - eps && temp > eps)
			stay.pb(lddiv(b[i]));
	}
	
	sort(stay.begin(),stay.end());


	for (int i = 0; i < (int)stay.size(); ){
		int j = i;
		for (; j < (int)stay.size() && stay[j] == stay[i]; j++);
		ans = max(ans,j-i);
		i = j;	
	}
	stay.clear();

    return ans;				
}


int main()
{
    freopen("traffic.in","r",stdin);
    freopen("traffic.out","w",stdout);
	int n;

	cin >> x;


	scanf("%d",&n);
	for (int i = 0; i < n; i++){
		double v,x;
		scanf("%lf %lf",&x,&v);
		a.pb(x/v);
		vars.pb(ldmod(x/v));

	}


	scanf("%d",&n);

	for (int i = 0; i < n; i++){
		double x,v;
		scanf("%lf %lf",&x,&v);
		b.pb(x/v);
	}

	for (int i = 1; i < a.size(); i++)
		a[i] = max(a[i],a[i-1]);
	for (int i = 1; i < b.size(); i++)
		b[i] = max(b[i],b[i-1]);

	vars.pb(0);
	vars.pb(x);

	ld g = 0;
	int ans = 1<<30;

	for (int i = 0; i < (int)vars.size(); i++){
		int cur = get(vars[i]);
		if (cur < ans){
			ans = cur;
			g = vars[i];
		}
	}

	cout.precision(15);
	cout << ans <<" "<<fixed << g <<" "<<x-g << endl;
  return 0;
}