#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;


ll gcd(ll a,ll b){
	if (!a || !b)
		return a+b;
	return gcd(b,a%b);
}

struct ld{
	ll ch,zn;
	ld(ll ch,ll zn=1):ch(ch),zn(zn){
		ll g = gcd(ch,zn);
		ch /= g;
		zn /= g;
	}
	ld(){
		ch = 0,zn = 1;
	}
	ld operator/(const ld& a)const{
		return ld(ch*a.zn,zn*a.ch);
	}
	ld operator*(const ld& a)const{
		return ld(ch*a.ch,zn*a.zn);
	}
	ld operator-(const ld& a)const{
		return ld(ch*a.zn - zn*a.ch,zn*a.zn);
	}
	ld operator+(const ld& a)const{
		return ld(ch*a.zn + zn*a.ch,zn*a.zn);
	}
	int ivalue()const{
		return ch/zn;
	}
	ld modvalue(const ld& x)const{
		return *this - ((ld)((*this/x).ivalue()))*x;
	}

	bool operator<(const ld& x)const{
		return ch*x.zn < zn*x.ch;
	}
	bool operator>(const ld& x)const{
	    return x < *this;
	}
	bool operator==(const ld& x)const{
		return !(*this < x) && !(x < *this);
	}
	bool operator!=(const ld& x)const{
		return !(*this == x);
	}

	bool operator<=(const ld& x)const{
		return !(*this > x);
	}
	bool operator>=(const ld& x)const{
		return !(*this < x);
	}

	long double dvalue() const{
//		cerr << ch << "/"<<zn <<"="<<ch/(long double)zn<<endl;
		return ch/(long double)zn;
	}

	void read(){
		int a,b;
		string s;
		cin >> s;
		int t = sscanf(s.data(),"%d.%d",&a,&b);  
		if (t == 1)
			b = 0;
		else if (s[s.size()-2] == '.')
			b *= 100;
		else if (s.size() >= 3 && s[s.size()-3] == '.')
			b *= 10;
		ch = a*1000+b;
		zn = 1000;

		ll g = gcd(ch,zn);
		ch /= g;
		zn /= g;
	}               
};


vector<ld> a;
vector<ld> b;

vector<ld> vars;


ld x;
                        
int get(ld g){
	vector<int> stay;
	for (int i = 0; i < (int)a.size(); i++){
		ld temp = a[i].modvalue(x);
		if (temp > g && temp != x)
			stay.pb((a[i]/x).ivalue());
	}

	sort(stay.begin(),stay.end());
	int ans = 0;

	for (int i = 0; i < (int)stay.size(); ){
		int j = i;
		for (; j < (int)stay.size() && stay[j] == stay[i]; j++);
		ans = max(ans,j-i);
		i = j;	
	}
	stay.clear();

	for (int i = 0; i < (int)b.size(); i++){
		ld temp = b[i].modvalue(x);
		if (temp < g && temp != 0)
			stay.pb((b[i]/x).ivalue());
	}

	sort(stay.begin(),stay.end());


	for (int i = 0; i < (int)stay.size(); ){
		int j = i;
		for (; j < (int)stay.size() && stay[j] == stay[i]; j++);
		ans = max(ans,j-i);
		i = j;	
	}
	stay.clear();

    return ans;		
}


int main()
{               
    freopen("traffic.in","r",stdin);
    freopen("traffic.out","w",stdout);
	int n;

	x.read();
	scanf("%d",&n);

	for (int i = 0; i < n; i++){
		ld x,v;
		x.read(),v.read();
		a.pb(x/v);
		vars.pb(a.back().modvalue( ::x));
	}

	scanf("%d",&n);

	for (int i = 0; i < n; i++){
		ld x,v;
		x.read(),v.read();
		b.pb(x/v);
	}

	for (int i = 1; i < a.size(); i++)
		a[i] = max(a[i],a[i-1]);
	for (int i = 1; i < b.size(); i++)
		b[i] = max(b[i],b[i-1]);



	vars.pb(0);
	vars.pb(x);

	ld g = 0;
	int ans = 1<<30;

	for (int i = 0; i < (int)vars.size(); i++){
		int cur = get(vars[i]);
		if (cur < ans){
			ans = cur;
			g = vars[i];
		}
	}

	cout.precision(15);
	cout << ans <<" "<<fixed << g.dvalue() <<" "<<(x-g).dvalue() << endl;
  return 0;
}
