#include <iostream>
#include <stdarg.h>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "weights"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;

void Load()
{
	assert(scanf("%d", &n) == 1);
	assert(1 <= n && n <= 100000);
}

vector <int> wei[3];
bool used[100001];

void Solve()
{
	int rem = n % 6;
	if (n < 5 || rem == 1 || rem == 4)
	{
		printf("Impossible");
		return;
	}

	LL need = ((LL)n * (LL)(n + 1)) / 6;
	memset(used, false, sizeof(used));

	for (int i = 0; i < 3; i++)
	{
		LL s = 0;
		for (int j = n; j >= 1; j--)
		{
			if (used[j]) continue;
			if (s + j <= need)
			{
				s += j;
				used[j] = true;
				wei[i].pb(j);
			}
		}
	}

	for (int i = 0; i < 3; i++)
	{
		printf("%d\n", wei[i].size());
		for (int j = 0; j < (int)wei[i].size(); j++)
			printf("%d ", wei[i][j]);
		printf("\n");
	}
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
